/**
 * Created by ylj on 2016/10/31.
 */
var HosReadImgDetailModule = angular.module("HosReadImgDetailModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);
HosReadImgDetailModule.service("HosReadImgDetailService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};
  //获取读片列表
  service.getReadFileList = function (data, $scope) {
    httpHandlerService.readFileRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.ReadFileList = response.Body.ReadFileList;
        } else {
          navigator.notification.alert(response.Header.Message,function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 新增读片
  service.addReadFile = function ($scope) {
    /* if (!$.formValidator.pageIsValid("1")) {
     return;
     }*/

    if ($scope.addedReadFile.Doctor != null && $scope.addedReadFile.Doctor.UserID != null) {
      $scope.addedReadFile.ReceiverID = $scope.addedReadFile.Doctor.UserID;
      $scope.addedReadFile.ReceiverName = $scope.addedReadFile.Doctor.Name;
      $scope.addedReadFile.ReceiverType = 0;
    } else {
      $scope.addedReadFile.ReceiverID = $scope.addedReadFile.selectedDepartment.DepartmentID;
      $scope.addedReadFile.ReceiverName = $scope.addedReadFile.selectedDepartment.Name;
      $scope.addedReadFile.ReceiverType = 1;
    }

    var data = {ReadFile: $scope.addedReadFile, FileList: []};
    httpHandlerService.readFileRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("新增成功",function(){},"提示消息","确定");
          service.getReadFileList($scope.searchPar, $scope);
        }
        else {
          navigator.notification.alert("新增失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        navigator.notification.alert("新增失败",function(){},"提示消息","确定");
      }
    );
  };

  // 更新读片
  service.updateReadFile = function ($scope) {

    if ($scope.updatedReadFile.Doctor != null && $scope.updatedReadFile.Doctor.UserID != null) {
      $scope.updatedReadFile.ReadFile.ReceiverID = $scope.updatedReadFile.Doctor.UserID;
      $scope.updatedReadFile.ReadFile.ReceiverName = $scope.updatedReadFile.Doctor.Name;
      $scope.updatedReadFile.ReadFile.ReceiverType = 0;
    } else {
      $scope.updatedReadFile.ReadFile.ReceiverID = $scope.updatedReadFile.selectedDepartment.DepartmentID;
      $scope.updatedReadFile.ReadFile.ReceiverName = $scope.updatedReadFile.selectedDepartment.Name;
      $scope.updatedReadFile.ReadFile.ReceiverType = 1;
    }

    service.updateReadFileToDatabase($scope);
  };

  service.updateReadFileToDatabase = function ($scope) {
    httpHandlerService.readFileRequest($scope.updatedReadFile, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getReadFileList($scope.searchPar, $scope);
        }
        else {
          navigator.notification.alert(response.Header.Message,function(){},"提示消息","确定");
        }
      },
      function (response) {
        navigator.notification.alert("更新失败",function(){},"提示消息","确定");
      }
    );
  };

  // 获取科室转诊管理列表
  service.getDepartmentControlList = function (data, $scope) {
    httpHandlerService.departmentControlRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.departmentControls = response.Body.DepartmentControlList;
          service.getDoctorGroupByDepartment({
            "ReceiveCustomerID": "gy3y",
            "ReceiveIsTop": 1
          }, $scope);
        } else {
          navigator.notification.alert(response.Header.Message,function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //获取层级数据
  service.getDoctorGroupByDepartment = function ($scope) {
    httpHandlerService.getAllDepartmentChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.length > 0) {
          $scope.topCustomer = [];
          for (var i = 0; i < response.Body.DepartmentList.length; i++) {
            var department = response.Body.DepartmentList[i];
            for (var j = 0; j < $scope.departmentControls.length; j++) {
              var control = $scope.departmentControls[j];
              if (control.DepartmentID == department.DepartmentID) {
                $scope.topCustomer.push(department);
                break;
              }
            }
          }
        }
        else {
          console.error("没有任何用户");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取人员
  service.getDoctorByDepartmentID = function (department, readFile, $scope, callBack) {
    var data = {
      RequestDepartmentID: department.DepartmentID,
      RequestIsTop: 1
    };

    httpHandlerService.getDoctorByDepartmentIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body != null && response.Body.UserList.length > 0) {
          readFile.selectedDepartment.UserList = response.Body.UserList;
          department.UserList = response.Body.UserList;

          if (callBack != null) {
            callBack(response.Body.UserList);
          }
        }
        else {
          console.error("没有任何人员");
        }

        // loading
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.error(response);
      }
    );
  };

  return service;
});

HosReadImgDetailModule.controller("HosReadImgDetailController", function ($scope, $ionicHistory,$state,$ionicHistory, HosReadImgDetailService, enumFactory, commonFunctionFactory, paginationService, resourceService, userService) {

  $scope.goBack = function () {
    $ionicHistory.goBack();
  };
  // 初始化
  $scope.initialize = function () {
    $scope.system = "0";
    $scope.currentUser = userService.getUser().Body;
    // todo 暂时只判上下级医院
    $scope.canReadFile = $scope.currentUser.IsTop == 0;

    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginDate: commonFunctionFactory.displayText.DateToTimeText(beginDate),
      EndDate: commonFunctionFactory.displayText.DateToTimeText(endDate),
      BeginDateText: commonFunctionFactory.displayText.DateToDayText(beginDate),
      EndDateText: commonFunctionFactory.displayText.DateToDayText(endDate),
      Keyword: ""
    };

    HosReadImgDetailService.getDepartmentControlList({
      "ReceiveCustomerID": "gy3y",
      "ModuleType": 2
    },$scope);
    $scope.search();
  };

  /*搜索事件*/
  $scope.search = function () {
    HosReadImgDetailService.getReadFileList($scope.searchPar, $scope);
  };

  /*自定义查询事件*/
  $scope.customSearch = function () {
    $scope.searchPar.BeginDate = $scope.searchPar.BeginDateText + " 00:00:00";
    $scope.searchPar.EndDate = $scope.searchPar.EndDateText + " 23:59:59";
    $scope.search();
  };

  /*更多查询按钮*/
  $scope.isTrue = false;
  $scope.toggle = function () {
    $scope.isTrue = !$scope.isTrue;
  };

  // 弹出新增读片
  $scope.showAddReadFile = function () {
    $scope.cleanModal();
    $('#addReadFileDiv').modal('show');
  };

  /*清空新增读片*/
  $scope.cleanModal = function () {
    $scope.addedReadFile = {
      CreatorID: $scope.currentUser.User.UserID,
      CreatorName: $scope.currentUser.User.Name,
      selectedDepartment: {},
      Status: 1
    };
    $scope.uploadedFiles = [];
  };

  // 保存新增读片
  $scope.addReadFile = function () {
    HosReadImgDetailService.addReadFile($scope);
  };

  /*点击读片详情*/
  $scope.showReadFileDetail = function (item) {
    $scope.updatedReadFile = $rootScope.updatedReadFile;
    $scope.updatedReadFile = $rootScope.updatedReadFile.selectedDepartment;
    /* $scope.updatedReadFile = JSON.parse(JSON.stringify(item));
     $scope.updatedReadFile.selectedDepartment = {};*/
    for (var i = 0; i < $scope.topCustomer.length; i++) {
      var departmentCategory = $scope.topCustomer[i];
      for (var j = 0; j < departmentCategory.DepartmentList.length; j++) {
        var department = departmentCategory.DepartmentList[j];
        if ($scope.updatedReadFile.ReadFile.ReceiverType == 0) {
          for (var k = 0; k < department.UserList.length; k++) {
            var user = department.UserList[k];
            if (user.UserID == $scope.updatedReadFile.ReadFile.ReceiverID) {
              $scope.updatedReadFile.selectedDepartment.DepartmentID = department.Department.DepartmentID;
              $scope.updatedReadFile.selectedDepartment.Name = department.Department.Name;
              $scope.updatedReadFile.selectedDepartment.UserList = department.UserList;
              $scope.updatedReadFile.Doctor = user;
              break;
            }
          }
        } else {
          if (department.Department.DepartmentID == $scope.updatedReadFile.ReadFile.ReceiverID) {
            $scope.updatedReadFile.selectedDepartment.DepartmentID = department.Department.DepartmentID;
            $scope.updatedReadFile.selectedDepartment.Name = department.Department.Name;
            $scope.updatedReadFile.selectedDepartment.UserList = department.UserList;
            break;
          }
        }
      }
    }
    //$('#updateReadFileDiv').modal('show');
  };

  // 删除读片
  $scope.deleteReadFile = function (item) {
    // $scope.updatedReadFile=$rootScope.updatedReadFile;
    $scope.updatedReadFile = JSON.parse(JSON.stringify(item));
    $scope.updatedReadFile.ReadFile.State = 2;
    HosReadImgDetailService.updateReadFileToDatabase($scope);
    $state.go("communityReadImg");
  };

  // 确认读片
  $scope.confirmReadFile = function (item, status) {
    $scope.updatedReadFile = JSON.parse(JSON.stringify(item));
    $scope.updatedReadFile.ReadFile.Status = status;
    $scope.updatedReadFile.ReadFile.ConfirmorID = $scope.currentUser.User.UserID;
    $scope.updatedReadFile.ReadFile.ConfirmorName = $scope.currentUser.User.Name;
    $scope.updatedReadFile.ReadFile.ConfirmTime = commonFunctionFactory.displayText.DateToTimeText(new Date);
    HosReadImgDetailService.updateReadFileToDatabase($scope);
  };

  // 更新读片
  $scope.updateReadFile = function (item) {
    HosReadImgDetailService.updateReadFile($scope);
    $state.go("communityReadImg");

  };


  $scope.focusShow = function ($event, id) {
    resourceService.focusShow($event, id);
  };

  $scope.blurHide = function (name, id) {
    resourceService.blurHide(name, id);
  };

  // 选择li
  $scope.selectLi = function (li) {
    li.show = !li.show;
  };

  // 选择具体部门
 /* $scope.selectDepartment = function (readFile, department) {
    readFile.selectedDepartment.DepartmentID = department.Department.DepartmentID;
    readFile.selectedDepartment.Name = department.Department.Name;
    readFile.selectedDepartment.UserList = department.UserList;
  };*/
  $scope.selectDepartment = function (readFile, department) {
    readFile.selectedDepartment.DepartmentID = department.DepartmentID;
    readFile.selectedDepartment.Name = department.Name;
    if (department.UserList == null || department.UserList.length == 0) {
      ComReadImgDetailService.getDoctorByDepartmentID(department, readFile, $scope);
    } else {
      readFile.selectedDepartment.UserList = department.UserList;
    }
  };

  //时间
  $scope.DateToDayText = function (date) {
    return commonFunctionFactory.displayText.DateToDayText(date);
  };

  // 读片状态
  $scope.ShowStatus = function (status) {
    if (status == 2) {
      return "已收到";
    } else if (status == 3) {
      return "已完成";
    }

    return "已申请";
  };

  $scope.initialize();
});

angular.bootstrap($("#HosReadImgDetail"), ["HosReadImgDetailModule"]);
