angular.module('bookControllers', ['bookService'])

  //主控制器
  .controller('bookController', function ($scope, $ionicHistory, service, $state) {

    //初始化
    $scope.initialize = function () {
      $scope.showDoctor = false;
      $scope.user = {};
      $scope.bookInfo = {};
      $scope.deptIntro = {};
    };

    $scope.goToBook = function () {
      //获取科室列表
      service.getDepartment($scope);
      $state.go("book");
    };

    //回到上一页
    $scope.goBack = function () {
      $ionicHistory.goBack();
    };

    $scope.initialize();
  })

  .controller('HomeCtrl', function ($scope, $state, $ionicSlideBoxDelegate) {
    $scope.initialize = function () {
    };
    $scope.initialize();
  })

  .controller('registerCtrl', function ($scope, service, $state, $rootScope, $ionicHistory) {
    $scope.initialize = function () {
      $scope.updatePatient = $rootScope.updatePatient;
      var data = {CustomerID: $scope.updatePatient.ReplyCustomer.CustomerID}
      //初始化
      $rootScope.bookInfo = {};
      service.getDepartmentCanOrderLocalRequest(data, $scope);
    };

    $scope.goBack = function () {
      $ionicHistory.goBack();
    };
    console.log($scope.RequestDepartmentID);
    //搜索医生
    $scope.CreachUser = function () {
      console.log($scope.CreachUserName);
      var data = {RequestDepartmentID: $scope.RequestDepartmentID, RequestDoctorName: $scope.CreachUserName};
      service.getDoctorByDepartmentIDRequest(data, $scope);
      console.log(data);
    };

    //点击科室查询医生
    $scope.CheckDoctor = function (Department, index) {
      $scope.DepartmentIndex = index;
      $scope.RequestDepartmentID = Department.DepartmentID;
      $scope.RequestDepartmentName = Department.Name;
      $scope.SelectDoctor = 0;
      var data = {RequestDepartmentID: $scope.RequestDepartmentID};
      service.getDoctorByDepartmentIDRequest(data, $scope);
    };

    //点击医生
    $scope.CheckAppointmentDoctor = function (doctor, RequestDepartmentID, index) {
      $scope.TimeRegInfo = []; //清除预约时间列表
      $state.go("bookTime");
      var today = new Date();
      var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() + 1, 0, 0, 0);
      var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() + 7, 23, 59, 59);
      $rootScope.index = index;
      $rootScope.RequestDepartmentID = RequestDepartmentID;
      $rootScope.doctor = doctor;
      $scope.DoctorIndex = index;
      var data = {
        deptId: RequestDepartmentID,
        doctorId: doctor.RemoteID,
        startDate: resources.displayText.DateToDayText(beginDate),
        endDate: resources.displayText.DateToDayText(endDate)
      };
      $scope.doctorId = doctor.RemoteID;
      service.getRegInfoBeCurrentRequest(data, $scope);
    };

    //获取预约时间等信息并跳转到选择时间页面
    $scope.goToBookTime = function (doctor) {
      service.getRegInfo($scope, doctor, $rootScope);
      $scope.regInfo = $rootScope.regInfo;
      $rootScope.bookInfo.doctorName = doctor.doctorName;
      $rootScope.bookInfo.doctorId = doctor.doctorId;
      $state.go("bookTime");
    };

    $scope.initialize();

  })

  .controller('CenterCtrl', function ($scope) {
    $scope.settings = {
      enableFriends: true
    };
  })

  .controller('loginCtrl', function ($scope, service) {
  })

  .controller('myBookCtrl', function ($scope) {
  })

  .controller('bookTimeCtrl', function ($scope, $rootScope, $state, $ionicHistory, service) {
    $scope.goBack = function () {
      $state.go("book");
    };

    $scope.initialize = function () {
      $scope.dayIndex = 0;
      $($("#check-date li")[0]).addClass("bg-light-blue");
      $scope.RequestDepartmentName = $rootScope.RequestDepartmentName;
      var today = new Date();
      var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
      var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() + 6, 23, 59, 59);
      $scope.DoctorIndex = $rootScope.index;
      $scope.RequestDepartmentID = $rootScope.RequestDepartmentID;
      $scope.doctorId = $scope.doctor.RemoteID;
      $rootScope.doctorId = $scope.doctorId;
      console.log($scope.doctor);
    };

    //绑定数据
    $scope.TimeRegInfoAppointment = function (reg, doctorName) {
      $scope.TimeRegInfo = reg.timeRegInfo;
      $scope.doctorName = doctorName;
      $scope.regDate = reg.regDate;
    };

    //点击医生加载预约挂号详情
    $scope.ShowAddAppointment = function (timeReg, doctorName, doctorTitle, regDate) {
      $state.go("bookPage");
      $rootScope.timeReg = timeReg;
      $rootScope.doctorName = doctorName;
      $rootScope.doctorTitle = doctorTitle;
      $rootScope.regDate = regDate;

      $scope.RegTestInfo = {
        doctorName: doctorName,
        doctorTitle: doctorTitle,
        regDate: regDate,
        startTime: timeReg.startTime,
        endTime: timeReg.endTime,
        timeRegisterTypeName: timeReg.timeRegisterTypeName
      };
      $scope.regFee = timeReg.regFee;
      $scope.timeFlag = timeReg.timeFlag;
      $scope.gbFee = timeReg.gbFee;
      $scope.treatFee = timeReg.treatFee;
      $scope.updatePatient = $rootScope.updatePatient;
    };

    //进入预约信息详情页
    $scope.goToBook = function (item) {
      $rootScope.bookInfo.startTime = item.startTime;
      $rootScope.bookInfo.endTime = item.endTime;
      $rootScope.bookInfo.timeRegisterTypeName = item.timeRegisterTypeName;
      $rootScope.bookInfo.timeFlag = item.timeFlag;
      $rootScope.bookInfo.gbFee = item.gbFee;
      $rootScope.bookInfo.treatFee = item.treatFee;
      $rootScope.bookInfo.regFee = item.regFee;
      $rootScope.bookInfo.userIdType = '01';
      $state.go("bookPage");
    };

    $scope.initialize();
  })
  .controller('bookPageCtrl', function ($scope, $state, service, $rootScope, $ionicHistory) {
    $scope.initialize = function () {
      $scope.timeReg = $rootScope.timeReg;
      $scope.doctorName = $rootScope.doctorName;
      $scope.doctorTitle = $rootScope.doctorTitle;
      $scope.regDate = $rootScope.regDate;
      $scope.RequestDepartmentName = $rootScope.RequestDepartmentName;
      $scope.doctorId = $rootScope.doctorId
      $scope.RegTestInfo = {
        doctorName: $scope.doctorName,
        doctorTitle: $scope.doctorTitle,
        regDate: $scope.regDate,
        startTime: $scope.timeReg.startTime,
        endTime: $scope.timeReg.endTime,
        timeRegisterTypeName: $scope.timeReg.timeRegisterTypeName
      };
      $scope.regFee = $scope.timeReg.regFee;
      $scope.timeFlag = $scope.timeReg.timeFlag;
      $scope.gbFee = $scope.timeReg.gbFee;
      $scope.treatFee = $scope.timeReg.treatFee;
    }

    $scope.goBack = function () {
      $ionicHistory.goBack();
    }

    $scope.goToSuccess = function () {
      service.addOrder($scope, $rootScope.bookInfo, $rootScope);
      $state.go("bookSuccess");
    };

    //提交绿色通道预约
    $scope.addAppointmentRegInfo = function () {
      var data = {
        deptId: $scope.RequestDepartmentID,
        deptName: $scope.RequestDepartmentName,
        doctorId: $scope.doctorId,
        doctorName: $scope.RegTestInfo.doctorName,
        regDate: $scope.RegTestInfo.regDate,
        timeFlag: $scope.timeFlag,
        startTime: $scope.RegTestInfo.startTime,
        endTime: $scope.RegTestInfo.endTime,
        patientCard: "",
        userIdType: "01", //默认身份证
        userIdCard: $scope.updatePatient.Patient.IdentityCard,
        userName: $scope.updatePatient.Patient.Name,
        userGender: $scope.updatePatient.Patient.Gender == 1 ? "M" : "F",
        userMobile: $scope.updatePatient.Patient.Phone,
        userBirthday: $scope.updatePatient.Patient.Birthday,
        orderType: "0",  //默认网站
        regFee: $scope.regFee,
        treatFee: $scope.treatFee,
        gbFee: $scope.gbFee,
        userId: $scope.updatePatient.DiagnosisAsk.DiagnosisAskID,
        ModuleNo: "M002"
      };
      service.InsertaddOrderBeCurrentRequest(data, $scope);
    };

    $scope.initialize();
  })

  .controller('bookSuccessCtrl', function ($scope, $state) {
    $scope.goToCenter = function () {

    }

  });
