var chatUtility=angular.module('chatUtilityModule',['UserModule']);
chatUtility.service('chatUtilityService',['userService',function (userService) {
  var service = {};
  /*----------------------内部方法---------------------------------*/
  var notification = window.Notification || window.mozNotification || window.webkitNotification || window.msNotification || window.webkitNotifications;
  if (!!notification) {
    notification.requestPermission(function (permission) {
      if (notification.permission !== "granted") {
        notification.permission = "granted";
      }
    });
  }


  // 桌面提醒功能
  var deskNotice = function (you_sender, nickName, you_msgContent, msgType, isFireMsg, isCallMsg, msgSender) {
    console.log("you_msgContent=" + you_msgContent + "；msgType=" + msgType + "；isCallMsg=" + isCallMsg);
    if (11 == msgType) {
      if (!notification) {
        return;
      }
    } else {
      if (!notification || !checkWindowHidden()) {
        return;
      }
    }
    var title;
    var body = '';
    if (!!you_sender || !!nickName) {
      if ('g' == you_sender.substr(0, 1)) {
        title = "群消息";
        if (!!nickName) {
          body = msgSender + ":";
        } else {
          body = you_sender + ":";
        }
      } else {
        if (!!nickName) {
          title = nickName;
        } else {
          title = you_sender;
        }
      }
    } else {
      title = "系统通知";
      body = you_msgContent;
    }
    if (isFireMsg) {
      body += "[阅后即焚消息]";
    } else if (isCallMsg) {
      body += you_msgContent;
    } else {
      if (1 == msgType) {
        body += you_msgContent;
      } else if (2 == msgType) {
        body += "[语音]";
      } else if (3 == msgType) {
        body += "[视频]";
      } else if (4 == msgType) {
        body += "[图片]";
      } else if (5 == msgType) {
        body += "[位置]";
      } else if (6 == msgType || 7 == msgType) {
        body += "[附件]";
      } else if (11 == msgType) {
        body += you_msgContent; //@群组，type为11的时候
      }
    }
    var instance = new notification(
      title, {
        body: body,
        icon: "../images/logo-blue.png"
      }
    );
    instance.onclick = function () {
    };
    instance.onerror = function () {
      console.log('notification encounters an error');
    };
    instance.onshow = function () {
      setTimeout(function () {
        instance.close();
      }, 3000);
    };
    instance.onclose = function () {
      console.log('notification is closed');
    };
  };

  // 获取hidden属性
  var checkWindowHidden = function () {
    var prefix = getBrowserPrefix();
    //不支持该属性
    if (!prefix) {
      return document['hidden'];
    }

    return document[prefix + 'Hidden'];
  };
  var getBrowserPrefix = function () {
    return 'hidden' in document ? null : function () {
      var r = null;
      ['webkit', 'moz', 'ms', 'o'].forEach(function (prefix) {
        if ((prefix + 'Hidden') in document) {
          return r = prefix;
        }
      });
      return r;
    }();
  };

  //消息监听
  var MsgReceiveListener=function (obj) {
    console.log('Receive message sender:[' + obj.msgSender + ']...msgId:[' + obj.msgId + ']...content[' + obj.msgContent + ']');
    if(obj.msgType == 12){
      if (obj.msgDomain == 1) {
        $("#notice").html(obj.msgSender + "正在输入……");
        return;
      } else if (obj.msgDomain == 0) {
        $("#notice").html("");
        return;
      } else if (obj.msgDomain == 2) {
        $("#notice").html(obj.msgSender + "正在录音");
        return;
      }
    }
    MsgReceiveHandle(obj);

    // 播放铃声
    // $("im_ring").play();
  };

  //视频状态监听
  var onCallMsgListener = function (obj) {
    console.log("-------obj.callId = " + obj.callId);
    console.log("-------obj.caller = " + obj.caller);
    console.log("-------obj.called = " + obj.called);
    console.log("-------obj.callType = " + obj.callType);
    console.log("-------obj.state = " + obj.state);
    console.log("-------obj.reason = " + obj.reason);
    console.log("-------obj.code = " + obj.code);
    var noticeMsg = ''; //桌面提醒消息
    if (obj.callType == 1) { //视频
      if (200 == obj.code) {
        if (obj.state == 1) { //收到振铃消息
          //本地播放振铃
          //document.getElementById("voipCallRing").play();
        } else if (obj.state == 2) { //呼叫中

        } else if (obj.state == 3) { //被叫接受
          document.getElementById("voipCallRing").pause();
          $("#advice").removeAttr('disabled');
          $("#title").show();
          //noticeMsg = "[接收视频通话]";
        } else if (obj.state == 4) { //呼叫失败 对主叫设定：自动取消，对方拒绝或者忙
          //$("#pop_videoView").hide();
          //  resourceService.showMessage("对方不在线，请稍等",1);
          document.getElementById("voipCallRing").pause();
          noticeMsg = "[视频通话结束]";
        } else if (obj.state == 5) { //结束通话  或者主叫取消（对被叫而言）
          document.getElementById("voipCallRing").pause();
          $("#buttons").html('');
          //noticeMsg = "[视频通话结束]";
        } else if (obj.state == 6) { //呼叫到达
          //  resourceService.confirmMessage("华山医院医生向您发起了远程会诊邀请！",function(){
          $("#room-wrap").show();
          $("#wait-wrap").hide();
          $("#personal-wait-wrap").hide();
          var str='<button class="green" id="cancelVoipCall" disabled><i><img src="../images/video/overVideo.jpg"/></i> 结束问诊</button> ' +
            '<button class="green disabled" id="advice" disabled><i><img src="../images/video/advice.png"/></i> 查看诊疗</button> ';
          $("#buttons").append(str);
          $("#cancelVoipCall").click(function () {
            cancelCall(obj.callId, obj.caller, obj.called);
          });
          $("#voiceCallDiv_audio").hide();
          answerCall(obj.callId, obj.caller, obj.called);
          //本地播放振铃
          //document.getElementById("voipCallRing").play();
          noticeMsg = "[视频呼叫]";
          // ,function(){
          //
          // });
        }
      } else {
        var str = '<pre>请求视频通话，请使用其他终端处理</pre>';
      }
    }

    //桌面提醒通知
    //if (!!noticeMsg) {
    //    deskNotice(obj.caller, '', noticeMsg, '', false, true);
    //}
  };

  //医生端接收消息内容处理
  var MsgReceiveHandle = function (obj) {
    var name = obj.senderNickName || obj.msgSender; // 发送者的名字
    var you_sender = obj.msgSender; //消息发送者

    // push消息的联系人，是否是当前展示的联系人
    var is_current_contact_you = createMsgHelp(you_sender);

    // 是否为mcm消息 0普通im消息 1 start消息 2 end消息 3发送mcm消息
    var you_msgContent = obj.msgContent;
    var content_type = 'C';
    var version = obj.msgId;

    if (0 == obj.mcmEvent) { // 0普通im消息
      var msgType = obj.msgType;
      var str = '';

      //消息类型1:文本消息 2：语音消息 3：视频消息 4：图片消息 5：位置消息 6：文件
      if (1 == msgType) {
        str=PushReceiveTextHtml(obj);
      }
      else if (2 == msgType) {
        //判断是否支持支持audio标签
        str = '<pre>您有一条语音消息,请用其他设备接收</pre>';
      }
      else if (3 == msgType) { // 3：视频消息
        str=PushReceiveVideoHtml(obj);
      }
      else if (4 == msgType) { // 4：图片消息
        str=PushReceiveImageHtml(obj);
      }
      else if (5 == msgType) { // 位置消息
      }
      else if (6 == msgType) { //压缩文件  仅支持火狐和谷歌浏览器
        str=PushReceiveZippedFileHtml(obj);
      }
      else if (7 == msgType) { // 非压缩文件
        str=PushReceiveFileHtml(obj);
      }
      //需要一个消息的发送着
      PushMsgHTML(msgType, you_sender, version, content_type, name, str,is_current_contact_you);

      //桌面提醒通知
      deskNotice(you_sender, name, you_msgContent, msgType, false, you_sender);
    }
  };

  //患者端接收消息处理
  var MsgReceiveHandleInApp=function (obj) {
    if(obj.msgSender=="systemOver"){
      IM.common.logout();
      return;
    }
    var name = obj.senderNickName || obj.msgSender; // 发送者的名字
    var you_sender = obj.msgSender; //消息发送者
    $(".chat-box").find('div[data-type="contact_you"]').remove();
    $(".chat-box").append('<div data-type="contact_you" style="display: none">"'+obj.msgSender+'"</div>');

    // 是否为mcm消息 0普通im消息 1 start消息 2 end消息 3发送mcm消息
    var content_type = 'C';
    var version = obj.msgId;

    if (0 == obj.mcmEvent) { // 0普通im消息
      var msgType = obj.msgType;
      var str = '';

      //消息类型1:文本消息 2：语音消息 3：视频消息 4：图片消息 5：位置消息 6：文件
      if (1 == msgType) {
        str=PushReceiveTextHtml(obj);
      }
      else if (2 == msgType) {
        //判断是否支持支持audio标签
        str = '<pre>您有一条语音消息,请用其他设备接收</pre>';
      }
      else if (3 == msgType) { // 3：视频消息
        str=PushReceiveVideoHtml(obj);
      }
      else if (4 == msgType) { // 4：图片消息
        str=PushReceiveImageHtml(obj);
      }
      else if (5 == msgType) { // 位置消息
      }
      else if (6 == msgType) { //压缩文件  仅支持火狐和谷歌浏览器
        str=PushReceiveZippedFileHtml(obj);
      }
      else if (7 == msgType) { // 非压缩文件
        str=PushReceiveFileHtml(obj);
      }
      //需要一个消息的发送着
      PushMsgHTML(msgType, you_sender, version, content_type, name, str,true);
    }
  };

  //拼接文本消息
  var PushReceiveTextHtml=function (obj) {
    // str = emoji.replace_unified(you_msgContent);
    var str = obj.msgContent;
    return str;
  };

  //拼接视视频消息
  var PushReceiveVideoHtml=function (obj) {
    var urlShow = obj.msgFileUrlThum; //小视频消息的缩略图地址
    var urlReal = obj.msgFileUrl;
    var windowWid = $(window).width();
    var imgWid = 0;
    var imgHei = 0;
    if (windowWid < 666) {
      imgWid = 100;
      imgHei = 150;
    } else {
      imgWid = 150;
      imgHei = 200;
    }
    var num = obj.msgFileSize;
    var size = 0;
    if (num < 1024) {
      size = num + "byte";
    }
    else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
      size = Number(num / 1024).toFixed(2) + "KB";
    }
    else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
      size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
    }
    else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
      size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
    }
    var str = '<div style="display:inline">' +
      '<img onclick="showContentImage(this)" videourl="' + urlReal + '" src="' + urlShow + '" style="cursor:pointer;max-width:' + imgWid + 'px;max-height:' + imgHei + 'px;" />' +
      '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
    return str;
  };

  //拼接图片消息
  var PushReceiveImageHtml=function (obj) {
    var url = obj.msgFileUrl;
    var windowWid = $(window).width();
    var imgWid = 0;
    var imgHei = 0;
    if (windowWid < 666) {
      imgWid = 60;
      imgHei = 80;
    } else {
      imgWid = 80;
      imgHei = 100;
    }
    var str= '<img src="' + url + '" style="cursor:pointer;max-width:' + imgWid + 'px; max-height:' + imgHei + 'px;" onclick="showContentImage(this)"/">';
    return str;
  };

  //拼接压缩文件消息
  var PushReceiveZippedFileHtml=function (obj) {
    var url = obj.msgFileUrl;
    var num = obj.msgFileSize;
    var size = 0;
    if (num < 1024) {
      size = num + "byte";
    }
    else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
      size = Number(num / 1024).toFixed(2) + "KB";
    }
    else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
      size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
    }
    else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
      size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
    }
    var fileName = obj.msgFileName;
    var str = '<div style="display:inline">' +
      '<a href="' + url + '" target="_blank">' +
      '<span>' +
      '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="../images/attachment_icon.png" />' +
      '</span>' +
      '<span>' + fileName + '</span>' +
      '</a>' +
      '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
    return str;
  };

  //拼接文件消息
  var PushReceiveFileHtml=function (obj) {
    var url = obj.msgFileUrl;
    var num = obj.msgFileSize;
    var size = 0;
    if (num < 1024) {
      size = num + "byte";
    }
    else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
      size = Number(num / 1024).toFixed(2) + "KB";
    }
    else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
      size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
    }
    else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
      size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
    }
    var fileName = obj.msgFileName;
    var str = '<div style="display:inline">' +
      '<a href="' + url + '" target="_blank">' +
      '<span>' +
      '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="../images/attachment_icon.png" />' +
      '</span>' +
      '<span>' + fileName + '</span>' +
      '</a>' +
      '<span style="font-size: small;margin-left:15px;">' + size + '</span>' +
      '</div>';
    return str;
  };

  //左侧联系人显示状态
  var createMsgHelp= function(you_sender) {
    // 处理联系人列表，如果新联系人添加一条新的到im_contact_list，如果已经存在给出数字提示
    var is_current_contact_you = false; // push消息的联系人(you_sender)，是否是当前展示的联系人
    $('#im_contact_list').find('tbody tr').each(function() {
      if (you_sender == $(this).attr('contact_you')) {
        if ($(this).hasClass('active')) {
          is_current_contact_you = true;
        }
      }
    });
    return is_current_contact_you;
  };

  //push 新联系人到左侧
  var addContactToList= function(contactVal, contactName, content_type, isNotice) {
    var old = $("#im_contact_" + contactVal);
    // 已存在
    if (!!old && old.length > 0) {
      return;
    }
    // 创建新的联系列表
    var active = '';
    var str='<li class="item-content" onclick="DO_chooseContactList(\'' + content_type + '\', \'' + contactVal + '\',' + 'true)" id="im_contact_' + contactVal + '" im_isnotice="' + isNotice + '" contact_type="' + content_type + '" contact_you="' + contactVal + '" class="' + active + '"">'+
      '<div class="item-avatar">'+
      '<span class="avatar avatar-tab avatar-random-bg-3">'+
      '<img src="img/contact_avatar.png">'+
      '</span>'+
      '</div>'+
      '<div class="item-text">'+
      '<p class="multi-row">'+
      '<span class="name">' + contactName + '</span>'+
      '<b contact_style_type="warn" class="time" style="display:none;">0</b>'+
      '<b contact_style_type="onlineState" class="time" style="display:none;">0</b>'+
      '</p>'+
      '</div>'+
      '</li>';
    $('#im_contact_list').append(str);
  };

  //push 接收消息到右侧
  var PushMsgHTML=function (msgtype, you_sender, version, content_type, name, you_msgContent,b) {
    var carousel = '';
    if (msgtype == 4 || msgtype == 3) {
      carousel = "real";
    }
    var str = '<div msg="msg" im_carousel="' + carousel + '" im_msgtype="' + msgtype + '" id="' + you_sender + '_' + version + '" content_type="' + content_type + '" content_you="' + you_sender + '" class="rj-message-wrap" style="display:block">' +
      '<img src="img/contact_avatar.png" class="avatar avatar-random-bg-3 rj-head-pic">' +
      '<span class="rj-triangle-left"></span>'+
      '<p class="rj-message">' + you_msgContent + '</p>'+
      '</div>';

    $('#im_content_list').append(str);

    setTimeout(function () {
      $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
    }, 100);
    // 右侧列表添加数字提醒
    var current_contact = $('#im_contact_' + you_sender);
    if (!current_contact.hasClass('active')) {
      var warn = current_contact.find('span[contact_style_type="warn"]');
      if ('99+' == warn.html()) {
        return;
      }
      var warnNum = parseInt((!!warn.html()) ? warn.html() : 0) + 1;
      if (warnNum > 99) {
        warn.html('99+');
      } else {
        warn.html(warnNum);
      }
      $(warn).css("visibility","visible");
    }
    if (you_msgContent) {
      // 消息类型提示，发完消息接收方隐藏即可
      $("#notice").html("");
    }
  };

  // 创建历史信息
  var createHistory = function (historyList, messageId) {
    if (historyList == null || historyList.length == 0) {
      return messageId;
    }

    var resultMessageID = "";
    for (var i = 0; i < historyList.length; i++) {
      resultMessageID = historyList[i].ID;
      var sender = historyList[i].SenderID;
      var senderName = historyList[i].SenderName; // 历史数据文件中没有 需要处理文件中插入数据库
      var receiver = historyList[i].ReceiverID;
      var msgType = historyList[i].ChatType;
      var content = historyList[i].Message;
      var sourceName = historyList[i].SourceName;
      var htmlContent = "";
      if (msgType == 0) {
        // 文字
        htmlContent = content;
      } else if (msgType == 1 && (content.indexOf(".jpeg") > 0 || content.indexOf(".jpg") > 0 || content.indexOf(".png") > 0)) {
        // 图片
        var url = content;
        var windowWid = $(window).width();
        var imgWid = 0;
        var imgHei = 0;
        if (windowWid < 666) {
          imgWid = 100;
          imgHei = 150;
        } else {
          imgWid = 150;
          imgHei = 200;
        }
        htmlContent = '<img src="' + url + '" style="cursor:pointer;max-width:' + imgWid + 'px; max-height:' + imgHei + 'px;" onclick="showContentImage(this)"/>';
      } else {
        var url = content;
        htmlContent = '<div style="display:inline"><a href="" fileurl="' + url + '" onclick="showContentImage(this)">' + '<span>' + '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="../images/attachment_icon.png" />' + '</span>'
          + '<span>' + sourceName + '</span>'
          + '</a></span></div>';
      }

      var str = "";
      //获取当前登陆人
      var currentUser=null;
      if(!!userService.getUser()){
        currentUser=userService.getUser().Body.User;
      }
      if (sender == currentUser.UserID) {
        var str = '<div msg="msg"  content_you="' + receiver + '" class="rj-message-wrap" style="display:block">' +
          '<img src="img/contact_avatar.png" class="avatar avatar-random-bg-2 rj-head-pic-right">' +
          '<span class="rj-triangle-right"></span>'+
          '<p class="rj-message-right">' + htmlContent + '</p>'+
          '</div>';
      } else {
        var str = '<div msg="msg"  content_you="' + receiver + '" class="rj-message-wrap" style="display:block">' +
          '<img src="img/contact_avatar.png" class="avatar avatar-random-bg-3 rj-head-pic">' +
          '<span class="rj-triangle-left"></span>'+
          '<p class="rj-message">' + htmlContent + '</p>'+
          '</div>';
      }

      $('#im_content_list').prepend(str);
      setTimeout(function () {
        $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
      }, 100);
    }
    return resultMessageID;
  };

  // 获取当前时间
  var generateTime = function () {
    var date = new Date();
    var year = date.getFullYear();
    var month = (date.getMonth() + 1).toString();
    if (month.length == 1) {
      month = "0" + month;
    }

    var day = date.getDate().toString();
    if (day.length == 1) {
      day = "0" + day;
    }

    var hour = date.getHours().toString();
    if (hour.length == 1) {
      hour = "0" + hour;
    }

    var minute = date.getMinutes().toString();
    if (minute.length == 1) {
      minute = "0" + minute;
    }

    var seconds = date.getSeconds().toString();
    if (seconds.length == 1) {
      seconds = "0" + seconds;
    }

    return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;
  };

  /*----------------------外部方法---------------------------------*/
  //初始化SDK
  service.initialize=function () {
    IM.common.initializeSDK(null, null, function(){
    }, function () {
    });
  };

  //SDK登陆
  service.loginSDK=function (sender,errorCallBack) {
    IM.common.login(sender, function () {
      IM.common.installListeners(MsgReceiveListener,null,null, null, onCallMsgListener, null);
    }, function () {
      if (errorCallBack != null) {
        errorCallBack();
      }
    });
  };
  //获取用户在线状态
  service.getUserStatus=function (list) {
    if (list.length > 0) {
      IM.common.getUserState(list, true, function (obj) {
        for(var i=0;i<obj.length;i++){
          $('#im_contact_list').find('tbody tr').each(function() {
            if($(this).attr("contact_you")== obj[i].useracc){
              if (obj[i].state == 1) { //1在线 2离线
                $(this).find('span[contact_style_type="onlineState"]').text('已报到');
              }
              return false;
            }
          })
        }
      }, function (obj) {
        console.error("错误码：" + obj.code + "; 错误描述：" + obj.msg);
      });
    }
  };
  // 发送内容处理
  service.preReplaceContentToDb = function (inputStr) {
    if (inputStr == undefined || inputStr == null || inputStr == '') {
      return inputStr;
    }
    var str = inputStr;
    str = str.replace(/<(div|br|p)[/]?>/g, '\u000A');
    str = str.replace(/\u000A+/g, '\u000D');
    str = str.replace(/<[^img][^>]+>/g, ''); // 去掉所有的html标记
    str = str.replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&amp;/g, '&').replace(/&nbsp;/g, ' ');
    if ('\u000D' == str) {
      str = '';
    }
    return str;
  };

  // 发送信息到容联云
  service.sendMsgToServer = function (im_send_content, content_you, messageId,successCallBack,errorCallBack) {
    // 发送消息至服务器
    var msgId = IM.chat.sendTextMsg(
      im_send_content,
      content_you,
      [],
      false,
      null,
      successCallBack,
      errorCallBack
    );
    var id = "#" + content_you + "_" + messageId;
    $(id).attr("id", content_you + "_" + msgId);
  };

  // 发送附件到容联云
  var sendAttachMsgToServer = function (oldMsgId, file, type, receiver,$scope) {
    var oldMsg = $(document.getElementById(receiver + '_' + oldMsgId));
    oldMsg.attr('msg', 'msg');
    oldMsg.css('display', 'block');
    if (4 == type) {
      oldMsg.attr('im_carousel', 'real');
      oldMsg.attr('im_msgtype', '4');
    }

    $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
    var msgId = IM.chat.sendFileMsg(
      file,
      type,
      receiver,
      false,
      function (obj) {
        setTimeout(function () {
          var id = "#" + receiver + "_" + obj.msgClientNo;
          var msg = $(id);
          msg.find('div[class="bar"]').parent().css('display', 'none');
          msg.find('span[imtype="msg_attach"]').css('display', 'block');
          $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
        }, 100);
      },
      function (obj) { // 失败
        setTimeout(function () {
          var msg = $("#" + receiver + "_" + obj.msgClientNo);
          msg.find('div[class="bar"]').parent().css('display', 'none');
          msg.find('span[imtype="msg_attach"]').css('display', '');
          console.log("错误码： " + obj.code + "; 错误描述：" + obj.msg);
          alert("发送附件失败");
        }, 100);
      },
      function (sended, total, msgId) { // 进度条
        setTimeout(function () {
          var msg = $("#" + receiver + "_" + msgId);
          // sended;//已发送字节数
          // total;//总字节数
          if (sended < total) {
            msg.find('div[class="bar"]').css('width', (sended / total * 100 + '%'));
          } else {
            msg.find('div[class="bar"]').parent().css('display', 'none');
            msg.find('span[imtype="msg_attach"]').css('display', 'block');
          }
        }, 100);
      });
    oldMsg.attr("id", receiver + '_' + msgId);
    if (file instanceof Blob) {
      oldMsg.find("object").val(file);
    }
  };

  // 发送信息添加到右侧样式
  service.addSendMsgHTML = function (msg,msgtype, msgid, content_type, content_you, im_send_content) {
    //im_send_content = emoji.replace_unified(im_send_content);
    var display = ('temp_msg' == msg) ? 'none' : 'block';
    var carousel = '';
    if (msgtype == 4 || msgtype == 3) {
      carousel = "real";
    }
    var str = '<div contactor="sender" im_carousel="' + carousel + '" msg="msg" im_msgtype="' + msgtype + '" id="' + content_you + '_' + msgid + '" content_type="' + content_type + '" content_you="' + content_you + '" class="rj-message-wrap" style="display:' + display + '">' +
      '<img src="img/contact_avatar.png" class="avatar avatar-random-bg-2 rj-head-pic-right">' +
      '<span class="rj-triangle-right"></span>'+
      '<p class="rj-message-right">' + im_send_content + '</p>'+
      '</div>';

    $('#im_content_list').append(str);
    $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
    return content_you + '_' + msgid;
  };

  // push监听到右侧样式
  service.addPushMsgHTML = function (msgtype, you_sender, version, content_type, name, you_msgContent) {
    PushMsgHTML(msgtype, you_sender, version, content_type, name, you_msgContent);
  };

  //切换消息内容
  service.ChooseContactList=function(contact_you) {
    // 清除列表选中状态class
    $('#im_contact_list').find('tbody tr').each(function() {
      $(this).removeClass('active');
    });
    var current_contact = document.getElementById("im_contact_" + contact_you);
    $(current_contact).addClass('active');
    var warn = $(current_contact).find('span[contact_style_type="warn"]');
    $(warn).css("visibility","hidden");
    warn.html(0);
    // 切换内容显示
    $('#im_content_list').find('div[msg="msg"]').each(function() {
      if ($(this).attr('content_you') == contact_you) {
        $(this).show();
      } else {
        $(this).hide();
      }
    });
    $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
  };

  //表情框显隐
  service.showOrHideEmojiDiv=function(){
    if ('none' == $('#emoji_div').css('display')) {
      $('#emoji_div').show();
    } else {
      $('#emoji_div').hide();
    }
  };

  // 读取历史数据
  service.createHistory = function (historyList, $scope) {
    $scope.historyMessages = historyList;
    $scope.historyMsgId = createHistory($scope.historyMessages, $scope.historyMsgId);
  };

  // 打开本地文件时触发本方法
  window.uploadFileToServer = function (id, oldMsgId) {
    var msg = $("#" + id);
    var oFile = msg.find('input[imtype="msg_attach_button"]')[0].files[0];
    var msgType = 0;
    console.log(oFile.name + ':' + oFile.type);
    window.URL = window.URL || window.webkitURL || window.mozURL || window.msURL;
    var url = window.URL.createObjectURL(oFile);
    var num = oFile.size;
    var size = 0;
    if (num < 1024) {
      size = num + "byte";
    } else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
      size = Number(num / 1024).toFixed(2) + "KB";
    } else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
      size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
    } else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
      size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
    }

    var receiver = msg.attr('content_you');
    if ("image" == oFile.type.substring(0, oFile.type.indexOf("/"))) {
      var windowWid = $(window).width();
      var imgWid = 0;
      var imgHei = 0;
      if (windowWid < 666) {
        imgWid = 100;
        imgHei = 150;
      } else {
        imgWid = 150;
        imgHei = 200;
      }

      var str = '<img imtype="msg_attach_src" src="' + url + '" style="max-width:' + imgWid + 'px; max-height:' + imgHei + 'px;" ' + ' onclick="showContentImage(this);" />';
      msg.find('a[imtype="msg_attach_href"]').replaceWith(str);
      msgType = 4;
    } else {
      msg.find('a[imtype="msg_attach_href"]').attr('href', url);
      msg.find('span[imtype="msg_attach_name"]').html(oFile.name);
      msg.find('a[imtype="msg_attach_href"]').next().html(size);
      msgType = 7;
    }

    sendAttachMsgToServer(oldMsgId, oFile, msgType, receiver);
    // blob文件没有后缀名 目前只有拍照 所以变为固定文件名
    if (!(oFile instanceof File) && oFile instanceof Blob) {
      oFile = new File([oFile], "拍照.jpg");
    }
    //获取当前登陆人
    var currentUser=null;
    if(!!userService.getUser()){
      currentUser=userService.getUser().Body.User;
    }
    uploadFile(oFile, generateTime(), receiver, 0, currentUser!=null?currentUser.UserID:'', currentUser!=null?currentUser.Name:'');
  };

  // 显示原图
  window.showContentImage = function (img) {
    var src = $(img).attr("videourl") != null && $(img).attr("videourl") != "" ? $(img).attr("videourl") : $(img).attr("src");
    window.open(src);
  };


  //发起视频
  service.videoCall = function (sender, receiver) {
    var receiver = receiver;
    var view = document.getElementById("receivedVideo");
    var localView = document.getElementById("localVideo");
    localView.muted = true;
    IM.video.videoCall(receiver, view, localView, function (callId, receiver) {//视频发起成功回调
      $("#buttons").html('');
      var str=' <button class="green" id="cancelVoipCall"><i><img src="../images/video/overVideo.jpg"/></i> 结束问诊</button> ' +
        '<button class="green" id="advice" disabled><i><img src="../images/video/advice.png"/></i> 填写反馈意见</button> ';
      $("#buttons").append(str);
      $("#cancelVoipCall").click(function () {
        cancelCall(callId, sender, receiver);
      });
      $("#voiceCallDiv_audio").hide();
    }, function (obj) {//视频发起失败回调
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
      $("#buttons").html('');
    });
  };


  /*----------------------视频通讯相关---------------------------------*/




  //接受视频
  var answerCall = function (callId, caller, called) {
    document.getElementById("voipCallRing").pause();
    //设置页面view句柄
    var view = document.getElementById("receivedVideo");
    var localView = document.getElementById("localVideo");
    localView.muted = true;
    IM.video.answerCall(view, localView, callId, caller, called, function () {
    }, function (obj) {
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
    });
    $("#cancelVoipCall").removeAttr("disabled");
    $("#advice").removeAttr("disabled");
    $("#title").show();
  };

  //拒绝视频
  var refuseCall = function (callId, caller, called) {
    document.getElementById("voipCallRing").pause();
    IM.video.refuseCall(callId, caller, function () {
      //$("#pop_videoView").hide();
      $("#videoHandle").remove()
    }, function (obj) {
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
    });
  };

  //取消视频
  var cancelCall = function (callId, caller, called) {
    document.getElementById("voipCallRing").pause();
    IM.video.cancelCall(callId, caller, called, function () {
      $("#buttons").html('');
    }, function (obj) {
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
    });
  };
  return service;

}]);
