var sessionControl;
var resource = angular.module("resourceModule", []);
resource.factory('enumFactory', function () {
  var factory = {};
  factory.checkType = {
    //必填项
    Required: 0,
    //手机号
    Mobile: 1,
    //邮箱
    Email: 2,
    //身份证
    Identify: 3,
    //大于0的正整数
    Number: 4,
    //邮编
    PostCode: 5,
    //日期
    DateFormat: 6
  };
  /*性别列表*/
  factory.GenderList = [{
    Value: 1,
    Text: "男"
  }, {
    Value: 0,
    Text: "女"
  }];

  //转院类型
  factory.AskType = [{
    Value: 0,
    Text: "门诊"
  }, {
    Value: 1,
    Text: "住院"
  }];
  /* , {
   Value: 2,
   Text: "生殖"
   }
   */
  //查找类型
  factory.SearchType = [
    {
      Value: 0,
      Text: "全部"
    },
    //}, {
    //  Value: 1,
    //  Text: "门诊"
    //}, {
    //  Value: 2,
    //  Text: "住院"
    //}, {
    //  Value: 3,
    //  Text: "生殖"
    //},
    {
      Value: 4,
      Text: "今日"
    }, {
      Value: 5,
      Text: "最新"
    }];

  //人员类型
  factory.PatientTypeList = [{
    Value: 0,
    Text: "自费"
  }, {
    Value: 1,
    Text: "城居医保"
  }, {
    Value: 2,
    Text: "职工医保"
  }, {
    Value: 3,
    Text: "公费"
  }];

  /*状态*/
  factory.StateList = [{
    Value: 0,
    Text: "激活"
  }, {
    Value: 1,
    Text: "冻结"
  }];

  /*患者状态*/
  factory.PatientStatusList = [{
    Value: 0,
    Text: "未提交"
  }, {
    Value: 1,
    Text: "待审批"
  }, {
    Value: 2,
    Text: "审批退回"
  }, {
    Value: 3,
    Text: "已审批"
  }];

  /*生殖模块*/
  factory.ReproductionModelList = [{
    Value: 0,
    Text: "婚育史"
  }, {
    Value: 1,
    Text: "月经史"
  }, {
    Value: 2,
    Text: "相关检查和手术"
  }];

  return factory;
});

/*共同方法*/
resource.factory('commonFunctionFactory', function (enumFactory, $location) {
  var factory = {};
  // 校验
  factory.validate = {
    //数据格式校验
    checkFormat: function (data, type, notRequired) {
      if (data == undefined || data == "" || data == null) {
        if (notRequired) {
          return true;
        }

        return false;
      }

      switch (type) {
        case enumFactory.checkType.Required:
          return true;
        case enumFactory.checkType.Email:  //邮箱
          var reg = /^\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
          return reg.test(data);
        case enumFactory.checkType.Identify:  //身份证
          var reg = new RegExp("(^\d{18}$)|(^\d{15}$)");
          return reg.test(data);
        case enumFactory.checkType.Number:
          var reg = /^[0-9]*[1-9][0-9]*$/;
          return reg.test(data);
        case enumFactory.checkType.Mobile:
          var reg = /^[1]+[3,4,5,8]+\d{9}/;
          return reg.test(data);
        case enumFactory.checkType.PostCode:
          var reg = /^\d{6}$/;
          return reg.test(data);
        case enumFactory.checkType.DateFormat://(YYYY/MM/DD)
          var reg = /^\d{4}(\-|\/|\.)\d{1,2}\1\d{1,2}$/;
          return reg.test(data);
        default :
          return false;
          break;
      }
    },

    //必填项校验(必须)
    validateRequired: function (val, element) {
      if (!factory.validate.checkFormat(val, enumFactory.checkType.Required)) {
        return "此项为必填项，请输入值！";
      }
      else {
        return true;
      }
    },

    //手机号校验(必须)
    validateMobile: function (val, element) {
      if (!factory.validate.checkFormat(val, enumFactory.checkType.Mobile)) {
        return "请输入有效的手机号！";
      }
      else {
        return true;
      }
    },

    //数字校验(必须)
    validateNumber: function (val, element) {
      if (!factory.validate.checkFormat(val, enumFactory.checkType.Number)) {
        return "请输入有效的数字！";
      }
      else {
        return true;
      }
    },

    //时间
    validateDateFormat: function (val, element) {
      if (!factory.validate.checkFormat(val, enumFactory.checkType.DateFormat)) {
        return "请选择时间";
      } else {
        return true;
      }
    }
  };
  // 时间
  factory.date = {
    createDateTimePicker: function (ids) {
      for (var i = 0; i < ids.length; i++) {
        var temp = $("#" + ids[i]);
        temp.datetimepicker({
          language: "zh-CN",
          todayHighlight: true,
          autoclose: true
        });
      }
    },
    createDatePicker: function (ids) {
      for (var i = 0; i < ids.length; i++) {
        var temp = $("#" + ids[i]);
        temp.datetimepicker({
          language: "zh-CN",
          todayHighlight: true,
          minView: 2,
          format: "yyyy-mm-dd",
          autoclose: true
        });
      }
    }
  };
  factory.displayText = {
    /*患者状态*/
    PatientStatusText: function (status) {
      switch (status) {
        case 0:
          return "未提交"
        case 1:
          return "待审批"
        case 2:
          return "审批退回"
        case 3:
          return "已审批"
        default:
          return "未知"
      }
    },
    PatientTypeList: function (type) {
      switch (type) {
        case 0:
          return "自费"
        case 1:
          return "城居医保"
        case 2:
          return "职工医保"
        case 3:
          return "公费"
      }
    }
    ,
    DiagnosisAskStatus: function (status) {
      switch (status) {
        case 0:
          return "未接诊"
        case 1:
          return "已接诊"
        case 2:
          return "已登记"
        case 3:
          return "已关闭"
      }
    },
    DiagnosisReplyStatus: function (status) {
      switch (status) {
        case 0:
          return "未接诊"
        case 1:
          return "已接诊"
        case 2:
          return "已关闭"
      }
    },
    AskTypeText: function (status) {
      switch (status) {
        case 0:
          return "门诊"
        case 1:
          return "住院"
        case 2:
          return "生殖"
      }
    },
    /*用户状态*/
    UserStateText: function (state) {
      switch (state) {
        case 0:
          return "有效"
        case 1:
          return "冻结"
        default:
          return "删除"
      }
    }, /*用户性别*/
    GenderText: function (Gender) {
      switch (Gender) {
        case 0:
          return "女"
        case 1:
          return "男"
      }
    },
    /*生殖状态*/
    ReproductiveStatusText: function (state) {
      switch (state) {
        case 0:
          return "新建"
        case 2:
          return "完结"
        case 3:
          return "拒绝"
        case 4:
          return "资料合格"
        case 5:
          return "资料有问题"
        case 6:
          return "有更新"
        default:
          return ""
      }
    },
    /*公告类型*/
    AnnounceTypeText: function (type) {
      switch (type) {
        case 0:
          return "系统公告"
        case 1:
          return "医务处公告"
      }
    },
    /*截取时间至年月日*/
    DateToDayText: function (date) {
      if (date == null) {
        return date;
      }

      var type = typeof(date);
      if (type == "string") {
        return date.length > 10 ? date.substr(0, 10) : date;
      } else if (type == "object") {
        var year = date.getFullYear();
        var month = (date.getMonth() + 1).toString();
        if (month.length == 1) {
          month = "0" + month;
        }

        var day = date.getDate().toString();
        if (day.length == 1) {
          day = "0" + day;
        }

        return year + "-" + month + "-" + day;
      } else {
        return "";
      }
    },
    /*截取时间至年月日时分秒*/
    DateToTimeText: function (date) {
      if (date == null) {
        return "";
      }

      var type = typeof(date);
      if (type == "string") {
        return date;
      } else if (type == "object") {
        var year = date.getFullYear();
        var month = (date.getMonth() + 1).toString();
        if (month.length == 1) {
          month = "0" + month;
        }

        var day = date.getDate().toString();
        if (day.length == 1) {
          day = "0" + day;
        }

        var hour = date.getHours().toString();
        if (hour.length == 1) {
          hour = "0" + hour;
        }

        var minute = date.getMinutes().toString();
        if (minute.length == 1) {
          minute = "0" + minute;
        }

        var seconds = date.getSeconds().toString();
        if (seconds.length == 1) {
          seconds = "0" + seconds;
        }

        return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;
      } else {
        return "";
      }
    }
  };
  // 跳转到login页面
  factory.goToLogin = function () {
    window.location.href = "index.html";
  };

  /*显示下拉框*/
  factory.focusShow = function ($event, id) {
    var e = $event.target;
    var width = e.offsetWidth;
    var height = e.offsetHeight;
    var left = 2 * (e.offsetLeft);
    var top = e.offsetTop;
    /*var left = e.scrollLeft;
     var top = e.scrollTop;*/
    $("#" + id).css({
      "left": left,
      "top": (top + height),
      "position": "absolute",
      "width": width / 2,
      "top": height,
      "z-index": 999,
      "height": height / 2


    });
    $("#" + id).slideDown("slow");
  };
  /*隐藏下拉框*/
  factory.blurHide = function (name, id) {
    $(document).click(function ($event) {
      var e = $event, obj = $(e.srcElement || e.target);
      if ($(obj).is("#" + id + "," + "#" + id + " *")) {
        var domParent = $($(obj)[0]).parent()[0];
        if ($(domParent).attr("class").indexOf("first") > -1 || $(domParent).attr("class").indexOf("second") > -1) {
          var brotherNodes = $($(domParent)[0]).siblings();
          if (brotherNodes != undefined && brotherNodes.length > 0) {
            for (var i = 0; i < brotherNodes.length; i++) {
              $(brotherNodes[i]).children("ul").slideUp("slow");
            }
          }
        }
      } else {
        if (!$(obj).is(".autoSelect[name=" + name + "]")) {
          $("#" + id).slideUp("slow");
        }
      }
    });
  };

  /*展开隐藏子菜单*/
  factory.inactiveClick = function ($event) {
    var e = $event.target;
    if ($(e).siblings('ul').css('display') == 'none') {
      $(e).parent('li').siblings('li').removeClass('inactives');
      $(e).addClass('inactives');
      $(e).siblings('ul').slideDown(100).children('li');
      if ($(e).parents('li').siblings('li').children('ul').css('display') == 'block') {
        $(e).parents('li').siblings('li').children('ul').parent('li').children('a').removeClass('inactives');
        $(e).parents('li').siblings('li').children('ul').slideUp(100);
      }
    } else {
      //控制自身变成+号
      $(e).removeClass('inactives');
      //控制自身菜单下子菜单隐藏
      $(e).siblings('ul').slideUp(100);
      //控制自身子菜单变成+号
      $(e).siblings('ul').children('li').children('ul').parent('li').children('a').addClass('inactives');
      //控制自身菜单下子菜单隐藏
      $(e).siblings('ul').children('li').children('ul').slideUp(100);
      //控制同级菜单只保持一个是展开的（-号显示）
      $(e).siblings('ul').children('li').children('a').removeClass('inactives');
    }
  };

  return factory;
});

resource.service('resourceService', function (commonFunctionFactory) {
  var Service = {};

  Service.focusShow = function ($event, id) {
    commonFunctionFactory.focusShow($event, id);
  };

  Service.blurHide = function (name, id) {
    commonFunctionFactory.blurHide(name, id);
  };

  Service.inactiveClick = function ($event) {
    commonFunctionFactory.inactiveClick($event);
  };
  //激活当前按钮
  Service.activeCurrentMenu = function (moduleNo) {
    $($("#sidebar").find("li[data-bind=" + moduleNo + "]")[0]).addClass("active-menu");
  };

  return Service;
});

/*sessionStorage*/
var sessionModule = angular.module("sessionModule", []);
sessionModule.factory('sessionFactory', function () {
  return {
    /*保存数据到session*/
    saveDataToSession: function (key, value) {
      var item = sessionStorage.getItem(key);
      if (item != null) {
        sessionStorage.removeItem(item)
      }

      if (value != null && value != '' && value != undefined) {
        sessionStorage.setItem(key, JSON.stringify(value));
      }
    },
    /*添加数据到session*/
    addDataToSession: function (key, value) {
      var item = sessionStorage.getItem(key);
      if (item != null) {
      }
      else {
        sessionStorage.setItem(key, JSON.stringify(value));
      }
    },
    /*删除session一个item*/
    deleteDataFromSession: function (key) {
      var item = sessionStorage.getItem(key);
      if (key != null) {
        sessionStorage.removeItem(key);
      }
    },
    /*获取某一个item*/
    getDataFromSession: function (key) {
      var item = sessionStorage.getItem(key);
      if (item != null) {
        item = JSON.parse(item);
      }

      return item;
    }
  }
});

/*当前用户*/
var user = angular.module("UserModule", ["sessionModule", "resourceModule"]);
user.service('userService', function ($location, sessionFactory, commonFunctionFactory) {
  return {
    getUser: function () {
      if (!sessionFactory.getDataFromSession('CurrentUser')
        && $location.absUrl().lastIndexOf('index.html') < 0) {
        commonFunctionFactory.goToLogin();
      } else {
        var result = sessionFactory.getDataFromSession('CurrentUser');
        if (result != 'undefined') {
          return JSON.parse(result);
        }
        else {
          return null;
        }
      }
    },
    setUser: function (user) {
      sessionFactory.saveDataToSession('CurrentUser', JSON.stringify(user));
    },
    removeUser: function () {
      sessionFactory.deleteDataFromSession('CurrentUser');
    }
  }
});

/*请求和响应*/
var httpHandler = angular.module("httpHandlerModule", ["UserModule", "angularFileUpload", "sessionModule", "resourceModule"]);
httpHandler.config(function ($httpProvider) {
  $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
});

httpHandler.factory('resourceFactory', function () {
  //GYSY生产服务器
   var base = 'https://ehospital.gy3y.com:8021/api/';
   var fileDomain = 'https://ehospital.gy3y.com:8021/gy3yFile/File/';
   var groupPhotoDomain = 'https://ehospital.gy3y.com:8021/gy3yFile/GroupPhoto/';
   var readFileDomain = "https://ehospital.gy3y.com:8021/gy3yFile/ReadFile/";
   var bookDomain = 'https://ehospital.gy3y.com:8021/api/';
   var listReportDomain = "https://ehospital.gy3y.com:8021/gy3yFile/LisReportImage/";
   var AskChatDomain = "https://ehospital.gy3y.com:8021/gy3yFile/AskChat/";

  ////本地服务器
 /* var base = 'http://192.192.192.114:8021/api/';
  var fileDomain = 'http://192.192.192.114:8021/gy3yFile/File/';
  var groupPhotoDomain = 'http://192.192.192.114:8024/GroupPhoto/';
  var readFileDomain = "http://192.192.192.114:8024/ReadFile/";
  var bookDomain = 'http://192.192.192.114:8021/api/';
  var listReportDomain = "http://192.192.192.114:8021/gy3yFile/LisReportImage/";
  var AskChatDomain = "http://192.192.192.114:8024/AskChat/";
  var reproductionDomain = "http://192.192.192.114:8021/gy3yFile/ReproductiveFile/";*/

  //阿里云地址
  /* var base = 'http://120.27.25.112:8021/api/';
   var fileDomain = 'http://120.27.25.112:8024/File/';
   var groupPhotoDomain = 'http://120.27.25.112:8024/GroupPhoto/';
   var readFileDomain = "http://192.192.192.56:8024/ReadFile/";*/
  return {
    requestBody: function (token, operateCode, date, timestamp) {
      return {
        'Header': {
          "Token": token,
          "StatusCode": 0,
          "Message": null,
          "OperateCode": operateCode,
          "TimeStamp": timestamp
        },
        'Body': date
      }
    },
    address: {
      login: base + "Login/Login",
      sendSMS: base + "Tenant/SendSMS",
      user: base + "User/UserCURD",
      medicalDepartment: base + "User/UserCURD",
      patient: base + "Patient/PatientCURD",
      diagnosisPatient: base + "Patient/GetPatientChoose",
      customer: base + "Customer/CustomerCURD",
      topCustomerChoose: base + "Customer/GetCustomerChoose",
      customerChoose: base + "Customer/GetCustomerChoose",
      customerImage: base + "Customer/LogoUpload",
      diagnosisReply: base + "DiagnosisReply/DiagnosisReplyCURD",
      diagnosisAsk: base + "DiagnosisAsk/DiagnosisAskCURD",
      neteaseMessage: base + "NeteaseMessage/NeteaseMessage",
      chat: base + "Chat/ChatCURD",
      uploadFileUrl: base + "File/UploadFile",
      uploadImageUrl: base + "File/UploadImage",
      uploadGroupPhoto: base + "Chat/UploadGroupPhoto",
      fileDomain: fileDomain,
      groupPhotoDomain: groupPhotoDomain,
      getDoctorGroupByDepartment: base + "User/GetDoctorGroupByDepartment",
      getListByGroupID: base + "Chat/GetListByGroupID",
      removeByGroupID: base + "Chat/RemoveByGroupID",
      chatMessage: base + "ChatMessage/ChatMessageCURD",
      getUnreadList: base + "ChatMessage/GetUnread",
      chatRead: base + "ChatRead/ChatReadCURD",
      uploadReadFile: base + "ReadFile/FileUpload",
      readFileDomain: readFileDomain,
      readFileDomain: readFileDomain,
      readFile: base + "ReadFile/ReadFileCURD",
      readFileDetail: base + "ReadFileDetail/ReadFileDetailCURD",
      department: base + "Department/GetDepartmentChoose",
      getAllDepartmentChoose: base + "Department/GetAllDepartmentChoose",
      getDoctorByDepartmentID: base + "User/GetDoctorByDepartmentID",
      departmentControl: base + "DepartmentControl/DepartmentControlCURD",
      GetListByFirstDoctorID: base + "DiagnosisAsk/GetListByFirstDoctorID",
      getPatientDetailByID: base + "Patient/GetPatientInfoByPatientID",
      feedback: base + "Feedback/FeedbackCURD",
      announce: base + "Announce/AnnounceCURD",
      announceList: base + "Announce/GetList",
      //医生接诊单等待接诊
      topAssign: base + "DiagnosisAsk/TopAssign",
      getDepartment: bookDomain + "User/GetDoctorByDepartmentID",

      //getDoctor: bookDomain + "ReqToHisService/getDoctorInfo",
      //getDoctor: bookDomain + "ReqToHis/getDoctorList",
      //getDoctor: bookDomain + "User/GetDoctorByDepartmentID",

      //getRegInfo: bookDomain + "ReqToHisService/getRegInfo",
      getRegInfo: bookDomain + "ReqToHis/getRegInfo",

      //addOrder: bookDomain + "ReqToHisService/addOrder"
      addOrder: bookDomain + "ReqToHis/addOrder",

      //  预约借口
      getRegInfoBeCurrent: base + "CustomOrder/GetRegInfoBeCurrent",
      addOrderBeCurrent: base + "CustomOrder/AddOrderBeCurrent",
      getDepartmentCanOrderLocal: base + "Department/GetDepartmentCanOrderLocal",

      //就诊卡
      cardList: base + "PatientCard/CardList",
      //患者接口
      getPatientInfo: base + "CustomOrder/GetPatientInfo",
      //检查报告
      getInspectReport: base + "IPushMasterDataService/GetPatientReport",
      //读取检查报告
      downloadInspectReport: base + "LisReport/DownloadReport2AsImage",
      // 获取检验报告
      getPatientsInfo: base + "LisReport/GetPatientsInfo",
      //  读取检验报告
      downloadReport2AsImage: base + "LisReport/DownloadReport2AsImage",
      //检验报告图片路径
      listReportDomain: listReportDomain,
      //会诊间获取医院
      GetCustomListGroup: base + "User/GetCustomListGroup",
      //会诊间科室
      GetDepartmentListGroupByCustom: base + "User/GetDepartmentListGroupByCustom",
      //会诊间医生
      GetDoctorListGroupByDepartment: base + "User/GetDoctorListGroupByDepartment",
      //网络问诊
      AskChatMessage: base + "AskChatMessage/ChatMessageCURD",
      AskChatUploadChatFile: base + "AskChat/UploadFile",
      askMessage: base + "ConsultMessage/ConsultMessageCURD",
      getConsult: base + "Consult/ConsultCURD",
      AskChatDomain: AskChatDomain,
      //修改密码
      resetPassword: base + "User/ResetPassword",
      //获取转诊筛选过的科室
      GetDepartmentSelect: base + "Department/GetDepartmentSelect",
      //获取验证码
      passwordResetSendCode: base + "User/PasswordResetSendCode",
      // 改密码
      passwordResetByPhone: base + "User/PasswordResetByPhone",
      //生殖
      reproductive: base + "Reproductive/ReproductiveCURD",
      //生殖上传图片
      //uploadReproductiveImage: base + "Reproductive/UploadImage",
      uploadReproductiveImage: base + "Reproductive/UploadFile",
      //reproductionDomain: reproductionDomain
    },
    operateCode: {
      nothing: 0,//非增删改查
      get: 1,//获取
      update: 2,//更新
      insert: 3//添加
    },
    statusCode: {
      Success: 0,
      NoLogin: 1,
      NoPermit: 2,
      NoData: 3,
      Exist: 4,
      ProgramError: 5,
      CatchError: 6,
      ParamError: 7
    }
  }
});

httpHandler.factory('httpFactory', function ($http, resourceFactory, userService, $location, sessionFactory, $upload, commonFunctionFactory, $ionicLoading) {
  var timestamp = (new Date()).valueOf();
  var factory = {};
  factory.getDomain = function () {
    var domain = $location.protocol() + '://' + $location.host() + ':' + $location.port();
    return domain + '/gy3y/WebPages/';
  };

  factory.getToken = function () {
    /*if ($location.absUrl().lastIndexOf('index.html') > 0) {
     return "";
     }*/

    var currentUser = userService.getUser();
    if (currentUser != null) {
      //currentUser = JSON.parse(currentUser);
      return currentUser.Header.Token;
    } else {
      return "";
    }
  };
  /*读片*/
  factory.uploadReadFileRequest = function (data, successCallback, errorCallback) {
    factory.baseUploadRequest(resourceFactory.address.uploadReadFile, data, successCallback, errorCallback);
  };
//读片申请
  factory.readFileRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.readFile, operateCode, data,
      successCallback, errorCallback);
  };

  factory.readFileDetailRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.readFileDetail, operateCode, data,
      successCallback, errorCallback);
  };

  factory.baseRequest = function (address, operateCode, data, successCallback, errorCallback) {
    var removeSession = function () {
      $ionicLoading.hide();
      sessionFactory.deleteDataFromSession('CurrentUser');
    };

    $ionicLoading.show({
      content: 'Loading',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });

    clearInterval(sessionControl);
    sessionControl = setInterval(removeSession, 3600000);
    var requestBody = resourceFactory.requestBody(factory.getToken(), operateCode, data, timestamp);
    $http.post(address, requestBody).success(function (response) {
      if (response.Header.TimeStamp != timestamp) {
        return;
      }
      //判断状态为登陆超时跳转登陆页面
      if (response.Header.StatusCode == 1) {
        commonFunctionFactory.goToLogin();
      }
      if (typeof(successCallback) == 'function') {
        successCallback(response);
      }
      else {
        console.log('此处应是函数');
        throw ('successCallback');
      }
      $ionicLoading.hide();
    }).error(function (response) {
      $ionicLoading.hide();
      if (typeof(errorCallback) == 'function') {
        errorCallback(response);
      }
      else {
        console.log('此处应该是函数');
        throw ('errorCallback');
      }
    });
  };

  factory.baseUploadRequest = function (url, data, successCallback, errorCallback) {
    var temp = {
      Token: factory.getToken(),
      TimeStamp: timestamp
    };
    $upload.upload({
      url: url,
      file: data,
      data: temp
    }).success(function (data) {
      if (typeof(successCallback) == 'function') {
        successCallback(data);
      } else {
        console.log('回调函数应该是个方法');
        throw ('successCallback');
      }
    }).error(function (data) {
      if (typeof(errorCallback) == 'function') {
        errorCallback(data);
      } else {
        console.log('回调函数应该是个方法');
        throw ('successCallback');
      }
    });
  };

  factory.uploadFilesRequest = function (data, successCallback, errorCallback) {
    factory.baseUploadRequest(resourceFactory.address.uploadFileUrl, data, successCallback, errorCallback);
  };

  factory.uploadGroupPhotoRequest = function (data, successCallback, errorCallback) {
    factory.baseUploadRequest(resourceFactory.address.uploadGroupPhoto, data, successCallback, errorCallback);
  };

  //登录请求
  factory.loginRequest = function (data, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.login, resourceFactory.operateCode.nothing, data,
      successCallback, errorCallback);
  };

  //获取邀请码
  factory.verifyCodeRequest = function (data, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.sendSMS, resourceFactory.operateCode.nothing, data,
      successCallback, errorCallback);
  };

  //注册请求
  factory.registerRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.login, operateCode, data,
      successCallback, errorCallback);
  };

  //用户请求
  factory.userRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.user, operateCode, data,
      successCallback, errorCallback);
  };

  //患者请求
  factory.patientRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.patient, operateCode, data,
      successCallback, errorCallback);
  };

  //转院获取患者
  factory.diagnosisPatientRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.diagnosisPatient, operateCode, data,
      successCallback, errorCallback);
  };

  //合作医院请求
  factory.customerRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.customer, operateCode, data,
      successCallback, errorCallback);
  };

  //选择向上转诊医院
  factory.topCustomerChooseRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.topCustomerChoose, operateCode, data,
      successCallback, errorCallback);
  };

  //选择向上转诊医院
  factory.customerChooseRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.customerChoose, operateCode, data,
      successCallback, errorCallback);
  };

  //获取文件ImageBase
  factory.getImageBase = function (customerID) {
    return resourceFactory.address.customerImage + "/" + customerID + "/";
  };

  //向上转院请求
  factory.diagnosisAskRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.diagnosisAsk, operateCode, data,
      successCallback, errorCallback);
  };

  //向下转院请求
  factory.diagnosisReplyRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.diagnosisReply, operateCode, data,
      successCallback, errorCallback);
  };

  //短信消息请求
  factory.neteaseMessageRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.neteaseMessage, operateCode, data,
      successCallback, errorCallback);
  };

  //会诊间请求
  factory.chatRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.chat, operateCode, data,
      successCallback, errorCallback);
  };

  //获取文件base
  factory.getFileBase = function (customerID) {
    return resourceFactory.address.fileDomain + customerID + "/";
  };

  //获取层级用户数据
  factory.getDoctorGroupByDepartmentRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getDoctorGroupByDepartment, operateCode, data,
      successCallback, errorCallback);
  };
  //获取会诊间医院数据
  factory.getCustomListGroupRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.GetCustomListGroup, operateCode, data,
      successCallback, errorCallback);
  };

  //获取会诊间科室数据
  factory.getDepartmentListGroupByCustomRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.GetDepartmentListGroupByCustom, operateCode, data,
      successCallback, errorCallback);
  };

  //会诊间医生数据
  factory.getDoctorListGroupByDepartmentRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.GetDoctorListGroupByDepartment, operateCode, data,
      successCallback, errorCallback);
  };
  //向下转院请求
  factory.departmentRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.department, operateCode, data,
      successCallback, errorCallback);
  };
  //获取所有chat数据通过groupid
  factory.getListByGroupIDRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getListByGroupID, operateCode, data,
      successCallback, errorCallback);
  };

  //删除所有chat数据通过groupid
  factory.removeByGroupIDRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.removeByGroupID, operateCode, data,
      successCallback, errorCallback);
  };

  //chatMessage
  factory.chatMessageRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.chatMessage, operateCode, data,
      successCallback, errorCallback);
  };

  //getUnreadList
  factory.getUnreadListRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getUnreadList, operateCode, data,
      successCallback, errorCallback);
  };

  //chatRead
  factory.chatReadRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.chatRead, operateCode, data,
      successCallback, errorCallback);
  };

  //提交预约接口
  factory.addOrderBeCurrentRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.addOrderBeCurrent, operateCode, data,
      successCallback, errorCallback);
  };

  //获取预约挂号科室医生可预约详情
  factory.getRegInfoBeCurrentRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getRegInfoBeCurrent, operateCode, data,
      successCallback, errorCallback);
  };

  //获取绿色通道科室（排除未开放科室）
  factory.getDepartmentCanOrderLocalRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getDepartmentCanOrderLocal, operateCode, data,
      successCallback, errorCallback);
  };

  //获取所有科室
  factory.getAllDepartmentChooseRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getAllDepartmentChoose, operateCode, data,
      successCallback, errorCallback);
  };

  //获取科室人员
  factory.getDoctorByDepartmentIDRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getDoctorByDepartmentID, operateCode, data,
      successCallback, errorCallback);
  };

  // 科室权限
  factory.departmentControlRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.departmentControl, operateCode, data,
      successCallback, errorCallback);
  };

  //患者端获取科室
  factory.getDepartmentRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getAllDepartmentChoose, operateCode, data,
      successCallback, errorCallback);
  };

  //患者端获取医生
  factory.getDoctorRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getDoctorByDepartmentID, operateCode, data,
      successCallback, errorCallback);
  };

  //患者端获取预约信息
  factory.getRegInfoRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getRegInfo, operateCode, data,
      successCallback, errorCallback);
  };

  //患者端挂号申请
  factory.addOrderRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.addOrder, operateCode, data,
      successCallback, errorCallback);
  };

  //分配权限请求
  factory.topAssignRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.topAssign, operateCode, data,
      successCallback, errorCallback);
  };

  //我的接诊/等待接诊请求
  factory.GetListByFirstDoctorIDRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.GetListByFirstDoctorID, operateCode, data,
      successCallback, errorCallback);
  };

  //获取患者详情
  factory.getPatientDetailByIDRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getPatientDetailByID, operateCode, data,
      successCallback, errorCallback);
  };

  // 获取检查报告
  factory.getInspectReportRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getInspectReport, operateCode, data,
      successCallback, errorCallback);
  };

// 读取检查报告
  factory.downloadInspectReportRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.downloadInspectReport, operateCode, data,
      successCallback, errorCallback);
  };

  //患者端获取就诊卡列表
  factory.cardListRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.cardList, operateCode, data,
      successCallback, errorCallback);
  };

  //患者信息
  factory.getPatientInfoRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getPatientInfo, operateCode, data,
      successCallback, errorCallback);
  };

  // 获取报告
  factory.getPatientsInfoRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getPatientsInfo, operateCode, data,
      successCallback, errorCallback);
  };

  // 读取报告
  factory.downloadReport2AsImageRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.downloadReport2AsImage, operateCode, data,
      successCallback, errorCallback);
  };

  // 提交反馈
  factory.FeedbackRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.feedback, operateCode, data, successCallback, errorCallback);
  };

  // 公告curd
  factory.AnnounceRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.announce, operateCode, data, successCallback, errorCallback);
  };

  // 公告list
  factory.AnnounceListRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.announceList, operateCode, data, successCallback, errorCallback);
  };

  /** 网络问诊 **/
    //问诊列表
  factory.getConsultRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.getConsult, operateCode, data,
      successCallback, errorCallback);
  };

  //在线问诊消息
  factory.AskChatMessageRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.AskChatMessage, operateCode, data,
      successCallback, errorCallback);
  };

  //问诊文件上传
  factory.AskChatUploadChatFileRequest = function (data, successCallback, errorCallback) {
    factory.baseUploadRequest(resourceFactory.address.AskChatUploadChatFile, data, successCallback, errorCallback);
  };

  //图文问诊消息
  factory.AskMessageRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.askMessage, operateCode, data, successCallback, errorCallback);
  };
  //修改密码
  factory.resetPasswordRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.resetPassword, operateCode, data, successCallback, errorCallback);
  };
  //获取转诊筛选过的科室
  factory.getDepartmentSelectRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.GetDepartmentSelect, operateCode, data,
      successCallback, errorCallback);
  };
  //获取验证码
  factory.passwordResetSendCodeRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.passwordResetSendCode, operateCode, data,
      successCallback, errorCallback);
  };
  //改密码
  factory.passwordResetByPhoneRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.passwordResetByPhone, operateCode, data,
      successCallback, errorCallback);
  };
  // 生殖接口
  factory.ReproductiveRequest = function (data, operateCode, successCallback, errorCallback) {
    factory.baseRequest(resourceFactory.address.reproductive, operateCode, data, successCallback, errorCallback);
  };

  // 生殖上传图片
  factory.UploadReproductiveImageRequest = function (data, successCallback, errorCallback) {
    factory.baseUploadRequest(resourceFactory.address.uploadReproductiveImage, data, successCallback, errorCallback);
  };

  return factory;
});

httpHandler.service('httpHandlerService', function (httpFactory) {
  var service = {};
  service.getDomain = function () {
    return httpFactory.getDomain();
  };
  /*读片*/
  service.uploadReadFileRequest = function (data, successCallback, errorCallback) {
    return httpFactory.uploadReadFileRequest(data, successCallback, errorCallback);
  };
  //读片申请
  service.readFileRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.readFileRequest(data, operateCode, successCallback, errorCallback);
  };

  service.readFileDetailRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.readFileDetailRequest(data, operateCode, successCallback, errorCallback);
  };
  /*读片*/
  service.uploadFilesRequest = function (data, successCallback, errorCallback) {
    return httpFactory.uploadFilesRequest(data, successCallback, errorCallback);
  };

  service.uploadGroupPhotoRequest = function (data, successCallback, errorCallback) {
    return httpFactory.uploadGroupPhotoRequest(data, successCallback, errorCallback);
  };

  //登陆请求
  service.loginRequest = function (data, successCallback, errorCallback) {
    httpFactory.loginRequest(data, successCallback, errorCallback);
  };

  //获取邀请码
  service.verifyCodeRequest = function (data, successCallback, errorCallback) {
    httpFactory.verifyCodeRequest(data, successCallback, errorCallback);
  };

  //注册请求
  service.registerRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.registerRequest(data, operateCode, successCallback, errorCallback);
  };

  //用户请求
  service.userRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.userRequest(data, operateCode, successCallback, errorCallback);
  };

  //患者请求
  service.patientRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.patientRequest(data, operateCode, successCallback, errorCallback);
  };

  //转院获取患者
  service.diagnosisPatientRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.diagnosisPatientRequest(data, operateCode, successCallback, errorCallback);
  };


  //合作医院请求
  service.customerRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.customerRequest(data, operateCode, successCallback, errorCallback);
  };

  //选择向上转诊医院
  service.topCustomerChooseRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.topCustomerChooseRequest(data, operateCode, successCallback, errorCallback);
  };

  //选择向上转诊医院
  service.customerChooseRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.customerChooseRequest(data, operateCode, successCallback, errorCallback);
  };

  //向上转院
  service.diagnosisAskRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.diagnosisAskRequest(data, operateCode, successCallback, errorCallback);
  };

  //向下转院
  service.diagnosisReplyRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.diagnosisReplyRequest(data, operateCode, successCallback, errorCallback);
  };

  //短信消息
  service.neteaseMessageRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.neteaseMessageRequest(data, operateCode, successCallback, errorCallback);
  };

  // 会诊间
  service.chatRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.chatRequest(data, operateCode, successCallback, errorCallback);
  };

  // 获取文件base
  service.getFileBase = function (customerID) {
    return httpFactory.getFileBase(customerID);
  };

  // 获取图片base
  service.getImageBase = function (customerID) {
    return httpFactory.getImageBase(customerID);
  };

  //获取会诊间医院数据
  service.getCustomListGroupRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getCustomListGroupRequest(data, operateCode, successCallback, errorCallback);
  };

  //获取会诊间科室数据
  service.getDepartmentListGroupByCustomRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDepartmentListGroupByCustomRequest(data, operateCode, successCallback, errorCallback);
  };

  //获取获取会诊间医生数据GetDoctorListGroupByDepartment
  service.getDoctorListGroupByDepartmentRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDoctorListGroupByDepartmentRequest(data, operateCode, successCallback, errorCallback);
  };

  //获取层级用户数据
  service.getDoctorGroupByDepartmentRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDoctorGroupByDepartmentRequest(data, operateCode, successCallback, errorCallback);
  };

  //科室
  service.departmentRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.departmentRequest(data, operateCode, successCallback, errorCallback);
  };

  //获取所有chat数据通过groupid
  service.getListByGroupIDRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getListByGroupIDRequest(data, operateCode, successCallback, errorCallback);
  };

  //删除所有chat数据通过groupid
  service.removeByGroupIDRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.removeByGroupIDRequest(data, operateCode, successCallback, errorCallback);
  };

  //chatMessage
  service.chatMessageRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.chatMessageRequest(data, operateCode, successCallback, errorCallback);
  };

  //getUnreadList
  service.getUnreadListRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getUnreadListRequest(data, operateCode, successCallback, errorCallback);
  };

  //chatRead
  service.chatReadRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.chatReadRequest(data, operateCode, successCallback, errorCallback);
  };

  //提交预约接口
  service.addOrderBeCurrentRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.addOrderBeCurrentRequest(data, operateCode, successCallback, errorCallback);
  };

  //获取绿色通道科室（排除未开放科室）
  service.getRegInfoBeCurrentRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getRegInfoBeCurrentRequest(data, operateCode, successCallback, errorCallback);
  };

  //预约管理科室医生可预约信息详情
  service.getDepartmentCanOrderLocalRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDepartmentCanOrderLocalRequest(data, operateCode, successCallback, errorCallback);
  };

  // 获取所有科室
  service.getAllDepartmentChooseRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getAllDepartmentChooseRequest(data, operateCode, successCallback, errorCallback);
  };

  // 获取科室人员
  service.getDoctorByDepartmentIDRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDoctorByDepartmentIDRequest(data, operateCode, successCallback, errorCallback);
  };

  // 科室权限
  service.departmentControlRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.departmentControlRequest(data, operateCode, successCallback, errorCallback);
  };

  //患者端获取科室
  service.getDepartmentRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDepartmentRequest(data, operateCode, successCallback, errorCallback);
  };

  //患者端获取科室
  service.getDoctorRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDoctorRequest(data, operateCode, successCallback, errorCallback);
  };

  //患者端获取科室
  service.getRegInfoRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getRegInfoRequest(data, operateCode, successCallback, errorCallback);
  };

  //患者端挂号申请
  service.addOrderRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.addOrderRequest(data, operateCode, successCallback, errorCallback);
  };

  //分配权限请求
  service.topAssignRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.topAssignRequest(data, operateCode, successCallback, errorCallback);
  };

//我的接诊/等待接诊
  service.GetListByFirstDoctorIDRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.GetListByFirstDoctorIDRequest(data, operateCode, successCallback, errorCallback);
  };

//获取患者详情
  service.getPatientDetailByIDRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getPatientDetailByIDRequest(data, operateCode, successCallback, errorCallback);
  };

  // 获取检查报告
  service.getInspectReportRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getInspectReportRequest(data, operateCode, successCallback, errorCallback);
  };

  // 检查报告详细
  service.downloadInspectReportRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.downloadInspectReportRequest(data, operateCode, successCallback, errorCallback);
  };

  //患者端获取就诊卡列表
  service.cardListRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.cardListRequest(data, operateCode, successCallback, errorCallback);
  };
  //检查报告获取患者信息
  service.getPatientInfoRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getPatientInfoRequest(data, operateCode, successCallback, errorCallback);
  };

  // 获取检验报告
  service.getPatientsInfoRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getPatientsInfoRequest(data, operateCode, successCallback, errorCallback);
  };

  // 检验报告详细
  service.downloadReport2AsImageRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.downloadReport2AsImageRequest(data, operateCode, successCallback, errorCallback);
  };

  // 提交反馈
  service.FeedbackRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.FeedbackRequest(data, operateCode, successCallback, errorCallback);
  };

  // 公告curd
  service.AnnounceRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.AnnounceRequest(data, operateCode, successCallback, errorCallback);
  };

  // 公告list
  service.AnnounceListRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.AnnounceListRequest(data, operateCode, successCallback, errorCallback);
  };

  /**  网络问诊 **/
    //问诊列表
  service.getConsultRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getConsultRequest(data, operateCode, successCallback, errorCallback);
  };

  //在线问诊消息
  service.AskChatMessageRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.AskChatMessageRequest(data, operateCode, successCallback, errorCallback);
  };

  //问诊文件上传
  service.AskChatUploadChatFileRequest = function (data, successCallback, errorCallback) {
    httpFactory.AskChatUploadChatFileRequest(data, successCallback, errorCallback);
  };

  //图文问诊消息
  service.AskMessageRequest = function (data, successCallback, errorCallback) {
    httpFactory.AskMessageRequest(data, successCallback, errorCallback);
  };

  //修改密码
  service.resetPasswordRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.resetPasswordRequest(data, operateCode, successCallback, errorCallback);
  };

  // 获取转诊筛选过的科室
  service.getDepartmentSelectRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.getDepartmentSelectRequest(data, operateCode, successCallback, errorCallback);
  };

  //获取验证码passwordResetSendCode
  service.passwordResetSendCodeRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.passwordResetSendCodeRequest(data, operateCode, successCallback, errorCallback);
  };
  //改密码
  service.passwordResetByPhoneRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.passwordResetByPhoneRequest(data, operateCode, successCallback, errorCallback);
  };
  // 生殖接口
  service.ReproductiveRequest = function (data, operateCode, successCallback, errorCallback) {
    httpFactory.ReproductiveRequest(data, operateCode, successCallback, errorCallback);
  };
  //生殖上传图片
  service.UploadReproductiveImageRequest = function (data, successCallback, errorCallback) {
    return httpFactory.UploadReproductiveImageRequest(data, successCallback, errorCallback);
  };

  return service;
});

var pushGoEasy = {
  goEasy: null,
  initialize: function () {
    if (this.goEasy == null) {
      this.goEasy = new GoEasy({
        appkey: '23ddbf64-d496-4375-ad89-10c7bdb0686b'
      });
    }
  },
  subscribe: function (channel, callback) {
    this.goEasy.subscribe({
      channel: channel,
      onMessage: function (result) {
        callback(result);
      }
    });
  }
};

var authentication = {
  checkAuthentication: function (list, ModuleNo, index, userType) {
    //如果是系统管理员就默认权限true
    if (userType == "2") {
      return true;
    }
    for (var j = 0; j < list.length; j++) {
      var roleModule = list[j];
      if (roleModule.ModuleNo == ModuleNo && roleModule.Purview != null && roleModule.Purview.length > index && roleModule.Purview[roleModule.Purview.length - 1 - index] == "1") {
        return true;
      }
    }

    return false;
  }
};

/*身份证校验*/
function IdentityCodeValid(code) {
  var city = {
    11: "北京",
    12: "天津",
    13: "河北",
    14: "山西",
    15: "内蒙古",
    21: "辽宁",
    22: "吉林",
    23: "黑龙江 ",
    31: "上海",
    32: "江苏",
    33: "浙江",
    34: "安徽",
    35: "福建",
    36: "江西",
    37: "山东",
    41: "河南",
    42: "湖北 ",
    43: "湖南",
    44: "广东",
    45: "广西",
    46: "海南",
    50: "重庆",
    51: "四川",
    52: "贵州",
    53: "云南",
    54: "西藏 ",
    61: "陕西",
    62: "甘肃",
    63: "青海",
    64: "宁夏",
    65: "新疆",
    71: "台湾",
    81: "香港",
    82: "澳门",
    91: "国外 "
  };
  var tip = "";
  var pass = true;

  if (!code || !/^\d{6}(18|19|20)?\d{2}(0[1-9]|1[12])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)$/i.test(code)) {
    tip = "身份证号格式错误";
    pass = false;
  }

  else if (!city[code.substr(0, 2)]) {
    tip = "地址编码错误";
    pass = false;
  }
  else {
    //18位身份证需要验证最后一位校验位
    if (code.length == 18) {
      code = code.split('');
      //∑(ai×Wi)(mod 11)
      //加权因子
      var factor = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
      //校验位
      var parity = [1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2];
      var sum = 0;
      var ai = 0;
      var wi = 0;
      for (var i = 0; i < 17; i++) {
        ai = code[i];
        wi = factor[i];
        sum += ai * wi;
      }
      var last = parity[sum % 11];
      if (parity[sum % 11] != code[17]) {
        tip = "校验位错误";
        pass = false;
      }
    }
  }
  if (!pass) alert(tip);
  return pass;
}

var download = {
  downloadUrl: "",
  downloadFile: function (url) {
    if (url == "" || url == null) {
      return;
    }

    var index = url.lastIndexOf("/") + 1;
    var fileName = url.substr(index, url.length - index);
    var fileTransfer = new FileTransfer();
    var uri = encodeURI(url);
    var fileURL = "///storage/emulated/0/download/" + fileName;

    fileTransfer.download(
      uri, fileURL, function (entry) {
        navigator.notification.alert("文件下载成功:" + fileURL, function () {
        }, "提示消息", "确定");
        download.downloadUrl = fileURL;
      }, function (error) {
        console.log("download error source " + error.source);
        console.log("download error target " + error.target);
        console.log("download error code" + error.code);
        navigator.notification.alert("文件下载失败", function () {
        }, "提示消息", "确定");
      }
    );
  }
};
