/**
 * Created by ylj on 2016/10/19.
 */
var resources = {};
/*公用函数 Begin*/
var sessionStorage = window.sessionStorage;

/*枚举*/
var checkType = {
  //必填项
  Required: 0,
  //手机号
  Mobile: 1,
  //邮箱
  Email: 2,
  //身份证
  Identify: 3,
  //大于0的正整数
  Number: 4,
  //邮编
  PostCode: 5,
  //日期
  DateFormat: 6
};

/*公用函数*/
resources.CommonFun = {
  //数据格式校验
  checkFormat: function (data, type, notRequired) {
    if (data == undefined || data == "" || data == null) {
      if (notRequired) {
        return true;
      }

      return false;
    }

    switch (type) {
      case checkType.Required:
        return true;
      case checkType.Email:  //邮箱
        var reg = /^\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
        return reg.test(data);
      case checkType.Identify:  //身份证
        var reg = new RegExp("(^\d{18}$)|(^\d{15}$)");
        return reg.test(data);
      case checkType.Number:
        var reg = /^[0-9]*[1-9][0-9]*$/;
        return reg.test(data);
      case checkType.Mobile:
        var reg = /^[1]+[3,4,5,8]+\d{9}/;
        return reg.test(data);
      case checkType.PostCode:
        var reg = /^\d{6}$/;
        return reg.test(data);
      case checkType.DateFormat://(YYYY/MM/DD)
        var reg = /^\d{4}(\-|\/|\.)\d{1,2}\1\d{1,2}$/;
        return reg.test(data);
      default :
        return false;
        break;
    }
  },
  //必填项校验(必须)
  validateRequired: function (val, element) {
    if (!resources.CommonFun.checkFormat(val, checkType.Required)) {
      return "此项为必填项，请输入值！";
    }
    else {
      return true;
    }
  },
  //手机号校验(必须)
  validateMobile: function (val, element) {
    if (!resources.CommonFun.checkFormat(val, checkType.Mobile)) {
      return "请输入有效的手机号！";
    }
    else {
      return true;
    }
  },
  //数字校验(必须)
  validateNumber: function (val, element) {
    if (!resources.CommonFun.checkFormat(val, checkType.Number)) {
      return "请输入有效的数字！";
    }
    else {
      return true;
    }
  },
  //时间
  validateDateFormat: function (val, element) {
    if (!resources.CommonFun.checkFormat(val, checkType.DateFormat)) {
      return "请选择时间";
    } else {
      return true;
    }
  },
  //保存数据到Session
  saveDataToSession: function (key, value) {
    var item = sessionStorage.getItem(key);
    if (item != null) {
      sessionStorage.removeItem(item)
    }

    if (value != null && value != "" && value != undefined) {
      sessionStorage.setItem(key, JSON.stringify(value));
    }
  },
  //从Session删除一个item
  deleteDataFromSession: function (key) {
    var item = sessionStorage.getItem(key);

    if (key != null) {
      sessionStorage.removeItem(key);
    }
  },
  //从Session中获取一个Item
  getDataFromSession: function (key) {
    var item = sessionStorage.getItem(key);
    if (item != null) {
      item = JSON.parse(item);
    }
    return item;
  },
  //导出table到excel文件
  exportToExcel: function (tableId) {
    $("#" + tableId).table2excel({
      exclude: ".noExl",
      name: "Document",
      filename: "PatientList"
    });
  },
  //计算年龄
  calculateAge: function (str) {
    var r = str.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
    if (r == null) {
      return false;
    }
    var d = new Date(r[1], r[3] - 1, r[4]);
    if (d.getFullYear() == r[1] && (d.getMonth() + 1) == r[3] && d.getDate() == r[4]) {
      var year = new Date().getFullYear();
      return (year - r[1]);
    }
    return 0;
  },
  //绑定日期控件
  bindingDateControl: function (id, isSetMinDate, isSetMaxDate, minChoiceDate, maxChoiceDate, isDateTime) {
    var currentDate = new Date();
    var formatDate = currentDate.getFullYear() + "-" + (currentDate.getMonth() + 1) + "-" + currentDate.getDate();
    var maxSelectedDate = "2099-01-01";
    var minSelectedDate = "1900-01-01";

    switch (isSetMinDate) {
      case 1://设置最小日期
        minSelectedDate = minChoiceDate;
        break;
      case 2://不设置最小日期
        minSelectedDate = formatDate;
        break;
      default :
        break
    }

    switch (isSetMaxDate) {
      case 1://设置最大日期
        maxSelectedDate = maxChoiceDate;
        break;
      case 2://不设置最大日期
        maxSelectedDate = formatDate;
        break;
      default :
        break
    }

    if (isDateTime) {
      $("#" + id).datetimepicker({
        autoSize: true,
        dateFormat: 'yy-mm-dd',
        closeText: "关闭",
        yearSuffix: '年',
        currentText: "今天",
        showButtonPanel: true,
        changeYear: true,
        showMonthAfterYear: true,
        defaultDate: formatDate,
        minDate: minSelectedDate,
        maxDate: maxSelectedDate,
        minHour: "",
        monthNames: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
        dayNames: ['星期一', '星期二', '星期三', '星期四', '星期五', '星期六', '星期日'],
        dayNamesShort: ['周一', '周二', '周三', '周四', '周五', '周六', '周日'],
        dayNamesMin: ['一', '二', '三', '四', '五', '六', '日']
      });
    }
    else {
      $("#" + id).datepicker({
        autoSize: true,
        dateFormat: 'yy-mm-dd',
        closeText: "关闭",
        yearSuffix: '年',
        currentText: "今天",
        changeYear: true,
        showButtonPanel: true,
        showMonthAfterYear: true,
        defaultDate: formatDate,
        minDate: minSelectedDate,
        maxDate: maxSelectedDate,
        monthNames: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
        dayNames: ['星期一', '星期二', '星期三', '星期四', '星期五', '星期六', '星期日'],
        dayNamesShort: ['周一', '周二', '周三', '周四', '周五', '周六', '周日'],
        dayNamesMin: ['一', '二', '三', '四', '五', '六', '日']
      });
    }
  },
  //绑定autoComplete
  bindingAutoComplete: function (id, dataSource) {
    var data = [];
    if (dataSource != undefined && dataSource != null && dataSource != "") {
      for (var i = 0; i < dataSource.length; i++) {
        var item = {
          label: dataSource[i].Name,
          value: dataSource[i]
        };
        data.push(item);
      }
    }

    $("#" + id).autocomplete({
      minLength: 0,
      source: dataSource,
      select: function (event, ui) {

      },
      focus: function (event, ui) {

      },
      delay: 0
    }).data("ui-autocomplete")._renderItem = function (ul, item) {
      return $("<li>")
        .append("<label>" + item.label + "</label>")
        .appendTo(ul);
    };
  }
};
/*公用函数 End*/

/*列表显示*/
resources.factoryList = [{
  Value: 1,
  Text: "男"
}, {
  Value: 0,
  Text: "女"
}];

/*状态*/
resources.StateList = [{
  Value: 0,
  Text: "激活"
}, {
  Value: 1,
  Text: "冻结"
}];



/*显示单个*/
resources.displayText = {
  /*用户状态*/
  UserStateText: function (state) {
    switch (state) {
      case 0:
        return "有效"
      case 1:
        return "冻结"
      default:
        return "删除"
    }
  },
  /*用户性别*/
  GenderText: function (Gender) {
    switch (Gender) {
      case 0:
        return "女"
      case 1:
        return "男"
    }
  },
  /*机构类型*/
  hospitalTypeList: function (type) {
    switch (type) {
      case 0:
        return "全部"
      case 1:
        return "机构"
      case 2:
        return "医院"
    }
  },
  /*截取时间至月日*/
  DateToDayWithNoYearText: function (date) {
    if (!date) {
      return date;
    }

    var type = typeof(date);
    if (type == "string") {
      return date.length >= 10 ? date.substr(2, 8) : date;
    } else if (type == "object") {
      var year = date.getFullYear();
      var month = (date.getMonth() + 1).toString();
      if (month.length == 1) {
        month = "0" + month;
      }
      var day = date.getDate().toString();
      if (day.length == 1) {
        day = "0" + day;
      }

      return year.substr(2, 2) + "-" + month + "-" + day;
    } else {
      return "";
    }
  },
  /*截取时间至年月日*/
  DateToDayText: function (date) {
    if (date == null) {
      return date;
    }
    var type = typeof(date);
    if (type == "string") {
      return date.length > 10 ? date.substr(0, 10) : date;
    } else if (type == "object") {
      var year = date.getFullYear();
      var month = (date.getMonth() + 1).toString();
      if (month.length == 1) {
        month = "0" + month;
      }
      var day = date.getDate().toString();
      if (day.length == 1) {
        day = "0" + day;
      }
      var hour = date.getHours().toString();
      if (hour.length == 1) {
        hour = "0" + hour;
      }

      var minute = date.getMinutes().toString();
      if (minute.length == 1) {
        minute = "0" + minute;
      }
      //return year + "/" + month + "/" + day;
      return year + "-" + month + "-" + day + " " + hour + ":" + minute;
    } else {
      return "";
    }
  },
  /*截取时间至年月日时分秒*/
  DateToTimeText: function (date) {
    if (date == null) {
      return "";
    }
    var type = typeof(date);
    if (type == "string") {
      return date;
    } else if (type == "object") {
      var year = date.getFullYear();
      var month = (date.getMonth() + 1).toString();
      if (month.length == 1) {
        month = "0" + month;
      }

      var day = date.getDate().toString();
      if (day.length == 1) {
        day = "0" + day;
      }

      var hour = date.getHours().toString();
      if (hour.length == 1) {
        hour = "0" + hour;
      }

      var minute = date.getMinutes().toString();
      if (minute.length == 1) {
        minute = "0" + minute;
      }

      var seconds = date.getSeconds().toString();
      if (seconds.length == 1) {
        seconds = "0" + seconds;
      }

      return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;
    } else {
      return "";
    }
  },

  /*截取时间至年月日时分*/
  DateToMinuteText: function (date) {
    if (date == null) {
      return "";
    }

    var type = typeof(date);
    if (type == "string") {
      return date.length > 16 ? date.substr(0, 16) : date;
    } else if (type == "object") {
      var year = date.getFullYear();
      var month = (date.getMonth() + 1).toString();
      if (month.length == 1) {
        month = "0" + month;
      }

      var day = date.getDate().toString();
      if (day.length == 1) {
        day = "0" + day;
      }

      var hour = date.getHours().toString();
      if (hour.length == 1) {
        hour = "0" + hour;
      }

      var minute = date.getMinutes().toString();
      if (minute.length == 1) {
        minute = "0" + minute;
      }

      var seconds = date.getSeconds().toString();
      if (seconds.length == 1) {
        seconds = "0" + seconds;
      }

      return year + "-" + month + "-" + day + " " + hour + ":" + minute;
    } else {
      return "";
    }
  }
};


resources.DataFormat = {
  //全局重写日期格式转换
  DataTimeAll: function (fmt) {
    var o = {
      "M+": this.getMonth() + 1,
      "d+": this.getDate(),
      "h+": this.getHours(),
      "m+": this.getMinutes(),
      "s+": this.getSeconds(),
      "q+": Math.floor((this.getMonth() + 3) / 3),
      "S": this.getMilliseconds()
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
      if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
  },
  /*时间日历*/
  getTime: function () {
    var mon, day, now, hour, min, ampm, time, str, tz, end, beg, sec, area;
    mon = new Array("1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月");
    day = new Array("周日", "周一", "周二", "周三", "周四", "周五", "周六");
    now = new Date();
    hour = now.getHours();
    min = now.getMinutes();
    sec = now.getSeconds();
    switch (parseInt(hour / 6)) {
      case 0:
        area = "凌晨";
        break;
      case 1:
        area = "上午";
        break;
      case 2:
        area = "下午";
        break;
      case 3:
      case 4:
        area = "晚上";
        break;
    }
    if (hour < 10) {
      hour = "0" + hour;
    }
    if (min < 10) {
      min = "0" + min;
    }
    if (sec < 10) {
      sec = "0" + sec;
    }
    $("#current-time").html(
      "<nobr>" + now.getFullYear() + "年"
      + mon[now.getMonth()] + now.getDate() + "日 " + day[now.getDay()] + " " + area + " " + hour
      + ":" + min + ":" + sec + "</nobr>");
  },
  //时间年月日显示
  createDatePicker: function (ids) {
    for (var i = 0; i < ids.length; i++) {
      var temp = $("#" + ids[i]);
      temp.datetimepicker({
        language: "zh-CN",
        todayHighlight: true,
        minView: 2,
        format: "yyyy-mm-dd",
        autoclose: true
      });
    }
  },
  calculateAge:function(str){
    var r = str.match(/^(\d{1,4})(-|\/)(\d{1,2})\2(\d{1,2})$/);
    if(r == null){
      return false;
    }
    var d= new Date(r[1], r[3]-1, r[4]);
    if(d.getFullYear() == r[1] && (d.getMonth()+1) == r[3] && d.getDate() == r[4])
    {
      var year = new Date().getFullYear();
      return (year-r[1]);
    }
    return 0;
  },
  identityCardformat: function (date) {
    var year = date.substring(0, 4);
    var month = date.substring(4, 6);
    var day = date.substring(6, 8);
    var dateTime = year + "-" + month + "-" + day;
    return dateTime;
  },
};









