/**
 * Created by ylj on 2016/10/24.
 * 已优化
 */
var communityAddReferralModule = angular.module("communityAddReferralModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);
communityAddReferralModule.service("communityAddReferralService", function ($ionicLoading, $http, httpHandlerService, resourceFactory, $state) {
  var service = {};

  //获取向上转院列表
  service.getDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DiagnosisAsk = response.Body.DiagnosisAskList;
          $scope.DiagnosisAskList = $scope.DiagnosisAsk;
          $scope.showDetail(response.Body.DiagnosisAskList[0]);
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //修改向上操作
  service.UpdateDiagnosisAsk = function ($scope) {
    var data = {DiagnosisAsk: $scope.updateDiagnosisAsk, FileList: $scope.uploadedFiles};
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("用户更新成功", function () {
          }, "提示消息", "确定");
          service.getDiagnosisAskList($scope.searchPar, $scope);
        }
        else {
          navigator.notification.alert(response, function () {
          }, "提示消息", "确定");
          navigator.notification.alert("用户更新失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //生殖数据格式
  var executeForReproduction = function (list, ReproductiveFile, CreatorID, CreatorName) {
    if (!ReproductiveFile || !ReproductiveFile.FileName) {
      return;
    }

    var ReproductiveFileMessages = [];

    if (ReproductiveFile.newMessage) {
      ReproductiveFileMessages.push({
        Message: ReproductiveFile.newMessage,
        CreatorID: CreatorID,
        CreatorName: CreatorName
      });
    }

    list.push({
      ReproductiveFile: ReproductiveFile,
      ReproductiveFileMessages: ReproductiveFileMessages
    });
  };

  //新增向上操作
  service.InsertDiagnosisAsk = function ($scope) {
    // 住院门诊状态修正
    if ($scope.AddDiagnosisAsk.DiagnosisAsk.AskType == 1) {
      // 未接诊
      $scope.AddDiagnosisAsk.DiagnosisAsk.Status = 0;
    } else {
      // 未提交
      $scope.AddDiagnosisAsk.DiagnosisAsk.Status = -1;
    }

    var data = {
      DiagnosisAsk: $scope.AddDiagnosisAsk.DiagnosisAsk,
      Patient: $scope.AddDiagnosisAsk.Patient,
      FileList: $scope.uploadedFiles,
      ModuleNo: $scope.AddDiagnosisAsk.ModuleNo
    };

    //转换时间格式
    data.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType(data.DiagnosisAsk.TurnOutDate);
    data.Patient.Birthday = $scope.getDateTimeType(data.Patient.Birthday);

    /*映射医生*/
    for (var i = 0; i < $scope.userList.length; i++) {
      var item = $scope.userList[i];
      if (item.User.UserID == data.DiagnosisAsk.FirstDoctorID) {
        data.DiagnosisAsk.FirstDoctorName = item.User.Name;
      }
    }
    ;

    if ($scope.AddDiagnosisAsk.DiagnosisAsk.AskType != 2) {
      data.FileList = $scope.uploadedFiles;
    } else {
      data.RelationPatient = $scope.AddDiagnosisAsk.RelationPatient;
      var list = [];
      executeForReproduction(list, $scope.currentIFV, $scope.currentUser.User.UserID);
      for (var i = 0; i < $scope.uploadedFiles.length; i++) {
        var ReproductiveFile = $scope.uploadedFiles[i];
        executeForReproduction(list, ReproductiveFile, $scope.currentUser.User.UserID);
      }
      data.ReproductiveFileList = list;
    }
    ;

    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          //navigator.notification.alert("新增成功", function () {
          //}, "提示消息", "确定");
          alert("新增成功");
          $ionicLoading.hide();
          $state.go("communityReferralList");
          service.getDiagnosisAskList($scope.searchPar, $scope);
        } else {
          $ionicLoading.hide();
          //navigator.notification.alert("新增失败", function () {
          //}, "提示消息", "确定");
          alert("新增失败");
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  // 更新文件
  service.updateReadFile = function ($scope) {
    if (!$.formValidator.pageIsValid("2")) {
      return;
    }

    for (var i = 0; i < $scope.updatePatient.FileList.length; i++) {
      $scope.updatePatient.FileList[i].State = 2;
    }

    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.FileList.length; j++) {
        var current = $scope.updatePatient.FileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }

      if (!exist) {
        $scope.updatePatient.FileList.push(upload);
      }
    }

    service.UpdateDiagnosisAsk($scope.updatePatient, $scope);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.topCustomerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取科室医生数据
  service.getDoctorByDepartmentIDRequest = function (data, $scope) {
    httpHandlerService.getDoctorByDepartmentIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          if ($scope.SelectDoctor == 0) {  //预约
            $scope.DepartmentByRequest = response.Body.UserList;
          } else {
            $scope.DepartmentUser = response.Body.UserList;
          }
        } else {
          $scope.DepartmentUser = [];
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取科室数据
  service.getAllDepartmentChooseRequest = function (data, $scope) {
    httpHandlerService.getDepartmentSelectRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerDepartment = response.Body.DepartmentList;
          $scope.Gy3yCustomerDepartment = $scope.CustomerDepartment;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  return service;

});
communityAddReferralModule.controller("communityAddReferralController", function ($ionicTabsDelegate, $rootScope, $ionicLoading, $state, userService, $ionicPopup, $scope, resourceFactory, $ionicHistory, communityAddReferralService, enumFactory, commonFunctionFactory, paginationService) {
  // 初始化
  $scope.initialize = function () {
    $scope.PatientStatusList = enumFactory.PatientStatusList;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: "",
      ModuleNo: "M002"
    };

    if ($rootScope.fileList.length > 0) {
      $scope.uploadedFiles = $rootScope.fileList;
    } else {
      $scope.uploadedFiles = [];
    }

    if ($rootScope.ReproductiveFileList && $rootScope.ReproductiveFileList.length > 0) {
      $scope.ReproductiveFileList = $rootScope.ReproductiveFileList;
    } else {
      $scope.ReproductiveFileList = [];
    }
    $scope.currentUser = userService.getUser().Body;

    $scope.engineer = {
      Gender: {}
    };
    $scope.engineer.AskType = 0;
    $scope.AddDiagnosisAsk = {
      DiagnosisAsk: {
        AssignDepartmentID: "gy3y",
        AssignDepartment: "",
        ReceiveDoctorID: "",
        ReceiveDoctorName: "",
        AskType: 0,
        ReplyCustomerID: ""
      },
      Patient: {
        PatientType: 0,
        Gender: 1
      }
    };
    $rootScope.AddDiagnosisAsk = $scope.AddDiagnosisAsk;
    var data = {ReceiveCustomerID: "gy3y", ReceiveIsTop: 1, ModuleType: 1};
    communityAddReferralService.getAllDepartmentChooseRequest(data, $scope);
    $scope.showSelect($scope);
    if ($scope.AddDiagnosisAsk.DiagnosisAsk.AskType == 0) {
      $scope.AddDiagnosisAsk.DiagnosisAsk.TurnOutDate = resources.displayText.DateToDayText(new Date());
      return;
    }
  };

  //返回
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };

  // 选择医院
  $scope.changeCustomer = function (type) {
    if (type == 0) {
      if ($scope.AddDiagnosisAsk.DiagnosisAsk.ReplyCustomerID == "gy3y") {
        $scope.CustomerDepartment = $scope.Gy3yCustomerDepartment;
        $scope.DepartmentUser = [];
      } else {
        $scope.CustomerDepartment = [];
        $scope.DepartmentUser = [];
      }
    } else {
      if ($scope.updatePatient.DiagnosisAsk.ReplyCustomerID == "gy3y") {
        $scope.CustomerDepartment = $scope.Gy3yCustomerDepartment;
        $scope.DepartmentUser = [];
      } else {
        $scope.CustomerDepartment = [];
        $scope.DepartmentUser = [];
      }
    }
  };

  //初始化性别
  $scope.GenderList = enumFactory.GenderList;

  //人员类型
  $scope.PatientTypeList = enumFactory.PatientTypeList;

  //初始化转院类型
  $scope.AskTypeList = enumFactory.AskType;

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //根据省份证号码绑定生日，性别
  $scope.IdentityCardBirthday = function (flg) {
    if (flg == 0) {
      var IdentityCard = $scope.AddDiagnosisAsk.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.AddDiagnosisAsk.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisAsk.Patient.Gender = 0;
        } else {
          $scope.AddDiagnosisAsk.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisAsk.Patient.Gender = 1;
        }
      }
    } else if (flg == 1) {
      var IdentityCard = $scope.updatePatient.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 0;
        } else {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 1;
        }
      }
    } else if (flg == 2) {
      var IdentityCard = $scope.AddDiagnosisAsk.RelationPatient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.AddDiagnosisAsk.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisAsk.RelationPatient.Gender = 0;
        } else {
          $scope.AddDiagnosisAsk.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisAsk.RelationPatient.Gender = 1;
        }
      }
    } else if (flg == 3) {
      var IdentityCard = $scope.updatePatient.RelationPatient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.updatePatient.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.RelationPatient.Gender = 0;
        } else {
          $scope.updatePatient.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.RelationPatient.Gender = 1;
        }
      }
    }
  };

  //新增数据
  $scope.communityAddReferral = function () {
    var RegCard = /^[1-9]{1}[0-9]{14}$|^[1-9]{1}[0-9]{16}([0-9]|[xX])$/;
    if ($scope.AddDiagnosisAsk.Patient.Name == "" || $scope.AddDiagnosisAsk.Patient.Name == null) {
      navigator.notification.alert("请输入患者姓名，此项为必填项", function () {
      }, "提示消息", "确定");
    } else if ($scope.AddDiagnosisAsk.Patient.Birthday == "" || $scope.AddDiagnosisAsk.Patient.Birthday == null) {
      navigator.notification.alert("请选择出生日期，此项为必选项", function () {
      }, "提示消息", "确定");
    } else if ($scope.AddDiagnosisAsk.Patient.IdentityCard == "" || $scope.AddDiagnosisAsk.Patient.IdentityCard == null || RegCard.test($scope.AddDiagnosisAsk.Patient.IdentityCard) == false) {
      navigator.notification.alert("请输入18位有效身份证号,此项为必选项", function () {
      }, "提示消息", "确定");
    } else if ($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID == "" || $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID == null) {
      navigator.notification.alert("请选择首诊医生，此项为必选项", function () {
      }, "提示消息", "确定");
    } else if ($scope.AddDiagnosisAsk.DiagnosisAsk.TurnOutDate == "" || $scope.AddDiagnosisAsk.DiagnosisAsk.TurnOutDate == null) {
      //if($scope.AddDiagnosisAsk.DiagnosisAsk.AskType == 1){
      navigator.notification.alert("请选择转诊日期，此项为必选项", function () {
      }, "提示消息", "确定");
      //}
    } else if ($scope.AddDiagnosisAsk.DiagnosisAsk.ReplyCustomerID == "" || $scope.AddDiagnosisAsk.DiagnosisAsk.ReplyCustomerID == null) {
      navigator.notification.alert("请选择转入医院，此项为必选项", function () {
      }, "提示消息", "确定");
    } else {
      $scope.AddDiagnosisAsk.DiagnosisAsk.ReceiveDoctorName = $("#addReceiveDoctor option:selected").text();
      $scope.AddDiagnosisAsk.DiagnosisAsk.AssignDepartmentName = $("#addAssignDepartment option:selected").text();
      $scope.AddDiagnosisAsk.DiagnosisAsk.PatientAge = $scope.calculateAge($scope.AddDiagnosisAsk.Patient.Birthday);
      $scope.AddDiagnosisAsk.ModuleNo = "M002";
      $scope.AddDiagnosisAsk.DiagnosisAsk.CreatorID = $scope.currentUser.User.UserID;
      $scope.AddDiagnosisAsk.DiagnosisAsk.CreatorName = $scope.currentUser.User.Name;
      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: true,
        maxWidth: 200,
        showDelay: 0
      });
      communityAddReferralService.InsertDiagnosisAsk($scope);
    }
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    communityAddReferralService.getPatientList($scope);
    //获取医生列表
    communityAddReferralService.getUser($scope);
    //获取机构
    communityAddReferralService.getCustomerExclude($scope);
  };

  /*清空新增患者*/
  $scope.cleanModal = function () {
    $scope.updateDiagnosisAsk = {
      UploadState: "../images/gy-down.png",
      DetailState: "../images/gy-down.png",
      RemarkState: "../images/gy-down.png",
      ApprovalState: "../images/gy-down.png",
      Gender: 1,
      Status: 0
    };
    $scope.uploadedFiles = [];

  };

  /*点击详情*/
  $scope.showDetail = function (item) {
    $scope.cleanModal();
    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    $scope.updatePatient.Patient.Birthday = $scope.getDateTimeType($scope.updatePatient.Patient.Birthday);
    $scope.updatePatient.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.TurnOutDate);
    $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
    $scope.createFileList($scope.uploadedFiles);
  };

  // 页面显示相关
  $scope.showEachReadFile = function (file) {
    if (file.SourceName.length > 6) {
      file.SourceName = (file.SourceName).substr(0, 6) + "...";
    }
    if (file.FileName.indexOf(".jpg") > -1 || file.FileName.indexOf(".png") > -1 || file.FileName.indexOf(".jpeg") > -1) {
      return communityAddReferralService.getFileBase() + file.CustomerID + "/" + file.FileName;
    } else {
      return "img/attachment_icon.png";
    }
  };

  //普通附件上传
  $scope.uploadFile = function () {
    // 从指定来源检索图像文件位置
    var options = {
      //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
      quality: 100,                                            //相片质量0-100
      destinationType: Camera.DestinationType.DATA_URL,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
      sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,       //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
      allowEdit: false,                                        //在选择之前允许修改截图
      encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
      targetWidth: 200,                                        //照片宽度
      targetHeight: 200,                                       //照片高度
      mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
      cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: true                                   //保存进手机相册
    };
    navigator.camera.getPicture(function onPhotoDataSuccess(imageData) {
      var bstr = atob(imageData);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }

      var blob = new Blob([u8arr.buffer], {type: 'image/jpeg'});
      blob.fileName = new Date().getTime() + ".jpg";

      communityAddReferralService.uploadFiles(blob, function (data) {

          if (data == null || data.Body == null) {
            navigator.notification.alert("上传失败", function () {
            }, "提示消息", "确定");
          }
          for (var i = 0; i < data.Body.length; i++) {
            var file = data.Body[i];
            file.SourceName = blob.fileName;
            file.CustomerID = $scope.currentUser.CustomerID;
            $scope.uploadedFiles.push(data.Body[i]);

          }

          $scope.createFileList($scope.uploadedFiles);
        },
        function (data) {
          navigator.notification.alert("上传失败", function () {
          }, "提示消息", "确定");
        });
      //};
    }, function (err) {
      navigator.notification.alert("未选择任何图片", function () {
      }, "提示消息", "确定");
    }, options);
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }

    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = communityAddReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = communityAddReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].ShowFile = communityAddReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  //删除图片
  $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisAskList = [];
      $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
    }
  });

  //附件样式
  $scope.bigImage = false;    //初始默认大图是隐藏的
  $scope.hideBigImage = function () {
    $scope.bigImage = false;
  };
  var ScreenHeight = window.screen.height;
  $scope.showBigImage = function (imageName) {
    $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true;
    var rightDisplay = document.getElementById("rightDisplay");
    rightDisplay.style.height = ScreenHeight + "px";
  };

  //科室医生
  $scope.CustomerDepartmentMedical = function (selectAssignDeparID) {
    var data = {RequestIsTop: 1, RequestDepartmentID: selectAssignDeparID};
    communityAddReferralService.getDoctorByDepartmentIDRequest(data, $scope);
  };

  $scope.initialize();

});
angular.bootstrap($('communityAddReferral'), ['communityAddReferralModule']);
