/**
 * Created by ylj on 2017/1/13.
 */
gysyApp.service("communityAddReproductionService",function(httpHandlerService,resourceFactory){
  var service = {};

  //获取生殖列表
  service.getReproductiveList = function (data, $scope) {
    httpHandlerService.ReproductiveRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body && response.Body.ReproductiveList) {
          $scope.ReproductiveList = response.Body.ReproductiveList;
          //搜索条件清空
          $scope.searchPar = {
            BeginRow: 0,
            Rows: 100000,
            Name: "",
            BeginDate: "",
            EndDate: ""
          };
        } else {
          console.log(response);
          alert("获取数据出错，请稍后重试1");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 生成模板数据
  service.createItems = function (tag) {
    var items = [];
    var divs = $(tag);
    for (var i = 0; i < divs.length; i++) {
      var temp = {
        text: [],
        checkbox: [],
        select: []
      };
      $(divs[i]).find("input[type='text'],textarea").each(function (i, input) {
        temp.text.push($(input).val());
      });

      $(divs[i]).find("input[type='checkbox'], input[type='radio']").each(function (i, input) {
        temp.checkbox.push($(input).is(":checked"));
      });

      $(divs[i]).find("select").each(function (i, input) {
        temp.select.push($(input).val());
      });

      items.push({
        IVFContent: divs[i].outerHTML,
        IVFParams: JSON.stringify(temp)
      });
    }

    return items;
  };

  // 展示模板数据
  service.showItems = function (data) {
    for (var i = 0; i < data.length; i++) {
      var item = data[i];
      // 诊断
      if (item.IVFContent && item.IVFContent.indexOf('<div name="diagnosis">') > -1) {
        service.loadItems(item.IVFContent, item.IVFParams, "#UpdateReproduction #showDiagnosis", true, false);
      }
      // 诊疗过程
      else if (item.IVFContent && item.IVFContent.indexOf('<div name="treatProcess">') > -1) {
        service.loadItems(item.IVFContent, item.IVFParams, "#UpdateReproduction #showTreatProcess", false, false);
      } else {
        service.loadItems(item.IVFContent, item.IVFParams, "#UpdateReproduction .reproductionIVF", false, true);
        $("#UpdateReproduction .reproductionIVF").show();
      }
    }
  };

  //新增生殖单
  service.InsertReproduction = function ($scope) {
    /*if ($scope.AddReproduction.RelationPatient &&
      ($scope.AddReproduction.RelationPatient.Name || $scope.AddReproduction.RelationPatient.IdentityCard || $scope.AddReproduction.RelationPatient.Phone)
      //&& !$.formValidator.pageIsValid("3")
    ) {
      return;
    }*/

    // 模板
    var items = service.createItems("#InsertReproduction .reproductionIVF div[name]");

    // 诊疗过程
    items = items.concat(service.createItems("#InsertReproduction div[name='treatProcess']"));

    // 诊断
    items = items.concat(service.createItems("#InsertReproduction div[name='diagnosis']"));

    var data = {
      Reproductive: $scope.AddReproduction.Reproduction,
      Patient: $scope.AddReproduction.Patient,
      ReproductiveFileList: $scope.uploadedFiles,
      RelationPatient: $scope.AddReproduction.RelationPatient,
      ReproductiveIVFList: items,
      ReproductiveFileList: $scope.uploadedFiles
    };


    httpHandlerService.ReproductiveRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          alert("新增成功");
          console.log($scope.searchPar);
          service.getReproductiveList($scope.searchPar, $scope);
        } else {
          alert("新增失败");
          console.log(response);
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  service.DealPatientSource = function(patientList){
    var result = [];
    if (patientList && patientList.length > 0) {
      for (var i = 0; i < patientList.length; i++) {
        var item = {
          label: patientList[i].Patient.Name,
          model: JSON.stringify(patientList[i].Patient)
        };

        result.push(item);
      }
    }
    return result;
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.UploadReproductiveImageRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getReproductionFileBase = function () {
    return resourceFactory.address.reproductionDomain;
  };

  return service;
});
gysyApp.controller("communityAddReproductionController",function($scope,$ionicHistory,communityAddReproductionService,userService,resourceFactory,enumFactory){
  //初始化
  $scope.initialize = function(){
    $scope.currentUser = userService.getUser().Body;

    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginDate: resources.displayText.DateToDayText(beginDate),
      EndDate: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: "",
      ModuleNo: "M013"
    };

    $scope.searchPatientRequest = {
      BeginRow: 0,
      Rows: 10,
      BeginDate: "",
      EndDate: "",
      Name: ""
    };

    $scope.AddReproduction = {
      Reproduction: {
        FirstDoctorID: $scope.currentUser.User.UserID,
        FirstDoctorName: $scope.currentUser.User.Name
      },
      Patient: {
        PatientType: 0,
        Gender: 1
      }
    };

    $scope.isSelected = false;
    $scope.isSelectedOfAddRelationPatient = false;
    $scope.showDoctor = false;
    $scope.AddReproductionModel = 0;
    $scope.uploadedFiles = [];
    $("#InsertReproduction .reproductionIVF").html("");
    $("#InsertReproduction .reproductionIVF").hide();

    communityAddReproductionService.getUser($scope);
 } ;

  //新增患者
  $("#patient_name").autocomplete({
    source: function (request, response) {
      $scope.searchPatientRequest.Name = $scope.AddReproduction.Patient.Name;
      var currentUser = userService.getUser();
      var request1 = {
        'Header': {
          "Token": currentUser.Header.Token,
          "StatusCode": 0,
          "Message": null,
          "OperateCode": resourceFactory.operateCode.get,
          "TimeStamp": currentUser.Header.TimeStamp
        },
        'Body': ""
      };
      request1.Body = $scope.searchPatientRequest;
      $.ajax({
        type: "post",
        url: resourceFactory.address.patient,
        data: JSON.stringify(request1),
        success: function (data) {
          if (!data.Body || !data.Body.PatientList || data.Body.PatientList.length == 0) {
            $scope.isSelected = false;
            $scope.AddReproduction.Patient.ID = 0;
            $scope.AddReproduction.Patient.PatientID = "";
            $scope.AddReproduction.Patient.Gender = 0;
            $scope.AddReproduction.Patient.Birthday = "";
            $scope.AddReproduction.Patient.Phone = "";
            $scope.AddReproduction.Patient.IdentityCard = "";
            $scope.AddReproduction.Patient.Address = "";
            $scope.AddReproduction.Patient.Email = "";
            $scope.AddReproduction.Patient.PatientType = 0;
            $scope.AddReproduction.Patient.OtherContact = "";
            $scope.AddReproduction.Patient.Remark = "";
            $scope.AddReproduction.Patient.ApprovalOpinion = "";
            $scope.AddReproduction.Patient.MainID = "";
            $scope.AddReproduction.Patient.RelationType = 0;
            $scope.AddReproduction.Patient.Status = 0;
            $scope.AddReproduction.Patient.State = 0;
            $scope.AddReproduction.Patient.CustomerID = 0;
            $scope.$apply();
          }
          response(communityAddReproductionService.DealPatientSource(!data.Body ? [] : data.Body.PatientList));
        },
        error: function () {
          alert("患者数据源获取失败！");
        }
      });
    },
    minLength: 0,
    select: function (event, ui) {
      $scope.isSelected = true;
      var patient = $.parseJSON(ui.item.model);
      $scope.AddReproduction.Patient = {
        ID: patient.ID,
        PatientID: patient.PatientID,
        Name: patient.Name,
        Gender: patient.Gender,
        Birthday: new Date(patient.Birthday).Format("yyyy-MM-dd"),
        Phone: patient.Phone,
        IdentityCard: patient.IdentityCard,
        Address: patient.Address,
        Email: patient.Email,
        PatientType: patient.PatientType,
        OtherContact: patient.OtherContact,
        Remark: patient.Remark,
        ApprovalOpinion: patient.ApprovalOpinion,
        Photo: patient.Photo,
        MainID: patient.MainID,
        RelationType: patient.RelationType,
        Status: patient.Status,
        State: patient.State,
        CreateTime: patient.CreateTime,
        CustomerID: patient.CustomerID
      };
      $scope.$apply();
    },
    autoFill: true
  });

  //新增患者伴侣
  $("#relationPatient_name").autocomplete({
    source: function (request, response) {
      $scope.searchPatientRequest.Name = $scope.AddReproduction.RelationPatient.Name;
      var currentUser = userService.getUser();
      var request1 = {
        'Header': {
          "Token": currentUser.Header.Token,
          "StatusCode": 0,
          "Message": null,
          "OperateCode": resourceFactory.operateCode.get,
          "TimeStamp": currentUser.Header.TimeStamp
        },
        'Body': ""
      };
      request1.Body = $scope.searchPatientRequest;
      $.ajax({
        type: "post",
        url: resourceFactory.address.patient,
        data: JSON.stringify(request1),
        success: function (data) {
          if (!data.Body || !data.Body.PatientList || data.Body.PatientList.length == 0) {
            $scope.isSelectedOfAddRelationPatient = false;
            $scope.AddReproduction.RelationPatient.ID = 0;
            $scope.AddReproduction.RelationPatient.PatientID = "";
            $scope.AddReproduction.RelationPatient.Gender = 0;
            $scope.AddReproduction.RelationPatient.Birthday = "";
            $scope.AddReproduction.RelationPatient.Phone = "";
            $scope.AddReproduction.RelationPatient.IdentityCard = "";
            $scope.AddReproduction.RelationPatient.Address = "";
            $scope.AddReproduction.RelationPatient.Email = "";
            $scope.AddReproduction.RelationPatient.PatientType = 0;
            $scope.AddReproduction.RelationPatient.OtherContact = "";
            $scope.AddReproduction.RelationPatient.Remark = "";
            $scope.AddReproduction.RelationPatient.ApprovalOpinion = "";
            $scope.AddReproduction.RelationPatient.MainID = "";
            $scope.AddReproduction.RelationPatient.RelationType = 0;
            $scope.AddReproduction.RelationPatient.Status = 0;
            $scope.AddReproduction.RelationPatient.State = 0;
            $scope.AddReproduction.RelationPatient.CustomerID = 0;
            $scope.$apply();
          }
          response(communityAddReproductionService.DealPatientSource(!data.Body ? [] : data.Body.PatientList));
        },
        error: function () {
          alert("患者数据源获取失败！");
        }
      });
    },
    minLength: 0,
    select: function (event, ui) {
      $scope.isSelectedOfAddRelationPatient = true;
      var patient = $.parseJSON(ui.item.model);
      $scope.AddReproduction.RelationPatient = {
        ID: patient.ID,
        PatientID: patient.PatientID,
        Name: patient.Name,
        Gender: patient.Gender,
        Birthday: new Date(patient.Birthday).Format("yyyy-MM-dd"),
        Phone: patient.Phone,
        IdentityCard: patient.IdentityCard,
        Address: patient.Address,
        Email: patient.Email,
        PatientType: patient.PatientType,
        OtherContact: patient.OtherContact,
        Remark: patient.Remark,
        ApprovalOpinion: patient.ApprovalOpinion,
        Photo: patient.Photo,
        MainID: patient.MainID,
        RelationType: patient.RelationType,
        Status: patient.Status,
        State: patient.State,
        CreateTime: patient.CreateTime,
        CustomerID: patient.CustomerID
      };
      $scope.$apply();
    },
    autoFill: true
  });

  //新增数据
  $scope.InsertReproduction = function () {
    $scope.AddReproduction.Reproduction.PatientAge = $scope.calculateAge($scope.AddReproduction.Patient.Birthday);
    $scope.AddReproduction.Reproduction.CreatorID = $scope.currentUser.User.UserID;
    $scope.AddReproduction.Reproduction.CreatorName = $scope.currentUser.User.Name;
    if ($scope.showDoctor == false) {
      communityAddReproductionService.InsertReproduction($scope);
    }
    else {
      alert("输入的首诊医生不存在");
    }
  };

  //根据省份证号码绑定生日，性别
  $scope.IdentityCardBirthday = function (flg) {
    if (flg == 0) {
      var IdentityCard = $scope.AddReproduction.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.AddReproduction.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddReproduction.Patient.Gender = 0;
        } else {
          $scope.AddReproduction.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddReproduction.Patient.Gender = 1;
        }
      }
    } else if (flg == 1) {
      var IdentityCard = $scope.updatePatient.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 0;
        } else {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 1;
        }
      }
    } else if (flg == 2) {
      var IdentityCard = $scope.AddReproduction.RelationPatient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.AddReproduction.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddReproduction.RelationPatient.Gender = 0;
        } else {
          $scope.AddReproduction.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddReproduction.RelationPatient.Gender = 1;
        }
      }
    } else if (flg == 3) {
      var IdentityCard = $scope.updatePatient.RelationPatient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.updatePatient.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.RelationPatient.Gender = 0;
        } else {
          $scope.updatePatient.RelationPatient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.RelationPatient.Gender = 1;
        }
      }
    }
  };

  //生殖模块
  $scope.ReproductionModelList = enumFactory.ReproductionModelList;

  //动态查询医生
  $scope.changeUserLevel = function (flg) {
    if (flg == "0") {
      $scope.InsertUserComBoxList = [];
      if ($scope.AddReproduction.Reproduction.FirstDoctorName == "") {
        return;
      }

      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddReproduction.Reproduction.FirstDoctorName) > -1) {
          $scope.InsertUserComBoxList.push(temp);
        }
      }

      $scope.showDoctor = false;
      if ($scope.InsertUserComBoxList.length == 0) {
        $scope.showDoctor = true;
      }
    } else if (flg == "1") {
      $scope.UpdateUserComBoxList = [];
      if ($scope.updatePatient.Reproductive.FirstDoctorName == "") {
        return;
      }

      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.Reproductive.FirstDoctorName) > -1) {
          $scope.UpdateUserComBoxList.push(temp);
        }
      }

      $scope.showDoctor = false;
      if ($scope.UpdateUserComBoxList.length == 0) {
        $scope.showDoctor = true;
      }
    }
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //返回
  $scope.goBack = function(){
    $ionicHistory.goBack();
  };

  var modelZero = '<div name="zero">' +
    '<h2 style="text-align: center">婚育史</h2>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-4">' +
    '        <select>' +
    '            <option value="1">初婚</option>' +
    '            <option value="2">再婚</option>' +
    '        </select>' +
    '        <input type="text">年；' +
    '    </div>' +
    '    <div class="col-lg-8 col-md-8 col-sm-8 col-xs-8">' +
    '        避孕方式：<input type="checkbox">无/<input' +
    '            type="checkbox">避孕药/<input type="checkbox">避孕套/<input' +
    '            type="checkbox">上环/<input type="checkbox">输卵管结扎；' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-4 col-md-4 col-sm-4 col-xs-4">未避孕未怀孕 <input' +
    '            type="text">年' +
    '    </div>' +
    '    <div class="col-lg-8 col-md-8 col-sm-8 col-xs-8">性生活正常：' +
    '        <select>' +
    '            <option value="1">正常</option>' +
    '            <option value="2">不正常</option>' +
    '        </select>' +
    '        <input type="text">次/(<input' +
    '                type="radio" name="sexTime">周/<input type="radio" name="sexTime">月)' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        男方排精正常：' +
    '        <select>' +
    '            <option value="1">正常</option>' +
    '            <option value="2">不正常</option>' +
    '        </select>' +
    '        <input type="checkbox">阳痿/<input' +
    '            type="checkbox">无阴道内射精；' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">顺产 <input' +
    '            type="text">次/剖宫产 <input type="text">次，现存：<input' +
    '            type="text">男/<input' +
    '            type="text">女，末次分娩时间：<input class="inputYear"' +
    '                                        type="text">年/<input' +
    '            type="text">月' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">自然流产 <input' +
    '            type="text">次，' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        ①时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月孕 <input type="text">周，清宫：<input' +
    '            type="radio" name="oneQingGong">是/<input type="radio" name="oneQingGong">否，绒毛染色体 <input' +
    '            type="radio" name="oneRongMaoRanSeTi">否/<input type="radio" name="oneRongMaoRanSeTi">是' +
    '        <input type="text">' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        ②时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月孕 <input type="text">周，清宫：<input' +
    '            type="radio" name="twoQingGong">是/<input type="radio" name="twoQingGong">否，绒毛染色体 <input' +
    '            type="radio" name="twoRongMaoRanSeTi">否/<input type="radio" name="twoRongMaoRanSeTi">是' +
    '        <input type="text">' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        <select>' +
    '            <option value="1">药物流产</option>' +
    '            <option value="2">人工</option>' +
    '        </select>' +
    '        <input type="text">次，最后一次时间' +
    '        <input type="text" class="inputYear">年<input' +
    '            type="text">月<input type="text">日' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">宫外孕 <input' +
    '            type="text">次，' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        ①时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月，<input type="checkbox">左/<input' +
    '            type="checkbox">右，治疗：' +
    '        <select>' +
    '            <option value="1">保守治疗</option>' +
    '            <option value="2">切开取胚</option>' +
    '            <option value="3">输卵管切除</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        ②时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月，<input type="checkbox">左/<input' +
    '            type="checkbox">右，治疗：' +
    '        <select>' +
    '            <option value="1">保守治疗</option>' +
    '            <option value="2">切开取胚</option>' +
    '            <option value="3">输卵管切除</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">既往史：<textarea' +
    '            class="textareaVA" cols="50" rows="1"></textarea></div>' +
    '</div>' +
    '</div>';

  var modelOne = '<div name="one">' +
    '<h2 style="text-align: center">月经史</h2>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 col-xs-12"' +
    '         style="margin: 0 auto;">' +
    '        第一次来月经 <input type="text">岁；最近一年中，平均 <input type="text">天来一次月经/月经持续' +
    '        <input type="text">天；' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        月经量：' +
    '        <select>' +
    '            <option value="1">正常</option>' +
    '            <option value="2">多</option>' +
    '            <option value="3">少</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        是否痛经：' +
    '        <select>' +
    '            <option value="1">是</option>' +
    '            <option value="2">否</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
    '        末次月经时间：<input type="text" class="inputYear">年<input' +
    '            type="text">月<input type="text">日。' +
    '    </div>' +
    '</div>' +
    '</div>';

  var modelTwo = '<div name="two">' +
    '<h2 style="text-align: center">相关检查和手术</h2>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-3">输卵管造影术</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9 col-xs-9">' +
    '        左侧：<input type="checkbox">通畅/<input' +
    '            type="checkbox">通而不畅/<input' +
    '            type="checkbox">阻塞' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-3"></div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9 col-xs-9">' +
    '        右侧：<input type="checkbox">通畅/<input' +
    '            type="checkbox">通而不畅/<input type="checkbox">阻塞，时间：<input' +
    '            type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-3">宫腔镜检查术</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9 col-xs-9"><input' +
    '            class="inputWidth" type="text">时间：<input' +
    '            type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-3">腹腔镜</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9 col-xs-9"><input' +
    '            class="inputWidth" type="text">时间：<input' +
    '            type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-3">基础性激素</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9 col-xs-9">FSH <input' +
    '            type="text">ul/l, LH <input type="text">ul/l, E2' +
    '        <input type="text">pmol/L, T<input' +
    '                type="text">nmol/L, PRL' +
    '        <input type="text">ng/ml, AMH <input' +
    '                type="text">ng/ml, 时间：<input' +
    '                type="text" class="inputYear">年 <input type="text">月。;' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-3">其它</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9 col-xs-9"><textarea' +
    '            class="textareaVA" name="" id="" cols="50"' +
    '            rows="1"></textarea>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-3">配偶精液</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9 col-xs-9">密度 <input' +
    '            type="text">, PR(a级+b级)<input type="text">%,' +
    '        NP(c级)<input' +
    '                type="text">%, 畸形率 <input type="text">% 时间：<input' +
    '                type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '</div>';

  // 新增模板变换
  $scope.changeAddReproductionModel = function () {
    var model = "";
    var name = "";
    switch ($scope.AddReproductionModel) {
      case 0:
        model = modelZero;
        name = "#InsertReproduction .reproductionIVF div[name='zero']";
        break;
      case 1:
        model = modelOne;
        name = "#InsertReproduction .reproductionIVF [name='one']";
        break;
      case 2:
        model = modelTwo;
        name = "#InsertReproduction .reproductionIVF [name='two']";
        break;
      default:
        return;
    }

    if ($(name).length > 0) {
      alert("所选的模块已经添加");
      return;
    } else {
      $("#InsertReproduction .reproductionIVF").append(model);
      $("#InsertReproduction .reproductionIVF").show();
    }
  };

  //图片上传
  $scope.selectFile = function () {
    // 从指定来源检索图像文件位置
    var options = {
      //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
      quality: 100,                                            //相片质量0-100
      destinationType: Camera.DestinationType.DATA_URL,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
      sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,       //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
      allowEdit: false,                                        //在选择之前允许修改截图
      encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
      targetWidth: 200,                                        //照片宽度
      targetHeight: 200,                                       //照片高度
      mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
      cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: true                                   //保存进手机相册
    };
    navigator.camera.getPicture(function onPhotoDataSuccess(imageData) {
      var bstr = atob(imageData);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }

      var blob = new Blob([u8arr.buffer], {type: 'image/jpeg'});
      blob.fileName = new Date().getTime() + ".jpg";

      communityAddReproductionService.uploadFiles(blob, function (data) {
          if (data == null || data.Body == null) {
            navigator.notification.alert("上传失败", function () {
            }, "提示消息", "确定");
            alert(data.Header.Message);
          }
          for (var i = 0; i < data.Body.length; i++) {
            var file = data.Body[i];
            file.SourceName = blob.fileName;
            file.CustomerID = $scope.currentUser.CustomerID;
            $scope.uploadedFiles.push(data.Body[i]);

          }

          $scope.createFileList($scope.uploadedFiles);
        },
        function (data) {
          navigator.notification.alert("上传失败2", function () {
          }, "提示消息", "确定");
        });
      //};
    }, function (err) {
      navigator.notification.alert("未选择任何图片", function () {
      }, "提示消息", "确定");
    }, options);
  };

  //生殖图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }

    for (var i = 0; i < files.length; i++) {
      var url = files[i].FileName;
      files[i].ShowUrl = communityAddReproductionService.getReproductionFileBase() + url;
    }
  };
  $scope.initialize();
});
