/**
 * Created by ylj on 2016/10/28.
 * 已优化
 */
var communityReadImgModule = angular.module("communityReadImgModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);
communityReadImgModule.service("communityReadImgService", function ($http, httpHandlerService, resourceFactory, sessionFactory) {
  var service = {};

  //获取读片列表
  service.getReadFileList = function (data, $scope) {
    httpHandlerService.readFileRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.ReadFileList = response.Body.ReadFileList;
        } else {
          navigator.notification.alert(response.Header.Message, function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 获取科室转诊管理列表
  service.getDepartmentControlList = function (data, $scope) {
    httpHandlerService.departmentControlRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.departmentControls = response.Body.DepartmentControlList;
          var result = sessionFactory.getDataFromSession('readFileDoctorGroupByDepartment');
          if (result != null && result != 'undefined') {
            $scope.topCustomer = JSON.parse(result);
          } else {
            service.getDoctorGroupByDepartment({
              "ReceiveCustomerID": "gy3y",
              "ReceiveIsTop": 1
            }, $scope);
          }
        } else {
          console.log(response.Header.Message);
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };
  //获取层级数据
  service.getDoctorGroupByDepartment = function (data, $scope) {
    httpHandlerService.getAllDepartmentChooseRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body != null && response.Body.DepartmentList.length > 0) {
          $scope.topCustomer = [];
          for (var i = 0; i < response.Body.DepartmentList.length; i++) {
            var department = response.Body.DepartmentList[i];
            for (var j = 0; j < $scope.departmentControls.length; j++) {
              var control = $scope.departmentControls[j];
              if (control.DepartmentID == department.DepartmentID) {
                $scope.topCustomer.push(department);
                break;
              }
            }
          }
        }
        else {
          console.error("没有任何科室");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取人员
  service.getDoctorByDepartmentID = function (department, readFile, $scope, callBack) {
    var data = {
      RequestDepartmentID: department.DepartmentID,
      RequestIsTop: 1
    };

    httpHandlerService.getDoctorByDepartmentIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body != null && response.Body.UserList.length > 0) {
          readFile.selectedDepartment.UserList = response.Body.UserList;
          department.UserList = response.Body.UserList;

          if (callBack != null) {
            callBack(response.Body.UserList);
          }
        }
        else {
          console.error("没有任何人员");
        }

        // loading
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.error(response);
      }
    );
  };

  return service;
});


communityReadImgModule.controller("communityReadImgController", function ($ionicLoading,$rootScope, $ionicHistory, $scope, $state, communityReadImgService, enumFactory, commonFunctionFactory, paginationService, resourceService, userService) {
  // 初始化
  $scope.initialize = function () {
    $scope.system = "0";
    $scope.currentUser = userService.getUser().Body;
    //暂时只判上下级医院
    $scope.canReadFile = $scope.currentUser.IsTop == 0;

    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginDate: commonFunctionFactory.displayText.DateToTimeText(beginDate),
      EndDate: commonFunctionFactory.displayText.DateToTimeText(endDate),
      BeginDateText: commonFunctionFactory.displayText.DateToDayText(beginDate),
      EndDateText: commonFunctionFactory.displayText.DateToDayText(endDate),
      Keyword: ""
    };

    communityReadImgService.getDepartmentControlList({
      ModuleType: 2,
      ReceiveCustomerID: 'gy3y'
    }, $scope);
    $scope.search();
  };

  //新增读片
  $scope.addReadImg = function () {
    $ionicLoading.show({
      content: 'Loading',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });
    $state.go("ComAddReadImg");
    $ionicLoading.hide();
  };

  //返回
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };

  /*搜索事件*/
  $scope.search = function () {
    communityReadImgService.getReadFileList($scope.searchPar, $scope);
  };

  /*点击读片详情*/
  $scope.showReadFileDetail = function (item) {
    $scope.updatedReadFile = JSON.parse(JSON.stringify(item));
    $scope.updatedReadFile.selectedDepartment = {};
    for (var i = 0; i < $scope.topCustomer.length; i++) {
      var department = $scope.topCustomer[i];
      if ($scope.updatedReadFile.ReadFile.DepartmentID == department.DepartmentID) {
        $scope.updatedReadFile.selectedDepartment.DepartmentID = department.DepartmentID;
        $scope.updatedReadFile.selectedDepartment.Name = department.Name;

        if (department.UserList == null || department.UserList.length == 0) {
          communityReadImgService.getDoctorByDepartmentID(department, $scope.updatedReadFile, $scope, function (list) {
            if($scope.updatedReadFile.ReadFile.ReceiverType == 0) {
              for (var k = 0; k < list.length; k++) {
                var user = list[k];
                if (user.UserID == $scope.updatedReadFile.ReadFile.ReceiverID) {
                  $scope.updatedReadFile.Doctor = user;
                  break;
                }
              }
            }
          });
        } else {
          $scope.updatedReadFile.selectedDepartment.UserList = department.UserList;
          if($scope.updatedReadFile.ReadFile.ReceiverType == 0) {
            for (var k = 0; k < department.UserList.length; k++) {
              var user = department.UserList[k];
              if (user.UserID == $scope.updatedReadFile.ReadFile.ReceiverID) {
                $scope.updatedReadFile.Doctor = user;
                break;
              }
            }
          }
        }

        break;
      }
    }
    $rootScope.updatedReadFile = $scope.updatedReadFile;
    $state.go("ComReadImgDetail");
  };

  // 读片状态
  $scope.ShowStatus = function (status) {
    if (status == 2) {
      return "已收到";
    } else if (status == 3) {
      return "已完成";
    }
    return "已申请";
  };

  $scope.initialize();
});

angular.bootstrap($("#communityReadImg"), ["communityReadImgModule"]);
