/**
 * Created by ylj on 2016/11/2.
 * 已优化
 */
var communityReceiveDownModule = angular.module("communityReceiveDownModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);

communityReceiveDownModule.service("communityReceiveDownService", function ($ionicLoading,$state,$http, httpHandlerService, resourceFactory) {
  var service = {};

  //获取向下转院列表
  service.getDiagnosisReplyList = function (data, $scope) {
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.setTotalItems(response.Body.TotalRows);
          $scope.getPagination();
          $scope.DiagnosisReply = response.Body.DiagnosisReplyList;
          $scope.DiagnosisReplyList = [];
          $scope.changePaginationContent($scope.DiagnosisReply, $scope.DiagnosisReplyList);
        }
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //新增向上操作
  service.InsertDiagnosisAsk = function ($scope) {
    var data = {
      DiagnosisAsk: $scope.AddDiagnosisAsk.DiagnosisAsk,
      Patient: $scope.AddDiagnosisAsk.Patient,
      FileList: $scope.uploadedFiles
    };

    //转换时间格式
    data.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType(data.DiagnosisAsk.TurnOutDate);
    data.Patient.Birthday = $scope.getDateTimeType(data.Patient.Birthday);
    /*映射医生*/
    for (var i = 0; i < $scope.userList.length; i++) {
      var item = $scope.userList[i];
      if (item.User.UserID == data.DiagnosisAsk.FirstDoctorID) {
        data.DiagnosisAsk.FirstDoctorName = item.User.Name;
      }
    }

    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $ionicLoading.hide();
          navigator.notification.alert("患者新增成功", function () {
          }, "提示消息", "确定");
          $state.go("communityReferralList");
        } else {
          $ionicLoading.hide();
          navigator.notification.alert("患者新增失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.customerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取科室医生数据
  service.getDoctorByDepartmentIDRequest = function (data, $scope) {
    httpHandlerService.getDoctorByDepartmentIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DepartmentUser = response.Body.UserList;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取科室数据
  service.getAllDepartmentChooseRequest = function (data, $scope) {
    httpHandlerService.getDepartmentSelectRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerDepartment = response.Body.DepartmentList;
          $scope.Gy3yCustomerDepartment = $scope.CustomerDepartment;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  return service;
});

communityReceiveDownModule.controller("communityReceiveDownController", function ($ionicLoading,$scope, $ionicPopup, $state, $ionicHistory, $rootScope, communityReceiveDownService, enumFactory, commonFunctionFactory, paginationService, userService) {

  $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
  $scope.AddDiagnosisAsk = $rootScope.updatePatient;
  $scope.updatePatient = $rootScope.updatePatient;

// 初始化
  $scope.initialize = function () {
    $scope.uploadedFiles = [];
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      Name: "",
      Status: ""
    };

   $scope.AddDiagnosisAsk.DiagnosisAsk ={};
    $scope.AddDiagnosisAsk.DiagnosisAsk.AskType = 0;

    var data = {ReceiveCustomerID: "gy3y", ReceiveIsTop: 1,ModuleType: 1};
    communityReceiveDownService.getAllDepartmentChooseRequest(data, $scope);
    // 分页初始化
    //paginationService.initialize($scope);
    $scope.search();
    $scope.showSelect($scope);

    if ($scope.AddDiagnosisAsk.DiagnosisAsk.AskType == 0) {
      $scope.AddDiagnosisAsk.DiagnosisAsk.TurnOutDate = resources.displayText.DateToDayText(new Date());
      return;
    }
  };

  //返回
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };

  //选择医院
  $scope.changeCustomer = function(type) {
    if(type == 0) {
      if($scope.AddDiagnosisAsk.DiagnosisAsk.ReplyCustomerID == "gy3y") {
        $scope.CustomerDepartment = $scope.Gy3yCustomerDepartment;
        $scope.DepartmentUser = [];
      } else {
        $scope.CustomerDepartment = [];
        $scope.DepartmentUser = [];
      }
    } else {
      if($scope.updatePatient.DiagnosisAsk.ReplyCustomerID == "gy3y") {
        $scope.CustomerDepartment = $scope.Gy3yCustomerDepartment;
        $scope.DepartmentUser = [];
      } else {
        $scope.CustomerDepartment = [];
        $scope.DepartmentUser = [];
      }
    }
  };

  //初始化性别
  $scope.GenderList = enumFactory.GenderList;

  /*搜索事件*/
  $scope.search = function () {
    communityReceiveDownService.getDiagnosisReplyList($scope.searchPar, $scope);
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

  //人员类型
  $scope.PatientTypeText = function (status) {
    return commonFunctionFactory.displayText.PatientTypeList(status);
  };

  //初始化转院类型
  $scope.AskTypeList = enumFactory.AskType;

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    communityReceiveDownService.getPatientList($scope);
    //获取医生列表
    communityReceiveDownService.getUser($scope);
    //获取机构
    communityReceiveDownService.getCustomerExclude($scope);
  };

  $scope.goCommunityUpAddReferral = function () {
    $scope.AddDiagnosisAsk.DiagnosisAsk.DiagnosisReplyID = $scope.updatePatient.DiagnosisReply.DiagnosisReplyID;
    $scope.AddDiagnosisAsk.DiagnosisAsk.PatientID = $scope.updatePatient.DiagnosisReply.PatientID;
    $scope.AddDiagnosisAsk.DiagnosisAsk.PatientName = $scope.updatePatient.DiagnosisReply.PatientName;
    $scope.AddDiagnosisAsk.DiagnosisAsk.PatientAge = $scope.calculateAge($scope.AddDiagnosisAsk.Patient.Birthday);
    $scope.AddDiagnosisAsk.Patient = $scope.updatePatient.Patient;
    $scope.AddDiagnosisAsk.DiagnosisAsk.CreatorID = $scope.currentUser.User.UserID;
    $scope.AddDiagnosisAsk.DiagnosisAsk.CreatorName = $scope.currentUser.User.Name;

    if ($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID == "" || $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID == null) {
      //alert("首诊医生不能为空！");
      navigator.notification.alert("首诊医生不能为空！", function () {
      }, "提示消息", "确定");
    } else if ($scope.AddDiagnosisAsk.DiagnosisAsk.TurnOutDate == "" || $scope.AddDiagnosisAsk.DiagnosisAsk.TurnOutDate == null) {
      //alert("转诊日期不能为空！");
      navigator.notification.alert("转诊日期不能为空！", function () {
      }, "提示消息", "确定");
    } else if($scope.AddDiagnosisAsk.DiagnosisAsk.ReplyCustomerID ==""|| $scope.AddDiagnosisAsk.DiagnosisAsk.ReplyCustomerID == null){
      //alert("请选择转入医院！")
      navigator.notification.alert("请选择转入医院！", function () {
      }, "提示消息", "确定");
    } /*else if($scope.AddDiagnosisAsk.DiagnosisAsk.AskType == "" ||$scope.AddDiagnosisAsk.DiagnosisAsk.AskType ==  null){
      alert("请选择转院类型！")
    }*/else{
        $scope.AddDiagnosisAsk.DiagnosisAsk.ReceiveDoctorName = $("#addReceiveDoctor option:selected").text();
      $scope.AddDiagnosisAsk.DiagnosisAsk.AssignDepartmentName = $("#addAssignDepartment option:selected").text();
      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: true,
        maxWidth: 200,
        showDelay: 0
      });
      communityReceiveDownService.InsertDiagnosisAsk($scope);
    }

  };

  //页面显示相关
  $scope.showEachReadFile = function (file) {
    if(file.SourceName.length>6){
      file.SourceName = (file.SourceName).substr(0,6) +"...";
    }
    if (file.FileName.indexOf(".jpg") > -1 || file.FileName.indexOf(".png") > -1 || file.FileName.indexOf(".jpeg") > -1) {
      return communityReceiveDownService.getFileBase() + file.CustomerID + "/" + file.FileName;
    } /*else if(file.FileName ==""){
      return
    }*/
    else{
      return "img/attachment_icon.png";
    }
  };

  $scope.openEachReadFile = function (file) {
    var detailFile = {
      SourceName: file.SourceName,
      Description: file.Description
    };
    var url = file.FileName;
    if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
      detailFile.ShowUrl = communityReceiveDownService.getFileBase() + file.CustomerID + "/" + url;
    } else {
      detailFile.ShowUrl = communityReceiveDownService.getFileBase() + file.CustomerID + "/" + url;
      detailFile.ShowFile = communityReceiveDownService.getFileBase() + file.CustomerID + "/" + url;

      detailFile.IsPDF = true;
    }

    $scope.detailFile = detailFile;
    $("#fileDetail").modal("show");
  };

  $scope.uploadFile = function () {
    // 从指定来源检索图像文件位置
    var options = {
      //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
      quality: 100,                                            //相片质量0-100
      destinationType: Camera.DestinationType.DATA_URL,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
      sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,       //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
      allowEdit: false,                                        //在选择之前允许修改截图
      encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
      targetWidth: 200,                                        //照片宽度
      targetHeight: 200,                                       //照片高度
      mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
      cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: true                                   //保存进手机相册
    };

    navigator.camera.getPicture(function onPhotoDataSuccess(imageData) {

      /*var smallImage = document.getElementById('addImg');

      // 取消隐藏的图像元素
      smallImage.style.display = 'block';*/

      // 显示拍摄的照片
      // 使用内嵌CSS规则来缩放图片
      //smallImage.src = "data:image/jpeg;base64," + imageData;

      var bstr = atob(imageData);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }

      var blob = new Blob([u8arr.buffer], {type: 'image/jpeg'});
      blob.fileName = new Date().getTime() + ".jpg";

      communityReceiveDownService.uploadFiles(blob, function (data) {
          if (data == null || data.Body == null) {
            navigator.notification.alert("上传失败", function () {
            }, "提示消息", "确定");
          }
          for (var i = 0; i < data.Body.length; i++) {
            var file = data.Body[i];
            file.CustomerID = $scope.currentUser.CustomerID;
            $scope.uploadedFiles.push(data.Body[i]);
          }
          $scope.createFileList($scope.uploadedFiles);

        },
        function (data) {
          navigator.notification.alert("上传失败", function () {
          }, "提示消息", "确定");
        });
      //};
    }, function (err) {
      navigator.notification.alert("未选择任何图片", function () {
      }, "提示消息", "确定");
    }, options);
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }
    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = communityReceiveDownService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = communityReceiveDownService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].ShowFile = communityReceiveDownService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisReplyList = [];
      $scope.changePaginationContent($scope.DiagnosisReply, $scope.DiagnosisReplyList);
    }
  });

 //删除图片
  $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };

  /*附件样式start*/
  $scope.bigImage = false;    //初始默认大图是隐藏的
  $scope.hideBigImage = function () {
    $scope.bigImage = false;
  };
  var ScreenHeight = window.screen.height;
  $scope.showBigImage = function(imageName){
    $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true;
    var rightDisplay = document.getElementById("rightDisplay");
    rightDisplay.style.height = ScreenHeight+"px";
  };
  /*附件样式end*/

  //科室医生
  $scope.CustomerDepartmentMedical = function (selectAssignDeparID) {
    var data = {RequestIsTop: 1, RequestDepartmentID: selectAssignDeparID};
    communityReceiveDownService.getDoctorByDepartmentIDRequest(data, $scope);
  };

  $scope.initialize();
});

