/**
 * Created by ylj on 2016/10/26.
 * 已优化
 */
var communityReceiveReferralModule=angular.module("communityReceiveReferralModule",["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);
communityReceiveReferralModule.service("communityReceiveReferralService",function($http, httpHandlerService, resourceFactory){
  var service = {};

  //接诊单列表
  service.getDiagnosisReplyList = function (data, $scope) {
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DiagnosisReply = response.Body.DiagnosisReplyList;
          $scope.DiagnosisReplyList = response.Body.DiagnosisReplyList;
          console.log($scope.DiagnosisReplyList.length);
          //搜索条件清空
          $scope.searchPar = {
            BeginRow: 0,
            Rows: 100000,
            Name: "",
            TurnDownDateBegin: "",
            TurnDownDateEnd: "",
          };
        }
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.customerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  return service;
});

communityReceiveReferralModule.controller("communityReceiveReferralController",function($ionicHistory,$scope,$rootScope,$state, communityReceiveReferralService, enumFactory, commonFunctionFactory, paginationService, userService){
  // 初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      Name: "",
      Status: ""
    };

    $scope.search();
    $scope.showSelect($scope);
  };

  //查看诊单
  $scope.goReferralDetail=function(item){
    $rootScope.updatePatient = item;
    $state.go("communityReceiveReferralDetail");
  };

  //返回
  $scope.goBack = function(){
    $ionicHistory.goBack();
  };

  /*搜索事件*/
  $scope.search = function () {
    communityReceiveReferralService.getDiagnosisReplyList($scope.searchPar, $scope);
  };

  /*更多查询按钮*/
  $scope.isTrue = false;
  $scope.toggle = function () {
    $scope.isTrue = !$scope.isTrue;
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //时间年月日时分
  $scope.getDateToMinuteText = function (date) {
    return resources.displayText.DateToMinuteText(date);
  };

  //转院管理状态
  $scope.DiagnosisReplyStatus = function (status) {
    return commonFunctionFactory.displayText.DiagnosisReplyStatus(status);
  };

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    communityReceiveReferralService.getPatientList($scope);
    //获取医生列表
    communityReceiveReferralService.getUser($scope);
    //获取机构
    communityReceiveReferralService.getCustomerExclude($scope);
  };

  //初始化查找类型
  $scope.searchTypeList = enumFactory.SearchType;

  /*自定义查询事件*/
  $scope.customSearch = function () {
    $scope.searchPar.Name = $scope.searchPar.PatientName;
    $scope.searchPar.TurnOutDateBegin = "";
    $scope.searchPar.TurnOutDateEnd = "";
    $scope.search();
  };

  /*最新时间查询事件*/
  $scope.newTimePatientSearch = function () {
    var today = new Date();
    var oldday = new Date(today.getTime() - 6 * 24 * 3600 * 1000);
    var beginDate = new Date(oldday.getFullYear(), oldday.getMonth(), oldday.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      Name: "",
      TurnDownDateBegin: commonFunctionFactory.displayText.DateToDayText(beginDate),
      TurnDownDateEnd: commonFunctionFactory.displayText.DateToDayText(endDate)
    };
    $scope.search();
  };

  /*今日患者事件*/
  $scope.todayPatientSearch = function () {
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      Name: "",
      TurnDownDateBegin: commonFunctionFactory.displayText.DateToDayText(beginDate),
      TurnDownDateEnd: commonFunctionFactory.displayText.DateToDayText(endDate)
    };
    $scope.search();
  };

  //根据类型进行患者查询
  $scope.searchSort = function (value) {
    switch (value) {
      case 0:
        $scope.customSearch();
        break;
      case 1:
        break;
      case 2:
        break;
      case 3:
        break;
      case 4:
        $scope.todayPatientSearch();
        break;
      case 5:
        $scope.newTimePatientSearch();
        break;

    }
  }

  $scope.initialize();
});

angular.bootstrap($('communityReceiveReferral'), ['communityReceiveReferralModule']);
