/**
 * Created by ylj on 2016/10/26.
 * 已优化
 */
var communityReceiveReferralDetailModule = angular.module("communityReceiveReferralDetailModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);
communityReceiveReferralDetailModule.service("communityReceiveReferralDetailService", function ($state, $http, httpHandlerService, resourceFactory) {
  var service = {};

  //获取向下转院列表
  service.getDiagnosisReplyList = function (data, $scope) {
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DiagnosisReply = response.Body.DiagnosisReplyList;
          $scope.DiagnosisReplyList = response.Body.DiagnosisReplyList;
          if (response.Body.DiagnosisReplyList != null && response.Body.DiagnosisReplyList.length > 0) {
            $scope.showDetail(response.Body.DiagnosisReplyList[0], response.Body.DiagnosisReplyList[0].IsReceiver)
          }
          /*response.Body.DiagnosisReplyList[0]*/
          //搜索条件清空
          $scope.searchPar = {
            BeginRow: 0,
            Rows: 100000,
            Name: "",
            TurnDownDateBegin: "",
            TurnDownDateEnd: "",
          };
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //修改向下转院
  service.updateDiagnosisReply = function (data, $scope) {
    $scope.updatePatient.VisitList.VisitDate = $scope.getDateTimeType($scope.updatePatient.VisitList.VisitDate);
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
           navigator.notification.alert("操作成功", function () {
           }, "提示消息", "确定");
          //alert("操作成功");
          $state.go("communityReceiveReferral");
        }
        else {
          //alert("操作失败");
          navigator.notification.alert("操作失败", function () {
           }, "提示消息", "确定");
        }
        ;

      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 更新文件
  service.updateReadFile = function ($scope) {
    for (var i = 0; i < $scope.updatePatient.FileList.length; i++) {
      $scope.updatePatient.FileList[i].State = 2;
    }

    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.FileList.length; j++) {
        var current = $scope.updatePatient.FileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }

      if (!exist) {
        $scope.updatePatient.FileList.push(upload);
      }
    }
    service.updateDiagnosisReply($scope.updatePatient, $scope);
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.customerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };
  return service;
});

communityReceiveReferralDetailModule.controller("communityReceiveReferralDetailController", function ($ionicPopup,$ionicLoading,resourceFactory, $ionicHistory, $scope, $rootScope, $state, communityReceiveReferralDetailService, enumFactory, commonFunctionFactory, paginationService, userService) {
  // 初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      Name: "",
      Status: ""
    };

    // 分页初始化
    //paginationService.initialize($scope);
    //$scope.search();
    $scope.admissionsStatus();
    $scope.showSelect($scope);
    $scope.showDetail($rootScope.updatePatient);
  };

  //是否有上转诊单 （显示/隐藏）
  $scope.currentUser = userService.getUser().Body;
  $scope.updatePatient = $rootScope.updatePatient;

  //是否有上转诊单 （显示/隐藏）
  $scope.ShowReply = true;
  $scope.canReadFile = false;

  if ($scope.updatePatient.DiagnosisAsk == null) {
    $scope.ShowReply = false;
    // 暂时只判下级医院 新增权限
    $scope.canReadFile = true;
  }
  $scope.GetCustomerNo = $scope.updatePatient.CustomerName;
  if ($scope.updatePatient.Patient.Birthday != null) {
    $scope.updatePatient.Patient.Birthday = ($scope.updatePatient.Patient.Birthday).substr(0, 10);
  }
  if ($scope.updatePatient.DiagnosisReply.TurnDownDate) {
    $scope.updatePatient.DiagnosisReply.TurnDownDate = ($scope.updatePatient.DiagnosisReply.TurnDownDate).substr(0, 10);
  }

  //返回
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };

  //查看关联
  $scope.goCommunityScanMessage = function () {
    $state.go("communityScanMessage");
  };

  //上转
  $scope.goUpReferral = function () {
    $ionicLoading.show({
      content: 'Loading',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });
    $state.go("communityReceiveDown");
    $ionicLoading.hide();
  };

  //初始化性别
  $scope.GenderList = enumFactory.GenderList;

  /*搜索事件*/
  $scope.search = function () {
    communityReceiveReferralDetailService.getDiagnosisReplyList($scope.searchPar, $scope);
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

//人员类型
  $scope.PatientTypeText = function (status) {
    return commonFunctionFactory.displayText.PatientTypeList(status);
  };

  //转院类型
  $scope.AskTypeText = function (state) {
    return commonFunctionFactory.displayText.AskTypeText(state);
  };

  //修改数据
  $scope.UpdateDiagnosisReply = function (flg) {
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), today.getHours(), today.getMinutes(), 0);
    $scope.updatePatient.VisitList = [];

    if ($scope.updatePatient.Visit) {
      $scope.updatePatient.Visit.DiagnosisID = $scope.updatePatient.DiagnosisReply.DiagnosisAskID;
      $scope.updatePatient.Visit.PatientID = $scope.updatePatient.DiagnosisReply.PatientID;
        //填写了内容未填写日期默认当前日期
      if ($scope.updatePatient.Visit.VisitContent) {
        if (!$scope.updatePatient.Visit.VisitDate) {
          $scope.updatePatient.Visit.VisitDate = beginDate;
        }
      }
      $scope.updatePatient.VisitList.push($scope.updatePatient.Visit);
    }
    if (flg == 0) {
      $scope.updatePatient.DiagnosisReply.AskCustomerDoctorID = $scope.currentUser.User.UserID;
      $scope.updatePatient.DiagnosisReply.AskCustomerDoctorName = $scope.currentUser.User.Name;
      $scope.updatePatient.DiagnosisReply.AskCustomerDoctorDate = $scope.getDateTimeType(beginDate);
      $scope.updatePatient.DiagnosisReply.Status = 1;
    } else if (flg == 1) {
      $scope.updatePatient.DiagnosisReply.AskCustomerDoctorID = "";
      $scope.updatePatient.DiagnosisReply.AskCustomerDoctorName = "";
      $scope.updatePatient.DiagnosisReply.AskCustomerDoctorDate = "";
      $scope.updatePatient.DiagnosisReply.Status = 0;
    }else if( flg == 2){
      if ($scope.updatePatient.Visit.VisitContent == "" || $scope.updatePatient.Visit.VisitContent == null) {
        navigator.notification.alert("随访内容不能为空！", function () {
        }, "提示消息", "确定");

      } else if ($scope.updatePatient.Visit.VisitDate == "" || $scope.updatePatient.Visit.VisitDate == null) {
        navigator.notification.alert("请选择随访日期！", function () {
        }, "提示消息", "确定");
      }
    }
    communityReceiveReferralDetailService.updateReadFile($scope);

  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    communityReceiveReferralDetailService.getPatientList($scope);
    //获取医生列表
    communityReceiveReferralDetailService.getUser($scope);
    //获取机构
    communityReceiveReferralDetailService.getCustomerExclude($scope);
  };

  /*点击详情*/
  $scope.showDetail = function (item) {
    //$scope.cleanModal();
    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    if ($scope.updatePatient.Patient != null && $scope.updatePatient.Patient.Birthday != null) {
      $scope.updatePatient.Patient.Birthday = $scope.getDateTimeType($scope.updatePatient.Patient.Birthday);
    }
    if ($scope.updatePatient.DiagnosisReply) {
      if ($scope.updatePatient.DiagnosisReply.TurnDownDate) {
        $scope.updatePatient.DiagnosisReply.TurnDownDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisReply.TurnDownDate);
      }
      if ($scope.updatePatient.DiagnosisReply.AskCustomerDoctorDate) {
        $scope.updatePatient.DiagnosisReply.AskCustomerDoctorDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisReply.AskCustomerDoctorDate);
      }
    }
    if ($scope.updatePatient.Visit) {
      if ($scope.updatePatient.Visit.VisitDate) {
        $scope.updatePatient.Visit.VisitDate = $scope.getDateTimeType($scope.updatePatient.Visit.VisitDate);
      }
    }
    $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
    $scope.createFileList($scope.uploadedFiles);

    $scope.ShowCustomer = true;
    if (item.IsReceiver == "1") {
      $scope.GetCustomerNo = $scope.updatePatient.CustomerName;
      $scope.ShowCustomer = false;
    }

    //是否有上转诊单 （显示/隐藏）
    $scope.ShowReply = true;
    $scope.canReadFile = false;
    if ($scope.updatePatient.DiagnosisAsk == null) {
      $scope.ShowReply = false;
      // 暂时只判下级医院 新增权限
      $scope.canReadFile = $scope.currentUser.IsTop == 0 && $scope.updatePatient.DiagnosisReply.Status == 1 && $scope.updatePatient.DiagnosisAsk == null;
    }
  };

  // 能否关闭接诊单
  $scope.CanClose = function () {
    if ($scope.updatePatient && $scope.updatePatient.DiagnosisReply.Status != 2) {
      if (authentication.checkAuthentication($scope.currentUser.RoleModuleList, "M001", 4, $scope.currentUser.UserType)) {
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  };

  // 关闭接诊单弹出
  $scope.ShowCloseDiagnosisReply = function () {
    $ionicPopup.show({
        template: "<textarea cols='10' rows='5' textarea-auto= 'true' ng-model = 'updatePatient.DiagnosisReply.ClosedReason'></textarea>",
        title: '关闭理由',
        scope: $scope,
        buttons: [
          {
            text: "确定",
            onTap:function(){
              if (!$scope.updatePatient.DiagnosisReply.ClosedReason) {
                navigator.notification.alert("请填写关闭理由",function(){},"提示消息","确定");
                return;
              }
              $scope.updatePatient.DiagnosisReply.Status = 2;
              communityReceiveReferralDetailService.updateReadFile($scope);
            }
          }
        ]
      })
      .then(function (res) {
      });
  };

  //接诊按钮显示隐藏
  $scope.admissionsStatus = function () {
    if ($scope.updatePatient != undefined && $scope.updatePatient.DiagnosisReply.Status == 0) {
      if (authentication.checkAuthentication($scope.currentUser.RoleModuleList, "M001", 4, $scope.currentUser.UserType)) {
        return true;
      } else {
        return false;
      }
    } else {
      console.log(4);
      return false;
    }
  };

  //页面显示相关
  $scope.showEachReadFile = function (file) {
    console.log(file.SourceName);
    if(file.SourceName.length>6){
      file.SourceName = (file.SourceName).substr(0,6) +"...";
    }
    if (file.SourceName.indexOf(".jpg") > -1 || file.SourceName.indexOf(".png") > -1 || file.FileName.indexOf(".jpeg") > -1) {
      return communityReceiveReferralDetailService.getFileBase() + file.CustomerID + "/" + file.FileName;
    } else {
      return "img/attachment_icon.png";
    }
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }
    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = communityReceiveReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = communityReceiveReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].ShowFile = communityReceiveReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisReplyList = [];
      $scope.changePaginationContent($scope.DiagnosisReply, $scope.DiagnosisReplyList);
    }
  });

  /*附件样式start*/
  $scope.bigImage = false;    //初始默认大图是隐藏的
  $scope.hideBigImage = function () {
    $scope.bigImage = false;
  };
  var ScreenHeight = window.screen.height;
  $scope.showBigImage = function (imageName) {
    $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true;
    var rightDisplay = document.getElementById("rightDisplay");
    rightDisplay.style.height = ScreenHeight + "px";
  };
  /*附件样式end*/

  //下载图片
  $scope.downloadImg = function(file){
    navigator.notification.confirm('您确定要下载吗？', showConfirm, '下载文件', '确定,取消');
    var url = communityReceiveReferralService.getFileBase() + file.CustomerID + "/" + file.FileName;
    function showConfirm(button) {
      if( button == 1 ) {
        download.downloadFile(url);
      } else {
      }
    }
  };

  $scope.initialize();
});

angular.bootstrap($('communityReceiveReferralDetail'), ['communityReceiveReferralDetailModule']);
