/**
 * Created by ylj on 2016/10/24.
 * 已优化
 */
var communityReferralDetailModule = angular.module("communityReferralDetailModule", ['resourceModule', "bookControllers", "bookService"]);
communityReferralDetailModule.service("communityReferralDetailService", function ($ionicLoading, $http, httpHandlerService, resourceFactory) {
  var service = {};

  //获取向上转院列表
  service.getDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DiagnosisAsk = response.Body.DiagnosisAskList;
          $scope.DiagnosisAskList = [];
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //修改向上操作
  service.UpdateDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getDiagnosisAskList($scope.searchPar, $scope);
          //alert("修改成功")
          navigator.notification.alert("修改成功", function () {
          }, "提示消息", "确定");
        }
        else {
          //alert("修改失败")
          navigator.notification.alert("修改失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 更新文件
  service.updateReadFile = function ($scope) {
    for (var i = 0; i < $scope.updatePatient.FileList.length; i++) {
      $scope.updatePatient.FileList[i].State = 2;
    }
    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.FileList.length; j++) {
        var current = $scope.updatePatient.FileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }
      if (!exist) {
        $scope.updatePatient.FileList.push(upload);
      }
    }
    $ionicLoading.hide();
    service.UpdateDiagnosisAskList($scope.updatePatient, $scope);
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取机构排除自己查询
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.topCustomerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取绿色通道科室数据（排除未开放科室）
  service.getDepartmentCanOrderLocalRequest = function (data, $scope) {
    httpHandlerService.getDepartmentCanOrderLocalRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.RegInfoBeCurrent = response.Body.DepartmentList;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取科室医生数据
  service.getDoctorByDepartmentIDRequest = function (data, $scope) {
    httpHandlerService.getDoctorByDepartmentIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DepartmentUser = response.Body.UserList;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取科室数据
  service.getAllDepartmentChooseRequest = function (data, $scope) {
    httpHandlerService.getDepartmentSelectRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerDepartment = response.Body.DepartmentList;
          $scope.Gy3yCustomerDepartment = $scope.CustomerDepartment;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  return service;
});
communityReferralDetailModule.controller("communityReferralDetailController", function ($ionicLoading, resourceFactory, $scope, $rootScope, $ionicPopup, $state, $ionicHistory, communityReferralDetailService, enumFactory, commonFunctionFactory, paginationService, resourceService, userService, service) {
  // 初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body;
    $scope.updatePatient.Patient.Birthday = ($scope.updatePatient.Patient.Birthday).substr(0, 10);
    console.log($scope.updatePatient.DiagnosisAsk.RegisteredDate);
    if ($scope.updatePatient.DiagnosisAsk.RegisteredDate != null) {
      $scope.updatePatient.DiagnosisAsk.RegisteredDate = ($scope.updatePatient.DiagnosisAsk.RegisteredDate).substr(0, 10);
    }

    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: ""
    };

    //判下级医院 修改权限
    $scope.updateFleReadFile = $scope.updatePatient.DiagnosisAsk.Status != 1 && authentication.checkAuthentication($scope.currentUser.RoleModuleList, "M002", 2, $scope.currentUser.UserType);

    //检查是否已预约
    $scope.RegistereNo = true;
    if ($scope.updatePatient.DiagnosisAsk.RegisteredNo) {
      $scope.RegistereNo = false;
    }
    if ($scope.updatePatient.DiagnosisAsk.ReplyCustomerID == "gy3y") {
      $scope.CustomerDepartment = $scope.Gy3yCustomerDepartment;
      $scope.DepartmentUser = [];
    } else {
      $scope.CustomerDepartment = [];
      $scope.DepartmentUser = [];
    }

    //根据科室查询医生
    var data = {RequestDepartmentID: $scope.updatePatient.DiagnosisAsk.AssignDepartmentID, RequestIsTop: 1};
    communityReferralDetailService.getDoctorByDepartmentIDRequest(data, $scope);
    //默认加载广医三院的科室
    var data2 = {ReceiveCustomerID: "gy3y", ReceiveIsTop: 1, ModuleType: 1};
    communityReferralDetailService.getAllDepartmentChooseRequest(data2, $scope);

    $scope.search();
    $scope.showSelect($scope);
  };

  $scope.updatePatient = $rootScope.updatePatient;
  $scope.updatePatient.DiagnosisAsk.TurnOutDate = new Date($scope.updatePatient.DiagnosisAsk.TurnOutDate);
  $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));

  // 选择医院
  $scope.changeCustomer = function (type) {
    if (type == 0) {
      if ($scope.AddDiagnosisAsk.DiagnosisAsk.ReplyCustomerID == "gy3y") {
        $scope.CustomerDepartment = $scope.Gy3yCustomerDepartment;
        $scope.DepartmentUser = [];
      } else {
        $scope.CustomerDepartment = [];
        $scope.DepartmentUser = [];
      }
    } else {
      if ($scope.updatePatient.DiagnosisAsk.ReplyCustomerID == "gy3y") {
        $scope.CustomerDepartment = $scope.Gy3yCustomerDepartment;
        $scope.DepartmentUser = [];
      } else {
        $scope.CustomerDepartment = [];
        $scope.DepartmentUser = [];
      }
    }
  };

  //初始化性别
  $scope.GenderList = resources.factoryList;

  //初始化转院类型
  $scope.AskTypeList = enumFactory.AskType;

  //人员类型
  $scope.PatientTypeList = enumFactory.PatientTypeList;

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  /*搜索事件*/
  $scope.search = function () {
    communityReferralDetailService.getDiagnosisAskList($scope.searchPar, $scope);
  };

  //根据省份证号码绑定生日，性别
  $scope.IdentityCardBirthday = function (flg) {
    if (flg == 0) {
      var IdentityCard = $scope.AddDiagnosisAsk.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.AddDiagnosisAsk.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisAsk.Patient.Gender = 0;
        } else {
          $scope.AddDiagnosisAsk.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisAsk.Patient.Gender = 1;
        }
      }
    } else if (flg == 1) {
      var IdentityCard = $scope.updatePatient.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender / 2 == 0) {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 0;
        } else {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 1;
        }
      }
    }
  };

  //修改数据
  $scope.submitDiagnosisAsk = function () {
    var RegCard = /^[1-9]{1}[0-9]{14}$|^[1-9]{1}[0-9]{16}([0-9]|[xX])$/;
    if ($scope.updatePatient.Patient.Name == "" || $scope.updatePatient.Patient.Name == undefined) {
      navigator.notification.alert("患者姓名不能为空！", function () {
      }, "提示消息", "确定");
    } else if ($scope.updatePatient.Patient.Birthday == "" || $scope.updatePatient.Patient.Birthday == undefined) {
      navigator.notification.alert("出生日期不能为空！", function () {
      }, "提示消息", "确定");
    } else if ($scope.updatePatient.Patient.IdentityCard == "" || $scope.updatePatient.Patient.IdentityCard == undefined || RegCard.test($scope.updatePatient.Patient.IdentityCard) == false) {
      navigator.notification.alert("请输入正确格式的身份证号！", function () {
      }, "提示消息", "确定");
    } else if ($scope.updatePatient.DiagnosisAsk.FirstDoctorName == "" || $scope.updatePatient.DiagnosisAsk.FirstDoctorName == undefined) {
      navigator.notification.alert("首诊医生不能为空！", function () {
      }, "提示消息", "确定");
    } else if ($scope.updatePatient.DiagnosisAsk.TurnOutDate == "" || $scope.updatePatient.DiagnosisAsk.TurnOutDate == undefined) {
      navigator.notification.alert("转诊日期不能为空！", function () {
      }, "提示消息", "确定");
    } else {
      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: true,
        maxWidth: 200,
        showDelay: 0
      });
      alert(00)
      $scope.updatePatient.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.TurnOutDate);
      alert(11);
      communityReferralDetailService.updateReadFile($scope);
    }

  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    communityReferralDetailService.getPatientList($scope);
    //获取医生列表
    communityReferralDetailService.getUser($scope);
    //获取机构列表
    communityReferralDetailService.getCustomerExclude($scope);
  };

  // 页面显示相关
  $scope.showEachReadFile = function (file) {
    console.log((file.SourceName).substr(0, 6) + "...");
    if (file.SourceName.length > 6) {
      file.SourceName = (file.SourceName).substr(0, 6) + "...";
    }
    if (file.FileName.indexOf(".jpg") > -1 || file.FileName.indexOf(".png") > -1 || file.FileName.indexOf(".jpeg") > -1) {
      return communityReferralDetailService.getFileBase() + file.CustomerID + "/" + file.FileName;
    }
    else {
      return "img/attachment_icon.png";
    }
  };

  //添加附件
  $scope.uploadFile = function () {
    // 从指定来源检索图像文件位置
    var options = {
      //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
      quality: 100,                                            //相片质量0-100
      destinationType: Camera.DestinationType.DATA_URL,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
      sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,       //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
      allowEdit: false,                                        //在选择之前允许修改截图
      encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
      targetWidth: 200,                                        //照片宽度
      //targetHeight: 1000,                                       //照片高度
      mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
      cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: true                                   //保存进手机相册
    };
    navigator.camera.getPicture(function onPhotoDataSuccess(imageData) {
      var bstr = atob(imageData);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }

      var blob = new Blob([u8arr.buffer], {type: 'image/jpeg'});
      blob.fileName = new Date().getTime() + ".jpg";
      communityReferralDetailService.uploadFiles(blob, function (data) {
          if (data == null || data.Body == null) {
            navigator.notification.alert("上传失败", function () {
            }, "提示消息", "确定");
          }
          for (var i = 0; i < data.Body.length; i++) {
            var file = data.Body[i];
            file.SourceName = blob.fileName;
            file.CustomerID = $scope.currentUser.CustomerID;
            $scope.uploadedFiles.push(data.Body[i]);
          }
          $scope.createFileList($scope.uploadedFiles);
        },
        function (data) {
          navigator.notification.alert("上传失败", function () {
          }, "提示消息", "确定");
        });
      //};
    }, function (err) {
      navigator.notification.alert("未选择任何图片", function () {
      }, "提示消息", "确定");
    }, options);
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }

    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = communityReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = "../images/attachment_icon.png";
          files[i].ShowFile = communityReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisAskList = [];
      $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
    }
  });

  //返回
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };

  $scope.goToBook = function () {
    //获取科室列表
    var data = {CustomerID: $scope.updatePatient.ReplyCustomer.CustomerID}
    console.log($scope.updatePatient.ReplyCustomer.CustomerID);
    service.getDepartmentCanOrderLocalRequest(data, $scope);
    //service.getDepartment($scope,$rootScope);
    //$scope.departmentList = $rootScope.departmentList;
    $state.go("book");
  };
  /*附件样式start*/
  $scope.showTab = true;
  $scope.bigImage = false;    //初始默认大图是隐藏的
  $scope.hideBigImage = function () {
    $scope.bigImage = false;
    $scope.showTab = true;
  };
  var ScreenHeight = window.screen.height;
  $scope.showBigImage = function (imageName) {
    $scope.showTab = false;
    $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true;
    var rightDisplay = document.getElementById("rightDisplay");
    rightDisplay.style.height = ScreenHeight - 100 + "px";
  };
  /*附件样式end*/

  //删除图片
  $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };

  //科室医生
  $scope.CustomerDepartmentMedical = function (selectAssignDeparID) {
    var data = {RequestIsTop: 1, RequestDepartmentID: selectAssignDeparID};
    communityReferralDetailService.getDoctorByDepartmentIDRequest(data, $scope);
  };

  //图片下载
  $scope.downloadImg = function (file) {
    navigator.notification.confirm('您确定要下载吗？', showConfirm, '下载文件', '确定,取消');
    var url = communityReferralDetailService.getFileBase() + file.CustomerID + "/" + file.FileName;

    function showConfirm(button) {
      if (button == 1) {
        download.downloadFile(url);
      } else {
      }
    }
  };

  $scope.initialize();
})

angular.bootstrap($("#communityReferralDetail"), ["communityReferralDetailModule"]);

