/**
 * Created by ylj on 2016/10/24.
 * 已优化
 */
var communityReferralListModule = angular.module("communityReferralListModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule","bookControllers","bookService"]);
communityReferralListModule.service("communityReferralListService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};
  //获取向上转院列表
  service.getDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
         /* $scope.setTotalItems(response.Body.TotalRows);
          $scope.getPagination();*/
          $scope.DiagnosisAskList = response.Body.DiagnosisAskList;
        /*  $scope.DiagnosisAskList = [];
          $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);*/
        }
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取机构排除自己查询
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.topCustomerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  return service;
});

communityReferralListModule.controller("communityReferralListController", function ($ionicLoading,$ionicHistory,$ionicScrollDelegate,$scope, $rootScope, $state, $ionicPopup, communityReferralListService, enumFactory, commonFunctionFactory, paginationService, resourceService, userService,service) {
  // 初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body;
    //$scope.PatientStatusList = enumFactory.PatientStatusList;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: ""
    };

    $scope.search();
    $scope.showSelect($scope);
  };

  //新增上转单
  $scope.gocommunityAddReferral = function () {
    $ionicLoading.show({
      content: 'Loading',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });
    $rootScope.fileList = [];
    $rootScope.ReproductiveFileList = [];
    $state.go("communityAddReferral");
    $ionicLoading.hide();
  };

  //查看上转单详情
  $scope.goReferralDetail = function (item) {
    $rootScope.updatePatient = item;
    $state.go("communityReferralDetail");
  };

  //返回
  $scope.goBack = function(){
    $ionicHistory.goBack();
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //时间年月日时分
  $scope.getDateToMinuteText = function (date) {
    return resources.displayText.DateToMinuteText(date);
  };

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //转院管理状态
  $scope.DiagnosisAskStatus = function (status) {
    return commonFunctionFactory.displayText.DiagnosisAskStatus(status);
  };

  /*搜索事件*/
  $scope.search = function () {
    communityReferralListService.getDiagnosisAskList($scope.searchPar, $scope);
  };

  /*自定义查询事件*/
  $scope.customSearch = function () {
    $scope.searchPar.Name = $scope.searchPar.PatientName;
    $scope.searchPar.TurnOutDateBegin = "";
    $scope.searchPar.TurnOutDateEnd = "";
    $scope.search();
  };

  /*更多查询按钮*/
  $scope.isTrue = false;
  $scope.toggle = function () {
    $scope.isTrue = !$scope.isTrue;
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    communityReferralListService.getPatientList($scope);
    //获取医生列表
    communityReferralListService.getUser($scope);
    //获取机构列表
    communityReferralListService.getCustomerExclude($scope);
  };

  //列表编辑显示隐藏
  $scope.showDetailed = function (type) {
    if (type == "1") {
      $scope.DetailedShow = true;
      $scope.DetailedShow != $scope.DetailedShow;
      $scope.DiagnosisAskShow = false;
      $scope.DiagnosisAskShow != $scope.DiagnosisAskShow;
      $scope.DiagnosisReplyShow = false;
      $scope.DiagnosisReplyShow != $scope.DiagnosisReplyShow;
      $scope.fileDetailShow = false;
      $scope.fileDetailShow != $scope.fileDetailShow;

      $scope.SelectedLi = true;
      $scope.SelectedLi != $scope.SelectedLi;
      $scope.SelectedLi2 = false;
      $scope.SelectedLi2 != $scope.SelectedLi2;
      $scope.SelectedLi3 = false;
      $scope.SelectedLi3 != $scope.SelectedLi3;
      $scope.SelectedLi4 = false;
      $scope.SelectedLi4 != $scope.SelectedLi4;
    } else if (type == "2") {
      $scope.DiagnosisAskShow = true;
      $scope.DiagnosisAskShow != $scope.DiagnosisAskShow;
      $scope.DetailedShow = false;
      $scope.DetailedShow != $scope.DetailedShow;
      $scope.DiagnosisReplyShow = false;
      $scope.DiagnosisReplyShow != $scope.DiagnosisReplyShow;
      $scope.fileDetailShow = false;
      $scope.fileDetailShow != $scope.fileDetailShow;

      $scope.SelectedLi = false;
      $scope.SelectedLi != $scope.SelectedLi;
      $scope.SelectedLi2 = true;
      $scope.SelectedLi2 != $scope.SelectedLi2;
      $scope.SelectedLi3 = false;
      $scope.SelectedLi3 != $scope.SelectedLi3;
      $scope.SelectedLi4 = false;
      $scope.SelectedLi4 != $scope.SelectedLi4;

      if ($scope.updatePatient.DiagnosisAsk != null && $scope.updatePatient.Patient != null) {
        $scope.hide = true;
      }

    } else if (type == "3") {
      $scope.DiagnosisReplyShow = true;
      $scope.DiagnosisReplyShow != $scope.DiagnosisReplyShow;
      $scope.DetailedShow = false;
      $scope.DetailedShow != $scope.DetailedShow;
      $scope.DiagnosisAskShow = false;
      $scope.DiagnosisAskShow != $scope.DiagnosisAskShow;
      $scope.fileDetailShow = false;
      $scope.fileDetailShow != $scope.fileDetailShow;

      $scope.SelectedLi = false;
      $scope.SelectedLi != $scope.SelectedLi;
      $scope.SelectedLi2 = false;
      $scope.SelectedLi2 != $scope.SelectedLi2;
      $scope.SelectedLi3 = true;
      $scope.SelectedLi3 != $scope.SelectedLi3;
      $scope.SelectedLi4 = false;
      $scope.SelectedLi4 != $scope.SelectedLi4;

      if ($scope.updatePatient.DiagnosisReply == null) {
        $scope.hide = false;
      }

    } else if (type == "0") {
      $scope.DiagnosisReplyShow = false;
      $scope.DiagnosisReplyShow != $scope.DiagnosisReplyShow;
      $scope.DetailedShow = false;
      $scope.DetailedShow != $scope.DetailedShow;
      $scope.DiagnosisAskShow = false;
      $scope.DiagnosisAskShow != $scope.DiagnosisAskShow;
      $scope.fileDetailShow = true;
      $scope.fileDetailShow != $scope.fileDetailShow;

      $scope.SelectedLi = false;
      $scope.SelectedLi != $scope.SelectedLi;
      $scope.SelectedLi2 = false;
      $scope.SelectedLi2 != $scope.SelectedLi2;
      $scope.SelectedLi3 = false;
      $scope.SelectedLi3 != $scope.SelectedLi3;
      $scope.SelectedLi4 = true;
      $scope.SelectedLi4 != $scope.SelectedLi4;

      if ($scope.updatePatient.FileList != null) {
        $scope.hide = true;
      }
    }
  };

  // 动态查询患者
  $scope.changePatientLevel = function () {
    $scope.PatientComBoxList = [];
    if ($scope.AddDiagnosisAsk.Patient.Name == "") {
      return;
    }
    for (var i = 0; i < $scope.PatientComBox.length; i++) {
      var temp = $scope.PatientComBox[i];
      if (temp.Name.indexOf($scope.AddDiagnosisAsk.Patient.Name) > -1) {
        $scope.PatientComBoxList.push(temp);
      }
    }
  };

  // 加载患者数据
  $scope.searchTemplateClick = function (temp) {
    $scope.AddDiagnosisAsk.Patient.Name = temp.Name;
    $scope.AddDiagnosisAsk.Patient.Phone = temp.Phone;
    $scope.AddDiagnosisAsk.Patient.Gender = temp.Gender;
    $scope.AddDiagnosisAsk.Patient.Birthday = resources.displayText.DateToDayText(temp.Birthday);
    $scope.AddDiagnosisAsk.Patient.IdentityCard = temp.IdentityCard;
    $scope.AddDiagnosisAsk.Patient.Address = temp.Address;
    $scope.AddDiagnosisAsk.Patient.UserID = temp.PatientID;
    $scope.AddDiagnosisAsk.Patient.PatientType = temp.PatientType;
    $scope.PatientComBoxList = [];
  };

  //动态查询医生
  $scope.changeUserLevel = function (flg) {
    if (flg == "0") {
      $scope.InsertUserComBoxList = [];
      if ($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i];
        if (temp.Name.indexOf($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.InsertUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "1") {
      $scope.UpdateUserComBoxList = [];
      if ($scope.updatePatient.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i];
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.UpdateUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "2") {
      $scope.UpdateReceiveDoctor = [];
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i];
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName) > -1) {
          $scope.UpdateReceiveDoctor.push(temp);
        }
      }
    }
    if (flg == "3") {
      $scope.UpdateDiagnosis = [];
      if ($scope.updateDiagnosisAsk.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i];
        if (temp.Name.indexOf($scope.updateDiagnosisAsk.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.UpdateDiagnosis.push(temp);
        }
      }
    }
    if (flg == "4") {
      $scope.UpReceiveDoctor = [];
      if ($scope.updateDiagnosisAsk.DiagnosisAsk.ReceiveDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i];
        if (temp.Name.indexOf($scope.updateDiagnosisAsk.DiagnosisAsk.ReceiveDoctorName) > -1) {
          $scope.UpReceiveDoctor.push(temp);
        }
      }
    }
  };

  //绑定首诊医生数据
  $scope.searchUserClick = function (temp, flg) {
    if (flg == "0") { //首诊医生新增
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.InsertUserComBoxList = [];
    }
    if (flg == "1") {
      $scope.updatePatient.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.UpdateUserComBoxList = [];
    }
    if (flg == "2") {
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorName = temp.Name;
      $scope.UpdateReceiveDoctor = [];
    }
    if (flg == "3") {
      $scope.updateDiagnosisAsk.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.updateDiagnosisAsk.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.UpdateDiagnosis = [];
    }
    if (flg == "4") {
      $scope.updateDiagnosisAsk.DiagnosisAsk.ReceiveDoctorName = temp.UserID;
      $scope.updateDiagnosisAsk.DiagnosisAsk.ReceiveDoctorName = temp.Name;
      $scope.UpReceiveDoctor = [];
    }
  };

  //科室
  $scope.focusShow = function ($event, id) {
    resourceService.focusShow($event, id);
  };

  $scope.blurHide = function (name, id) {
    resourceService.blurHide(name, id);
  };

  $scope.inactiveClick = function ($event) {
    resourceService.inactiveClick($event);
  };

  /*清空新增患者*/
  $scope.cleanModal = function () {
    $scope.updateDiagnosisAsk = {
      UploadState: "∨",
      DetailState: "∨",
      RemarkState: "∨",
      ApprovalState: "∨",
      Gender: 1,
      Status: 0
    };
    $scope.uploadedFiles = [];
  };

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisAskList = [];
      $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
    }
  });
  /**/
  $scope.testList = function (){
    $ionicScrollDelegate.resize();
  };

  //初始化查找类型
  $scope.searchTypeList = enumFactory.SearchType;

  /*最新时间查询事件*/
  $scope.newTimePatientSearch = function () {
    var today = new Date();
    var oldday = new Date(today.getTime() - 6 * 24 * 3600 * 1000);
    var beginDate = new Date(oldday.getFullYear(), oldday.getMonth(), oldday.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      Name: "",
      TurnOutDateBegin: commonFunctionFactory.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: commonFunctionFactory.displayText.DateToDayText(endDate)
    };
    $scope.search();
  };

  /*今日患者事件*/
  $scope.todayPatientSearch = function () {
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);

    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      Name: "",
      TurnOutDateBegin: commonFunctionFactory.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: commonFunctionFactory.displayText.DateToDayText(endDate)
    };
    $scope.search();
  };

  //根据类型进行患者查询
  $scope.searchSort = function (value) {

    switch (value) {
      case 0:
        $scope.customSearch();
        break;
      case 1:
        break;
      case 2:
        break;
      case 3:
        break;
      case 4:
        $scope.todayPatientSearch();
        break;
      case 5:
        $scope.newTimePatientSearch();
        break;

    }
  };

  $scope.initialize();
});
angular.bootstrap($('communityReferralList'), ['communityReferralListModule']);

