/**
 * Created by ylj on 2017/1/18.
 */
gysyApp.service("communityReproductionDetailService", function (resourceFactory,httpHandlerService) {
  var service = {};

  //获取生殖列表
  service.getReproductiveList = function (data, $scope) {
    $("#loading_div").modal("show");
    console.log(data);
    httpHandlerService.ReproductiveRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body && response.Body.ReproductiveList) {
          $scope.ReproductiveList = response.Body.ReproductiveList;
          //搜索条件清空
          $scope.searchPar = {
            BeginRow: 0,
            Rows: 100000,
            Name: "",
            BeginDate: "",
            EndDate: ""
          };
        } else {
          console.log(response);
          alert("获取数据出错，请稍后重试");
        }
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 文件上传路径base
  service.getReproductionFileBase = function () {
    return resourceFactory.address.reproductionDomain;
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.UploadReproductiveImageRequest(data, successCallback, errorCallback)
  };

  // 生成模板数据
  service.createItems = function (tag) {
    var items = [];
    var divs = $(tag);
    for (var i = 0; i < divs.length; i++) {
      var temp = {
        text: [],
        checkbox: [],
        select: []
      };
      $(divs[i]).find("input[type='text'],textarea").each(function (i, input) {
        temp.text.push($(input).val());
      });

      $(divs[i]).find("input[type='checkbox'], input[type='radio']").each(function (i, input) {
        temp.checkbox.push($(input).is(":checked"));
      });

      $(divs[i]).find("select").each(function (i, input) {
        temp.select.push($(input).val());
      });

      items.push({
        IVFContent: divs[i].outerHTML,
        IVFParams: JSON.stringify(temp)
      });
    }

    return items;
  };

  // 展示模板数据
  service.showItems = function (data) {
    for (var i = 0; i < data.length; i++) {
      var item = data[i];
      // 诊断
      if (item.IVFContent && item.IVFContent.indexOf('<div name="diagnosis">') > -1) {
        service.loadItems(item.IVFContent, item.IVFParams, "#UpdateReproduction #showDiagnosis", true, false);
      }
      // 诊疗过程
      else if (item.IVFContent && item.IVFContent.indexOf('<div name="treatProcess">') > -1) {
        service.loadItems(item.IVFContent, item.IVFParams, "#UpdateReproduction #showTreatProcess", false, false);
      } else {
        service.loadItems(item.IVFContent, item.IVFParams, "#UpdateReproduction .reproductionIVF", false, true);
        $("#UpdateReproduction .reproductionIVF").show();
      }
    }
  };

  // 解读模板数据
  service.loadItems = function (html, obj, tag, isPrepend, isModel) {
    var data = JSON.parse(obj);
    var container = $(tag);
    if (isPrepend) {
      container.prepend(html);
    } else {
      container.append(html);
    }

    var target = container;
    if (isModel) {
      var divs = $(tag + " div[name]");
      target = divs[divs.length - 1];
    }

    $(target).find("input[type='text'],textarea").each(function (i, input) {
      if (data.text.length > i) {
        $(input).val(data.text[i]);
      }
    });

    $(target).find("input[type='checkbox'], input[type='radio']").each(function (i, input) {
      if (data.checkbox.length > i) {
        if (data.checkbox[i]) {
          $(input).attr("checked", true);
        }
      }
    });

    $(target).find("select").each(function (i, input) {
      if (data.select.length > i) {
        $(input).val(data.select[i]);
      }
    });
  };

  //修改生殖单
  service.updateReproductionRequest = function (data, $scope) {
    httpHandlerService.ReproductiveRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getReproductiveList($scope.searchPar, $scope);
          $("#UpdateReproduction").modal("hide");
          alert("修改成功");
        }
        else {
          alert("修改失败");
        }

        $("#loading_div").modal("hide");
      },
      function (response) {
        console.log(response);
        $("#loading_div").modal("hide");
      }
    );
  };

  // 更新生殖单
  service.updateReproduction = function ($scope) {
    /*if (!$.formValidator.pageIsValid("2")) {
      return;
    }

    if ($scope.updatePatient.RelationPatient &&
      ($scope.updatePatient.RelationPatient.Name || $scope.updatePatient.RelationPatient.IdentityCard || $scope.updatePatient.RelationPatient.Phone)
      && !$.formValidator.pageIsValid("4")) {
      return;
    }*/

    $("#loading_div").modal("show");

    // 处理文件
    for (var i = 0; i < $scope.updatePatient.ReproductiveFileList.length; i++) {
      $scope.updatePatient.ReproductiveFileList[i].State = 2;
    }

    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.ReproductiveFileList.length; j++) {
        var current = $scope.updatePatient.ReproductiveFileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }

      if (!exist) {
        $scope.updatePatient.ReproductiveFileList.push(upload);
      }
    }

    // 处理动态模板
    // 模板
    var items = service.createItems("#UpdateReproduction .reproductionIVF div[name]");

    // 诊疗过程
    items = items.concat(service.createItems("#UpdateReproduction div[name='treatProcess']"));

    // 诊断
    items = items.concat(service.createItems("#UpdateReproduction div[name='diagnosis']"));

    for (var j = 0; j < items.length; j++) {
      var item = items[j];
      var exist = false;
      /*for (var i = 0; i < $scope.updatePatient.ReproductiveIVFList.length; i++) {
        var file = $scope.updatePatient.ReproductiveIVFList[i];
        if (file.IVFContent == item.IVFContent) {
          file.IVFParams = item.IVFParams;
          exist = true;
          break;
        }
      }*/
      for (var i = 0; i < $scope.updatePatient.ReproductiveIVFList.length; i++) {
        var file = $scope.updatePatient.ReproductiveIVFList[i];

        // check div name
        if (file.IVFContent && item.IVFContent && file.IVFContent.split('>')[0] == item.IVFContent.split('>')[0]) {
          file.IVFParams = item.IVFParams;
          exist = true;
          break;
        }
      }

      if (!exist) {
        $scope.updatePatient.ReproductiveIVFList.push(item);
      }
    }

    // 非新建 改动 状态变为有更新
    if ($scope.updatePatient.Reproductive.Status != 0) {
      $scope.updatePatient.Reproductive.Status = 6;
    }

    service.updateReproductionRequest($scope.updatePatient, $scope);
  };

  return service;
});
gysyApp.controller("communityReproductionDetailController", function ($rootScope,$scope,$ionicHistory,communityReproductionDetailService,userService,enumFactory) {
  //初始化
  $scope.initialize = function () {

    var item = $rootScope.item;
    var index = $rootScope.index;
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginDate: resources.displayText.DateToDayText(beginDate),
      EndDate: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: "",
      ModuleNo: "M013"
    };

    $scope.showDoctor = false;
    $scope.UpdateReproductionModel = 0;
    $scope.uploadedFiles = [];
    $("#UpdateReproduction .reproductionIVF").html("");
    $("#UpdateReproduction .reproductionIVF").hide();
    $("#UpdateReproduction #showTreatProcess").html("");
    $("#UpdateReproduction #showDiagnosis div[name='diagnosis']").remove();

    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.ReproductiveFileList));
    $scope.createFileList($scope.uploadedFiles);

    //判下级医院 修改权限
    $scope.updateFleReadFile = authentication.checkAuthentication($scope.currentUser.RoleModuleList, "M013", 2, $scope.currentUser.UserType);
    if (!$scope.updateFleReadFile) {
      $scope.showLabel = true;
      $scope.showInput = false;
    } else {
      $scope.showLabel = false;
      $scope.showInput = true;
    }

    //加载首诊医生是否为空
    if ($scope.updatePatient.Reproductive.FirstDoctorName) {
      $scope.showDoctor = false;
    }

    $scope.selectIndex = index;

    // 展示动态html
    communityReproductionDetailService.showItems($scope.updatePatient.ReproductiveIVFList);

    // 审查建议
    if ($scope.updatePatient.ReproductiveMessageList && $scope.updatePatient.ReproductiveMessageList.length > 0) {
      $scope.updatePatient.LatestReproductiveMessage = $scope.updatePatient.ReproductiveMessageList[$scope.updatePatient.ReproductiveMessageList.length - 1].Message;
    }
  };

  $scope.goBack = function(){
    $ionicHistory.goBack();
  };
  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }

    for (var i = 0; i < files.length; i++) {
      var url = files[i].FileName;
      files[i].ShowUrl = communityReproductionDetailService.getReproductionFileBase() + url;
    }
  };

  //修改数据
  $scope.submitReproduction = function () {
    $scope.updatePatient.Reproductive.PatientName = $scope.updatePatient.Patient.Name;
    $scope.updatePatient.ModuleNo = "M013";
    if ($scope.showDoctor == false) {
      communityReproductionDetailService.updateReproduction($scope);
    }
    else {
      alert("输入的首诊医生不存在");
    }
  };

  //初始化性别
  $scope.GenderList = resources.factoryList;

  //生殖模块
  $scope.ReproductionModelList = enumFactory.ReproductionModelList;

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //动态查询医生
  $scope.changeUserLevel = function (flg) {
    if (flg == "0") {
      $scope.InsertUserComBoxList = [];
      if ($scope.AddReproduction.Reproduction.FirstDoctorName == "") {
        return;
      }

      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddReproduction.Reproduction.FirstDoctorName) > -1) {
          $scope.InsertUserComBoxList.push(temp);
        }
      }

      $scope.showDoctor = false;
      if ($scope.InsertUserComBoxList.length == 0) {
        $scope.showDoctor = true;
      }
    } else if (flg == "1") {
      $scope.UpdateUserComBoxList = [];
      if ($scope.updatePatient.Reproductive.FirstDoctorName == "") {
        return;
      }

      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.Reproductive.FirstDoctorName) > -1) {
          $scope.UpdateUserComBoxList.push(temp);
        }
      }

      $scope.showDoctor = false;
      if ($scope.UpdateUserComBoxList.length == 0) {
        $scope.showDoctor = true;
      }
    }
  };

  //绑定首诊医生数据
  $scope.searchUserClick = function (temp, flg) {
    if (flg == "0") { //首诊医生新增
      $scope.AddReproduction.Reproduction.FirstDoctorID = temp.UserID;
      $scope.AddReproduction.Reproduction.FirstDoctorName = temp.Name;
      $scope.InsertUserComBoxList = [];
    }
    if (flg == "1") {
      $scope.updatePatient.Reproductive.FirstDoctorID = temp.UserID;
      $scope.updatePatient.Reproductive.FirstDoctorName = temp.Name;
      $scope.UpdateUserComBoxList = [];
    }
  };

  var modelZero = '<div name="zero">' +
    '<h2 style="text-align: center">婚育史</h2>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-4 col-md-4 col-sm-4">' +
    '        <select>' +
    '            <option value="1">初婚</option>' +
    '            <option value="2">再婚</option>' +
    '        </select>' +
    '        <input type="text">年；' +
    '    </div>' +
    '    <div class="col-lg-8 col-md-8 col-sm-8">' +
    '        避孕方式：<input type="checkbox">无/<input' +
    '            type="checkbox">避孕药/<input type="checkbox">避孕套/<input' +
    '            type="checkbox">上环/<input type="checkbox">输卵管结扎；' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-4 col-md-4 col-sm-4">未避孕未怀孕 <input' +
    '            type="text">年' +
    '    </div>' +
    '    <div class="col-lg-8 col-md-8 col-sm-8">性生活正常：' +
    '        <select>' +
    '            <option value="1">正常</option>' +
    '            <option value="2">不正常</option>' +
    '        </select>' +
    '        <input type="text">次/(<input' +
    '                type="radio" name="sexTime">周/<input type="radio" name="sexTime">月)' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        男方排精正常：' +
    '        <select>' +
    '            <option value="1">正常</option>' +
    '            <option value="2">不正常</option>' +
    '        </select>' +
    '        <input type="checkbox">阳痿/<input' +
    '            type="checkbox">无阴道内射精；' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">顺产 <input' +
    '            type="text">次/剖宫产 <input type="text">次，现存：<input' +
    '            type="text">男/<input' +
    '            type="text">女，末次分娩时间：<input class="inputYear"' +
    '                                        type="text">年/<input' +
    '            type="text">月' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">自然流产 <input' +
    '            type="text">次，' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        ①时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月孕 <input type="text">周，清宫：<input' +
    '            type="radio" name="oneQingGong">是/<input type="radio" name="oneQingGong">否，绒毛染色体 <input' +
    '            type="radio" name="oneRongMaoRanSeTi">否/<input type="radio" name="oneRongMaoRanSeTi">是' +
    '        <input type="text">' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        ②时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月孕 <input type="text">周，清宫：<input' +
    '            type="radio" name="twoQingGong">是/<input type="radio" name="twoQingGong">否，绒毛染色体 <input' +
    '            type="radio" name="twoRongMaoRanSeTi">否/<input type="radio" name="twoRongMaoRanSeTi">是' +
    '        <input type="text">' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        <select>' +
    '            <option value="1">药物流产</option>' +
    '            <option value="2">人工</option>' +
    '        </select>' +
    '        <input type="text">次，最后一次时间' +
    '        <input type="text" class="inputYear">年<input' +
    '            type="text">月<input type="text">日' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">宫外孕 <input' +
    '            type="text">次，' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        ①时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月，<input type="checkbox">左/<input' +
    '            type="checkbox">右，治疗：' +
    '        <select>' +
    '            <option value="1">保守治疗</option>' +
    '            <option value="2">切开取胚</option>' +
    '            <option value="3">输卵管切除</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        ②时间：<input type="text" class="inputYear">年 <input' +
    '            type="text">月，<input type="checkbox">左/<input' +
    '            type="checkbox">右，治疗：' +
    '        <select>' +
    '            <option value="1">保守治疗</option>' +
    '            <option value="2">切开取胚</option>' +
    '            <option value="3">输卵管切除</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">既往史：<textarea' +
    '            class="textareaVA" cols="50" rows="1"></textarea></div>' +
    '</div>' +
    '</div>';

  var modelOne = '<div name="one">' +
    '<h2 style="text-align: center">月经史</h2>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12"' +
    '         style="margin: 0 auto;">' +
    '        第一次来月经 <input type="text">岁；最近一年中，平均 <input type="text">天来一次月经/月经持续' +
    '        <input type="text">天；' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        月经量：' +
    '        <select>' +
    '            <option value="1">正常</option>' +
    '            <option value="2">多</option>' +
    '            <option value="3">少</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        是否痛经：' +
    '        <select>' +
    '            <option value="1">是</option>' +
    '            <option value="2">否</option>' +
    '        </select>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-12 col-md-12 col-sm-12">' +
    '        末次月经时间：<input type="text" class="inputYear">年<input' +
    '            type="text">月<input type="text">日。' +
    '    </div>' +
    '</div>' +
    '</div>';

  var modelTwo = '<div name="two">' +
    '<h2 style="text-align: center">相关检查和手术</h2>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3">输卵管造影术</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9">' +
    '        左侧：<input type="checkbox">通畅/<input' +
    '            type="checkbox">通而不畅/<input' +
    '            type="checkbox">阻塞' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3"></div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9">' +
    '        右侧：<input type="checkbox">通畅/<input' +
    '            type="checkbox">通而不畅/<input type="checkbox">阻塞，时间：<input' +
    '            type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3">宫腔镜检查术</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9"><input' +
    '            class="inputWidth" type="text">时间：<input' +
    '            type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3">腹腔镜</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9"><input' +
    '            class="inputWidth" type="text">时间：<input' +
    '            type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3">基础性激素</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9">FSH <input' +
    '            type="text">ul/l, LH <input type="text">ul/l, E2' +
    '        <input type="text">pmol/L, T<input' +
    '                type="text">nmol/L, PRL' +
    '        <input type="text">ng/ml, AMH <input' +
    '                type="text">ng/ml, 时间：<input' +
    '                type="text" class="inputYear">年 <input type="text">月。;' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3">其它</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9"><textarea' +
    '            class="textareaVA" name="" id="" cols="50"' +
    '            rows="1"></textarea>' +
    '    </div>' +
    '</div>' +
    '<div class="row form-group">' +
    '    <div class="col-lg-3 col-md-3 col-sm-3">配偶精液</div>' +
    '    <div class="col-lg-9 col-md-9 col-sm-9">密度 <input' +
    '            type="text">, PR(a级+b级)<input type="text">%,' +
    '        NP(c级)<input' +
    '                type="text">%, 畸形率 <input type="text">% 时间：<input' +
    '                type="text" class="inputYear">年 <input type="text">月。' +
    '    </div>' +
    '</div>' +
    '</div>';

  // 修改模板变换
  $scope.changeUpdateReproductionModel = function () {
    var model = "";
    var name = "";
    switch ($scope.UpdateReproductionModel) {
      case 0:
        model = modelZero;
        name = "#UpdateReproduction .reproductionIVF div[name='zero']";
        break;
      case 1:
        model = modelOne;
        name = "#UpdateReproduction .reproductionIVF [name='one']";
        break;
      case 2:
        model = modelTwo;
        name = "#UpdateReproduction .reproductionIVF [name='two']";
        break;
      default:
        return;
    }

    if ($(name).length > 0) {
      alert("所选的模块已经添加");
      return;
    } else {
      $("#UpdateReproduction .reproductionIVF").append(model);
      $("#UpdateReproduction .reproductionIVF").show();
    }
  };

//图片上传
  $scope.selectFile = function () {
    // 从指定来源检索图像文件位置
    var options = {
      //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
      quality: 100,                                            //相片质量0-100
      destinationType: Camera.DestinationType.DATA_URL,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
      sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,       //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
      allowEdit: false,                                        //在选择之前允许修改截图
      encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
      targetWidth: 200,                                        //照片宽度
      targetHeight: 200,                                       //照片高度
      mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
      cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: true                                   //保存进手机相册
    };
    navigator.camera.getPicture(function onPhotoDataSuccess(imageData) {
      var bstr = atob(imageData);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }

      var blob = new Blob([u8arr.buffer], {type: 'image/jpeg'});
      blob.fileName = new Date().getTime() + ".jpg";
      communityReproductionDetailService.uploadFiles(blob, function (data) {
          if (data == null || data.Body == null) {
            navigator.notification.alert("上传失败1", function () {
            }, "提示消息", "确定");
          }
          for (var i = 0; i < data.Body.length; i++) {
            var file = data.Body[i];
            file.SourceName = blob.fileName;
            file.CustomerID = $scope.currentUser.CustomerID;
            $scope.uploadedFiles.push(data.Body[i]);

          }

          $scope.createFileList($scope.uploadedFiles);
        },
        function (data) {
          navigator.notification.alert("上传失败2", function () {
          }, "提示消息", "确定");
        });
      //};
    }, function (err) {
      navigator.notification.alert("未选择任何图片", function () {
      }, "提示消息", "确定");
    }, options);
  };

  $scope.initialize();
});
