/**
 * Created by ylj on 2017/1/13.
 */
gysyApp.service("communityReproductionListService", function (httpHandlerService, resourceFactory) {
  var service = {};

  //获取生殖列表
  service.getReproductiveList = function (data, $scope) {
    httpHandlerService.ReproductiveRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body && response.Body.ReproductiveList) {
          $scope.ReproductiveList = response.Body.ReproductiveList;
          //搜索条件清空
          $scope.searchPar = {
            BeginRow: 0,
            Rows: 100000,
            Name: "",
            BeginDate: "",
            EndDate: ""
          };
        } else {
          alert("获取数据出错，请稍后重试");
          console.log(response);
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  return service;
});
gysyApp.controller("communityReproductionListController", function ($rootScope,$scope, $ionicHistory,$state, communityReproductionListService, userService,commonFunctionFactory) {

  //初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginDate: resources.displayText.DateToDayText(beginDate),
      EndDate: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: "",
      ModuleNo: "M013"
    };
    $scope.search();
  };

  /*搜索事件*/
  $scope.search = function () {
    communityReproductionListService.getReproductiveList($scope.searchPar, $scope);
  };

  //生殖状态
  $scope.ReproductiveStatusText = function (date) {
    return commonFunctionFactory.displayText.ReproductiveStatusText(date);
  };

  //返回
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };

  //详情页面
  $scope.goCommunityReproductionDetail = function(item,index){
    $rootScope.item = item;
    $rootScope.index = index;
    $state.go("communityReproductionDetail");
};

  //新增生殖
  $scope.goCommunityAddReproduction = function(){
      $state.go("communityAddReproduction");
  };
  $scope.initialize();
});
