var discussModule = angular.module("DiscussModule", ["httpHandlerModule", "resourceModule", "UserModule", "sessionModule"]);

discussModule.factory("DiscussFactory", function (commonFunctionFactory) {
  return {
    initialize: function () {
      // 验证
      $.formValidator.initConfig({validatorGroup: "1", mode: "AlertTip"});
      $($("#addChat input[name='addChatSubject']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: commonFunctionFactory.validate.validateRequired});
      $($("#addChat input[name='addChatCreateTime']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: commonFunctionFactory.validate.validateMobile});
      $.formValidator.initConfig({validatorGroup: "2", mode: "AlertTip"});
      $($("#updateChat input[name='updateChatSubject']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: commonFunctionFactory.validate.validateRequired});
      $($("#updateChat input[name='updateChatCreateTime']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: commonFunctionFactory.validate.validateMobile});

      // 日期控件
      /**/ //  commonFunctionFactory.date.createDateTimePicker(["addChatCreateTime", "addUpdateCreateTime"]);
    }
  }
});

discussModule.service("DiscussService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};
  //获取层级数据
  service.getDoctorGroupByDepartment = function ($scope) {
    httpHandlerService.getDoctorGroupByDepartmentRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.customerList = response.Body;
        }
        else {
          console.error("没有任何用户");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // 获取所有chat数据通过groupid
  service.getListByGroupID = function (groupId, $scope) {
    httpHandlerService.getListByGroupIDRequest({GroupID: groupId}, resourceFactory.operateCode.get,
      function (response) {
        $scope.groupMemberList = [];
        $scope.groupList = [];
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          for (var i = 0; i < response.Body.ChatList.length; i++) {
            var temp = JSON.parse(JSON.stringify(response.Body.ChatList[i]));
            $scope.groupMemberList.push(temp.Chat);
            $scope.groupList.push(temp.Partner);
          }
        }
        else {
          console.error("获取失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // 获取所有chat数据通过groupid
  service.removeByGroupID = function (groupId, $scope) {
    httpHandlerService.removeByGroupIDRequest({GroupID: groupId}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getChatList({FunctionType: 1}, $scope);
          navigator.notification.alert("删除成功", function () {
          }, "提示消息", "确定");
        }
        else {
          navigator.notification.alert("删除失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取聊天列表
  service.getChatList = function (data, $scope) {
    httpHandlerService.chatRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          $scope.ChatList = response.Body.ChatList;
        }
        else {
          $scope.ChatList = [];
          navigator.notification.alert("当前没有会诊组", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 新增聊天
  service.addChat = function ($scope) {
    if (!$.formValidator.pageIsValid("1")) {
      return;
    }

    if ($scope.loginSuccessfully) {
      IM.group.createGroup(
        $scope.addChat.Subject,
        1,
        2,  // 群组
        "",
        "",
        "",
        "",
        function (obj) {
          var groupId = obj.data;
          console.log(groupId);
          var dataBag = [];
          for (var i = 0; i < $scope.selectdUsers.length; i++) {
            var temp = {
              Subject: $scope.addChat.Subject,
              BeginTime: $scope.addChat.BeginTime,
              PartnerID: $scope.selectdUsers[i].UserID,
              CreatorID: $scope.currentUser.UserID,
              GroupID: groupId,
              Status: 0,
              FunctionType: 1
            };

            // 组创建者默认参加
            if (temp.PartnerID == $scope.currentUser.UserID) {
              temp.Status = 1;
            }

            dataBag.push(temp);
          }

          httpHandlerService.chatRequest({ChatList: dataBag}, resourceFactory.operateCode.insert,
            function (response) {
              if (response.Header.StatusCode == 0) {
                navigator.notification.alert("新增成功", function () {
                }, "提示消息", "确定");
                service.getChatList({FunctionType: 1}, $scope);
              }
              else {
                navigator.notification.alert("新增失败", function () {
                }, "提示消息", "确定");
              }
            },
            function (response) {
              navigator.notification.alert("新增失败", function () {
              }, "提示消息", "确定");
            }
          );
        }, function (obj) {
          navigator.notification.alert("创建会诊群失败", function () {
          }, "提示消息", "确定");
        }
      );
    } else {
      navigator.notification.alert("还没有登陆成功", function () {
      }, "提示消息", "确定");

    }
  };

  // 更新聊天
  service.updateChat = function ($scope, isSingle) {
    if (isSingle) {
      $scope.Partners = [];
      $scope.Partners.push($scope.updateChat.Chat);
    } else {
      if (!$.formValidator.pageIsValid("2")) {
        return;
      }

      // 先删除所有
      for (var i = 0; i < $scope.Partners.length; i++) {
        $scope.Partners[i].Subject = $scope.updateChat.Chat.Subject;
        $scope.Partners[i].BeginTime = $scope.updateChat.Chat.BeginTime;
        $scope.Partners[i].State = 2;
      }

      // 更新或添加
      for (var i = 0; i < $scope.selectdUsers.length; i++) {
        var selectedUser = $scope.selectdUsers[i];
        var exist = false;
        for (var j = 0; j < $scope.Partners.length; j++) {
          var partner = $scope.Partners[j];
          if (partner.PartnerID == selectedUser.UserID) {
            exist = true;
            $scope.Partners[j].State = 0;
            break;
          }
        }

        if (!exist) {
          var temp = {
            Subject: $scope.updateChat.Chat.Subject,
            BeginTime: $scope.updateChat.Chat.BeginTime,
            PartnerID: selectedUser.UserID,
            CreatorID: $scope.updateChat.Chat.CreatorID,
            Status: 0,
            FunctionType: 1,
            GroupID: $scope.updateChat.Chat.GroupID
          };
          $scope.Partners.push(temp);
        }
      }
    }

    httpHandlerService.chatRequest({ChatList: $scope.Partners}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("更新成功", function () {
          }, "提示消息", "确定");
          service.getChatList({FunctionType: 1}, $scope);
        }
        else {
          navigator.notification.alert("更新失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        navigator.notification.alert("更新失败", function () {
        }, "提示消息", "确定");
      }
    );
  };

  return service;
});

gysyApp.controller("DiscussController", function ($scope, $state, DiscussService, DiscussFactory, enumFactory, commonFunctionFactory, userService, sessionFactory) {
  // 初期化
  DiscussFactory.initialize();
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body.User;
    // IM
    IM.common.initializeSDK();
    IM.common.login($scope.currentUser.UserID, function (obj) {
      $scope.loginSuccessfully = true;
    });
    $scope.search();
    DiscussService.getDoctorGroupByDepartment($scope);
  };
  /*进入会诊间*/
  $scope.goGroupDiscuss = function () {
    $scope.goSetting = function () {
      $state.go("setting");
    }
    $state.go("GroupDiscuss");
  };
  /*搜索事件*/
  $scope.search = function () {
    DiscussService.getChatList({FunctionType: 1}, $scope);
  };

  // 选择li
  $scope.selectLi = function (li) {
    li.show = !li.show;
  };

  // 选择User
  $scope.selectUser = function (user, department, departmentCategory, customer) {
    $scope.UserToSelect = user;
    $scope.UserToSelect.Department = department;
    $scope.UserToSelect.DepartmentCategory = departmentCategory;
    $scope.UserToSelect.Customer = customer;
  };

  // 选中删除人
  $scope.selectDeleteUser = function (user) {
    $scope.UserToDelete = user;
  };

  // 删除选中人
  $scope.deleteSelectUser = function (type) {
    if ($scope.UserToDelete.UserID == null) {
      return;
    }

    if (type == 0 && $scope.UserToDelete.UserID == $scope.currentUser.UserID) {
      navigator.notification.alert("会诊组创建人不能删除", function () {
      }, "提示消息", "确定");
      return;
    } else if (type == 1 && $scope.UserToDelete.UserID == $scope.updateChat.Chat.CreatorID) {
      navigator.notification.alert("会诊组创建人不能删除", function () {
      }, "提示消息", "确定");
      return;
    }

    for (var i = 0; i < $scope.selectdUsers.length; i++) {
      if ($scope.selectdUsers[i].UserID == $scope.UserToDelete.UserID) {
        $scope.selectdUsers.splice(i, 1);
        return;
      }
    }
  };

  // 添加选中人
  $scope.addSelectUser = function () {
    if ($scope.UserToSelect.UserID == null) {
      return;
    }

    var exist = false;
    for (var i = 0; i < $scope.selectdUsers.length; i++) {
      if ($scope.selectdUsers[i].UserID == $scope.UserToSelect.UserID) {
        exist = true;
        break;
      }
    }

    if (!exist) {
      $scope.selectdUsers.push($scope.UserToSelect);
    }
  };

  // 建造selectedUser
  $scope.createSelectedUser = function (userid) {
    for (var i = 0; i < $scope.customerList.length; i++) {
      var customer = $scope.customerList[i];
      for (var j = 0; j < customer.DepartmentCategoryList.length; j++) {
        var departmentCategory = customer.DepartmentCategoryList[j];
        for (var n = 0; n < departmentCategory.DepartmentList.length; n++) {
          var department = departmentCategory.DepartmentList[n];
          for (var k = 0; k < department.UserList.length; k++) {
            var user = department.UserList[k];
            if (user.UserID == userid) {
              user.Department = department.Department;
              user.DepartmentCategory = departmentCategory.DepartmentCategory;
              user.Customer = customer.Customer;
              return user;
            }
          }
        }
      }
    }

    return null;
  };

  // 弹出新增会诊间
  $scope.showAdd = function () {
    $scope.cleanModal();
    // 默认添加当前人
    var temp = $scope.createSelectedUser($scope.currentUser.UserID);
    if (temp != null) {
      $scope.selectdUsers.push(temp);
    }

    $('#addChat').modal('show');
  };

  /*清空新增会诊间*/
  $scope.cleanModal = function () {
    $scope.addChat = {};
    $scope.selectdUsers = [];
    $scope.UserToSelect = {};
    $scope.UserToDelete = {};
  };

  /*点击详情*/
  $scope.showDetail = function (item) {
    $scope.updateChat = JSON.parse(JSON.stringify(item));
    $scope.cleanModal();
    $scope.Partners = [];
    DiscussService.getListByGroupID($scope.updateChat.Chat.GroupID, $scope);
  };

  // 参加/拒绝
  $scope.updateStatus = function (item, status) {
    $scope.updateChat = JSON.parse(JSON.stringify(item));
    $scope.updateChat.Chat.Status = status;
    DiscussService.updateChat($scope, true);
  };

  // 删除
  $scope.deleteChat = function (item) {
    if (item.Chat.CreatorID == $scope.currentUser.UserID) {
      DiscussService.removeByGroupID(item.Chat.GroupID, $scope);
    } else {
      $scope.updateChat = JSON.parse(JSON.stringify(item));
      $scope.updateChat.Chat.State = 2;
      DiscussService.updateChat($scope, true);
    }
  };

  /*提交更新会诊间*/
  $scope.submitUpdateChat = function () {
    DiscussService.updateChat($scope);
  };

  /*提交新增会诊间*/
  $scope.submitAddChat = function () {
    DiscussService.addChat($scope);
  };

  // 状态
  $scope.StatusText = function (status) {
    switch (status) {
      case 0:
        return "待定"
      case 1:
        return "参加"
      case 2:
        return "拒绝"
      default:
        return "待定"
    }
  };

  // 显示用户名
  $scope.selectUserText = function (selectUser) {
    //var result = selectUser.Name + "(" + selectUser.Customer.CustomerName + "-" + selectUser.DepartmentCategory.Name + "-" + selectUser.Department.Name + ")";
    var result = selectUser.Name;
    if (selectUser.Status != null) {
      result += "(" + $scope.StatusText(selectUser.Status) + ")";
    }

    return result;
  };

  // 进入会诊间页面
  $scope.goDiscuss = function (item) {
    sessionFactory.saveDataToSession("groupID", item.Chat.GroupID);
    sessionFactory.saveDataToSession("groupCreatorID", item.Chat.CreatorID);
    sessionFactory.saveDataToSession("groupSubject", item.Chat.Subject);
    sessionFactory.saveDataToSession("groupBeginTime", item.Chat.BeginTime);
    window.open("GroupDiscuss.html");
    //window.location.href = "GroupDiscuss.html";
  };

  $scope.showText = function (show) {
    if (show) {
      return "-";
    } else {
      return "+";
    }
  };

  // $scope.initialize();
});

angular.bootstrap($("#mainContent"), ["DiscussModule"]);
