/**
 * Created by ylj on 2016/10/11.
 */
/*var discussGroupListModule = angular.module("discussGroupListModule", ["httpHandlerModule", "resourceModule", "UserModule", "sessionModule"]);*/
gysyApp.factory("discussGroupListFactory", function (commonFunctionFactory) {
  return {
    initialize: function () {
      // 验证
      $.formValidator.initConfig({validatorGroup: "1", mode: "AlertTip"});
      $($("#addChat input[name='addChatSubject']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: commonFunctionFactory.validate.validateRequired});
      $.formValidator.initConfig({validatorGroup: "2", mode: "AlertTip"});
      $($("#updateChat input[name='updateChatSubject']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: commonFunctionFactory.validate.validateRequired});
    }
  }
});
gysyApp.service("discussGroupListService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};
  //获取层级数据
  service.getDoctorGroupByDepartment = function ($scope) {
    httpHandlerService.getDoctorGroupByDepartmentRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.customerList = response.Body;
        }
        else {
          console.error("没有任何用户");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // 获取所有chat数据通过groupid
  service.getListByGroupID = function (groupId, $scope) {
    httpHandlerService.getListByGroupIDRequest({GroupID: groupId}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          for (var i = 0; i < response.Body.ChatList.length; i++) {
            $scope.Partners.push(response.Body.ChatList[i].Chat);
          }

          for (var i = 0; i < $scope.Partners.length; i++) {
            var partner = $scope.createSelectedUser($scope.Partners[i].PartnerID);
            if (partner != null) {
              partner.Status = $scope.Partners[i].Status;
              $scope.selectdUsers.push(partner);
            }
          }

          $('#updateChat').modal('show');
        }
        else {
          console.error("获取失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // 获取所有chat数据通过groupid
  service.removeByGroupID = function (groupId, $scope) {
    httpHandlerService.removeByGroupIDRequest({GroupID: groupId}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getChatList({FunctionType: 1}, $scope);
          navigator.notification.alert("删除成功", function () {
          }, "提示消息", "确定");
        }
        else {
          navigator.notification.alert("删除失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //获取聊天列表
  service.getChatList = function (data, $scope) {
      httpHandlerService.chatRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          $scope.ChatList = response.Body.ChatList;

          // 推送
          pushGoEasy.initialize();
          for (var i = 0; i < $scope.chatList.length; i++) {
            var chat = $scope.chatList[i].Chat;
            for (var j = 0; j < $scope.subChannels.length; j++) {
              var sub = $scope.subChannels[j];
              if (sub == chat.GroupID) {
                exist = true;
                break;
              }
            }

            var channel = "chat_channel_" + chat.GroupID;
            $scope.subChannels.push(chat.GroupID);
            pushGoEasy.subscribe(channel, function (result) {
              var content = JSON.parse(result.content);
              if ($scope.groupID == content.Header.GroupID && $scope.createSystemInformation) {
                $scope.createSystemInformation(content.Body.content);
              }
            });
          }
        }
        else {
          $scope.ChatList = [];
          navigator.notification.alert("当前没有会诊间", function () {
          }, "提示消息", "确定");
          //alert("当前没有会诊间")
        }
        $scope.resetGroupList();
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 新增聊天
  service.addChat = function ($scope) {
    if (!$.formValidator.pageIsValid("1")) {
      return;
    }

    if ($scope.loginSuccessfully) {
      IM.group.createGroup(
        $scope.addChat.Subject,
        1,
        2,  // 群组
        "",
        "",
        "",
        "",
        function (obj) {
          var groupId = obj.data;
          console.log(groupId);
          var dataBag = [];
          for (var i = 0; i < $scope.selectdUsers.length; i++) {
            var temp = {
              Subject: $scope.addChat.Subject,
              BeginTime: $scope.addChat.BeginTime,
              PartnerID: $scope.selectdUsers[i].UserID,
              CreatorID: $scope.currentUser.UserID,
              GroupID: groupId,
              Status: 0,
              FunctionType: 1
            };

            // 组创建者默认参加
            if (temp.PartnerID == $scope.currentUser.UserID) {
              temp.Status = 1;
            }

            dataBag.push(temp);
          }

          httpHandlerService.chatRequest({ChatList: dataBag}, resourceFactory.operateCode.insert,
            function (response) {
              if (response.Header.StatusCode == 0) {
                navigator.notification.alert("新增成功", function () {
                }, "提示消息", "确定");
                service.getChatList({FunctionType: 1}, $scope);
              }
              else {
                navigator.notification.alert("新增失败", function () {
                }, "提示消息", "确定");
              }
            },
            function (response) {
              navigator.notification.alert("新增失败", function () {
              }, "提示消息", "确定");
            }
          );
        }, function (obj) {
          navigator.notification.alert("创建会诊间失败", function () {
          }, "提示消息", "确定");
        }
      );
    } else {
      navigator.notification.alert("还没有登陆成功", function () {
      }, "提示消息", "确定");
    }
  };

  // 更新聊天
  service.updateChat = function ($scope, isSingle) {
    if (isSingle) {
      $scope.Partners = [];
      $scope.Partners.push($scope.updateChat.Chat);
    } else {
      if (!$.formValidator.pageIsValid("2")) {
        return;
      }

      // 先删除所有
      for (var i = 0; i < $scope.Partners.length; i++) {
        $scope.Partners[i].Subject = $scope.updateChat.Chat.Subject;
        $scope.Partners[i].BeginTime = $scope.updateChat.Chat.BeginTime;
        $scope.Partners[i].State = 2;
      }

      // 更新或添加
      for (var i = 0; i < $scope.selectdUsers.length; i++) {
        var selectedUser = $scope.selectdUsers[i];
        var exist = false;
        for (var j = 0; j < $scope.Partners.length; j++) {
          var partner = $scope.Partners[j];
          if (partner.PartnerID == selectedUser.UserID) {
            exist = true;
            $scope.Partners[j].State = 0;
            break;
          }
        }

        if (!exist) {
          var temp = {
            Subject: $scope.updateChat.Chat.Subject,
            BeginTime: $scope.updateChat.Chat.BeginTime,
            PartnerID: selectedUser.UserID,
            CreatorID: $scope.updateChat.Chat.CreatorID,
            Status: 0,
            FunctionType: 1,
            GroupID: $scope.updateChat.Chat.GroupID
          };
          $scope.Partners.push(temp);
        }
      }
    }

    httpHandlerService.chatRequest({ChatList: $scope.Partners}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("更新成功", function () {
          }, "提示消息", "确定");
          service.getChatList({FunctionType: 1}, $scope);
        }
        else {
          navigator.notification.alert("更新失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        navigator.notification.alert("更新失败", function () {
        }, "提示消息", "确定");
      }
    );
  };

  // 删除会诊间
  service.submitDeleteUpdateChat = function (chat, $scope) {
    chat.State = 2;
    httpHandlerService.chatRequest({ChatList: [chat]}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getChatList({FunctionType: 1}, $scope);
          navigator.notification.alert("会诊间已删除", function () {
          }, "提示消息", "确定");
        }
        else {
          alert("删除失败");
          navigator.notification.alert("删除失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        navigator.notification.alert("删除失败", function () {
        }, "提示消息", "确定");
      }
    );
  };

  return service;
});
gysyApp.controller("discussGroupListController", function ($ionicLoading,$rootScope,$ionicPopup,$scope, $state, discussGroupListService, discussGroupListFactory, enumFactory, commonFunctionFactory, userService, sessionFactory,resourceFactory,IMGroupListService) {
  $scope.goSetting = function () {
    $state.go("setting");
  };
  $scope.goSelectMember=function(){
    $ionicLoading.show({
      content: 'Loading',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });
    var currentUser = userService.getUser();
    var flg = false;
    // 判断权限
    var list = currentUser.Body.RoleModuleList;
    if(currentUser.Body.UserType == 2){
      flg = true;
    }else{
      for (var i = 0; i < list.length; i++) {
        //var nav = list[i];
        for (var j = 0; j < currentUser.Body.RoleModuleList.length; j++) {
          var roleModule = currentUser.Body.RoleModuleList[j];
          if (roleModule.ModuleNo == "M004" && roleModule.Purview != null && roleModule.Purview.indexOf("1") > -1) {
            flg = true;
            break;
          }
        }
      }
    }
    if(!flg){
      //alert("您没有该权限")
      navigator.notification.alert("您没有该权限", function () {
      }, "提示消息", "确定");
    }else{
      $state.go("selectMember");
    }

    $ionicLoading.hide();
  };
  $scope.goSearchDiscussGroup=function(){
    $ionicPopup.show({
        template: "<input type='tel'>",
        title: "请输入关键字",
        scope: $scope,
        buttons: [
          { text: "确定",
            type:'button-balanced'
          }
        ]
      })
      .then(function (res) {
      });
  }
  $scope.deleteGroup=function(chat){
    var result = confirm("确定要删除此会诊间吗？");
    if(result) {
      discussGroupListService.submitDeleteUpdateChat(chat, $scope);
    }
  };
  // 初期化
  discussGroupListFactory.initialize();
  $scope.initialize = function () {

    $scope.groupPhotoDomain = resourceFactory.address.groupPhotoDomain;
    IMGroupListService.initialize($scope);
    $scope.currentUser = userService.getUser().Body.User;
    // IM
    IM.common.initializeSDK();
    IM.common.login($scope.currentUser.UserID, function (obj) {
      $scope.loginSuccessfully = true;
    });
    $scope.search();
    discussGroupListService.getDoctorGroupByDepartment($scope);
  };
  /*进入会诊间*/
  $scope.goGroupDiscuss = function (item) {
    $rootScope.groupID = item.Chat.GroupID;
    $rootScope.groupSubject = item.Chat.Subject;
    $rootScope.groupCreatorID = item.Chat.CreatorID;
    $rootScope.contactID = $scope.groupID;
    item.UnreadRows = 0;
    $state.go("GroupDiscuss");

  };
  /*搜索事件*/
  $scope.search = function () {
    discussGroupListService.getChatList({FunctionType: 1}, $scope);
  };



  // 选择li
  $scope.selectLi = function (li) {
    li.show = !li.show;
  };

  // 选择User
  $scope.selectUser = function (user, department, departmentCategory, customer) {
    $scope.UserToSelect = user;
    $scope.UserToSelect.Department = department;
    $scope.UserToSelect.DepartmentCategory = departmentCategory;
    $scope.UserToSelect.Customer = customer;
  };

  // 选中删除人
  $scope.selectDeleteUser = function (user) {
    $scope.UserToDelete = user;
  };

  // 删除选中人
  $scope.deleteSelectUser = function (type) {
    if ($scope.UserToDelete.UserID == null) {
      return;
    }

    if (type == 0 && $scope.UserToDelete.UserID == $scope.currentUser.UserID) {
      navigator.notification.alert("会诊间创建人不能删除", function () {
      }, "提示消息", "确定");
      return;
    } else if (type == 1 && $scope.UserToDelete.UserID == $scope.updateChat.Chat.CreatorID) {
      navigator.notification.alert("会诊间创建人不能删除", function () {
      }, "提示消息", "确定");
      return;
    }

    for (var i = 0; i < $scope.selectdUsers.length; i++) {
      if ($scope.selectdUsers[i].UserID == $scope.UserToDelete.UserID) {
        $scope.selectdUsers.splice(i, 1);
        return;
      }
    }
  };

  // 添加选中人
  $scope.addSelectUser = function () {
    if ($scope.UserToSelect.UserID == null) {
      return;
    }

    var exist = false;
    for (var i = 0; i < $scope.selectdUsers.length; i++) {
      if ($scope.selectdUsers[i].UserID == $scope.UserToSelect.UserID) {
        exist = true;
        break;
      }
    }

    if (!exist) {
      $scope.selectdUsers.push($scope.UserToSelect);
    }
  };

  // 建造selectedUser
  $scope.createSelectedUser = function (userid) {
    for (var i = 0; i < $scope.customerList.length; i++) {
      var customer = $scope.customerList[i];
      for (var j = 0; j < customer.DepartmentCategoryList.length; j++) {
        var departmentCategory = customer.DepartmentCategoryList[j];
        for (var n = 0; n < departmentCategory.DepartmentList.length; n++) {
          var department = departmentCategory.DepartmentList[n];
          for (var k = 0; k < department.UserList.length; k++) {
            var user = department.UserList[k];
            if (user.UserID == userid) {
              user.Department = department.Department;
              user.DepartmentCategory = departmentCategory.DepartmentCategory;
              user.Customer = customer.Customer;
              return user;
            }
          }
        }
      }
    }

    return null;
  };

  // 弹出新增会诊间
  $scope.showAdd = function () {
    $scope.cleanModal();
    // 默认添加当前人
    var temp = $scope.createSelectedUser($scope.currentUser.UserID);
    if (temp != null) {
      $scope.selectdUsers.push(temp);
    }

    $('#addChat').modal('show');
  };

  /*清空新增会诊间*/
  $scope.cleanModal = function () {
    $scope.addChat = {};
    $scope.selectdUsers = [];
    $scope.UserToSelect = {};
    $scope.UserToDelete = {};
  };

  /*点击详情*/
  $scope.showDetail = function (item) {
    $scope.updateChat = JSON.parse(JSON.stringify(item));
    $scope.cleanModal();
    $scope.Partners = [];
    discussGroupListService.getListByGroupID($scope.updateChat.Chat.GroupID, $scope);
  };

  // 参加/拒绝
  $scope.updateStatus = function (item, status) {
    $scope.updateChat = JSON.parse(JSON.stringify(item));
    $scope.updateChat.Chat.Status = status;
    discussGroupListService.updateChat($scope, true);
  };

  // 删除
  $scope.deleteChat = function (item) {
    if (item.Chat.CreatorID == $scope.currentUser.UserID) {
      discussGroupListService.removeByGroupID(item.Chat.GroupID, $scope);
    } else {
      $scope.updateChat = JSON.parse(JSON.stringify(item));
      $scope.updateChat.Chat.State = 2;
      discussGroupListService.updateChat($scope, true);
    }
  };

  /*提交更新会诊间*/
  $scope.submitUpdateChat = function () {
    discussGroupListService.updateChat($scope);
  };

  /*提交新增会诊间*/
  $scope.submitAddChat = function () {
    discussGroupListService.addChat($scope);
  };

  // 状态
  $scope.StatusText = function (status) {
    switch (status) {
      case 0:
        return "待定"
      case 1:
        return "参加"
      case 2:
        return "拒绝"
      default:
        return "待定"
    }
  };

  // 显示用户名
  $scope.selectUserText = function (selectUser) {
    //var result = selectUser.Name + "(" + selectUser.Customer.CustomerName + "-" + selectUser.DepartmentCategory.Name + "-" + selectUser.Department.Name + ")";
    var result = selectUser.Name;
    if (selectUser.Status != null) {
      result += "(" + $scope.StatusText(selectUser.Status) + ")";
    }

    return result;
  };

  // 进入会诊间页面
  $scope.goDiscuss = function (item) {
    sessionFactory.saveDataToSession("groupID", item.Chat.GroupID);
    sessionFactory.saveDataToSession("groupCreatorID", item.Chat.CreatorID);
    sessionFactory.saveDataToSession("groupSubject", item.Chat.Subject);
    sessionFactory.saveDataToSession("groupBeginTime", item.Chat.BeginTime);
    window.open("GroupDiscuss.html");
    //window.location.href = "GroupDiscuss.html";
  };

  $scope.showText = function (show) {
    if (show) {
      return "-";
    } else {
      return "+";
    }
  };

  $scope.initialize();
});
