/**
 * Created by ylj on 2016/12/3.greenRouteList
 */
var greenRouteListModule = angular.module("greenRouteListModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule","bookControllers","bookService"]);
greenRouteListModule.service("greenRouteListService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};
  //获取向上转院列表
  service.getDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DiagnosisAskList = response.Body.DiagnosisAskList;
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //修改向上操作
  service.UpdateDiagnosisAskList = function (data, $scope) {
    if (!$.formValidator.pageIsValid("2")) {
      return;
    }
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getDiagnosisAskList($scope.searchPar, $scope);
          navigator.notification.alert("修改成功", function () {
          }, "提示消息", "确定");
        }
        else {
          navigator.notification.alert("修改失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 更新文件
  service.updateReadFile = function ($scope) {
    for (var i = 0; i < $scope.updatePatient.FileList.length; i++) {
      $scope.updatePatient.FileList[i].State = 2;
    }

    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.FileList.length; j++) {
        var current = $scope.updatePatient.FileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }

      if (!exist) {
        $scope.updatePatient.FileList.push(upload);
      }
    }
    service.UpdateDiagnosisAskList($scope.updatePatient, $scope);
  };

  //新增向上操作
  service.InsertDiagnosisAsk = function ($scope) {
    if (!$.formValidator.pageIsValid("1")) {
      return;
    }
    var data = {
      DiagnosisAsk: $scope.AddDiagnosisAsk.DiagnosisAsk,
      Patient: $scope.AddDiagnosisAsk.Patient,
      FileList: $scope.uploadedFiles
    };
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("新增成功", function () {
          }, "提示消息", "确定");
          service.getDiagnosisAskList($scope.searchPar, $scope);
        } else {
          navigator.notification.alert("新增失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取机构排除自己查询
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.topCustomerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };


  /*删除患者*/
  service.deletePatient = function (chat, $scope) {

    httpHandlerService.chatRequest({ChatList: [chat]}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getChatList({FunctionType: 1}, $scope);
          navigator.notification.alert("患者已删除", function () {
          }, "提示消息", "确定");
        }
        else {
          navigator.notification.alert("删除失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        navigator.notification.alert("删除失败", function () {
        }, "提示消息", "确定");
      }
    );
  };

  //获取绿色通道科室数据（排除未开放科室）
  service.getDepartmentCanOrderLocalRequest = function (data, $scope) {
    httpHandlerService.getDepartmentCanOrderLocalRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.RegInfoBeCurrent = response.Body.DepartmentList;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  return service;
});
/*greenRouteListModule.factory("greenRouteListFactory", function (commonFunctionFactory) {
  return {
    initialize: function () {
      // 日期控件
      commonFunctionFactory.date.createDatePicker(["startTime", "endTime", "TurnOutDate", "ReceiveDatetime", "TurnOutDateAsk", "TurnOutDateTime",
        "TurnDownDateTime", "TurnDownDate", "iptBirthday", "ReceiveDatetimeAsk"]);

      // 验证
      $.formValidator.initConfig({validatorGroup: "1", mode: "AlertTip"});
      $($("#InsertDiagnosisAsk input[name='PatientName']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk input[name='PatientBirthday']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk input[name='FirstDoctorName']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk input[name='TurnOutDate']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk select[name='ReplyCustomerID']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});

      $.formValidator.initConfig({validatorGroup: "2", mode: "AlertTip"});
      $($("#DiagnosisAskUser input[name='UpdatePatientName']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#DiagnosisAskUser input[name='UpdateFirstDoctorName']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#DiagnosisAskUser input[name='UpdateTurnOutDate']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: resources.CommonFun.validateRequired});


      $("#loading_div").modal("show");
    },
    showHide: function (mark) {
      if (mark == "∨") {
        return "∧";
      }
      return "∨";
    }
  }
});*/
greenRouteListModule.controller("greenRouteListController", function ($ionicHistory,$ionicScrollDelegate,$scope, $rootScope, $state, $ionicPopup, greenRouteListService, enumFactory, commonFunctionFactory, paginationService, resourceService, userService,service) {
  // 初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: "",
      RegisterStatus:0
    };
    $scope.search();
    $scope.showSelect($scope);
  };

  //返回
  $scope.goBack = function(){
    $ionicHistory.goBack();
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //时间年月日时分
  $scope.getDateToMinuteText = function (date) {
    return resources.displayText.DateToMinuteText(date);
  };

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

  /*搜索事件*/
  $scope.search = function () {
    greenRouteListService.getDiagnosisAskList($scope.searchPar, $scope);
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    greenRouteListService.getPatientList($scope);
    //获取医生列表
    greenRouteListService.getUser($scope);
    //获取机构列表
    greenRouteListService.getCustomerExclude($scope);
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisAskList = [];
      $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
    }
  });

  //进入预约
  $scope.goToBook = function(item){
    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    $rootScope.updatePatient = $scope.updatePatient;
    //获取科室列表
    var data = {CustomerID: $scope.updatePatient.ReplyCustomer.CustomerID}
    console.log($scope.updatePatient.ReplyCustomer.CustomerID);
    greenRouteListService.getDepartmentCanOrderLocalRequest(data,$scope);
    $state.go("book");
  };

  $scope.greenDisplay = true;
  $scope.greenList = function(fla){
      if(fla == 1){
        $scope.greenDisplay = false;
        $scope.searchPar = {
          BeginRow: 0,
          Rows: 100000,
          PatientName: "",
          Status: "",
          RegisterStatus:1
        };
        $scope.search();
      };
    if(fla == 0){
        $scope.greenDisplay = true;
        $scope.searchPar = {
          BeginRow: 0,
          Rows: 100000,
          PatientName: "",
          Status: "",
          RegisterStatus:0
        };
        $scope.search();
    }

  }

  $scope.initialize();
});
angular.bootstrap($('#greenRouteList'), ['greenRouteListModule']);

