var groupDiscussModule = angular.module('GroupDiscussModule', ["IMModule", "UserModule", "sessionModule", "httpHandlerModule", "resourceModule"]);

groupDiscussModule.service("GroupDiscussService", function (httpHandlerService, resourceFactory, IMContentService,sessionFactory) {
  var service = {};
  // 获取所有聊天记录
  service.getChatMessages = function (ReceiverID, SenderID, LastID, Rows, $scope) {
    httpHandlerService.chatMessageRequest({
        LastID: LastID,
        Rows: Rows,
        ReceiverID: ReceiverID,
        SenderID: SenderID
      }, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          var historyList = response.Body;
          if (historyList != null && historyList.length > 0) {
            // 更新第一条历史消息读取状态
            var temp = historyList[0];
            service.addChatRead(temp.MessageTime, $scope.currentUserID, $scope.groupID, null, $scope);
            for (var i = 0; i < historyList.length; i++) {
              var history = historyList[i];
              if (history.ChatType == 1) {
                history.Message = service.getFileBase(history.CustomerID) + history.Message;
              }
            }
          }

          IMContentService.createHistory(historyList, $scope);
        }
        else {
          console.error("获取信息失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  service.getListByGroupID = function (groupId, $scope) {
    httpHandlerService.getListByGroupIDRequest({GroupID: groupId}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          for (var i = 0; i < response.Body.ChatList.length; i++) {
            $scope.Partners.push(response.Body.ChatList[i].Chat);
          }

          for (var i = 0; i < $scope.Partners.length; i++) {
            var partner = $scope.createSelectedUser($scope.Partners[i].PartnerID);
            if (partner != null) {
              partner.Status = $scope.Partners[i].Status;
              $scope.selectdUsers.push(partner);
            }
          }

          $('#updateChat').modal('show');
        }
        else {
          console.error("获取失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  // 上传聊天记录
  service.addChatMessage = function (MessageTime, ReceiverID, IsGroup, SenderID, SenderName, Message, ChatType, SourceName, $scope) {
    // isGroup 0 否 1 是
    httpHandlerService.chatMessageRequest({
        MessageTime: MessageTime,
        ReceiverID: ReceiverID,
        IsGroup: IsGroup,
        SenderID: SenderID,
        SenderName: SenderName,
        Message: Message,
        ChatType: ChatType,
        SourceName: SourceName
      }, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
        }
        else {
          console.error("添加信息失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // 上传聊天状态
  service.addChatRead = function (MessageTime, UserID, GroupID, SenderID, $scope) {
    // isGroup 0 否 1 是
    httpHandlerService.chatReadRequest({
        ChatReadList: [{
          MessageTime: MessageTime,
          UserID: UserID,
          GroupID: GroupID,
          SenderID: SenderID
        }]
      }, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
        }
        else {
          console.error("添加信息失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // 上传文件
  service.uploadFiles = function (data, MessageTime, ReceiverID, IsGroup, SenderID, SenderName, $scope) {
    return httpHandlerService.uploadFilesRequest(data, function (data) {
        if (data == null || data.Body == null || data.Body.length < 1) {
          console.error("文件上传失败");
          return;
        }

        var fileName = data.Body[0].FileName;
        var sourceName = data.Body[0].SourceName;
        service.addChatMessage(MessageTime, ReceiverID, IsGroup, SenderID, SenderName, fileName, 1, sourceName, $scope);
      },
      function (data) {
        console.error("文件上传失败");
      });
  };

  // 文件上传路径base
  service.getFileBase = function (customerID) {
    return httpHandlerService.getFileBase(customerID);
  };

  //获取层级数据
  service.getDoctorGroupByDepartment = function ($scope) {
    var result = sessionFactory.getDataFromSession('doctorDepartment');
    if (result != 'undefined') {
      $scope.customerList = JSON.parse(result);
    } else {
      httpHandlerService.getDoctorGroupByDepartmentRequest({}, resourceFactory.operateCode.get,
        function (response) {
          if (response.Header.StatusCode == 0 && response.Body.length > 0) {
            $scope.customerList = response.Body;
            sessionFactory.saveDataToSession('doctorDepartment', JSON.stringify($scope.customerList));
          }
          else {
            console.error("没有任何用户");
          }
        },
        function (response) {
          console.error(response);
        }
      );
    }
  };

  // 获取所有chat数据通过groupid
  service.getListByGroupID = function (groupId, $scope) {
    httpHandlerService.getListByGroupIDRequest({GroupID: groupId}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          $scope.chatList = [];
          $scope.groupList = [];
          for (var i = 0; i < response.Body.ChatList.length; i++) {
            var temp = JSON.parse(JSON.stringify(response.Body.ChatList[i]));
            $scope.chatList.push(temp.Chat);
            $scope.groupList.push({
              id: temp.Partner.UserID + "_" + $scope.groupID,
              name: temp.Partner.Name
            });
          }
        }
        else {
          console.error("获取失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // 更新聊天
  service.updateChat = function (userId, $scope) {
    // 更新或添加
    var exist = false;
    for (var j = 0; j < $scope.chatList.length; j++) {
      var partner = $scope.chatList[j];
      if (partner.PartnerID == userId) {
        exist = true;
        break;
      }
    }

    if (exist) {
      navigator.notification.alert("该成员已经是会诊组成员", function () {
      }, "提示消息", "确定");
      return;
    }

    var list = [];
    var temp = {
      Subject: $scope.groupSubject,
      BeginTime: $scope.groupBeginTime,
      PartnerID: userId,
      CreatorID: $scope.groupCreatorID,
      Status: 0,
      FunctionType: 1,
      GroupID: $scope.groupID
    };
    list.push(temp);
    httpHandlerService.chatRequest({ChatList: list}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("组成员添加成功", function () {
          }, "提示消息", "确定");
        }
        else {
          navigator.notification.alert("组成员添加失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        navigator.notification.alert("组成员添加失败", function () {
        }, "提示消息", "确定");
      }
    );
  };

  return service;
});

gysyApp.controller("GroupDiscussController", function ($ionicLoading,$rootScope, $scope, $state, $ionicHistory,userService, sessionFactory, IMContentService, GroupDiscussService,IMGroupMemberService) {
  $scope.groupID = $rootScope.groupID;
  $scope.groupSubject = $rootScope.groupSubject;
    $scope.groupCreatorID = $rootScope.groupCreatorID;
  $scope.contactID = $rootScope.contactID;
/*显示当前用户*/
  $scope.currentUser = userService.getUser().Body.User;
  // 当前用户id
  $scope.currentUserID = $scope.currentUser.UserID;
  // 当前用户姓名(用来更新myInfo)
  $scope.currentUserName = $scope.currentUser.Name;

  // 推送
  pushGoEasy.initialize();
  /*pushGoEasy.subscribe("chat_channel", function (result) {
    var content = JSON.parse(result.content);
    if ($scope.groupID == content.Header.GroupID && $scope.createSystemInformation) {
      $scope.createSystemInformation(content.Body.content);
    }
  });*/
  var channel = "chat_channel_" + $scope.groupID;
  //$scope.subChannels.push(chat.GroupID);
  pushGoEasy.subscribe(channel, function (result) {
    var content = JSON.parse(result.content);
    if ($scope.groupID == content.Header.GroupID && $scope.createSystemInformation) {
      $scope.createSystemInformation(content.Body.content);
    }
  });

  var screenWidth=window.screen.availWidth;
  var screenHeight=window.screen.availHeight-50;
  var sendHeight=screenHeight/10;
  var chatHeight=screenHeight-sendHeight;
  var c= $("#im_content_list").css({"background-color":"#ffffff","width":screenWidth,"maxHeight":screenHeight,"overflow":"auto","padding-bottom":"100px"});
  $("#contentEditDiv").css({"min-height":sendHeight,"position":"fixed","bottom":0,"background":"#fff"})
  $scope.goDiscussGroupMember=function(){
    $ionicLoading.show({
      content: 'Loading',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });
    $state.go("discussGroupMember");
    $ionicLoading.hide();
  }
  $scope.goBack=function(){
    $ionicHistory.goBack();
  }


  // IM content 相关
  // 上传文件
  $scope.uploadFiles = function (data, MessageTime, ReceiverID, IsGroup, SenderID, SenderName) {
    GroupDiscussService.uploadFiles(data, MessageTime, ReceiverID, IsGroup, SenderID, SenderName, $scope);
  };
  // 上传聊天状态
  $scope.addChatRead = function (MessageTime, UserID, GroupID, SenderID) {
    GroupDiscussService.addChatRead(MessageTime, UserID, GroupID, SenderID, $scope);
  };
  // 上传聊天记录
  $scope.addChatMessage = function (MessageTime, ReceiverID, IsGroup, SenderID, SenderName, Message, ChatType) {
    GroupDiscussService.addChatMessage(MessageTime, ReceiverID, IsGroup, SenderID, SenderName, Message, ChatType, null, $scope);
  };
  // 获取历史数据
  $scope.loadHistory = 10;
  $scope.getChatMessages = function (lastID) {
    GroupDiscussService.getChatMessages($scope.contactID, "", lastID, $scope.loadHistory, $scope);
  };
  /*提交更新会诊间*/
  $scope.submitGroupMembers = function (ids) {
    GroupDiscussService.submitGroupMembers(ids, $scope);
  };

 // 拍照 获取获取图片；
$scope.goPhotoImg=function(){
  $state.go("photoImg");
}

IMContentService.initialize($scope, function (obj) {
}, function (obj) {
});

});
