/**
 * Created by ylj on 2016/10/24.
 * 优化
 */
var hospitalAddReferralModule = angular.module("hospitalAddReferralModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"])
hospitalAddReferralModule.service("hospitalAddReferralService", function ($ionicLoading,$state, $http, httpHandlerService, resourceFactory) {
  var service = {};

  //获取向上转院列表
  service.getDiagnosisReplyList = function (data, $scope) {
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DiagnosisReply = response.Body.DiagnosisReplyList;
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //新增向下转院
  service.InsertDiagnosisDown = function ($scope) {
    var data = {
      Patient: $scope.AddDiagnosisReply.Patient,
      DiagnosisReply: $scope.AddDiagnosisReply.DiagnosisReply,
      FileList: $scope.uploadedFiles
    };
    //转换时间格式
    data.DiagnosisReply.TurnDownDate = $scope.getDateTimeType(data.DiagnosisReply.TurnDownDate);
    data.Patient.Birthday = $scope.getDateTimeType(data.Patient.Birthday);
    /*映射医生*/
    for (var i = 0; i < $scope.userList.length; i++) {
      var item = $scope.userList[i];
      if (item.User.UserID == data.DiagnosisReply.TreatDoctorID) {
        data.DiagnosisReply.TreatDoctorName = item.User.Name;
      }
    }

    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $ionicLoading.hide();
          navigator.notification.alert("新增成功",function(){},"提示消息","确定");
          service.getDiagnosisReplyList($scope.searchPar, $scope);
          $state.go("hospitalReferralList");
        }
        else {
          $ionicLoading.hide();
          navigator.notification.alert("新增失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.topCustomerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  return service;
});
hospitalAddReferralModule.controller("hospitalAddReferralController", function ($ionicLoading,$ionicPopup, $scope, $ionicHistory, hospitalAddReferralService, enumFactory, commonFunctionFactory, paginationService, userService) {
  //初始化
  $scope.initialize = function () {
    $scope.uploadedFiles = [];
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnDownDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnDownDateEnd: resources.displayText.DateToDayText(endDate),
      Name: "",
      Status: ""
    };

    $scope.AddDiagnosisReply = {
      DiagnosisReply: {
        ReplyType: 0
      },
      Patient: {}
    };
    $scope.engineer = {
      ReplyType: {}
    };

    $scope.search();
    $scope.showSelect($scope);
    $scope.isSelected = false;
    $scope.AddDiagnosisReply.Patient.ID = 0;
    $scope.AddDiagnosisReply.Patient.PatientID = "";
    $scope.AddDiagnosisReply.Patient.PatientName = "";
    $scope.AddDiagnosisReply.Patient.Gender = 0;
    $scope.AddDiagnosisReply.Patient.Birthday = "";
    $scope.AddDiagnosisReply.Patient.Phone = "";
    $scope.AddDiagnosisReply.Patient.IdentityCard = "";
    $scope.AddDiagnosisReply.Patient.Address = "";
    $scope.AddDiagnosisReply.Patient.Email = "";
    $scope.AddDiagnosisReply.Patient.PatientType = 0;
    $scope.AddDiagnosisReply.Patient.OtherContact = "";
    $scope.AddDiagnosisReply.Patient.Remark = "";
    $scope.AddDiagnosisReply.Patient.ApprovalOpinion = "";
    $scope.AddDiagnosisReply.Patient.MainID = "";
    $scope.AddDiagnosisReply.Patient.RelationType = 0;
    $scope.AddDiagnosisReply.Patient.Status = 0;
    $scope.AddDiagnosisReply.Patient.State = 0;
    $scope.AddDiagnosisReply.Patient.Phone = "";
    $scope.AddDiagnosisReply.Patient.CustomerID = 0;
  };

  //返回
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };

  //初始化性别
  $scope.GenderList = enumFactory.GenderList;

  /*搜索事件*/
  $scope.search = function () {
    hospitalAddReferralService.getDiagnosisReplyList($scope.searchPar, $scope);
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  //人员类型
  $scope.PatientTypeList = enumFactory.PatientTypeList;

  //初始化转院类型
  $scope.AskTypeList = enumFactory.AskType;

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

//根据省份证号码绑定生日，性别
  $scope.IdentityCardBirthday = function (flg) {
    if (flg == 0) {
      var IdentityCard = $scope.AddDiagnosisReply.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender % 2 == 0) {
          $scope.AddDiagnosisReply.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisReply.Patient.Gender = 0;
        } else {
          $scope.AddDiagnosisReply.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.AddDiagnosisReply.Patient.Gender = 1;
        }
      }
    } else if (flg == 1) {
      var IdentityCard = $scope.updatePatient.Patient.IdentityCard;
      var birthday = IdentityCard.substring(6, 14);
      var gender = IdentityCard.substring(16, 17);
      if (birthday.length == 8) {
        if (gender / 2 == 0) {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 0;
        } else {
          $scope.updatePatient.Patient.Birthday = resources.DataFormat.identityCardformat(birthday);
          $scope.updatePatient.Patient.Gender = 1;
        }
      }
    }
  };

  //新增下转诊数据
  $scope.hospitalAddReferral = function () {
    var RegCard = /^[1-9]{1}[0-9]{14}$|^[1-9]{1}[0-9]{16}([0-9]|[xX])$/;
    if ($scope.AddDiagnosisReply.Patient.Name == "" || $scope.AddDiagnosisReply.Patient.Name == null) {
      navigator.notification.alert("请输入患者姓名，此项为必选项！",function(){},"提示消息","确定");
    }else if($scope.AddDiagnosisReply.Patient.Birthday == "" || $scope.AddDiagnosisReply.Patient.Birthday ==null){
      navigator.notification.alert("请选择患者出生日期，此项为必选项！",function(){},"提示消息","确定");
    } else if ($scope.AddDiagnosisReply.Patient.IdentityCard == "" || $scope.AddDiagnosisReply.Patient.IdentityCard == null || RegCard.test($scope.AddDiagnosisReply.Patient.IdentityCard) == false) {
      navigator.notification.alert("请输入正确格式的身份证号，此项为必选项！",function(){},"提示消息","确定");
    } else if ($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorID == "" || $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorID == null) {
      navigator.notification.alert("请选择经治医生！",function(){},"提示消息","确定");
    } else if ($scope.AddDiagnosisReply.DiagnosisReply.TurnDownDate == "" || $scope.AddDiagnosisReply.DiagnosisReply.TurnDownDate == null) {
      navigator.notification.alert("请输入下转日期！",function(){},"提示消息","确定");
    } else if ($scope.AddDiagnosisReply.DiagnosisReply.AskCustomerID == "" || $scope.AddDiagnosisReply.DiagnosisReply.AskCustomerID == null) {
      navigator.notification.alert("请选择转入医院！",function(){},"提示消息","确定");
    } else {
      $scope.AddDiagnosisReply.DiagnosisReply.PatientAge = $scope.calculateAge($scope.AddDiagnosisReply.Patient.Birthday);
      $scope.AddDiagnosisReply.ModuleNo = "M003";
      $scope.AddDiagnosisReply.DiagnosisReply.CreatorID = $scope.currentUser.User.UserID;
      $scope.AddDiagnosisReply.DiagnosisReply.CreatorName = $scope.currentUser.User.Name;
      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: true,
        maxWidth: 200,
        showDelay: 0
      });
      hospitalAddReferralService.InsertDiagnosisDown($scope);
    }
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    hospitalAddReferralService.getPatientList($scope);
    //获取医生列表
    hospitalAddReferralService.getUser($scope);

    hospitalAddReferralService.getCustomerExclude($scope);
  };

  //页面显示相关
  $scope.showEachReadFile = function (file) {
    if(file.SourceName.length>6){
      file.SourceName = (file.SourceName).substr(0,6) +"...";
    };
    if (file.FileName.indexOf(".jpg") > -1 || file.FileName.indexOf(".png") > -1 || file.FileName.indexOf(".jpeg") > -1) {
      return hospitalAddReferralService.getFileBase() + file.CustomerID + "/" + file.FileName;
    } else {
      return "img/attachment_icon.png";
    }
  };

  $scope.uploadFile = function () {
    // 从指定来源检索图像文件位置
    var options = {
      //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
      quality: 100,                                            //相片质量0-100
      destinationType: Camera.DestinationType.DATA_URL,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
      sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,       //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
      allowEdit: false,                                        //在选择之前允许修改截图
      encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
      targetWidth: 200,                                        //照片宽度
      targetHeight: 200,                                       //照片高度
      mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
      cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: true                                   //保存进手机相册
    };

    navigator.camera.getPicture(function onPhotoDataSuccess(imageData) {

    /*  var smallImage = document.getElementById('addImg');

      // 取消隐藏的图像元素
      smallImage.style.display = 'block';

      // 显示拍摄的照片
      // 使用内嵌CSS规则来缩放图片
      smallImage.src = "data:image/jpeg;base64," + imageData;*/

      var bstr = atob(imageData);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }

      var blob = new Blob([u8arr.buffer], {type: 'image/jpeg'});
      blob.fileName = new Date().getTime() + ".jpg";

      hospitalAddReferralService.uploadFiles(blob, function (data) {
          if (data == null || data.Body == null) {
            navigator.notification.alert("上传失败", function () {
            }, "提示消息", "确定");
          }
          for (var i = 0; i < data.Body.length; i++) {
            var file = data.Body[i];
            file.SourceName = blob.fileName;
            file.CustomerID = $scope.currentUser.CustomerID;
            $scope.uploadedFiles.push(data.Body[i]);
          }
          $scope.createFileList($scope.uploadedFiles);
        },
        function (data) {
          navigator.notification.alert("上传失败", function () {
          }, "提示消息", "确定");
        });
      //};
    }, function (err) {
      navigator.notification.alert("未选择任何图片", function () {
      }, "提示消息", "确定");
    }, options);
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }
    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = hospitalAddReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = hospitalAddReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].ShowFile = hospitalAddReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  //删除图片
  $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisReplyList = [];
      $scope.changePaginationContent($scope.DiagnosisReply, $scope.DiagnosisReplyList);
    }
  });

  /*附件样式start*/
  $scope.bigImage = false;    //初始默认大图是隐藏的
  $scope.hideBigImage = function () {
    $scope.bigImage = false;
  };
  var ScreenHeight = window.screen.height;
  $scope.showBigImage = function(imageName){
    $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true;
    var rightDisplay = document.getElementById("rightDisplay");
    rightDisplay.style.height = ScreenHeight+"px";
  };
  /*附件样式end*/
  $scope.initialize();
});
angular.bootstrap($('#hospitalAddReferral'), ['hospitalAddReferralModule']);
