/**
 * Created by ylj on 2016/11/2.
 */
var hospitalReceiveDownModule = angular.module("hospitalReceiveDownModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);

hospitalReceiveDownModule.service("hospitalReceiveDownService", function ($http, httpHandlerService, resourceFactory,$state) {
  var service = {};

  //获取向上转院列表
  service.getDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          //$scope.setTotalItems(response.Body.TotalRows);
          //$scope.getPagination();
          $scope.DiagnosisAsk = response.Body.DiagnosisAskList;
          //$scope.DiagnosisAskList = [];
          //$scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //修改向上操作
  service.UpdateDiagnosisAsk = function ($scope) {
    var data = {DiagnosisAsk: $scope.DiagnosisAsk, Patient: $scope.Patient, FileList: $scope.uploadedFiles};
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("用户更新成功", function () {
          }, "提示消息", "确定");
          service.getDiagnosisAskList($scope.searchPar, $scope);
          $("#UpdateDiagnosisAsk").modal("hide");
        }
        else {
          navigator.notification.alert("用户更新失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //新增向上操作
  service.InsertDiagnosisAsk = function ($scope) {
    if (!$.formValidator.pageIsValid("1")) {
      return;
    }
    var data = {
      DiagnosisAsk: $scope.AddDiagnosisAsk.DiagnosisAsk,
      Patient: $scope.AddDiagnosisAsk.Patient,
      FileList: $scope.uploadedFiles
    };
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("用户新增成功", function () {
          }, "提示消息", "确定");
          service.getDiagnosisAskList($scope);
        } else {
          navigator.notification.alert("用户新增失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //新增向下转院
  service.InsertDiagnosisReply = function ($scope) {
//        if (!$.formValidator.pageIsValid("1")) {
//            return;
//        }
    var data = {
      Patient: $scope.AddDiagnosisReply.Patient,
      DiagnosisReply: $scope.AddDiagnosisReply.DiagnosisReply,
      FileList: $scope.uploadedFiles
    };
    //转换时间格式
    data.DiagnosisReply.TurnDownDate = $scope.getDateTimeType(data.DiagnosisReply.TurnDownDate);
    data.Patient.Birthday = $scope.getDateTimeType(data.Patient.Birthday);
    /*映射医生*/
    for (var i = 0; i < $scope.userList.length; i++) {
      var item = $scope.userList[i];
      if (item.User.UserID == data.DiagnosisReply.TreatDoctorID) {
        data.DiagnosisReply.TreatDoctorName = item.User.Name;
      }
    }

    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.insert, function (response) {
        if (response.Header.StatusCode == 0) {
          $ionicLoading.hide();
          navigator.notification.alert("新增成功", function () {
          }, "提示消息", "确定");
          //alert("新增成功");
          service.getDiagnosisAskList($scope.searchPar, $scope);
        }
        else {
          $ionicLoading.hide();
          navigator.notification.alert("新增失败", function () {
          }, "提示消息", "确定");

        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 更新文件
  service.updateReadFile = function ($scope) {
    if (!$.formValidator.pageIsValid("2")) {
      return;
    }

    for (var i = 0; i < $scope.updatePatient.FileList.length; i++) {
      $scope.updatePatient.FileList[i].State = 2;
    }

    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.FileList.length; j++) {
        var current = $scope.updatePatient.FileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }

      if (!exist) {
        $scope.updatePatient.FileList.push(upload);
      }
    }
    service.UpdateDiagnosisAsk($scope.updatePatient, $scope);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取向上转院列表
  service.getDiagnosisReplyList = function (data, $scope) {
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.setTotalItems(response.Body.TotalRows);
          $scope.getPagination();
          $scope.DiagnosisReply = response.Body.DiagnosisReplyList;
          $scope.DiagnosisReplyList = [];
          $scope.changePaginationContent($scope.DiagnosisReply, $scope.DiagnosisReplyList);
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //新增向下转院
  service.InsertDiagnosisDown = function ($scope) {
    /* if (!$.formValidator.pageIsValid("1")) {
     return;
     }*/
    var data = {
      Patient: $scope.AddDiagnosisReply.Patient,
      DiagnosisReply: $scope.AddDiagnosisReply.DiagnosisReply,
      FileList: $scope.uploadedFiles
    };

    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("新增成功", function () {
          }, "提示消息", "确定");
          //alert("新增成功");
          service.getDiagnosisReplyList($scope.searchPar, $scope);
          $state.go("hospitalReferralList");
        }
        else {
          //alert("新增失败");
          navigator.notification.alert("新增失败", function () {
          }, "提示消息", "确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.customerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  return service;
});

hospitalReceiveDownModule.controller("hospitalReceiveDownController", function ($ionicLoading,$ionicPopup, $scope, $state, $rootScope, $ionicHistory, hospitalReceiveDownService, enumFactory,userService, commonFunctionFactory, paginationService) {

  $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
  // 初始化
  $scope.initialize = function () {
    $scope.uploadedFiles = [];
    //for(var i=0;i<$scope.uploadedFiles.length;i++){
    //  $scope.uploadedFiles[i].FileName = "";
    //};
    $scope.currentUser = userService.getUser().Body;
    $scope.PatientStatusList = enumFactory.PatientStatusList;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: ""
    };

    $scope.AddDiagnosisReply = {
      DiagnosisReply: {
        TreatDoctorName: "",
        TurnDownDate:"",
        AskCustomerID:"",
        ReplyType:0
       },
      Patient: {
        Name:$scope.updatePatient.DiagnosisAsk.PatientName,
        Gender:$scope.updatePatient.Patient.Gender,
        Birthday:$scope.updatePatient.Patient.Birthday,
        Phone:$scope.updatePatient.Patient.Phone,
        IdentityCard:$scope.updatePatient.Patient.IdentityCard,
        Address:$scope.updatePatient.Patient.Address,
        PatientType:$scope.updatePatient.Patient.PatientType
      }
    };
    $scope.engineer = {
      ReplyType: {}
    };

    // 分页初始化
    paginationService.initialize($scope);
    $scope.search();
    $scope.showSelect($scope);
  };

  $scope.goBack = function () {
    $ionicHistory.goBack();
  };



  $scope.goHospitalAddReferral = function () {

    if ($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorID == "" || $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorID == null) {
      //alert("请选择经治医生！");
      navigator.notification.alert("请选择经治医生！",function(){},"提示消息","确定");
    } else if ($scope.AddDiagnosisReply.DiagnosisReply.TurnDownDate == "" || $scope.AddDiagnosisReply.DiagnosisReply.TurnDownDate == null) {
      //alert("请选择下转日期！");
      navigator.notification.alert("请选择下转日期！",function(){},"提示消息","确定");
    } else if ($scope.AddDiagnosisReply.DiagnosisReply.AskCustomerID == "" || $scope.AddDiagnosisReply.DiagnosisReply.AskCustomerID == null) {
      //alert("请选择转入医院");
      navigator.notification.alert("请选择转入医院",function(){},"提示消息","确定");
    }/* else if ($scope.AddDiagnosisReply.DiagnosisReply.ReplyType == "" || $scope.AddDiagnosisReply.DiagnosisReply.ReplyType == null) {
      alert("请选择转院类型")
    }*/ else {
      $scope.AddDiagnosisReply.DiagnosisReply.DiagnosisAskID = $scope.updatePatient.DiagnosisAsk.DiagnosisAskID;
      $scope.AddDiagnosisReply.DiagnosisReply.PatientID = $scope.updatePatient.DiagnosisAsk.PatientID;
      $scope.AddDiagnosisReply.DiagnosisReply.PatientName = $scope.updatePatient.DiagnosisAsk.PatientName;
      $scope.AddDiagnosisReply.DiagnosisReply.PatientAge = $scope.calculateAge($scope.updatePatient.Patient.Birthday);
      $scope.AddDiagnosisReply.ModuleNo = "M001";
      $scope.AddDiagnosisReply.DiagnosisReply.CreatorID = $scope.currentUser.User.UserID;
      $scope.AddDiagnosisReply.DiagnosisReply.CreatorName = $scope.currentUser.User.Name;
      $scope.AddDiagnosisReply.Patient = $scope.updatePatient.Patient;

      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: true,
        maxWidth: 200,
        showDelay: 0
      });
      hospitalReceiveDownService.InsertDiagnosisReply($scope);

    }
  };

  $scope.AddDiagnosisReply = $rootScope.updatePatient;

  // $scope.AddDiagnosisReply.DiagnosisReply.TurnDownDate = new Date($scope.AddDiagnosisReply.DiagnosisReply.TurnDownDate);
  // $scope.AddDiagnosisReply.Patient.Birthday = new Date($scope.AddDiagnosisReply.Patient.Birthday);
  /* alert($scope.AddDiagnosisReply.Patient.Birthday);
   $scope.AddDiagnosisReply.Patient.Birthday = ($scope.AddDiagnosisReply.Patient.Birthday).substr(0,10);*/


  //初始化性别
  $scope.GenderList = enumFactory.GenderList;

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

  //转院管理状态
  $scope.DiagnosisAskStatus = function (status) {
    return commonFunctionFactory.displayText.DiagnosisAskStatus(status);
  };

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //人员类型
  $scope.PatientTypeList = enumFactory.PatientTypeList;

  //人员类型
  $scope.PatientTypeText = function (status) {
    return commonFunctionFactory.displayText.PatientTypeList(status);
  };

  //初始化转院类型
  $scope.AskTypeList = enumFactory.AskType;


  //转院类型
  $scope.AskTypeText = function (state) {
    return commonFunctionFactory.displayText.AskTypeText(state);
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  /*搜索事件*/
  $scope.search = function () {
    hospitalReceiveDownService.getDiagnosisAskList($scope.searchPar, $scope);
  };

  /*更多查询按钮*/
  $scope.isTrue = false;
  $scope.toggle = function () {
    $scope.isTrue = !$scope.isTrue;
  };

  /*自定义查询事件*/
  $scope.diagnosisUpSearch = function () {
    $scope.searchPar.BeginTime = $scope.searchPar.BeginDateText + " 00:00:00";
    $scope.searchPar.EndTime = $scope.searchPar.EndDateText + " 23:59:59";
    $scope.search();
  };

  /*最新时间查询事件*/
  $scope.newTimePatientSearch = function () {
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      Name: "",
      Status: 0 // 未提交
    };

    $scope.search();
  };

  /*今日患者事件*/
  $scope.todayPatientSearch = function () {
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginTime: commonFunctionFactory.displayText.DateToTimeText(beginDate),
      EndTime: commonFunctionFactory.displayText.DateToTimeText(endDate),
      BeginDateText: commonFunctionFactory.displayText.DateToDayText(beginDate),
      EndDateText: commonFunctionFactory.displayText.DateToDayText(endDate),
      Name: ""
    };

    $scope.search();
  };

  //修改数据
  $scope.submitDiagnosisAsk = function () {
    hospitalReceiveDownService.updateReadFile($scope);
  };

  //新增数据
  /*$scope.CreateDiagnosisReply = function () {
   $scope.AddDiagnosisReply.DiagnosisReply.DiagnosisAskID = $scope.updatePatient.DiagnosisAsk.DiagnosisAskID;
   $scope.AddDiagnosisReply.DiagnosisReply.PatientID = $scope.updatePatient.DiagnosisAsk.PatientID;
   $scope.AddDiagnosisReply.DiagnosisReply.PatientName = $scope.updatePatient.DiagnosisAsk.PatientName;
   hospitalReceiveDownService.InsertDiagnosisReply($scope);

   window.location.href = "ResponseDiagnosisReply.html";
   };
   */
  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    hospitalReceiveDownService.getPatientList($scope);
    //获取医生列表
   // hospitalReceiveDownService.getUser($scope);
    //获取机构
    hospitalReceiveDownService.getCustomerExclude($scope);
  };

  // 显示用户新增详情页面
  $scope.showDiagnosisAsk = function () {
    $scope.engineer = {
      currentActivityId: 1,
      PatientID: 14
    };
    $scope.cleanModal();
    $("#InsertDiagnosisAsk").modal("show");
  };

  /*清空新增患者*/
  $scope.cleanModal = function () {
    $scope.updateDiagnosisAsk = {
      Gender: 1,
      Status: 0
    };
    $scope.uploadedFiles = [];
  };

  /*点击详情*/
  $scope.showDetail = function (item) {
    $scope.cleanModal();
    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    $scope.updatePatient.Patient.Birthday = $scope.getDateTimeType($scope.updatePatient.Patient.Birthday);
    $scope.updatePatient.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.TurnOutDate);

    if ($scope.updatePatient.DiagnosisAsk) {
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDate) {
        $scope.updatePatient.DiagnosisAsk.ReceiveDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.ReceiveDate);
      }
    }

    $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
    $scope.createFileList($scope.uploadedFiles);

    $scope.ShowCustomer = true;
    if (item.IsReceiver == "1") {
      $scope.GetCustomerNo = $scope.updatePatient.ReplyCustomerName;
      $scope.ShowCustomer = false;
    }

    //是否有下转诊单 （显示/隐藏）
    $scope.ShowReply = true;
    $scope.ShowAsk = false;
    if (!$scope.updatePatient.DiagnosisReply) {
      $scope.ShowReply = false;
      $scope.ShowAsk = true;
    }

    $('#UpdateDiagnosisAsk').modal('show');
  };

  /*跳转页面下转*/
  $scope.submitDiagnosisReply = function () {
    $scope.AddDiagnosisReply = {
      Patient: {},
      DiagnosisReply: {ReplyType: 1}
    }
    ;
    $scope.AddDiagnosisReply.Patient.Name = $scope.updatePatient.Patient.Name;
    $scope.AddDiagnosisReply.Patient.Gender = $scope.updatePatient.Patient.Gender;
    $scope.AddDiagnosisReply.Patient.Birthday = $scope.updatePatient.Patient.Birthday;
    $scope.AddDiagnosisReply.Patient.Phone = $scope.updatePatient.Patient.Phone;
    $scope.AddDiagnosisReply.Patient.IdentityCard = $scope.updatePatient.Patient.IdentityCard;
    $scope.AddDiagnosisReply.Patient.Address = $scope.updatePatient.Patient.Address;
    $scope.AddDiagnosisReply.Patient.PatientType = $scope.updatePatient.Patient.PatientType;
    $scope.uploadedFiles = [];
  };


  //弹出下转诊单信息
  $scope.showDiagnosisReply = function () {
    $scope.DiagnosisReply = {};
    $scope.DiagnosisReply.TreatDoctorName = $scope.updatePatient.DiagnosisReply.TreatDoctorName;
    $scope.DiagnosisReply.TurnDownDate = $scope.updatePatient.DiagnosisReply.TurnDownDate;
    $scope.DiagnosisReply.CustomerName = $scope.updatePatient.CustomerName;
    $scope.DiagnosisReply.ReplyType = $scope.updatePatient.DiagnosisReply.ReplyType;
    $scope.DiagnosisReply.LeaveDiagnosis = $scope.updatePatient.DiagnosisReply.LeaveDiagnosis;
    $scope.DiagnosisReply.TreatSummary = $scope.updatePatient.DiagnosisReply.TreatSummary;
    $scope.DiagnosisReply.Suggestion = $scope.updatePatient.DiagnosisReply.Suggestion;

    $("#ShowDiagnosisReply").modal("show");
  };

  // 动态查询患者
  $scope.changePatientLevel = function () {
    $scope.PatientComBoxList = [];
    if ($scope.updatePatient.Patient.Name == "") {
      return;
    }
    for (var i = 0; i < $scope.PatientComBox.length; i++) {
      var temp = $scope.PatientComBox[i];
      if (temp.Name.indexOf($scope.updatePatient.Patient.Name) > -1) {
        $scope.PatientComBoxList.push(temp);
      }
    }
  };

  // 加载患者数据
  $scope.searchTemplateClick = function (temp) {
    $scope.updatePatient.Patient.Name = temp.Name;
    $scope.updatePatient.Patient.Phone = temp.Phone;
    $scope.updatePatient.Patient.Gender = temp.Gender;
    $scope.updatePatient.Patient.Birthday = resources.displayText.DateToDayText(temp.Birthday);
    $scope.updatePatient.Patient.IdentityCard = temp.IdentityCard;
    $scope.updatePatient.Patient.Address = temp.Address;
    $scope.updatePatient.Patient.UserID = temp.PatientID;
    $scope.updatePatient.Patient.PatientType = temp.PatientType;
    $scope.PatientComBoxList = [];
  };

  //动态查询医生
  $scope.changeUserLevel = function (flg) {
    if (flg == "0") {
      $scope.InsertUserComBoxList = [];
      if ($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.InsertUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "1") {
      $scope.UpdateUserComBoxList = [];
      if ($scope.updatePatient.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.UpdateUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "2") {
      $scope.UpdateReceiveDoctorName = [];
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName) > -1) {
          $scope.UpdateReceiveDoctorName.push(temp);
        }
      }
    }
    if (flg == "3") {
      $scope.UpdateDoctor = [];
      if ($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName) > -1) {
          $scope.UpdateDoctor.push(temp);
        }
      }
    }
  };

  //绑定首诊医生数据
  $scope.searchUserClick = function (temp, flg) {
    if (flg == "0") { //首诊医生新增
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.InsertUserComBoxList = [];
    }
    if (flg == "1") {
      $scope.updatePatient.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.UpdateUserComBoxList = [];
    }
    if (flg == "2") {
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorName = temp.Name;
      $scope.UpdateReceiveDoctorName = [];
    }
    if (flg == "3") {
      $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorID = temp.UserID;
      $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName = temp.Name;
      $scope.UpdateDoctor = [];
    }

  };

  // 点击具体图片
  $scope.showItemDetail = function (item) {
    $scope.detailFile = item;
    $("#fileDetail").modal("show");
  };

  // 页面显示相关
  $scope.showEachReadFile = function (file) {
    if(file.SourceName.length>6){
      file.SourceName = (file.SourceName).substr(0,6) +"...";
    };
    if (file.FileName.indexOf(".jpg") > -1 || file.FileName.indexOf(".png") > -1 || file.FileName.indexOf(".jpeg") > -1) {
      return hospitalReceiveDownService.getFileBase() + file.CustomerID + "/" + file.FileName;
    } else {
      return "img/attachment_icon.png";
    }
  };

  $scope.openEachReadFile = function (file) {
    var detailFile = {
      SourceName: file.SourceName,
      Description: file.Description
    };
    var url = file.FileName;
    if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
      detailFile.ShowUrl = hospitalReceiveDownService.getFileBase() + file.CustomerID + "/" + url;
    } else {
      detailFile.ShowUrl = hospitalReceiveDownService.getFileBase() + file.CustomerID + "/" + url;
      detailFile.ShowFile = hospitalReceiveDownService.getFileBase() + file.CustomerID + "/" + url;
      detailFile.IsPDF = true;
    }

    $scope.detailFile = detailFile;
    $("#fileDetail").modal("show");
  };

  $scope.openFile = function () {
    window.open($scope.detailFile.IsPDF ? $scope.detailFile.ShowFile : $scope.detailFile.ShowUrl);
  };

  // 上传资料 Begin
  $scope.selectFile = function () {
    $("#selectFile").click();
  };

  //上传
  $scope.changeFile = function (files) {
    hospitalReceiveDownService.uploadFiles(files, function (data) {
        if (data == null || data.Body == null) {
          navigator.notification.alert("上传失败", function () {
          }, "提示消息", "确定");
        }
        for (var i = 0; i < data.Body.length; i++) {
          var file = data.Body[i];
          file.CustomerID = $scope.currentUser.CustomerID;
          $scope.uploadedFiles.push(data.Body[i]);
        }

        $scope.createFileList($scope.uploadedFiles);
      },
      function (data) {
        navigator.notification.alert("上传失败", function () {
        }, "提示消息", "确定");
      });
  };

  $scope.uploadFile = function () {
    // 从指定来源检索图像文件位置
    var options = {
      //这些参数可能要配合着使用，比如选择了sourcetype是0，destinationtype要相应的设置
      quality: 100,                                            //相片质量0-100
      destinationType: Camera.DestinationType.DATA_URL,        //返回类型：DATA_URL= 0，返回作为 base64 編碼字串。 FILE_URI=1，返回影像档的 URI。NATIVE_URI=2，返回图像本机URI (例如，資產庫)
      sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,       //从哪里选择图片：PHOTOLIBRARY=0，相机拍照=1，SAVEDPHOTOALBUM=2。0和1其实都是本地图库
      allowEdit: false,                                        //在选择之前允许修改截图
      encodingType: Camera.EncodingType.JPEG,                   //保存的图片格式： JPEG = 0, PNG = 1
      targetWidth: 200,                                        //照片宽度
      targetHeight: 200,                                       //照片高度
      mediaType: 0,                                             //可选媒体类型：圖片=0，只允许选择图片將返回指定DestinationType的参数。 視頻格式=1，允许选择视频，最终返回 FILE_URI。ALLMEDIA= 2，允许所有媒体类型的选择。
      cameraDirection: 0,                                       //枪后摄像头类型：Back= 0,Front-facing = 1
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: true                                   //保存进手机相册
    };

    navigator.camera.getPicture(function onPhotoDataSuccess(imageData) {
/*
      var smallImage = document.getElementById('addImg');

      // 取消隐藏的图像元素
      smallImage.style.display = 'block';

      // 显示拍摄的照片
      // 使用内嵌CSS规则来缩放图片
      smallImage.src = "data:image/jpeg;base64," + imageData;*/

      var bstr = atob(imageData);
      var n = bstr.length;
      var u8arr = new Uint8Array(n);
      while (n--) {
        u8arr[n] = bstr.charCodeAt(n);
      }

      var blob = new Blob([u8arr.buffer], {type: 'image/jpeg'});
      blob.fileName = new Date().getTime() + ".jpg";
      hospitalReceiveDownService.uploadFiles(blob, function (data) {
          if (data == null || data.Body == null) {
            navigator.notification.alert("上传失败", function () {
            }, "提示消息", "确定");
          }
          for (var i = 0; i < data.Body.length; i++) {
            var file = data.Body[i];
            file.SourceName = blob.fileName;
            file.CustomerID = $scope.currentUser.CustomerID;
            $scope.uploadedFiles.push(data.Body[i]);
          }
          $scope.createFileList($scope.uploadedFiles);

        },
        function (data) {
          navigator.notification.alert("上传失败", function () {
          }, "提示消息", "确定");
        });
      //};
    }, function (err) {
      navigator.notification.alert("未选择任何图片", function () {
      }, "提示消息", "确定");
    }, options);
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }

    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = hospitalReceiveDownService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = hospitalReceiveDownService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].ShowFile = hospitalReceiveDownService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  //删除图片
 /* $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };*/
  $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisAskList = [];
      $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
    }
  });
  $scope.showPopup = function (title, modelName) {
    var template = "<input type='text' ng-model='" + modelName + "'>";
    $ionicPopup.show({
        template: template,
        title: title,
        scope: $scope,
        buttons: [
          {
            text: "确定",
          }
        ]
      })
      .then(function (res) {
      });
  };

  /*附件样式start*/
  $scope.bigImage = false;    //初始默认大图是隐藏的
  $scope.hideBigImage = function () {
    $scope.bigImage = false;
  };
  var ScreenHeight = window.screen.height;
 /* $scope.showBigImage = function(imageName){
    $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true;
    var rightDisplay = document.getElementById("rightDisplay");
    rightDisplay.style.height = ScreenHeight+"px";
  };*/
  /*附件样式end*/

  $scope.initialize();
});

angular.bootstrap($('#hospitalReceiveDown'), ['hospitalReceiveDownModule']);
