/**
 * Created by ylj on 2016/10/26.
 */
var hospitalReceiveReferralModule=angular.module("hospitalReceiveReferralModule",["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);
hospitalReceiveReferralModule.service("hospitalReceiveReferralService",function($http, httpHandlerService, resourceFactory){
  var service = {};

  //获取向上转院列表
  service.getDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          //$scope.setTotalItems(response.Body.TotalRows);
          //$scope.getPagination();
          $scope.DiagnosisAskList = response.Body.DiagnosisAskList;
          //$scope.DiagnosisAskList = [];
          //$scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
        }
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //修改向上操作
  service.UpdateDiagnosisAsk = function ($scope) {
    var data = {DiagnosisAsk: $scope.DiagnosisAsk, Patient: $scope.Patient, FileList: $scope.uploadedFiles};
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("用户更新成功",function(){},"提示消息","确定");
          service.getDiagnosisAskList($scope.searchPar, $scope);
        }
        else {
          navigator.notification.alert("用户更新失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //新增向上操作
  service.InsertDiagnosisAsk = function ($scope) {
    if (!$.formValidator.pageIsValid("1")) {
      return;
    }
    var data = {DiagnosisAsk: $scope.AddDiagnosisAsk.DiagnosisAsk, Patient: $scope.AddDiagnosisAsk.Patient, FileList: $scope.uploadedFiles};
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("用户新增成功",function(){},"提示消息","确定");
          service.getDiagnosisAskList($scope);
        } else {
          navigator.notification.alert("用户新增失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //新增向下转院
  service.InsertDiagnosisReply = function ($scope) {
//        if (!$.formValidator.pageIsValid("1")) {
//            return;
//        }
    var data = {Patient: $scope.AddDiagnosisReply.Patient, DiagnosisReply: $scope.AddDiagnosisReply.DiagnosisReply, FileList: $scope.uploadedFiles};
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.insert, function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("新增成功",function(){},"提示消息","确定");
          service.getDiagnosisAskList($scope.searchPar, $scope);
        }
        else {
          navigator.notification.alert("新增失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 更新文件
  service.updateReadFile = function ($scope) {
    if (!$.formValidator.pageIsValid("2")) {
      return;
    }

    for (var i = 0; i < $scope.updatePatient.FileList.length; i++) {
      $scope.updatePatient.FileList[i].State = 2;
    }

    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.FileList.length; j++) {
        var current = $scope.updatePatient.FileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }

      if (!exist) {
        $scope.updatePatient.FileList.push(upload);
      }
    }
    service.UpdateDiagnosisAsk($scope.updatePatient, $scope);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
    httpHandlerService.customerChooseRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerComBox = response.Body.CustomerList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取我的接诊/等待接诊列表
  service.GetListByFirstDoctorID = function (data, $scope) {
    httpHandlerService.GetListByFirstDoctorIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DiagnosisAsk = response.Body.DiagnosisAskList;
          $scope.assignedSearch =
          {
            FirstDoctorID: $scope.currentUser.User.UserID,
            AssignType: $scope.assignedSearch.AssignType,
            BeginRow: 0,
            Rows: 100000,
            PatientName: "",
            TurnOutDateBegin: "",
            TurnOutDateEnd: "",
          };
          if (response.Body.DiagnosisAskList != null && response.Body.DiagnosisAskList.length > 0) {
            $scope.showDetail(response.Body.DiagnosisAskList[0]);
          }
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //获取科室医生数据
  service.getDoctorByDepartmentIDRequest = function (data, $scope) {
    httpHandlerService.getDoctorByDepartmentIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DepartmentUser = response.Body.UserList;
        } else {
          $scope.DepartmentUser = [];
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  return service;
});

hospitalReceiveReferralModule.factory("hospitalReceiveReferralFactory",function(commonFunctionFactory){
  return {
    initialize: function () {
      // 验证
      $.formValidator.initConfig({validatorGroup: "1", mode: "AlertTip"});
      $($("#InsertDiagnosisAsk input[name='PatientID']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk input[name='TurnOutDate']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk input[name='ReceviceDate']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $.formValidator.initConfig({validatorGroup: "2", mode: "AlertTip"});
      $($("#UpdateDiagnosisAsk input[name='ReceiveDoctorName']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: resources.CommonFun.validateRequired});

      // 日期控件
      commonFunctionFactory.date.createDatePicker(["startTime", "endTime", "Birthday", "TurnOutDate", "ReceiveDate", "TurnDownDate"]);

      $("#loading_div").modal("show");
    }
  }
});

hospitalReceiveReferralModule.controller("hospitalReceiveReferralController",function($ionicHistory,$ionicLoading,userService,$scope,$state, $rootScope,hospitalReceiveReferralService, hospitalReceiveReferralFactory, enumFactory, commonFunctionFactory, paginationService){
  hospitalReceiveReferralFactory.initialize();

  $scope.goReferralDetail = function (item) {
    $rootScope.updatePatient = item;
    $state.go("hospitalReceiveReferralDetail");
  };
  // 初始化
  $scope.initialize = function () {

    $scope.PatientStatusList = enumFactory.PatientStatusList;
    $scope.currentUser = userService.getUser().Body;
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: ""
    };
    $scope.assignedSearch = {
      FirstDoctorID: $scope.currentUser.User.UserID,
      AssignType: 3,
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: "",
      TurnOutDateEnd: "",
      PatientName: "",
      Status: ""
    };
    $scope.assignedPatientSearch($scope.assignedSearch.AssignType);
    // 分页初始化
    //paginationService.initialize($scope);
    $scope.search();
    $scope.showSelect($scope);
  };

  $scope.goBack = function(){
    $ionicHistory.goBack();
  };
  //初始化性别
  $scope.GenderList = enumFactory.GenderList;

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

  //转院管理状态
  $scope.DiagnosisAskStatus = function (status) {
    return commonFunctionFactory.displayText.DiagnosisAskStatus(status);
  };

  //初始化查找类型
  $scope.searchTypeList = enumFactory.SearchType;

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //人员类型
  $scope.PatientTypeList = enumFactory.PatientTypeList;

  //初始化转院类型
  $scope.AskTypeList = enumFactory.AskType;

  //转院类型
  $scope.AskTypeText = function (state) {
    return commonFunctionFactory.displayText.AskTypeText(state);
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  /*搜索事件*/
  $scope.search = function () {
    hospitalReceiveReferralService.getDiagnosisAskList($scope.searchPar, $scope);
  };

  /*更多查询按钮*/
  $scope.isTrue = false;
  $scope.toggle = function () {
    $scope.isTrue = !$scope.isTrue;
  };

  /*自定义查询事件*/
  $scope.diagnosisUpSearch = function () {
    $scope.searchPar.BeginTime = $scope.searchPar.BeginDateText + " 00:00:00";
    $scope.searchPar.EndTime = $scope.searchPar.EndDateText + " 23:59:59";
    $scope.search();
  };

  /*最新时间查询事件*/
  $scope.newTimePatientSearch = function () {
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      Name: "",
      Status: 0 // 未提交
    };

    $scope.search();
  };

  /*今日患者事件*/
  $scope.todayPatientSearch = function () {
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginTime: commonFunctionFactory.displayText.DateToTimeText(beginDate),
      EndTime: commonFunctionFactory.displayText.DateToTimeText(endDate),
      BeginDateText: commonFunctionFactory.displayText.DateToDayText(beginDate),
      EndDateText: commonFunctionFactory.displayText.DateToDayText(endDate),
      Name: ""
    };

    $scope.search();
  };

  //修改数据
  $scope.submitDiagnosisAsk = function () {

    hospitalReceiveReferralService.updateReadFile($scope);
  };

  //新增数据
  $scope.CreateDiagnosisReply = function () {
    $scope.AddDiagnosisReply.DiagnosisReply.DiagnosisAskID = $scope.updatePatient.DiagnosisAsk.DiagnosisAskID;
    $scope.AddDiagnosisReply.DiagnosisReply.PatientID = $scope.updatePatient.DiagnosisAsk.PatientID;
    $scope.AddDiagnosisReply.DiagnosisReply.PatientName = $scope.updatePatient.DiagnosisAsk.PatientName;
    hospitalReceiveReferralService.InsertDiagnosisReply($scope);

    window.location.href = "ResponseDiagnosisReply.html";
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    hospitalReceiveReferralService.getPatientList($scope);
    //获取医生列表
    hospitalReceiveReferralService.getUser($scope);
    //获取机构
    hospitalReceiveReferralService.getCustomerExclude($scope);
  };

  // 显示用户新增详情页面
  $scope.showDiagnosisAsk = function () {
    $scope.engineer = {
      currentActivityId: 1,
      PatientID: 14
    };
    $scope.cleanModal();
    $("#InsertDiagnosisAsk").modal("show");
  };

  /*清空新增患者*/
  $scope.cleanModal = function () {
    $scope.updateDiagnosisAsk = {
      Gender: 1,
      Status: 0
    };
    $scope.uploadedFiles = [];
  };

  /*点击详情*/
  /*$scope.showDetail = function (item) {
    $scope.cleanModal();
    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    $scope.updatePatient.Patient.Birthday = $scope.getDateTimeType($scope.updatePatient.Patient.Birthday);
    $scope.updatePatient.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.TurnOutDate);

    if ($scope.updatePatient.DiagnosisAsk) {
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDate) {
        $scope.updatePatient.DiagnosisAsk.ReceiveDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.ReceiveDate);
      }
    }

    $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
    $scope.createFileList($scope.uploadedFiles);

    $scope.ShowCustomer = true;
    if (item.IsReceiver == "1") {
      $scope.GetCustomerNo = $scope.updatePatient.ReplyCustomerName;
      $scope.ShowCustomer = false;
    }

    $('#UpdateDiagnosisAsk').modal('show');
  };*/
  $scope.showDetail = function (item) {
    $scope.cleanModal();
    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    $scope.updatePatient.Patient.Birthday = $scope.getDateTimeType($scope.updatePatient.Patient.Birthday);
    $scope.updatePatient.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.TurnOutDate);

    if ($scope.updatePatient.DiagnosisAsk) {
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDate) {
        $scope.updatePatient.DiagnosisAsk.ReceiveDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.ReceiveDate);
      }
      if ($scope.updatePatient.DiagnosisAsk.TreatDate) {
        $scope.updatePatient.DiagnosisAsk.TreatDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.TreatDate);
      }
    }

    $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
    $scope.createFileList($scope.uploadedFiles);
    console.log(JSON.stringify($scope.updatePatient.FileList));
    $scope.ShowCustomer = true;
    if (item.IsReceiver == "1") {
      $scope.GetCustomerNo = $scope.updatePatient.ReplyCustomerName;
      $scope.ShowCustomer = false;
    }

    //是否有上转诊单 （显示/隐藏）
    $scope.ShowReply = true;
    if ($scope.updatePatient.DiagnosisReply == null) {
      $scope.ShowReply = false;
    }
    //新增下转诊显示隐藏（接诊后显示）
    $scope.ReplyStatus = false;
    if ($scope.updatePatient.DiagnosisAsk.Status == 1 && $scope.ShowReply == false) {
      $scope.ReplyStatus = true;
    }

    var data = {RequestDepartmentID: $scope.updatePatient.DiagnosisAsk.AssignDepartmentID, RequestIsTop: $scope.currentUser.IsTop};
    hospitalReceiveReferralService.getDoctorByDepartmentIDRequest(data, $scope);
  };

  /*跳转页面下转*/
  $scope.submitDiagnosisReply = function () {
    $scope.AddDiagnosisReply = {
      Patient: {},
      DiagnosisReply: {ReplyType: 1}
    }
    ;
    $scope.AddDiagnosisReply.Patient.Name = $scope.updatePatient.Patient.Name;
    $scope.AddDiagnosisReply.Patient.Gender = $scope.updatePatient.Patient.Gender;
    $scope.AddDiagnosisReply.Patient.Birthday = $scope.updatePatient.Patient.Birthday;
    $scope.AddDiagnosisReply.Patient.Phone = $scope.updatePatient.Patient.Phone;
    $scope.AddDiagnosisReply.Patient.IdentityCard = $scope.updatePatient.Patient.IdentityCard;
    $scope.AddDiagnosisReply.Patient.Address = $scope.updatePatient.Patient.Address;
    $scope.AddDiagnosisReply.Patient.PatientType = $scope.updatePatient.Patient.PatientType;
    $scope.uploadedFiles = [];
    $('#CreateDiagnosisReply').modal('show');
    $('#UpdateDiagnosisAsk').modal('hide');
  };

  // 动态查询患者
  $scope.changePatientLevel = function () {
    $scope.PatientComBoxList = [];
    if ($scope.updatePatient.Patient.Name == "") {
      return;
    }
    for (var i = 0; i < $scope.PatientComBox.length; i++) {
      var temp = $scope.PatientComBox[i];
      if (temp.Name.indexOf($scope.updatePatient.Patient.Name) > -1) {
        $scope.PatientComBoxList.push(temp);
      }
    }
  };

  // 加载患者数据
  $scope.searchTemplateClick = function (temp) {
    $scope.updatePatient.Patient.Name = temp.Name;
    $scope.updatePatient.Patient.Phone = temp.Phone;
    $scope.updatePatient.Patient.Gender = temp.Gender;
    $scope.updatePatient.Patient.Birthday = resources.displayText.DateToDayText(temp.Birthday);
    $scope.updatePatient.Patient.IdentityCard = temp.IdentityCard;
    $scope.updatePatient.Patient.Address = temp.Address;
    $scope.updatePatient.Patient.UserID = temp.PatientID;
    $scope.updatePatient.Patient.PatientType = temp.PatientType;
    $scope.PatientComBoxList = [];
  };

  //动态查询医生
  $scope.changeUserLevel = function (flg) {
    if (flg == "0") {
      $scope.InsertUserComBoxList = [];
      if ($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.InsertUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "1") {
      $scope.UpdateUserComBoxList = [];
      if ($scope.updatePatient.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.UpdateUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "2") {
      $scope.UpdateReceiveDoctorName = [];
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName) > -1) {
          $scope.UpdateReceiveDoctorName.push(temp);
        }
      }
    }
    if (flg == "3") {
      $scope.UpdateDoctor = [];
      if ($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName) > -1) {
          $scope.UpdateDoctor.push(temp);
        }
      }
    }
  };

  //绑定首诊医生数据
  $scope.searchUserClick = function (temp, flg) {
    if (flg == "0") { //首诊医生新增
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.InsertUserComBoxList = [];
    }
    if (flg == "1") {
      $scope.updatePatient.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.UpdateUserComBoxList = [];
    }
    if (flg == "2") {
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorName = temp.Name;
      $scope.UpdateReceiveDoctorName = [];
    }
    if (flg == "3") {
      $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorID = temp.UserID;
      $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName = temp.Name;
      $scope.UpdateDoctor = [];
    }

  };

  // 点击具体图片
  $scope.showItemDetail = function (item) {
    $scope.detailFile = item;
    $("#fileDetail").modal("show");
  };

  // 页面显示相关
  $scope.showEachReadFile = function (file) {
    if (file.SourceName.indexOf(".jpg") > -1 || file.SourceName.indexOf(".png") > -1) {
      return hospitalReceiveReferralService.getFileBase() + file.CustomerID + "/" + file.FileName;
    } else {
      return "../images/wenjianjia.png";
    }
  };

  $scope.openEachReadFile = function (file) {
    var detailFile = {
      SourceName: file.SourceName,
      Description: file.Description
    };
    var url = file.FileName;
    if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
      detailFile.ShowUrl = hospitalReceiveReferralService.getFileBase() + file.CustomerID + "/" + url;
    } else {
      detailFile.ShowUrl = hospitalReceiveReferralService.getFileBase() + file.CustomerID + "/" + url;
      detailFile.ShowFile = hospitalReceiveReferralService.getFileBase() + file.CustomerID + "/" + url;
      detailFile.IsPDF = true;
    }

    $scope.detailFile = detailFile;
    $("#fileDetail").modal("show");
  };

  $scope.openFile = function () {
    window.open($scope.detailFile.IsPDF ? $scope.detailFile.ShowFile : $scope.detailFile.ShowUrl);
  };

  // 上传资料 Begin
  $scope.selectFile = function () {
    $("#selectFile").click();
  };

  //上传
  $scope.changeFile = function (files) {
    hospitalReceiveReferralService.uploadFiles(files, function (data) {
        if (data == null || data.Body == null) {
          navigator.notification.alert("上传失败",function(){},"提示消息","确定");
        }
        for (var i = 0; i < data.Body.length; i++) {
          var file = data.Body[i];
          file.CustomerID = $scope.currentUser.CustomerID;
          $scope.uploadedFiles.push(data.Body[i]);
        }

        $scope.createFileList($scope.uploadedFiles);
      },
      function (data) {
        navigator.notification.alert("上传失败",function(){},"提示消息","确定");
      });
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }

    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = hospitalReceiveReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = hospitalReceiveReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].ShowFile = hospitalReceiveReferralService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  //删除图片
  $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisAskList = [];
      $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
    }
  });

//我的接诊、等待接诊患者信息查询事件
  $scope.assignedPatientSearch = function (AssignType) {

    if(AssignType == 3){
      $(".my-receive").addClass("my-receive-on");
      $(".wait-receive").removeClass("wait-receive-on");
    }else if(AssignType == -1){
      $(".wait-receive").addClass("wait-receive-on");
      $(".my-receive").removeClass("my-receive-on");
    }
    $scope.assignedSearch.AssignType = AssignType;
    $scope.assignedSearch.ModuleNo = "M001";

    hospitalReceiveReferralService.GetListByFirstDoctorID($scope.assignedSearch, $scope)
    $scope.showSelect($scope);
  };

  /*自定义查询事件*/
  $scope.DiagnosisAskSearch = function () {
    $scope.assignedPatientSearch($scope.assignedSearch.AssignType);
  };
  /*今日患者事件*/
  $scope.todayPatientSearch = function () {
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.assignedSearch.TurnOutDateBegin = resources.displayText.DateToDayText(beginDate);
    $scope.assignedSearch.TurnOutDateEnd = resources.displayText.DateToDayText(endDate);
    $scope.assignedPatientSearch($scope.assignedSearch.AssignType);
    $scope.showSelect($scope);
  };
  //最近7天患者查询
  $scope.newTimePatientSearch = function () {
    var today = new Date();
    var oldday = new Date(today.getTime() - 6 * 24 * 3600 * 1000);
    var beginDate = new Date(oldday.getFullYear(), oldday.getMonth(), oldday.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.assignedSearch.TurnOutDateBegin = resources.displayText.DateToDayText(beginDate);
    $scope.assignedSearch.TurnOutDateEnd = resources.displayText.DateToDayText(endDate);
    $scope.assignedPatientSearch($scope.assignedSearch.AssignType);
  };
  $scope.searchSort = function(value){
    switch(value){
      case 0:$scope.DiagnosisAskSearch();
        break;
      case 1:break;
      case 2:break;
      case 3:break;
      case 4:$scope.todayPatientSearch();
            break;
      case 5:$scope.newTimePatientSearch();
            break;

    }
  }
  $scope.initialize();
});
angular.bootstrap($('hospitalReceiveReferral'), ['hospitalReceiveReferralModule']);
