/**
 * Created by ylj on 2016/10/26.
 */
var hospitalReceiveReferralDetailModule = angular.module("hospitalReceiveReferralDetailModule", ["httpHandlerModule", "resourceModule", "PaginationModule", "UserModule"]);
hospitalReceiveReferralDetailModule.factory("hospitalReceiveReferralDetailFactory", function (commonFunctionFactory) {
  return {
    initialize: function () {
      // 验证
      $.formValidator.initConfig({validatorGroup: "1", mode: "AlertTip"});
      $($("#InsertDiagnosisAsk input[name='PatientID']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk input[name='TurnOutDate']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $($("#InsertDiagnosisAsk input[name='ReceviceDate']")[0]).formValidator({validatorGroup: "1"}).functionValidator({fun: resources.CommonFun.validateRequired});
      $.formValidator.initConfig({validatorGroup: "2", mode: "AlertTip"});
      $($("#UpdateDiagnosisAsk input[name='ReceiveDoctorName']")[0]).formValidator({validatorGroup: "2"}).functionValidator({fun: resources.CommonFun.validateRequired});

      // 日期控件
      commonFunctionFactory.date.createDatePicker(["startTime", "endTime", "Birthday", "TurnOutDate", "ReceiveDate", "TurnDownDate"]);

      $("#loading_div").modal("show");
    }
  }
});

hospitalReceiveReferralDetailModule.service("hospitalReceiveReferralDetailService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};

  //获取向上转院列表
  service.getDiagnosisAskList = function (data, $scope) {
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.setTotalItems(response.Body.TotalRows);
          $scope.getPagination();
          $scope.DiagnosisAsk = response.Body.DiagnosisAskList;
          $scope.DiagnosisAskList = [];
          $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
        }
        $("#loading_div").modal("hide");
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //修改向上操作
  service.UpdateDiagnosisAsk = function ($scope) {
    var data = {DiagnosisAsk: $scope.DiagnosisAsk, Patient: $scope.Patient, FileList: $scope.uploadedFiles, IsConfirmReceive: $scope.IsConfirmReceive};
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("操作成功",function(){},"提示消息","确定");
          //alert("操作成功")
          service.getDiagnosisAskList($scope.searchPar, $scope);
        } else if (response.Header.StatusCode == 3) {
          navigator.notification.alert(response.Header.Message,function(){},"提示消息","确定");
          return false;
          //$scope.updatePatient.DiagnosisAsk.Status = 0;
        } else {
          navigator.notification.alert("操作失败",function(){},"提示消息","确定");
          return false;
          //alert("操作失败");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //新增向上操作
  service.InsertDiagnosisAsk = function ($scope) {
    if (!$.formValidator.pageIsValid("1")) {
      return;
    }
    var data = {
      DiagnosisAsk: $scope.AddDiagnosisAsk.DiagnosisAsk,
      Patient: $scope.AddDiagnosisAsk.Patient,
      FileList: $scope.uploadedFiles
    };
    httpHandlerService.diagnosisAskRequest(data, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("用户新增成功",function(){},"提示消息","确定");
          service.getDiagnosisAskList($scope);
        } else {
          navigator.notification.alert("用户新增失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //新增向下转院
  service.InsertDiagnosisReply = function ($scope) {
//        if (!$.formValidator.pageIsValid("1")) {
//            return;
//        }
    var data = {
      Patient: $scope.AddDiagnosisReply.Patient,
      DiagnosisReply: $scope.AddDiagnosisReply.DiagnosisReply,
      FileList: $scope.uploadedFiles
    };
    httpHandlerService.diagnosisReplyRequest(data, resourceFactory.operateCode.insert, function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("新增成功",function(){},"提示消息","确定");
          service.getDiagnosisAskList($scope.searchPar, $scope);
        }
        else {
          navigator.notification.alert("新增失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  // 更新文件
  service.updateReadFile = function ($scope) {
    if (!$.formValidator.pageIsValid("2")) {
      return;
    }

    for (var i = 0; i < $scope.updatePatient.FileList.length; i++) {
      $scope.updatePatient.FileList[i].State = 2;
    }

    for (var i = 0; i < $scope.uploadedFiles.length; i++) {
      var upload = $scope.uploadedFiles[i];
      var exist = false;
      for (var j = 0; j < $scope.updatePatient.FileList.length; j++) {
        var current = $scope.updatePatient.FileList[j];
        if (upload.FileName == current.FileName) {
          current.State = 0;
          exist = true;
        }
      }

      if (!exist) {
        $scope.updatePatient.FileList.push(upload);
      }
    }
    return service.UpdateDiagnosisAsk($scope.updatePatient, $scope);
  };

  //获取患者列表
  service.getPatientList = function ($scope) {
    httpHandlerService.diagnosisPatientRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.PatientComBox = response.Body.PatientList;
        }
      },
      function (response) {
        console.log(response);
      }, 1);
  };

  //获取医生列表
  service.getUser = function ($scope) {
    httpHandlerService.userRequest({}, resourceFactory.operateCode.get,
      function (result) {
        if (result != null && result.Header.StatusCode == 0) {
          $scope.userList = result.Body.UserList;
        }
      }, function (e) {
        console.log(e);
      }, 1);
  };

  //获取根据用户查询机构
  service.getCustomerExclude = function ($scope) {
   httpHandlerService.customerChooseRequest({}, resourceFactory.operateCode.get,
   function (response) {
   if (response.Header.StatusCode == 0) {
   $scope.CustomerComBox = response.Body.CustomerList;
   }
   },
   function (response) {
   console.log(response);
   }, 1);
   };

  // 上传文件
  service.uploadFiles = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadFilesRequest(data, successCallback, errorCallback)
  };

  // 文件上传路径base
  service.getFileBase = function () {
    return resourceFactory.address.fileDomain;
  };

  //获取科室医生数据
  service.getDoctorByDepartmentIDRequest = function (data, $scope) {
    httpHandlerService.getDoctorByDepartmentIDRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.DepartmentUser = response.Body.UserList;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  //修改向上操作
  service.saveTopAssign = function (data, $scope) {
    if (!$.formValidator.pageIsValid("2")) {
      return;
    }
    httpHandlerService.topAssignRequest(data, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getDiagnosisAskList($scope.searchPar, $scope);
          //alert("修改成功");
          navigator.notification.alert("修改成功",function(){},"提示消息","确定");
        }
        else {
          console.log(response.Header.Message);
        }
      },
      function (response) {
        console.log(response);
      }
    );
  };

  //获取科室数据
  service.getAllDepartmentChooseRequest = function (data, $scope) {
    httpHandlerService.getDepartmentSelectRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.CustomerDepartment = response.Body.DepartmentList;
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  return service;
});

hospitalReceiveReferralDetailModule.controller("hospitalReceiveReferralDetailController", function ($ionicPopup,$ionicLoading,userService,resourceFactory, $state, $rootScope, $scope, $ionicHistory, hospitalReceiveReferralDetailService, hospitalReceiveReferralDetailFactory, enumFactory, commonFunctionFactory, paginationService) {
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };
  $scope.goHospitalScanMessage=function(){
    $scope.DiagnosisReply = {};
    $scope.DiagnosisReply.TreatDoctorName = $scope.updatePatient.DiagnosisReply.TreatDoctorName;
    $scope.DiagnosisReply.TurnDownDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisReply.TurnDownDate);
    $scope.DiagnosisReply.CustomerName = $scope.updatePatient.CustomerName;
    $scope.DiagnosisReply.ReplyType = $scope.updatePatient.DiagnosisReply.ReplyType;
    $scope.DiagnosisReply.LeaveDiagnosis = $scope.updatePatient.DiagnosisReply.LeaveDiagnosis;
    $scope.DiagnosisReply.TreatSummary = $scope.updatePatient.DiagnosisReply.TreatSummary;
    $scope.DiagnosisReply.Suggestion = $scope.updatePatient.DiagnosisReply.Suggestion;
    $state.go("hospitalScanMessage");
  };
  $scope.updatePatient = $rootScope.updatePatient;
  if($scope.updatePatient.DiagnosisAsk.TurnOutDate != null){
    $scope.updatePatient.DiagnosisAsk.TurnOutDate = ($scope.updatePatient.DiagnosisAsk.TurnOutDate).substr(0,10);
  }

  if($scope.updatePatient.DiagnosisAsk.TreatDate != null){
    $scope.updatePatient.DiagnosisAsk.TreatDate = ($scope.updatePatient.DiagnosisAsk.TreatDate).substr(0,10);
  }

  if( $scope.updatePatient.Patient.Birthday != null){
    $scope.updatePatient.Patient.Birthday = ($scope.updatePatient.Patient.Birthday).substr(0,10);
  }
  //var data = {RequestDepartmentID: $scope.updatePatient.DiagnosisAsk.AssignDepartmentID, RequestIsTop: 1};
  /*$scope.RequestDepartmentID = $scope.updatePatient.DiagnosisAsk.AssignDepartmentID;
  $scope.RequestIsTop = 1;*/
  hospitalReceiveReferralDetailFactory.initialize();

  $scope.goHospitalReceiveDown = function () {
    $scope.updatePatient = $rootScope.updatePatient;
    $ionicLoading.show({
      content: 'Loading',
      animation: 'fade-in',
      showBackdrop: true,
      maxWidth: 200,
      showDelay: 0
    });
    $state.go("hospitalReceiveDown");
   $ionicLoading.hide();

  };

 /* $scope.ShowReply = false;
  $scope.ShowAsk = true;
  if ($scope.DiagnosisReply) {
    $scope.ShowReply = true;
    $scope.ShowAsk = false;
  }*/
  /*$scope.goDescendReferral=function(){
   $state.go("hospitalDescendReferral");
   };*/
  // 初始化
  $scope.initialize = function () {
    $scope.updatePatient = $rootScope.updatePatient;
    $scope.PatientStatusList = enumFactory.PatientStatusList;
    $scope.currentUser = userService.getUser().Body;
    $scope.uploadedFiles = [];
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate() - 30, 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: resources.displayText.DateToDayText(beginDate),
      TurnOutDateEnd: resources.displayText.DateToDayText(endDate),
      PatientName: "",
      Status: ""
    };

    $scope.assignedSearch = {
      FirstDoctorID: $scope.currentUser.User.UserID,
      AssignType: 3,
      BeginRow: 0,
      Rows: 100000,
      TurnOutDateBegin: "",
      TurnOutDateEnd: "",
      PatientName: "",
      Status: ""
    };

    var data = {ReceiveCustomerID: $scope.currentUser.CustomerID, ReceiveIsTop: $scope.currentUser.IsTop, ModuleType: 1};
    hospitalReceiveReferralDetailService.getAllDepartmentChooseRequest(data, $scope);


    //是否有上转诊单 （显示/隐藏）
    $scope.ShowReply = true;
    if ($scope.updatePatient.DiagnosisReply == null) {
      $scope.ShowReply = false;
    }

    //新增下转诊显示隐藏（接诊后显示）
    $scope.ReplyStatus = false;
    if ($scope.updatePatient.DiagnosisAsk.Status == 1 && $scope.ShowReply == false) {
      $scope.ReplyStatus = true;
    }
    //保存显示隐藏（我的转诊隐藏,等待转诊显示）
    $scope.ReplySave = function () {
      if ($scope.updatePatient) {
        if ($scope.updatePatient.DiagnosisAsk.AssignType == 1 || $scope.updatePatient.DiagnosisAsk.AssignType == 2)
          return true;
      }
    };
    $scope.CustomerDepartmentMedical($scope.updatePatient.DiagnosisAsk.AssignDepartmentID);

    //轉入醫院
    $scope.GetCustomerNo = $scope.updatePatient.CustomerName;
    // 分页初始化
    paginationService.initialize($scope);
    $scope.search();
    $scope.showSelect($scope);
  };

  //初始化性别
  $scope.GenderList = enumFactory.GenderList;

  //性别
  $scope.GenderText = function (state) {
    return commonFunctionFactory.displayText.GenderText(state);
  };

  //转院管理状态
  $scope.DiagnosisAskStatus = function (status) {
    return commonFunctionFactory.displayText.DiagnosisAskStatus(status);
  };

  //计算年龄
  $scope.calculateAge = function (date) {
    var data = $scope.getDateTimeType(date);
    return resources.CommonFun.calculateAge(data);
  };

  //人员类型
  $scope.PatientTypeList = enumFactory.PatientTypeList;

  //人员类型
  $scope.PatientTypeText = function (status) {
    return commonFunctionFactory.displayText.PatientTypeList(status);
  };

  //初始化转院类型
  $scope.AskTypeList = enumFactory.AskType;

  //转院类型
  $scope.AskTypeText = function (state) {
    return commonFunctionFactory.displayText.AskTypeText(state);
  };

  //时间
  $scope.getDateTimeType = function (date) {
    return resources.displayText.DateToDayText(date);
  };

  /*搜索事件*/
  $scope.search = function () {
    hospitalReceiveReferralDetailService.getDiagnosisAskList($scope.searchPar, $scope);
  };

  /*更多查询按钮*/
  $scope.isTrue = false;
  $scope.toggle = function () {
    $scope.isTrue = !$scope.isTrue;
  };

  /*自定义查询事件*/
  $scope.diagnosisUpSearch = function () {
    $scope.searchPar.BeginTime = $scope.searchPar.BeginDateText + " 00:00:00";
    $scope.searchPar.EndTime = $scope.searchPar.EndDateText + " 23:59:59";
    $scope.search();
  };

  /*最新时间查询事件*/
  $scope.newTimePatientSearch = function () {
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      Name: "",
      Status: 0 // 未提交
    };

    $scope.search();
  };

  /*今日患者事件*/
  $scope.todayPatientSearch = function () {
    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);
    var endDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 23, 59, 59);
    $scope.searchPar = {
      BeginRow: 0,
      Rows: 100000,
      BeginTime: commonFunctionFactory.displayText.DateToTimeText(beginDate),
      EndTime: commonFunctionFactory.displayText.DateToTimeText(endDate),
      BeginDateText: commonFunctionFactory.displayText.DateToDayText(beginDate),
      EndDateText: commonFunctionFactory.displayText.DateToDayText(endDate),
      Name: ""
    };

    $scope.search();
  };

  //修改数据
  $scope.submitDiagnosisAsk = function (flg) {

    var today = new Date();
    var beginDate = new Date(today.getFullYear(), today.getMonth(), today.getDate(), 0, 0, 0);

    //分配
    if (flg == 1) {
      $scope.updatePatient.DiagnosisAsk.ReceiveDate = commonFunctionFactory.displayText.DateToDayText(beginDate);
      $scope.ToAssign = {
        DiagnosisAskID: $scope.updatePatient.DiagnosisAsk.DiagnosisAskID,
        AssignDepartmentID: $scope.updatePatient.DiagnosisAsk.AssignDepartmentID,
        AssignDepartmentName: $("#selAssignDepartment option:selected").text() == "-- 请选择 --" ? null : $("#selAssignDepartment option:selected").text(),
        ReceiveDoctorID: $scope.updatePatient.DiagnosisAsk.ReceiveDoctorID,
        ReceiveDoctorName: $("#selReceiveDoctor option:selected").text() == "-- 请选择 --" ? null : $("#selReceiveDoctor option:selected").text(),
        ModuleNo: "M001"
      };
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorName = $("#selReceiveDoctor option:selected").text();
      $scope.updatePatient.DiagnosisAsk.AssignDepartmentName = $("#selAssignDepartment option:selected").text();
      hospitalReceiveReferralDetailService.saveTopAssign($scope.ToAssign, $scope);
    } else if (flg == 2) {//报道确认
      $scope.updatePatient.DiagnosisAsk.HospitalStatus = 1;
      $scope.updatePatient.ModuleNo = "M001";
      hospitalReceiveReferralDetailService.updateReadFile($scope);
    } else if (flg == 3) {
      $scope.updatePatient.DiagnosisAsk.TreatDoctorID = "";
      $scope.updatePatient.DiagnosisAsk.TreatDoctorName = "";
      $scope.updatePatient.DiagnosisAsk.TreatDate = "";
      $scope.updatePatient.DiagnosisAsk.Status = 0;
      $scope.updatePatient.DiagnosisAsk.HospitalStatus = 0;
      $scope.updatePatient.ModuleNo = "M001";
      hospitalReceiveReferralDetailService.updateReadFile($scope);
    } else {   //接诊
      console.log($scope.updatePatient);
      $scope.updatePatient.DiagnosisAsk.TreatDoctorID = $scope.currentUser.User.UserID;
      $scope.updatePatient.DiagnosisAsk.TreatDoctorName = $scope.currentUser.User.Name;
      $scope.updatePatient.DiagnosisAsk.TreatDate = commonFunctionFactory.displayText.DateToDayText(beginDate);
      $scope.updatePatient.DiagnosisAsk.Status = 1;
      $scope.updatePatient.ModuleNo = "M001";
      $scope.updatePatient.IsConfirmReceive = 1;  //接诊
      //if(hospitalReceiveReferralDetailService.updateReadFile($scope)){
      //  $scope.updatePatient.DiagnosisAsk.Status = 1;
      //}
      hospitalReceiveReferralDetailService.updateReadFile($scope);
    }
    //hospitalReceiveReferralDetailService.updateReadFile($scope);
  };

  //新增数据
  $scope.CreateDiagnosisReply = function () {
    $scope.AddDiagnosisReply.DiagnosisReply.DiagnosisAskID = $scope.updatePatient.DiagnosisAsk.DiagnosisAskID;
    $scope.AddDiagnosisReply.DiagnosisReply.PatientID = $scope.updatePatient.DiagnosisAsk.PatientID;
    $scope.AddDiagnosisReply.DiagnosisReply.PatientName = $scope.updatePatient.DiagnosisAsk.PatientName;
    hospitalReceiveReferralDetailService.InsertDiagnosisReply($scope);

    window.location.href = "ResponseDiagnosisReply.html";
  };

  //下拉框查询
  $scope.showSelect = function ($scope) {
    //获取患者列表
    hospitalReceiveReferralDetailService.getPatientList($scope);
    //获取医生列表
    hospitalReceiveReferralDetailService.getUser($scope);
    //获取机构
     hospitalReceiveReferralDetailService.getCustomerExclude($scope);
  };

  // 显示用户新增详情页面
  $scope.showDiagnosisAsk = function () {
    $scope.engineer = {
      currentActivityId: 1,
      PatientID: 14
    };
    $scope.cleanModal();
    $("#InsertDiagnosisAsk").modal("show");
  };

  /*清空新增患者*/
  $scope.cleanModal = function () {
    $scope.updateDiagnosisAsk = {
      Gender: 1,
      Status: 0
    };
    $scope.uploadedFiles = [];
  };

  /*点击详情*/
  $scope.showDetail = function (item) {
    $scope.cleanModal();
    $scope.updatePatient = JSON.parse(JSON.stringify(item));
    $scope.updatePatient.Patient.Birthday = $scope.getDateTimeType($scope.updatePatient.Patient.Birthday);
    $scope.updatePatient.DiagnosisAsk.TurnOutDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.TurnOutDate);
    if ($scope.updatePatient.DiagnosisAsk) {
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDate) {
        $scope.updatePatient.DiagnosisAsk.ReceiveDate = $scope.getDateTimeType($scope.updatePatient.DiagnosisAsk.ReceiveDate);
      }
    }

    $scope.uploadedFiles = JSON.parse(JSON.stringify($scope.updatePatient.FileList));
    $scope.createFileList($scope.uploadedFiles);

    $scope.ShowCustomer = true;
    if (item.IsReceiver == "1") {
      $scope.GetCustomerNo = $scope.updatePatient.ReplyCustomerName;
      $scope.ShowCustomer = false;
    }
  };

  /*跳转页面下转*/
  $scope.submitDiagnosisReply = function () {
    $scope.AddDiagnosisReply = {
      Patient: {},
      DiagnosisReply: {ReplyType: 1}
    }
    ;
    $scope.AddDiagnosisReply.Patient.Name = $scope.updatePatient.Patient.Name;
    $scope.AddDiagnosisReply.Patient.Gender = $scope.updatePatient.Patient.Gender;
    $scope.AddDiagnosisReply.Patient.Birthday = $scope.updatePatient.Patient.Birthday;
    $scope.AddDiagnosisReply.Patient.Phone = $scope.updatePatient.Patient.Phone;
    $scope.AddDiagnosisReply.Patient.IdentityCard = $scope.updatePatient.Patient.IdentityCard;
    $scope.AddDiagnosisReply.Patient.Address = $scope.updatePatient.Patient.Address;
    $scope.AddDiagnosisReply.Patient.PatientType = $scope.updatePatient.Patient.PatientType;
    $scope.uploadedFiles = [];
    $('#CreateDiagnosisReply').modal('show');
    $('#UpdateDiagnosisAsk').modal('hide');
  };

  // 动态查询患者
  $scope.changePatientLevel = function () {
    $scope.PatientComBoxList = [];
    if ($scope.updatePatient.Patient.Name == "") {
      return;
    }
    for (var i = 0; i < $scope.PatientComBox.length; i++) {
      var temp = $scope.PatientComBox[i];
      if (temp.Name.indexOf($scope.updatePatient.Patient.Name) > -1) {
        $scope.PatientComBoxList.push(temp);
      }
    }
  };

  // 加载患者数据
  $scope.searchTemplateClick = function (temp) {
    $scope.updatePatient.Patient.Name = temp.Name;
    $scope.updatePatient.Patient.Phone = temp.Phone;
    $scope.updatePatient.Patient.Gender = temp.Gender;
    $scope.updatePatient.Patient.Birthday = resources.displayText.DateToDayText(temp.Birthday);
    $scope.updatePatient.Patient.IdentityCard = temp.IdentityCard;
    $scope.updatePatient.Patient.Address = temp.Address;
    $scope.updatePatient.Patient.UserID = temp.PatientID;
    $scope.updatePatient.Patient.PatientType = temp.PatientType;
    $scope.PatientComBoxList = [];
  };

  //动态查询医生
  $scope.changeUserLevel = function (flg) {
    if (flg == "0") {
      $scope.InsertUserComBoxList = [];
      if ($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.InsertUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "1") {
      $scope.UpdateUserComBoxList = [];
      if ($scope.updatePatient.DiagnosisAsk.FirstDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.FirstDoctorName) > -1) {
          $scope.UpdateUserComBoxList.push(temp);
        }
      }
    }
    if (flg == "2") {
      $scope.UpdateReceiveDoctorName = [];
      if ($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.updatePatient.DiagnosisAsk.ReceiveDoctorName) > -1) {
          $scope.UpdateReceiveDoctorName.push(temp);
        }
      }
    }
    if (flg == "3") {
      $scope.UpdateDoctor = [];
      if ($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName == "") {
        return;
      }
      for (var i = 0; i < $scope.userList.length; i++) {
        var temp = $scope.userList[i].User;
        if (temp.Name.indexOf($scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName) > -1) {
          $scope.UpdateDoctor.push(temp);
        }
      }
    }
  };

  //绑定首诊医生数据
  $scope.searchUserClick = function (temp, flg) {
    if (flg == "0") { //首诊医生新增
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.AddDiagnosisAsk.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.InsertUserComBoxList = [];
    }
    if (flg == "1") {
      $scope.updatePatient.DiagnosisAsk.FirstDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.FirstDoctorName = temp.Name;
      $scope.UpdateUserComBoxList = [];
    }
    if (flg == "2") {
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorID = temp.UserID;
      $scope.updatePatient.DiagnosisAsk.ReceiveDoctorName = temp.Name;
      $scope.UpdateReceiveDoctorName = [];
    }
    if (flg == "3") {
      $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorID = temp.UserID;
      $scope.AddDiagnosisReply.DiagnosisReply.TreatDoctorName = temp.Name;
      $scope.UpdateDoctor = [];
    }

  };



  // 点击具体图片
  $scope.showItemDetail = function (item) {
    $scope.detailFile = item;
    $("#fileDetail").modal("show");
  };

  //根据科室查询医生
  $scope.CustomerDepartmentMedical = function (Id) {
    var data = {RequestDepartmentID: Id, RequestIsTop: 1};
    hospitalReceiveReferralDetailService.getDoctorByDepartmentIDRequest(data, $scope);
  };

  // 页面显示相关
  $scope.showEachReadFile = function (file) {
    if(file.SourceName.length>6){
      file.SourceName = (file.SourceName).substr(0,6) +"...";
    }
    if (file.FileName.indexOf(".jpg") > -1 || file.FileName.indexOf(".png") > -1 || file.FileName.indexOf(".jpeg") > -1) {
      return hospitalReceiveReferralDetailService.getFileBase() + file.CustomerID + "/" + file.FileName;
    } else {
      return "img/attachment_icon.png";
    }
  };

  $scope.openEachReadFile = function (file) {
    var detailFile = {
      SourceName: file.SourceName,
      Description: file.Description
    };
    var url = file.FileName;
    if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
      detailFile.ShowUrl = hospitalReceiveReferralDetailService.getFileBase() + file.CustomerID + "/" + url;
    } else {
      detailFile.ShowUrl = hospitalReceiveReferralDetailService.getFileBase() + file.CustomerID + "/" + url;
      detailFile.ShowFile = hospitalReceiveReferralDetailService.getFileBase() + file.CustomerID + "/" + url;
      detailFile.IsPDF = true;
    }

    $scope.detailFile = detailFile;
    $("#fileDetail").modal("show");
  };

  $scope.openFile = function () {
    window.open($scope.detailFile.IsPDF ? $scope.detailFile.ShowFile : $scope.detailFile.ShowUrl);
  };

  // 上传资料 Begin
  $scope.selectFile = function () {
    $("#selectFile").click();
  };

  //上传
  $scope.changeFile = function (files) {
    hospitalReceiveReferralDetailService.uploadFiles(files, function (data) {
        if (data == null || data.Body == null) {
          navigator.notification.alert("上传失败",function(){},"提示消息","确定");
        }
        for (var i = 0; i < data.Body.length; i++) {
          var file = data.Body[i];
          file.CustomerID = $scope.currentUser.CustomerID;
          $scope.uploadedFiles.push(data.Body[i]);
        }

        $scope.createFileList($scope.uploadedFiles);
      },
      function (data) {
        navigator.notification.alert("上传失败",function(){},"提示消息","确定");
      });
  };

  $scope.uploadFile = function () {
    // 从指定来源检索图像文件位置
    navigator.camera.getPicture(function (imageURI) {
        var options = new FileUploadOptions(); //文件参数选项
        options.fileKey = "file";//向服务端传递的file参数的parameter name
        options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);//文件名
        options.mimeType = "image/jpeg";//文件格式，默认为image/jpeg
        var ft = new FileTransfer();//文件上传类
        var ser = resourceFactory.address.uploadFileUrl;
        ft.upload(imageURI, encodeURI(ser), function () {
          navigator.notification.alert("上传成功",function(){},"提示消息","确定");
          $("#receiveAddFile").attr("src", imageURI);
          $("#receiveAddFile").show();
        }, null, options);
      },
      function (message) {
        navigator.notification.alert("未选择任何图片",function(){},"提示消息","确定");
      },
      {
        quality: 100,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY
      }
    );
  };

  //图片
  $scope.createFileList = function (files) {
    if (files == null || files.length < 0) {
      return null;
    }

    for (var i = 0; i < files.length; i++) {
      var max = 10;
      var showName = files[i].SourceName;
      if (showName != "") {
        if (showName.length > max) {
          showName = showName.substr(0, max - 3) + "...";
        }

        files[i].ShowName = showName;
        var url = files[i].FileName;
        if (url.indexOf(".png") > -1 || url.indexOf(".jpg") > -1) {
          files[i].ShowUrl = hospitalReceiveReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].Class = "icon-picture";
        } else {
          files[i].ShowUrl = hospitalReceiveReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].ShowFile = hospitalReceiveReferralDetailService.getFileBase() + files[i].CustomerID + "/" + url;
          files[i].IsPDF = true;
          files[i].Class = "icon-file";
        }
      }
    }
  };

  //删除图片
  $scope.deleteFile = function (item) {
    var list = $scope.uploadedFiles;
    var newList = [];
    for (var i = 0; i < list.length; i++) {
      if (list[i].FileName != item.FileName) {
        newList.push(list[i]);
      }
    }
    $scope.uploadedFiles = newList;
    $scope.createFileList($scope.uploadedFiles);
  };

  // 分页相关
  $scope.$watch('conf.currentPage', function () {
    if ($scope.changePaginationContent) {
      $scope.DiagnosisAskList = [];
      $scope.changePaginationContent($scope.DiagnosisAsk, $scope.DiagnosisAskList);
    }
  });
  /*附件样式start*/
  $scope.bigImage = false;    //初始默认大图是隐藏的
  $scope.hideBigImage = function () {
    $scope.bigImage = false;
  };
  var ScreenHeight = window.screen.height;
  $scope.showBigImage = function(imageName){
    $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true;
    var rightDisplay = document.getElementById("rightDisplay");
    rightDisplay.style.height = ScreenHeight+"px";
  };
  /*附件样式end*/

  //接诊显示隐藏（未分配隐藏）
  /*$scope.RelyAssign = function () {
    if ($scope.updatePatient) {
      if ($scope.updatePatient.DiagnosisAsk.AssignType == 1 || $scope.updatePatient.DiagnosisAsk.AssignType == 2)
        return false
      if ($scope.updatePatient.DiagnosisAsk.Status == 0)
        return true;
    }
  };*/
  $scope.RelyAssign = function () {
    if ($scope.updatePatient) {
      if (authentication.checkAuthentication($scope.currentUser.RoleModuleList, "M001", 6, $scope.currentUser.UserType)) {
        if ($scope.updatePatient.DiagnosisAsk.AssignType == 1 || $scope.updatePatient.DiagnosisAsk.AssignType == 2)
          return false
        if ($scope.updatePatient.DiagnosisAsk.Status == 0)
          return true;
      } else {
        return false;
      }
    }
  };

  //住院显示隐藏
  /*$scope.submitHospital = function () {
    if ($scope.updatePatient) {
      //未确认状态，并且类型为住院
      if ($scope.updatePatient.DiagnosisAsk.HospitalStatus != 1 && $scope.updatePatient.DiagnosisAsk.AskType == 1) {
        return true;
      } else {
        return false;
      }
    }
  };*/

  // 能否关闭接诊单
  $scope.CanClose = function () {
    if ($scope.updatePatient) {
      if (authentication.checkAuthentication($scope.currentUser.RoleModuleList, "M001", 6, $scope.currentUser.UserType)) {
        if ($scope.updatePatient.DiagnosisAsk.AssignType == 1 || $scope.updatePatient.DiagnosisAsk.AssignType == 2
          || $scope.updatePatient.DiagnosisAsk.Status == 3) {
          return false
        }
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  };
// 关闭接诊单弹出
  $scope.ShowCloseDiagnosisAsk = function () {
    $ionicPopup.show({
        template: "<textarea cols='10' rows='5' textarea-auto= 'true' ng-model = 'updatePatient.DiagnosisAsk.ClosedReason'></textarea>",
        title: '关闭理由',
        scope: $scope,
        buttons: [
          {
            text: "确定",
            onTap:function(){
              if (!$scope.updatePatient.DiagnosisAsk.ClosedReason) {
                navigator.notification.alert("请填写关闭理由",function(){},"提示消息","确定");
                return;
              }
              $scope.updatePatient.DiagnosisAsk.Status = 3;
              $scope.updatePatient.ModuleNo = "M001";
              hospitalReceiveReferralDetailService.updateReadFile($scope);
            }
          }
        ]
      })
      .then(function (res) {
      });
  };
  //显示弹出框
  /* $scope.showPopup = function (title, modelName) {
   /!* var template = "<input type='text' ng-model='" + modelName+"'>";*!/
   $ionicPopup.show({
   template: "<input type='text' ng-model='" + modelName + "'>",
   title: title,
   scope: $scope,
   buttons: [
   {
   text: "确定",
   }
   ]
   })
   .then(function (res) {
   });
   };*/
  $scope.submitHospital = function () {
    if ($scope.updatePatient) {
      //未确认状态，并且类型为住院
      if ($scope.updatePatient.DiagnosisAsk.HospitalStatus != 1 && $scope.updatePatient.DiagnosisAsk.AskType == 1) {
        return authentication.checkAuthentication($scope.currentUser.RoleModuleList, "M001", 5, $scope.currentUser.UserType);
      } else {
        return false;
      }
    }
  };
  //下载图片
  $scope.downloadImg = function(file){
    navigator.notification.confirm('您确定要下载吗？', showConfirm, '下载文件', '确定,取消');
    var url = hospitalReceiveReferralDetailService.getFileBase() + file.CustomerID + "/" + file.FileName;
    function showConfirm(button) {
      if( button == 1 ) {
        download.downloadFile(url);
      } else {
      }
    }
  };
  $scope.initialize();
});

angular.bootstrap($('hospitalReceiveReferralDetail'), ['hospitalReceiveReferralDetailModule']);
