var IMModule = angular.module('IMModule', []);
IMModule.service('IMContentService', function () {
  var service = {};
  var notification = window.Notification || window.mozNotification || window.webkitNotification || window.msNotification || window.webkitNotifications;
  if (!!notification) {
    notification.requestPermission(function (permission) {
      if (notification.permission !== "granted") {
        notification.permission = "granted";
      }
    });
  }


  // 发送内容处理
  var preReplaceContentToDb = function (inputStr) {
    if (inputStr == undefined || inputStr == null || inputStr == '') {
      return inputStr;
    }

    var str = inputStr;
    str = str.replace(/<(div|br|p)[/]?>/g, '\u000A');
    str = str.replace(/\u000A+/g, '\u000D');
    str = str.replace(/<[^img][^>]+>/g, ''); // 去掉所有的html标记
    str = str.replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&amp;/g, '&').replace(/&nbsp;/g, ' ');
    if ('\u000D' == str) {
      str = '';
    }

    return str;
  };
  // 改变id
  var changeClientNo = function (str) {
    return str.replace("|", "_");
  };
  // 发送信息到容联云
  var sendMsgToServer = function (im_send_content, content_you, messageId) {
    // 发送消息至服务器
    var msgId = IM.chat.sendTextMsg(
      im_send_content,
      content_you,
      [],
      false,
      null,
      function (obj) {
        var tempId = "#" + content_you + "_" + changeClientNo(obj.msgClientNo);
        $('#im_send_content').val('');
        $(tempId).show();
        $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
      },
      function (obj) {
        setTimeout(function () { //断线的时候如果不延迟会出现找不到标签的情况，延迟0.3秒可解决。
          var tempId = "#" + content_you + "_" + changeClientNo(obj.msgClientNo);
          if (170001 == obj.code) {
            $(tempId).remove();
            navigator.notification.alert("发送消息内容超长，请分条发送", function () {
            }, "提示消息", "确定");
          } else if (174002 == obj.code) {
            $(tempId).remove();
            console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
            navigator.notification.alert("和服务器断开连接", function () {
            }, "提示消息", "确定");
          } else {
            $(tempId).remove();
            console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
            navigator.notification.alert("消息发送失败", function () {
            }, "提示消息", "确定");
          }
        }, 300)
      }
    );

    var id = "#" + content_you + "_" + messageId;
    $(id).attr("id", content_you + "_" + changeClientNo(msgId));
    // 上传文字到本地
    if (scope != null && scope.addChatMessage != null) {
      scope.addChatMessage(generateTime(), receiverSystemUser, scope.groupID != null ? 1 : 0, scope.currentUserID, scope.currentUserName, im_send_content);
    }
  };
  // 时间处理
  var generateTime = function () {
    var date = new Date();
    var year = date.getFullYear();
    var month = (date.getMonth() + 1).toString();
    if (month.length == 1) {
      month = "0" + month;
    }

    var day = date.getDate().toString();
    if (day.length == 1) {
      day = "0" + day;
    }

    var hour = date.getHours().toString();
    if (hour.length == 1) {
      hour = "0" + hour;
    }

    var minute = date.getMinutes().toString();
    if (minute.length == 1) {
      minute = "0" + minute;
    }

    var seconds = date.getSeconds().toString();
    if (seconds.length == 1) {
      seconds = "0" + seconds;
    }

    return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;
  };
  // 发送信息添加到右侧样式
  var addSendMsgHTML = function (msgtype, msgid, content_type, content_you, im_send_content) {
    var display = 'none';
    var carousel = '';
    if (msgtype == 4 || msgtype == 3) {
      carousel = "real";
    }

    var str = '<div contactor="sender" im_carousel="' + carousel + '" msg="msg" im_msgtype="' + msgtype + '" id="' + content_you + '_' + msgid + '" content_type="' + content_type + '" content_you="' + content_you + '" class="alert alert-right alert-success" style="display:' + display + '">' + '<code class="pull-right" style="text-overflow:ellipsis;overflow: hidden;color:#ffffff;background:#5db4a0;border-radius: 4px;">&nbsp;我</code>' + im_send_content + '</div>';
    $('#im_content_list').append(str);
    $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
    return content_you + '_' + msgid;
  };
  // push监听到右侧样式
  var addPushMsgHTML = function (msgtype, you_sender, version, content_type, name, you_msgContent, msgSender, currentUser) {
    var carousel = '';
    if (msgtype == 4 || msgtype == 3) {
      carousel = "real";
    }

    if (msgSender != currentUser) {
      if (!msgSender || content_type.toUpperCase("G")) {
        msgSender = you_sender; //由于系统消息没有发送者，所以这里给定义为系统的发送者.群消息的发送者为群。
      }

      var str = '<div msg="msg" im_carousel="' + carousel + '" im_msgtype="' + msgtype + '" id="' + msgSender + '_' + version + '" content_type="' + content_type + '" content_you="' + you_sender + '" class="alert alert-left alert-info" style="display:block">' + '<code style=";text-overflow:ellipsis;overflow: hidden;text-overflow:ellipsis;overflow: hidden;color:#ffffff;background:#5db4a0;border-radius: 4px;">' + name + '</code>&nbsp;' + you_msgContent + '</div>';
    } else {
      name = "我";
      var str = '<div contactor="sender" im_carousel="' + carousel + '" msg="msg" im_msgtype="' + msgtype + '" id="' + you_sender + '_' + version + '" content_type="' + content_type + '" content_you="' + you_sender + '" class="alert alert-right alert-success" style="display:block">' + '<code class="pull-right" style=";text-overflow:ellipsis;overflow: hidden;text-overflow:ellipsis;overflow: hidden;color:#ffffff;background:#5db4a0;border-radius: 4px;">&nbsp;' + name + '</code>' + you_msgContent + '</div>';
    }

    $('#im_content_list').append(str);
    if (you_msgContent.indexOf("fireMsg") > -1) { //fireMsg="yes"
      // 阅后即焚
    }

    setTimeout(function () {
      $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
    }, 100);
    if (you_msgContent) {
      // 消息类型提示，发完消息接收方隐藏即可
      $("#notice").html("");
    }
  };
  // 发送附件到容联云
  var sendAttachMsgToServer = function (oldMsgId, file, type, receiver) {
    var oldMsg = $(document.getElementById(receiver + '_' + oldMsgId));
    oldMsg.attr('msg', 'msg');
    oldMsg.css('display', 'block');
    if (4 == type) {
      oldMsg.attr('im_carousel', 'real');
      oldMsg.attr('im_msgtype', '4');
    }

    $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
    var msgId = IM.chat.sendFileMsg(
      file,
      type,
      receiver,
      false,
      function (obj) {
        setTimeout(function () {
          var id = "#" + receiver + "_" + changeClientNo(obj.msgClientNo);
          var msg = $(id);
          msg.find('div[class="bar"]').parent().css('display', 'none');
          msg.find('span[imtype="msg_attach"]').css('display', 'block');
          $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
        }, 100);
      },
      function (obj) { // 失败
        setTimeout(function () {
          var msg = $("#" + receiver + "_" + changeClientNo(obj.msgClientNo));
          msg.find('div[class="bar"]').parent().css('display', 'none');
          msg.find('span[imtype="msg_attach"]').css('display', '');
          console.log("错误码： " + obj.code + "; 错误描述：" + obj.msg);
          navigator.notification.alert("发送附件失败", function () {
          }, "提示消息", "确定");
        }, 100);
      },
      function (sended, total, msgId) { // 进度条
        setTimeout(function () {
          var msg = $("#" + receiver + "_" + changeClientNo(msgId));
          // sended;//已发送字节数
          // total;//总字节数
          if (sended < total) {
            msg.find('div[class="bar"]').css('width', (sended / total * 100 + '%'));
          } else {
            msg.find('div[class="bar"]').parent().css('display', 'none');
            msg.find('span[imtype="msg_attach"]').css('display', 'block');
          }
        }, 100);
      });
    oldMsg.attr("id", receiver + '_' + changeClientNo(msgId));
    if (file instanceof Blob) {
      oldMsg.find("object").val(file);
    }

    // 上传文件到本地
    if (scope != null && scope.uploadFiles != null) {
      // blob文件没有后缀名 目前只有拍照 所以变为固定文件名
      if (!(file instanceof File) && file instanceof Blob) {
        file = new File([file], "拍照.jpg");
      }

      scope.uploadFiles(file, generateTime(), receiverSystemUser, scope.groupID != null ? 1 : 0, scope.currentUserID, scope.currentUserName);
    }
  };
  // 获取hidden属性
  var checkWindowHidden = function () {
    var prefix = getBrowserPrefix();
    //不支持该属性
    if (!prefix) {
      return document['hidden'];
    }

    return document[prefix + 'Hidden'];
  };
  var getBrowserPrefix = function () {
    return 'hidden' in document ? null : function () {
      var r = null;
      ['webkit', 'moz', 'ms', 'o'].forEach(function (prefix) {
        if ((prefix + 'Hidden') in document) {
          return r = prefix;
        }
      });
      return r;
    }();
  };
  // 桌面提醒功能
  var deskNotice = function (you_sender, nickName, you_msgContent, msgType, isFireMsg, isCallMsg, msgSender) {
    console.log("you_msgContent=" + you_msgContent + "；msgType=" + msgType + "；isCallMsg=" + isCallMsg);
    if (11 == msgType) {
      if (!notification) {
        return;
      }
    } else {
      if (!notification || !checkWindowHidden()) {
        return;
      }
    }

    var title;
    var body = '';
    if (!!you_sender || !!nickName) {
      if ('g' == you_sender.substr(0, 1)) {
        title = "群消息";
        if (!!nickName) {
          body = msgSender + ":";
        } else {
          body = you_sender + ":";
        }
      } else {
        if (!!nickName) {
          title = nickName;
        } else {
          title = you_sender;
        }
      }
    } else {
      title = "系统通知";
      body = you_msgContent;
    }

    if (isFireMsg) {
      body += "[阅后即焚消息]";
    } else if (isCallMsg) {
      body += you_msgContent;
    } else {
      if (1 == msgType) {
        body += you_msgContent;
      } else if (2 == msgType) {
        body += "[语音]";
      } else if (3 == msgType) {
        body += "[视频]";
      } else if (4 == msgType) {
        body += "[图片]";
      } else if (5 == msgType) {
        body += "[位置]";
      } else if (6 == msgType || 7 == msgType) {
        body += "[附件]";
      } else if (11 == msgType) {
        body += you_msgContent; //@群组，type为11的时候
      }
    }

    var instance = new notification(
      title, {
        body: body,
        icon: "../images/logo-blue.png"
      }
    );
    instance.onclick = function () {
    };
    instance.onerror = function () {
      console.log('notification encounters an error');
    };
    instance.onshow = function () {
      setTimeout(function () {
        instance.close();
      }, 3000);
    };
    instance.onclose = function () {
      console.log('notification is closed');
    };
  };
  var createPushMessage = function (obj) {
    console.log('Receive messagse sender:[' + obj.msgSender + ']...msgId:[' + obj.msgId + ']...content[' + obj.msgContent + ']');
    // 容联云bug 这类数据貌似是一部分离线的数据 离线数据我们采取自己库的
    if (obj.msgSenderNick != null) {
      return;
    }

    // 当消息发送者非当前聊天对象时 不添加入聊天列表中
    scope.latestMessages = [];
    if ((scope.groupID == null && obj.msgSender != scope.contactID) || (obj.msgReceiver != scope.groupID)) {
      // 当前只实装会诊间
      if ('g' == obj.msgReceiver.substr(0, 1)) {
        var inputSearch = "input[name='" + obj.msgReceiver + "']";
        var searchedInput = $(inputSearch);
        if (searchedInput.length > 0) {
          var inputted = false;
          var currentItem = null;
          for (var i = 0; i < scope.latestMessages.length; i++) {
            if (scope.latestMessages.ID == obj.msgReceiver) {
              inputted = true;
              currentItem = scope.latestMessages[i];
              break;
            }
          }

          if (!inputted) {
            currentItem = {ID: obj.msgReceiver};
            scope.latestMessages.push(currentItem);
          }

          currentItem.msgType = obj.msgType;
          currentItem.msgContent = obj.msgContent;
          currentItem.msgFileName = obj.msgFileName;
          currentItem.senderNickName = obj.senderNickName;
          searchedInput.click();
        }
      }

      return;
    }

    // 存取读写状态
    if (scope != null && scope.addChatRead != null) {
      scope.addChatRead(generateTime(), scope.currentUserID, scope.groupID, scope.groupID == null ? receiverSystemUser : null, scope);
    }

    // 判断是否是阅后即焚消息
    var isFireMsg = false;
    if ("fireMessage" == obj.msgDomain) {
      isFireMsg = true;
    }

    var b_isGroupMsg = ('g' == obj.msgReceiver.substr(0, 1));
    var msgSender = obj.msgSender; //消息发送者
    var name = obj.senderNickName || obj.msgSender; // 发送者的名字
    var you_sender = obj.msgSender; //消息接收者
    if (obj.msgSender != obj.msgReceiver && obj.msgReceiver != currentUser) {
      you_sender = obj.msgReceiver;
    }

    // 是否为mcm消息 0普通im消息 1 start消息 2 end消息 3发送mcm消息
    var you_msgContent = obj.msgContent;
    var content_type = null;
    var version = obj.msgId;
    var time = obj.msgDateCreated;
    if (obj.msgType == 12) {
      if (obj.msgDomain == 1) {
        $("#notice").html(obj.msgSender + "正在输入……");
        return;
      } else if (obj.msgDomain == 0) {
        $("#notice").html("");
        return;
      } else if (obj.msgDomain == 2) {
        $("#notice").html(obj.msgSender + "正在录音");
        return;
      }
    }

    if (0 == obj.mcmEvent) { // 0普通im消息
      // 点对点消息，或群组消息
      content_type = (b_isGroupMsg) ? "G" : "C";
      var msgType = obj.msgType;
      var str = '';

      //消息类型1:文本消息 2：语音消息 3：视频消息 4：图片消息 5：位置消息 6：文件
      if (1 == msgType) {
        if (isFireMsg) {
          str = '<pre fireMsg="yes">' + you_msgContent + '</pre>';
        } else {
          str = '<pre>' + you_msgContent + '</pre>';
        }
      } else if (2 == msgType) { //判断是否支持支持audio标签
      } else if (3 == msgType) { // 3：视频消息
        var urlShow = obj.msgFileUrlThum; //小视频消息的缩略图地址
        var urlReal = obj.msgFileUrl;
        var windowWid = $(window).width();
        var imgWid = 0;
        var imgHei = 0;
        if (windowWid < 666) {
          imgWid = 100;
          imgHei = 150;
        } else {
          imgWid = 150;
          imgHei = 200;
        }

        var num = obj.msgFileSize;
        var size = 0;
        if (num < 1024) {
          size = num + "byte";
        } else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
          size = Number(num / 1024).toFixed(2) + "KB";
        } else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
          size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
        } else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
          size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
        }

        if (isFireMsg) {
          str = '<div style="display:inline"><img fireMsg="yes" onclick="showContentImage(this)" videourl="' + urlReal + '" src="' + urlShow + '" style="max-width:' + imgWid + 'px;max-height:' + imgHei + 'px;display:none;cursor:pointer" />' + '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
        } else {
          str = '<div style="display:inline"><img onclick="showContentImage(this)" videourl="' + urlReal + '" src="' + urlShow + '" style="cursor:pointer;max-width:' + imgWid + 'px;max-height:' + imgHei + 'px;" />' + '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
        }
      } else if (4 == msgType) { // 4：图片消息
        var url = obj.msgFileUrl;
        var windowWid = $(window).width();
        var imgWid = 0;
        var imgHei = 0;
        if (windowWid < 666) {
          imgWid = 100;
          imgHei = 150;
        } else {
          imgWid = 150;
          imgHei = 200;
        }

        //阅读即焚同步
        if (isFireMsg && msgSender != currentUser) {
          var str = '<img fireMsg="yes" src="' + url + '" style="cursor:pointer;max-width:' + imgWid + 'px; max-height:' + imgHei + 'px;display:none" onclick="showContentImage(this)"/>';
        } else {
          var str = '<img src="' + url + '" style="cursor:pointer;max-width:' + imgWid + 'px; max-height:' + imgHei + 'px;" onclick="showContentImage(this)"/>';
        }
      } else if (5 == msgType) { // 位置消息
      } else if (6 == msgType) { //压缩文件  仅支持火狐和谷歌浏览器
        var url = obj.msgFileUrl;
        var num = obj.msgFileSize;
        var size = 0;
        if (num < 1024) {
          size = num + "byte";
        } else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
          size = Number(num / 1024).toFixed(2) + "KB";
        } else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
          size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
        } else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
          size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
        }

        var fileName = obj.msgFileName;
        if (isFireMsg) {
          str = '<div style="display:inline"><a fireMsg="yes" href="" onclick="showContentFile(\'' + url + '\')">' + '<span>' + '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="img/attachment_icon.png" />' + '</span>' + '<span>' + fileName + '</span>' //+ '<span style="font-size: small;margin-left:15px;">'+size+'</span>'
            + '</a>' + '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
        } else {
          str = '<div style="display:inline"><a href="" onclick="showContentFile(\'' + url + '\')">' + '<span>' + '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="img/attachment_icon.png" />' + '</span>' + '<span>' + fileName + '</span>' //+ '<span style="font-size: small;margin-left:15px;">'+size+'</span>'
            + '</a>' + '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
        }
      } else if (7 == msgType) { // 非压缩文件
        var url = obj.msgFileUrl;
        var num = obj.msgFileSize;
        var size = 0;
        if (num < 1024) {
          size = num + "byte";
        } else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
          size = Number(num / 1024).toFixed(2) + "KB";
        } else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
          size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
        } else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
          size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
        }

        var fileName = obj.msgFileName;
        if (isFireMsg) {
          str = '<div style="display:inline"><a fireMsg="yes" href="" onclick="showContentFile(\'' + url + '\')">' + '<span>' + '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="img/attachment_icon.png" />' + '</span>' + '<span>' + fileName + '</span>' //+ '<span style="font-size: small;margin-left:15px;">'+size+'</span>'
            + '</a>' + '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
        } else {
          str = '<div style="display:inline"><a href="" onclick="showContentFile(\'' + url + '\')">' + '<span>' + '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="img/attachment_icon.png" />' + '</span>' + '<span>' + fileName + '</span>' //+ '<span style="font-size: small;margin-left:15px;">'+size+'</span>'
            + '</a>' + '<span style="font-size: small;margin-left:15px;">' + size + '</span></div>';
        }
      } else if (11 == msgType) {
        str = '<pre>' + you_msgContent + '</pre>';
        //zyh @群主
      }
      //zyh 需要一个消息的发送着
      addPushMsgHTML(msgType, you_sender, version, content_type, name, str, msgSender, currentUser);

      //桌面提醒通知
      deskNotice(you_sender, name, you_msgContent, msgType, isFireMsg, false, msgSender);
    } else if (1 == obj.mcmEvent) { // 1 start消息
    } else if (2 == obj.mcmEvent) { // 2 end消息
    } else if (3 == obj.mcmEvent) { // 3发送mcm消息
    } else if (53 == obj.mcmEvent) { // 3发送mcm消息
    }
  };

  var maxLoadHistory = 0;
  // 创建历史信息
  var createHistory = function (historyList, messageId) {
    if (historyList == null || historyList.length == 0) {
      return messageId;
    }

    var resultMessageID = "";
    var maxHistoryNumber = 100;
    // 大于100条删除最新消息
    maxLoadHistory = maxLoadHistory + historyList.length;
    if (maxLoadHistory > maxHistoryNumber) {
      var count = maxLoadHistory - maxHistoryNumber;
      for (var i = 0; i < count; i++) {
        $($("#im_content_list div")[0]).remove();
      }

      maxLoadHistory = maxHistoryNumber;
    }

    for (var i = 0; i < historyList.length; i++) {
      resultMessageID = historyList[i].ID;
      var sender = historyList[i].SenderID;
      var senderName = historyList[i].SenderName; // 历史数据文件中没有 需要处理文件中插入数据库
      var receiver = historyList[i].ReceiverID;
      var msgType = historyList[i].ChatType;
      var content = historyList[i].Message;
      var sourceName = historyList[i].SourceName;
      var messageTime = historyList[i].MessageTime;
      var htmlContent = "";
      if (msgType == 0) {
        // 文字
        htmlContent = '<pre>' + content + '</pre>';
      } else if (msgType == 1 && (content.indexOf(".jpeg") > 0 || content.indexOf(".jpg") > 0 || content.indexOf(".png") > 0)) {
        // 图片
        var url = content;
        var windowWid = $(window).width();
        var imgWid = 0;
        var imgHei = 0;
        if (windowWid < 666) {
          imgWid = 100;
          imgHei = 150;
        } else {
          imgWid = 150;
          imgHei = 200;
        }

        htmlContent = '<img src="' + url + '" style="cursor:pointer;max-width:' + imgWid + 'px; max-height:' + imgHei + 'px;" onclick="showContentImage(this)"/>';
      } else {
        var url = content;
        htmlContent = '<div style="display:inline"><a href="" onclick="showContentFile(\'' + url + '\')">' + '<span>' + '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="img/attachment_icon.png" />' + '</span>'
          + '<span>' + sourceName + '</span>'
          + '</a></span></div>';
      }

      var str = "";
      if (sender == scope.currentUserID) {
        str = '<div class="alert alert-right alert-success" style="display:block;"><code class="pull-right" style=";text-overflow:ellipsis;overflow: hidden;text-overflow:ellipsis;overflow: hidden;color:#ffffff;background:#5db4a0;border-radius: 4px;">&nbsp;我</code><label style="background-color: #dddddd;color: white;margin-right: 15px" class="pull-right">' + messageTime + '</label>' + htmlContent + '</div>';
      } else {
        str = '<div class="alert alert-left alert-info" style="display:block">  <code style=";text-overflow:ellipsis;overflow: hidden;text-align: left;background: #5db4a0;color: #ffffff;border-radius: 4px;">' + senderName + '</code><label style="background-color: #dddddd;color: white;margin-left: 15px">' + messageTime + '</label>' + htmlContent + '</div>';
      }

      $('#im_content_list').prepend(str);
      setTimeout(function () {
        $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
      }, 100);
    }
    return resultMessageID;
  };

  var scope = null;
  var currentUser = "";
  var receiverSystemUser;
  var initialized = false;
  // 初始化
  service.initialize = function ($scope, customerInitialize, loginSuccessCallBack, loginErrorCallBack) {
    if (!initialized) {
      //initialized = true;
      service.setup($scope, customerInitialize, loginSuccessCallBack, loginErrorCallBack);
    }

    receiverSystemUser = scope.contactID;
    if (scope.groupID == null && receiverSystemUser.indexOf("_") > -1) {
      // 个人的话a_b a为本地数据库userId
      receiverSystemUser = receiverSystemUser.split("_")[0];
    }

    $("#im_content_list").empty();
    $scope.historyMsgId = null;
    maxLoadHistory = 0;
    $scope.getHistoryMessage();
  };
  service.setup = function ($scope, customerInitialize, loginSuccessCallBack, loginErrorCallBack) {
    scope = $scope;
    if ($scope.needInitializeSDK) {
      IM.common.initializeSDK(null, null, customerInitialize, null);
    }

    var callBack = function (obj) {
      // 当有群组时需要加入群组
      if ($scope.groupID != null) {
        IM.group.joinGroup($scope.groupID, function (obj) {
          // 修改群组成员名片(获取群组成员名采用本地库)
          //IM.group.modifyMemberCard(currentUser, $scope.groupID, $scope.currentUserName);
        }, function (obj) {
          // 这里errorcallback是由于已经加入了群组报错
          // 修改群组成员名片(获取群组成员名采用本地库)
          //IM.group.modifyMemberCard(currentUser, $scope.groupID, $scope.currentUserName);
        });
      }

      // 更新自己的姓名(有点滞后 无解)
      IM.common.uploadPersonInfo($scope.currentUserName);
      // push消息的监听器
      IM.common.installListeners(createPushMessage);
      if (loginSuccessCallBack != null) {
        loginSuccessCallBack(obj);
      }
    };

    currentUser = $scope.additionalID == null ? $scope.currentUserID : $scope.currentUserID + "_" + $scope.additionalID;
    if ($scope.needLogin) {
      IM.common.login(currentUser, callBack, loginErrorCallBack);
    } else {
      callBack();
    }

    // 发送文本
    $scope.sendMsg = function () {
      $scope.sendContent = $('#im_send_content').val();
      preReplaceContentToDb($scope.sendContent);
      if ($scope.sendContent == undefined || $scope.sendContent == null || $scope.sendContent == '') {
        return;
      }

      var messageId = new Date().getTime();
      var content_type = "G";
      var content_you = $scope.contactID;
      var im_send_content = $scope.sendContent;
      console.log('messageId[' + messageId + '] content_type[' + content_type + '] content_you[' + content_you + '] im_send_content[' + im_send_content + ']');
      var str = '<pre msgtype="content">' + im_send_content + '</pre>';
      addSendMsgHTML(1, messageId, content_type, content_you, str);
      sendMsgToServer(im_send_content, content_you, messageId);
    };

    // 发送附件
    $scope.sendAttachmentFile = function () {
      var msgId = new Date().getTime();
      var content_type = "G";
      var content_you = $scope.contactID;
      var str = '<div class="progress progress-striped active">' + '<div class="bar" style="width: 40%;"></div>' + '</div>' + '<span imtype="msg_attach">' + '<a imtype="msg_attach_href" href="javascript:void(0);" target="_blank">' + '<span>' + '<img style="width:32px; height:32px; margin-right:5px; margin-left:5px;" src="img/attachment_icon.png" />' + '</span>' + '<span imtype="msg_attach_name"></span>' + '</a>' + '<span style="font-size: small;margin-left:15px;"></span>' + '<input imtype="msg_attach_button" type="file" accept="" style="display:none;margin: 0 auto;" onchange="uploadFileToServer(\'' + content_you + '_' + msgId + '\', \'' + msgId + '\')">' + '</span>';
      // 添加右侧消息
      var id = addSendMsgHTML(6, msgId, content_type, content_you, str);
      $("#" + id).find('input[imtype="msg_attach_button"]').click();
    };

    // 打开本地文件时触发本方法
    window.uploadFileToServer = function (id, oldMsgId, blob) {
      var msg = $("#" + id);
      var oFile;
      if (blob != null) {
        oFile = blob;
      } else {
        oFile = msg.find('input[imtype="msg_attach_button"]')[0].files[0];
      }

      var msgType = 0;
      console.log(oFile.name + ':' + oFile.type);
      window.URL = window.URL || window.webkitURL || window.mozURL || window.msURL;
      var url = window.URL.createObjectURL(oFile);
      var num = oFile.size;
      var size = 0;
      if (num < 1024) {
        size = num + "byte";
      } else if (num / 1024 >= 1 && num / Math.pow(1024, 2) < 1) {
        size = Number(num / 1024).toFixed(2) + "KB";
      } else if (num / Math.pow(1024, 2) >= 1 && num / Math.pow(1024, 3) < 1) {
        size = Number(num / Math.pow(1024, 2)).toFixed(2) + "MB";
      } else if (num / Math.pow(1024, 3) >= 1 && num / Math.pow(1024, 4) < 1) {
        size = Number(num / Math.pow(1024, 3)).toFixed(2) + "G";
      }

      var receiver = msg.attr('content_you');
      if ("image" == oFile.type.substring(0, oFile.type.indexOf("/"))) {
        var windowWid = $(window).width();
        var imgWid = 0;
        var imgHei = 0;
        if (windowWid < 666) {
          imgWid = 100;
          imgHei = 150;
        } else {
          imgWid = 150;
          imgHei = 200;
        }

        var str = '<img imtype="msg_attach_src" id="imgUpload" src="' + url + '" style="max-width:' + imgWid + 'px; max-height:' + imgHei + 'px;" ' + ' onclick="showContentImage(this);" />';
        msg.find('a[imtype="msg_attach_href"]').replaceWith(str);
        msgType = 4;
      } else {
        msg.find('a[imtype="msg_attach_href"]').attr('href', url);
        msg.find('span[imtype="msg_attach_name"]').html(oFile.name);
        msg.find('a[imtype="msg_attach_href"]').next().html(size);
        msgType = 7;
      }

      sendAttachMsgToServer(oldMsgId, oFile, msgType, receiver);
    };

    /*手机屏幕*/
    var ScreenHeight = window.screen.height;

    // 显示原图
    window.showContentImage = function (img) {
      var url = $(img).attr("videourl") != null && $(img).attr("videourl") != "" ? $(img).attr("videourl") : $(img).attr("src");
      navigator.notification.confirm('您确定要下载吗？', showConfirm, '下载文件', '确定,取消');
      function showConfirm(button) {
        if (button == 1) {
          download.downloadFile(url);
        } else {
        }
      }
    };

    // 显示原图
    window.showContentFile = function (url) {
      navigator.notification.confirm('您确定要下载文件吗？', showConfirm, '下载文件', '确定,取消');
      function showConfirm(button) {
        if (button == 1) {
          download.downloadFile(url);
        } else {
        }
      }
    };


    // 登陆时退出
    window.onbeforeunload = function () {
      IM.common.logout();
    };

    // 加载更多历史消息
    $scope.getHistoryMessage = function () {
      if ($scope.getChatMessages != null) {
        $scope.getChatMessages($scope.historyMsgId);
      }
    };

    // 拍照取消
    $scope.cancelTakePic = function () {
      IM.photo.cancle();
      $('#pop_takePicture').hide();
    };

    // 拍照
    $scope.snapshot = function () {
      var resultObj = IM.photo.make();
      $('#pop_takePicture').hide();
      if ("174010" == resultObj.code) { //没有调用applay方法
        console.log("错误描述：" + resultObj.msg);
        navigator.notification.alert("拍照失败", function () {
        }, "提示消息", "确定");
      } else {
        var windowWid = $(window).width();
        var msgId = new Date().getTime();
        var imgWid = 0;
        var imgHei = 0;
        if (windowWid < 666) {
          imgWid = 100;
          imgHei = 150;
        } else {
          imgWid = 150;
          imgHei = 200;
        }

        var url = resultObj.blob.url;
        // 初始化右侧对话框消息
        var str1 = '<div class="progress progress-striped active">' + '<div class="bar" style="width: 20%;"></div>' + '</div>' + '<span imtype="msg_attach">' + '<img imtype="msg_attach_src" src="' + url + '" onclick="showContentImage(this)" style="cursor:pointer;max-width:' + imgWid + 'px;max-height:' + imgHei + 'px;" />' + '<object style="display:none"></object>' + '</span>';
        var content_type = "G";
        var content_you = $scope.contactID;
        var id = addSendMsgHTML(4, msgId, content_type, content_you, str1);
        uploadFileToServer(id, msgId, resultObj.blob);
      }
    };

    $scope.takePicture = function () {
      // 拍照按钮的浏览器兼容
      var windowWid = $(window).width();
      if (windowWid < 666) {
        $('#takePhoto').find('div').css("height", "35px");
        $('#takePhoto').find('img').css("height", "30px");
        $('#takePhoto').find('img').css("width", "30px");
      } else {
        $('#takePhoto').find('div').css("height", "50px");
        $('#takePhoto').find('img').css("height", "45px");
        $('#takePhoto').find('img').css("width", "45px");
      }

      var objTag = {};
      var video = $("#video")[0];
      objTag.tag = video;
      var onCanPlay = function () {
        var pop_photo = $('#pop_takePicture');
        pop_photo.show();
      };
      var onErr = function (errObj) {
        navigator.notification.alert("拍照功能出现错误", function () {
        }, "提示消息", "确定");
        return;
      };
      IM.photo.apply(objTag, onCanPlay, onErr);
    };

    // 建立系统消息
    $scope.createSystemInformation = function (message) {
      if ($scope.hasGroupMemberForGrouList) {
        $scope.getListByGroupID($scope.groupID, $scope);
        // groupMember和groupList同步
        IMGroupMemberService.clearTimer();
        IMGroupMemberService.initialize($scope);
      }

      var htmlContent = '<pre>' + message + '</pre>';
      var str = '<div class="alert alert-left alert-warning" style="display:block">' + htmlContent + '</div>';
      $('#im_content_list').append(str);
      setTimeout(function () {
        $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
      }, 100);
    };
  };

  // 读取历史数据
  service.createHistory = function (historyList, $scope) {
    $scope.historyMessages = historyList;
    $scope.historyMsgId = createHistory($scope.historyMessages, $scope.historyMsgId);
  };
  return service;
});

IMModule.service('IMGroupMemberService', function () {
  var service = {};
  var timer;
  var initialized = false;
  var showHide = function (mark) {
    if (mark == "∨") {
      return "∧";
    }

    return "∨";
  };
  service.initialize = function ($scope) {
    service.clearTimer();
    if (!initialized) {
      service.setup($scope);
      //initialized = true;
    }

    service.getMemberStatus($scope);
    // 实时刷新状态
    timer = setInterval(function () {
      service.getMemberStatus($scope);
    }, 15000);
  };
  service.setup = function ($scope) {
    // 选择li
    $scope.selectLi = function (li, flg) {
      li.show = !li.show;

      if(flg == 1) {
// customer
        if(li.DepartmentList == null) {
          $scope.getDepartmentList(li.Customer.CustomerID, li);
        }

      } else if (flg == 2) {
        // department
        if(li.UserList == null) {
          $scope.getDoctorList(li.Department.DepartmentID, li);
        }

      }
    };
    $scope.showText = function (show) {
      if (show) {
        return "-";
      } else {
        return "+";
      }
    };
    $scope.addGroupMember = function () {
      $scope.selectGroupMemberList = [];
      $scope.showCustomerList = JSON.parse(JSON.stringify($scope.customerList));
      $('#updateChatMembers').modal('show');
    };
    // 选择User
    $scope.selectUser = function ($event, user) {
      var target = $event.target;
      var checked = target.checked;
      if (checked) {
        $scope.selectGroupMemberList.push(user);
      } else {
        for (var i = 0; i < $scope.selectGroupMemberList.length; i++) {
          if (user.ID == $scope.selectGroupMemberList[i].UserID) {
            $scope.selectGroupMemberList.splice(i, 1);
            return;
          }
        }
      }
    };
    $scope.groupMemberStatusPicture = function (user) {
      if ($scope.groupMemberList == null) {
        return "";
      }

      for (var j = 0; j < $scope.groupMemberList.length; j++) {
        var partner = $scope.groupMemberList[j];
        if (partner.PartnerID == user.UserID) {
          user.SelectStatus = 1;
          return "img/defaultCircle.png";
        }
      }

      if (user.SelectStatus != 2) {
        user.SelectStatus = 0;
        return "img/emptyCircle.png";
      } else {
        return "img/selectCircle.png";
      }
    };
    $scope.deleteGroupMember = function (id) {
      for (var i = 0; i < $scope.selectGroupMemberList.length; i++) {
        if (id == $scope.selectGroupMemberList[i].UserID) {
          $scope.selectGroupMemberList.splice(i, 1);
          break;
        }
      }

      for (var i = 0; i < $scope.showCustomerList.length; i++) {
        var customer = $scope.showCustomerList[i];
        for (var n = 0; n < customer.DepartmentList.length; n++) {
          var department = customer.DepartmentList[n];
          for (var k = 0; k < department.UserList.length; k++) {
            var user = department.UserList[k];
            if (user.UserID == id) {
              user.SelectStatus = 3;
            }
          }
        }
      }
    };
    $scope.updateGroupMembers = function () {
      if ($scope.selectGroupMemberList.length == 0) {
        $('#updateChatMembers').modal('hide');
        return;
      }

      var ids = [];
      for (var i = 0; i < $scope.selectGroupMemberList.length; i++) {
        ids.push($scope.selectGroupMemberList[i].UserID);
      }
      $scope.submitGroupMembers(ids);
    };
    // 显示状态
    $scope.showStatus = function (status) {
      if (status == 1) {
        return "在线";
      } else if (status == 2) {
        return "离线";
      } else {
        return "离线";
      }
    };
    // group页面上面标题
    $scope.headerStatus = showHide();
    $scope.showGroupHeader = function () {
      var result = $scope.groupSubject + "会诊组" + "(" + ($scope.groupList != null ? $scope.groupList.length.toString() : "0") + "人)  " + $scope.headerStatus;
      return result;
    };
    $scope.showMemberList = function () {
      $scope.headerStatus = showHide($scope.headerStatus);
    };
    $scope.showGroupMemberPhoto = function (image) {
      if (image == null || image == "") {
        return "img/header.jpg";
      }

      // todo 用户设置里面没有加图片，目前
      return image;
    };
  };
  // 获取成员在线状态
  service.getMemberStatus = function ($scope) {
    var setStatus = function (list) {
      for (var m = 0; m < list.length; m++) {
        var key = list[m].useracc;
        var value = list[m].state;
        for (var i = 0; i < $scope.groupList.length; i++) {
          var member = $scope.groupList[i];
          var id = member.UserID;
          if (id == key) {
            member.onlineState = value;
            break;
          }
        }
      }

      $scope.$apply();
    };

    if ($scope.groupList != null && $scope.groupList.length > 0) {
      var list = [];
      for (var i = 0; i < $scope.groupList.length; i++) {
        var member = $scope.groupList[i];
        var id = member.UserID;
        // 当前用户默认在线
        if (id != $scope.currentUserID) {
          list.push(id);
        } else {
          member.onlineState = 1;
        }
      }

      if (list.length > 0) {
        IM.common.getUserState(list, true, function (obj) {
          setStatus(obj);
        }, function (obj) {
          console.error("错误码：" + obj.code + "; 错误描述：" + obj.msg);
        });
      }
    }
  };
  // 消除interval
  service.clearTimer = function () {
    if (timer != null) {
      clearInterval(timer);
    }
  };
  return service;
});

IMModule.service('IMGroupListService', function (IMGroupMemberService, IMContentService) {
  var service = {};
  service.initialize = function ($scope) {
    // 初始化列表
    $scope.resetGroupList = function () {
      $scope.showedGroupList = $scope.ChatList;
      $scope.showedCondition = "";
    };
    // 搜索
    //$scope.showedCondition = "123";
    $scope.changeShowedGroupList = function () {
      var list = [];
      for (var i = 0; i < $scope.ChatList.length; i++) {
        if ($scope.ChatList[i].Chat.Subject.toUpperCase().indexOf($scope.showedCondition.toUpperCase()) > -1) {
          list.push($scope.ChatList[i]);
        }
      }

      $scope.showedGroupList = list;
    };

    $scope.changeShowedGroupListEmpty = function () {
      if ($scope.showedCondition == "") {
        $scope.changeShowedGroupList();
      }
    };

    // 群最新消息时间
    $scope.showGroupListTime = function (time) {
      if (time == null || time == "" || time.length < 16) {
        return "";
      }

      var now = new Date();
      var currentYear = now.getFullYear();
      var currentMonth = now.getMonth() + 1;
      var currentDay = now.getDate();
      var inputYear = time.substr(0, 4);
      var inputMonth = time.substr(5, 2);
      var inputDay = time.substr(8, 2);
      if (currentYear == inputYear
        && currentMonth == parseInt(inputMonth)
        && currentDay == parseInt(inputDay)) {
        return time.substr(11, 5);
      } else {
        return inputMonth + "-" + inputDay;
      }
    };
    // 群最新信息
    $scope.showGroupListMessage = function (chatMessage) {
      if (chatMessage == null) {
        return "";
      }

      var message = chatMessage.ChatType == 1 ? chatMessage.SourceName : chatMessage.Message;
      if (message == null) {
        message = "";
      }

      if (message.length > 30) {
        message = message.substr(0, 30) + "...";
      }

      return chatMessage.SenderName + ":" + message;
    };
    // 新增群弹窗
    $scope.showGroupListAdd = function () {
      $scope.addChat = {
        PartnerID: $scope.currentUserID,
        CreatorID: $scope.currentUserID,
        Status: 0,
        FunctionType: 1
      };
      $scope.currentGroupListView = 0;
      $("#addChat").modal("show");
    };
    // 修改群信息弹窗
    $scope.showGroupListUpdate = function (chat) {
      $scope.currentGroupListView = 1;
      $scope.updateChat = JSON.parse(JSON.stringify(chat));
      $("#updateChat").modal("show");
    };
    // 显示群图片
    $scope.showAddChatPhoto = function (photo) {
      if (photo == null) {
        return "img/groupDefault.jpg";
      }

      return $scope.groupPhotoDomain + photo;
    };
    // 上传群图片
    $scope.selectGroupListFile = function () {
      $("#selectGroupListFile").click();
    };
    // 上传群图片
    $scope.changeGroupListFile = function (file) {
      if ($scope.uploadGroupListFile == null) {
        navigator.notification.alert("不支持上传文件", function () {
        }, "提示消息", "确定");
        return;
      }

      $scope.uploadGroupListFile(file, function (data) {
          if (data == null || data.Body == null || data.Body.length == 0) {
            navigator.notification.alert("上传失败", function () {
            }, "提示消息", "确定");
          }

          if ($scope.currentGroupListView == 0) {
            $scope.addChat.Photo = data.Body[0].FileName;
          } else {
            $scope.updateChat.Photo = data.Body[0].FileName;
          }

        },
        function (data) {
          navigator.notification.alert("上传失败", function () {
          }, "提示消息", "确定");
        });
    };
    // 点击某一个群
    $scope.clickGroup = function (item) {
      $scope.groupID = item.Chat.GroupID;
      $scope.groupSubject = item.Chat.Subject;
      $scope.groupCreatorID = item.Chat.CreatorID;
      $scope.contactID = $scope.groupID;
      item.UnreadRows = 0;
      if ($scope.hasGroupMemberForGrouList) {
        $scope.getListByGroupID($scope.groupID, $scope);
        // groupMember和groupList同步
        IMGroupMemberService.clearTimer();
        IMGroupMemberService.initialize($scope);
      }

      if ($scope.hasContentForGroupList) {
        IMContentService.initialize($scope, function (obj) {
        }, function (obj) {
        });
      }
    };

    $scope.showUnreadRows = function (rows) {
      if (rows > 99) {
        return "99+";
      }

      return rows;
    };

    // 实时最新消息
    $scope.addUnreadRows = function (item) {
      item.UnreadRows = item.UnreadRows + 1;
      var date = new Date();
      var year = date.getFullYear();
      var month = (date.getMonth() + 1).toString();
      if (month.length == 1) {
        month = "0" + month;
      }

      var day = date.getDate().toString();
      if (day.length == 1) {
        day = "0" + day;
      }

      var hour = date.getHours().toString();
      if (hour.length == 1) {
        hour = "0" + hour;
      }

      var minute = date.getMinutes().toString();
      if (minute.length == 1) {
        minute = "0" + minute;
      }

      var seconds = date.getSeconds().toString();
      if (seconds.length == 1) {
        seconds = "0" + seconds;
      }

      var nowTime = year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;

      for (var i = 0; i < $scope.latestMessages.length; i++) {
        var latest = $scope.latestMessages[i];
        if (latest.ID == item.Chat.GroupID) {
          item.ChatMessage = {
            ChatType: latest.msgType == 4 || latest.msgType == 7 ? 1 : 0,
            SourceName: latest.msgFileName,
            Message: latest.msgContent,
            SenderName: latest.senderNickName,
            MessageTime: nowTime
          };
          break;
        }
      }
    };
  };
  return service;
});

//视频对话
IMModule.service('IMVideoService', function () {
  var service = {};

  var notification = window.Notification || window.mozNotification || window.webkitNotification || window.msNotification || window.webkitNotifications;
  if (!!notification) {
    notification.requestPermission(function (permission) {
      if (notification.permission !== "granted") {
        notification.permission = "granted";
      }
    });
  }
  var onCallMsgListener = function (obj) {
    console.log("-------obj.callId = " + obj.callId);
    console.log("-------obj.caller = " + obj.caller);
    console.log("-------obj.called = " + obj.called);
    console.log("-------obj.callType = " + obj.callType);
    console.log("-------obj.state = " + obj.state);
    console.log("-------obj.reason = " + obj.reason);
    console.log("-------obj.code = " + obj.code);
    var noticeMsg = ''; //桌面提醒消息
    if (obj.callType == 1) { //视频
      if (200 == obj.code) {
        if (obj.state == 1) { //收到振铃消息
          //本地播放振铃
          document.getElementById("voipCallRing").play();
        } else if (obj.state == 2) { //呼叫中

        } else if (obj.state == 3) { //被叫接受
          document.getElementById("voipCallRing").pause();
          $("#cancelVoipCall").text("结束");
          noticeMsg = "[接收视频通话]";
        } else if (obj.state == 4) { //呼叫失败 对主叫设定：自动取消，对方拒绝或者忙
          $("#pop_videoView").hide();
          //alert("对方正在通话中");
          //IM.HTML_showAlert('alert-error', '对方不在线');
          document.getElementById("voipCallRing").pause();
          noticeMsg = "[视频通话结束]";
        } else if (obj.state == 5) { //结束通话  或者主叫取消（对被叫而言）
          document.getElementById("voipCallRing").pause();
          $("#pop_videoView").hide();
          noticeMsg = "[视频通话结束]";
        } else if (obj.state == 6) { //呼叫到达
          $("#videoView").show();
          $("#voiceCallDiv_audio").hide();
          videoView(obj.callId, obj.caller, obj.called);
          $("#cancelVoipCall").hide();
          $("#acceptVoipCall").show();
          $("#refuseVoipCall").show();
          //本地播放振铃
          document.getElementById("voipCallRing").play();
          noticeMsg = "[视频呼叫]";
        }
      } else {
        var str = '<pre>请求视频通话，请使用其他终端处理</pre>';
        //IM.HTML_pushCall_addHTML(obj.caller, obj.callId, str);
      }
    }

    //桌面提醒通知
    if (!!noticeMsg) {
      deskNotice(you_sender, name, you_msgContent, msgType, isFireMsg, false, msgSender);
    }
  };

  // 获取hidden属性
  var checkWindowHidden = function () {
    var prefix = getBrowserPrefix();
    //不支持该属性
    if (!prefix) {
      return document['hidden'];
    }

    return document[prefix + 'Hidden'];
  };
  //桌面提醒功能
  var deskNotice = function (you_sender, nickName, you_msgContent, msgType, isFireMsg, isCallMsg, msgSender) {
    console.log("you_msgContent=" + you_msgContent + "；msgType=" + msgType + "；isCallMsg=" + isCallMsg);
    if (11 == msgType) {
      if (!notification) {
        return;
      }
    } else {
      if (!notification || !checkWindowHidden()) {
        return;
      }
    }

    var title;
    var body = '';
    if (!!you_sender || !!nickName) {
      if ('g' == you_sender.substr(0, 1)) {
        title = "群消息";
        if (!!nickName) {
          body = msgSender + ":";
        } else {
          body = you_sender + ":";
        }
      } else {
        if (!!nickName) {
          title = nickName;
        } else {
          title = you_sender;
        }
      }
    } else {
      title = "系统通知";
      body = you_msgContent;
    }

    if (isFireMsg) {
      body += "[阅后即焚消息]";
    } else if (isCallMsg) {
      body += you_msgContent;
    } else {
      if (1 == msgType) {
        body += you_msgContent;
      } else if (2 == msgType) {
        body += "[语音]";
      } else if (3 == msgType) {
        body += "[视频]";
      } else if (4 == msgType) {
        body += "[图片]";
      } else if (5 == msgType) {
        body += "[位置]";
      } else if (6 == msgType || 7 == msgType) {
        body += "[附件]";
      } else if (11 == msgType) {
        body += you_msgContent; //@群组，type为11的时候
      }
    }

    var instance = new notification(
      title, {
        body: body,
        icon: "../images/logo-blue.png"
      }
    );
    instance.onclick = function () {
    };
    instance.onerror = function () {
      console.log('notification encounters an error');
    };
    instance.onshow = function () {
      setTimeout(function () {
        instance.close();
      }, 3000);
    };
    instance.onclose = function () {
      console.log('notification is closed');
    };
  };

  //展示视频通话窗口
  var videoView = function (callId, caller, called) {
    var windowWidth = document.body.clientWidth;
    if (windowWidth < 666) {
      $("#receivedVideo").removeAttr("width");
      $("#receivedVideo").css("height", "100%");
      $("#localVideo").removeAttr("width");
      $("#localVideo").css("height", "25%");
    } else {
      var windowHeight = document.body.clientHeight;
      $("#pop_videoView").css("display", "block");
      $("#pop_videoView").css("height", windowHeight);

      //设置视频框长
      var width = Math.round(windowWidth * 0.3);
      $("#videoView").css("width", width);

      var viewCanva = document.getElementById("videoViewCanvas");
      var context = viewCanva.getContext("2d");
      context.clearRect(0, 0, windowWidth, windowHeight + 200);
      context.globalAlpha = 0.4;
      context.fillRect(0, 0, windowWidth, windowHeight + 200);
      var leftWidth = (windowWidth - $("#videoView").width()) / 2;
      $("#videoView").css("left", leftWidth);
      if (!document.getElementById("cancelVoipCall")) {
        var str = '<div style="width:100%;height:30px;background-color:black;margin-top:-7px;' +
          'padding-top:5px;padding-bottom:5px;"><a href="javascript:void(0);" id="cancelVoipCall" ' +
          'class="btn" >取消</a><a href="javascript:void(0);" id="acceptVoipCall" ' +
          'class="btn btn-primary" >接受视频</a><a href="javascript:void(0);" id="refuseVoipCall" ' +
          'class="btn" >拒绝视频</a></div>';
        $("#videoView").append(str);

        $("#cancelVoipCall").click(function () {
          cancelCall(callId, caller, called);
        });
        $("#acceptVoipCall").click(function () {
          answerCall(callId, caller, called);
        });
        $("#refuseVoipCall").click(function () {
          refuseCall(callId, caller, called);
        })
      } else {
        $("#cancelVoipCall").unbind('click');
        $("#cancelVoipCall").click(function () {
          cancelCall(callId, caller, called);
        });
        $("#cancelVoipCall").text("取消");
        $("#acceptVoipCall").unbind('click');
        $("#acceptVoipCall").click(function () {
          answerCall(callId, caller, called);
        });
        $("#refuseVoipCall").unbind('click');
        $("#refuseVoipCall").click(function () {
          refuseCall(callId, caller, called);
        })
      }
    }
  };
  //发起视频
  var videoCall = function (sender, receiver) {
    var receiver = receiver;
    var view = document.getElementById("receivedVideo");
    var localView = document.getElementById("localVideo");
    localView.muted = true;
    IM.video.videoCall(receiver, view, localView, function (callId, receiver) {//视频发起成功回调
      videoView(callId, sender, receiver);
      $("#videoView").show();
      $("#voiceCallDiv_audio").hide();
      $("#cancelVoipCall").show();
      $("#cancelVoipCall").text("取消");
      $("#acceptVoipCall").hide();
      $("#refuseVoipCall").hide();
    }, function (obj) {//视频发起失败回调
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
      $("#videoViewCanvas").hide();
      $("#videoView").hide();
      $("#cancelVoipCall").hide();
      $("#voiceCallDiv_audio").hide();
      $("#cancelVoiceCall").hide();
      $("#pop_videoView").hide();
    });
  };

  //接受视频
  var answerCall = function (callId, caller, called) {
    document.getElementById("voipCallRing").pause();
    //设置页面view句柄
    var view = document.getElementById("receivedVideo");
    var localView = document.getElementById("localVideo");
    localView.muted = true;
    IM.video.answerCall(view, localView, callId, caller, called, function () {
    }, function (obj) {
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
    });
    $("#cancelVoipCall").text("结束");
    $("#cancelVoipCall").show();
    $("#acceptVoipCall").hide();
    $("#refuseVoipCall").hide();
  };

  //拒绝视频
  var refuseCall = function (callId, caller, called) {
    document.getElementById("voipCallRing").pause();
    IM.video.refuseCall(callId, caller, function () {
      $("#pop_videoView").hide();
    }, function (obj) {
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
    });
  };

  //取消视频
  var cancelCall = function (callId, caller, called) {
    document.getElementById("voipCallRing").pause();
    IM.video.cancelCall(callId, caller, called, function () {
      $("#pop_videoView").hide();
    }, function (obj) {
      alert("错误码：" + obj.code + "; 错误描述：" + obj.msg);
    });
  };

  var currentUser = "";
  // 初始化
  service.initialize = function ($scope, customerInitialize, loginSuccessCallBack, loginErrorCallBack) {
    if (!$scope.needInitializeSDK) {
      IM.common.initializeSDK(null, null, customerInitialize, null);
    }

    var callBack = function (obj) {
      // push消息的监听器
      IM.common.installListeners(null, null, null, null, onCallMsgListener, null);
      if (loginSuccessCallBack != null) {
        loginSuccessCallBack(obj);
      }
    };

    currentUser = $scope.additionalID == null ? $scope.currentUserID : $scope.currentUserID + "_" + $scope.additionalID;
    if (!$scope.needLogin) {
      IM.common.login(currentUser, callBack, loginErrorCallBack);
    } else {
      callBack();
    }

    // 发起视频
    var sender = currentUser;
    var receiver = 'U_SH_HuaShan__0355';
    videoCall(sender, receiver);
  };

  return service;
});

IMModule.directive('imContent', function () {
  return {
    restrict: 'E',
    template: '<div >' +
    '<div class="row">' +
    '<div >' +
    '<div style="color: #0044cc;" id="notice"></div>' +
    '<div id="im_content_list" data-spy="scroll" data-target="#navbarExample" data-offset="0" class="scrollspy-content-example" >' +
    '<div id="getHistoryMsgDiv" style="width: 100%;height:20px;text-align: center;z-index: 1;position: relative;top:25px;display:none;"></div>' +
    '</div>' +
    '</div>' +
    '</div>' +

    '<div id="contentEditDiv" class="row" style="position:absolute;bottom:0;margin-top: 30px;">' +
    '<div class="item-input" style="width:100%;height:100%;">' +
    '<input id="im_send_content" style="width:60%;margin-left:15px;"><button class="button " ng-click="sendMsg()" style="width:20%;">发送</button><i class="icon ion-ios-plus-outline" style="font-size:26px;margin:0 10px;float:right" ng-click="goPhotoImg()"></i></div>' +
    '</div>' +
    '</div>',
    replace: true
  };
});

IMModule.directive('imGroupMember', function () {
  return {
    restrict: 'E',
    template: '<ul  style="margin:0">' +
    '<li class="col-25"  style="text-align: center;margin:5px;display: inline-block;" ng-repeat="gm in groupList" >' +
    '<img src="" ng-src="{{showGroupMemberPhoto(gm.Photo)}}">' +
    '<p>{{gm.Name}}</p>' +
    '</li>' +
    '</ul>',
    replace: true
  };
});

IMModule.directive('imGroupList', function () {
  return {
    restrict: 'E',
    template: '<ul class="list">' +
    '<li class="item item-avatar-left discussGroupList" ng-click="goGroupDiscuss(item)" ng-class="{groupListSelect:item.Chat.GroupID == groupID}"  on-swipe-left="deleteGroup(item.Chat)" ng-repeat="item in showedGroupList">' +
    '<img ng-src="{{showAddChatPhoto(item.Chat.Photo)}}" alt=""  >' +
    '<h2 >{{item.Chat.Subject}}</h2>' +
    '<p>{{showGroupListMessage(item.ChatMessage)}}<span style="float:right;margin-right:1%;padding:5px 10px;">{{showGroupListTime(item.ChatMessage.MessageTime)}}</span> <span class="badge badge-assertive" ng-show="item.UnreadRows > 0">{{showUnreadRows(item.UnreadRows)}}</span></p>' +
    '</li>' +
    '</ul>',
    replace: true
  };
});

IMModule.directive('imVideo', function () {
  return {
    restrict: 'E',
    template: '<div class="span8">' +
    '<div class="row">' +
    '<div id="pop_videoView" class="span8">' +
    '<canvas id="videoViewCanvas" style="position: absolute;top:0px;left:0px; width: 0"></canvas>' +
    '<div id="videoView" data-spy="scroll" data-target="#navbarExample" data-offset="0" class="scrollspy-content-example" style="background-color: white;height: 394px">' +
    '<video autoplay="autoplay" id="receivedVideo" width="100%"></video>' +
    '<video autoplay="autoplay" id="localVideo" width="25%" style="position:absolute;top:0px;right:-1px; z-index:300;"></video>' +
    '</div>' +
    '<audio id="voipCallRing" src="../scripts/custom/ringback.wav" style="display:none" loop="loop"></audio>' +
    '</div>' +
    '</div>' +

    '</div>',
    replace: true
  };
});
