var IM = {};
IM.common = {
    defaultAppID: "8a216da85519f454015523b845200571",
    defaultAppToken: "450d828b57582b412de6728aa746e145",
    appID: "",
    appToken: "",
    account: "",
    loginSuccessCallBack: "",
    loginErrorCallBack: "",
    _onMsgReceiveListener: null,
    _onDeskMsgReceiveListener: null,
    _noticeReceiveListener: null,
    _onConnectStateChangeLisenter: null,
    _onCallMsgListener: null,
    _onMsgNotifyReceiveListener: null,
    // 获取当前时间戳 YYYYMMddHHmmss
    getTimeStamp: function () {
        var now = new Date();
        var timestamp = now.getFullYear() + '' + ((now.getMonth() + 1) >= 10 ? ""
            + (now.getMonth() + 1) : "0" + (now.getMonth() + 1))
            + (now.getDate() >= 10 ? now.getDate() : "0" + now.getDate())
            + (now.getHours() >= 10 ? now.getHours() : "0" + now.getHours())
            + (now.getMinutes() >= 10 ? now.getMinutes() : "0" + now.getMinutes())
            + (now.getSeconds() >= 10 ? now.getSeconds() : "0" + now.getSeconds());
        return timestamp;
    },
    // 初始化sdk
    initializeSDK: function (appID, appToken, successCallBack, errorCallBack) {
        // 初始化SDK
        this.appID = appID == null ? this.defaultAppID : appID;
        this.appToken = appToken == null ? this.defaultAppToken : appToken;
        var resp = RL_YTX.init(this.appID, null, null, '2b9c64616c98a93f1375bf0a2f6429e7');
        if (!resp) {
            console.log('SDK初始化错误');
            if (errorCallBack != null) {
                errorCallBack();
            }

            return;
        }

        if (200 == resp.code) { // 初始化成功
            console.log('SDK初始化成功');
            if (successCallBack != null) {
                successCallBack(resp.unsupport);
            }
        } else if (174001 == resp.code) { // 不支持HTML5
            console.log("错误码：174001,错误码描述" + resp.msg);
            if (errorCallBack != null) {
                errorCallBack(resp);
            }
        } else if (170002 == resp.code) { //缺少必须参数
            console.log("错误码：170002,错误码描述" + resp.msg);
            if (errorCallBack != null) {
                errorCallBack(resp);
            }
        } else {
            console.log('未知状态码');
            if (errorCallBack != null) {
                errorCallBack(resp);
            }
        }
    },
    // 注册监听事件
    installListeners: function (onMsgReceiveListener, onMCMMsgReceiveListener, onNoticeReceiveListener, onConnectStateChangeLisenter, onCallMsgListener, onMsgNotifyReceiveListener) {
        // 注册PUSH监听
        if (onMsgReceiveListener != null) {
            this._onMsgReceiveListener = RL_YTX.onMsgReceiveListener(onMsgReceiveListener);
        }

        // 注册客服消息监听
        if (onMCMMsgReceiveListener != null) {
            this._onDeskMsgReceiveListener = RL_YTX.onMCMMsgReceiveListener(onMCMMsgReceiveListener);
        }

        // 注册群组通知事件监听
        if (onNoticeReceiveListener != null) {
            this._noticeReceiveListener = RL_YTX.onNoticeReceiveListener(onNoticeReceiveListener);
        }

        // 服务器连接状态变更时的监听
        var listenState = function (obj) {
            // obj.code;//变更状态 1 断开连接 2 重练中 3 重练成功 4 被踢下线 5 断开连接，需重新登录
            // 断线需要人工重连
            if (1 == obj.code) {
              if(IM.common.errorCount == 0) {
                navigator.notification.alert("连接断开，请重新登录", function () {
                }, "提示消息", "确定");
                IM.common.errorCount = 1;
              }
            } else if (2 == obj.code) {
                console.warn('网络状况不佳，请重新登录');
            } else if (3 == obj.code) {
                console.warn('重练成功');
            } else if (4 == obj.code) {
              if(IM.common.errorCount == 0) {
                navigator.notification.alert("账户在别的地方登陆，请重新登录", function () {
                }, "提示消息", "确定");
                IM.common.errorCount = 1;
              }
            } else if (5 == obj.code) {
              if(IM.common.errorCount == 0) {
                navigator.notification.alert("连接断开，请重新登录", function () {
                }, "提示消息", "确定");
                IM.common.errorCount = 1;
              }
            } else {
              if(IM.common.errorCount == 0) {
                navigator.notification.alert("发生错误，请重新登录", function () {
                }, "提示消息", "确定");
                IM.common.errorCount = 1;
              }
            }

            if (onConnectStateChangeLisenter != null) {
                onConnectStateChangeLisenter(obj);
            }
        };

        // 状态连接监视是必须的
        this._onConnectStateChangeLisenter = RL_YTX.onConnectStateChangeLisenter(listenState);

        /*音视频呼叫监听
         obj.callId;//唯一消息标识  必有
         obj.caller; //主叫号码  必有
         obj.called; //被叫无值  必有
         obj.callType;//0 音频 1 视频 2落地电话
         obj.state;//1 对方振铃 2 呼叫中 3 被叫接受 4 呼叫失败 5 结束通话 6 呼叫到达
         obj.reason//拒绝或取消的原因
         obj.code//当前浏览器是否支持音视频功能
         */
        if (onCallMsgListener != null) {
            this._onCallMsgListener = RL_YTX.onCallMsgListener(onCallMsgListener);
        }

        if (onMsgNotifyReceiveListener != null) {
            this._onMsgNotifyReceiveListener = RL_YTX.onMsgNotifyReceiveListener(onMsgNotifyReceiveListener);
        }
    },
    // 销毁监听事件
    uninstallListeners: function () {
        // 销毁PUSH监听
        this._onMsgReceiveListener = null;
        // 注册客服消息监听
        this._onDeskMsgReceiveListener = null;
        // 销毁注册群组通知事件监听
        this._noticeReceiveListener = null;
        // 服务器连接状态变更时的监听
        this._onConnectStateChangeLisenter = null;
        //呼叫监听
        this._onCallMsgListener = null;
        //阅后即焚监听
        this._onMsgNotifyReceiveListener = null;
    },
    // 获取当前用户信息
    getMyInfo: function (successCallBack, errorCallBack) {
        RL_YTX.getMyInfo(function (obj) {
            console.log("RL_YTX.getMyInfo successfully...");
            if (successCallBack != null) {
                successCallBack(obj);
            }
        }, function (obj) {
            if (520015 != obj.code) {
                console.log("RL_YTX.getMyInfo 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            }

            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        });
    },
    // 获取sig
    getSIG: function (user_account) {
        // 当前没有第三方服务器，所以先采用本地sig
        return hex_md5(this.appID + user_account + this.getTimeStamp() + this.appToken);
    },
    errorCount: 0,
    // 登陆
    login: function (account, loginSuccessCallBack, loginErrorCallBack) {
        this.errorCount = 0;
        this.account = account;
        this.loginErrorCallBack = loginErrorCallBack;
        this.loginSuccessCallBack = loginSuccessCallBack;
        var loginBuilder = new RL_YTX.LoginBuilder();
        var user_account = account;
        loginBuilder.setType(1); //1是自定义账号
        loginBuilder.setUserName(user_account);
        loginBuilder.setSig(this.getSIG(user_account));
        loginBuilder.setTimestamp(this.getTimeStamp());
        RL_YTX.login(loginBuilder, function (obj) {
            console.log("RL_YTX.login successfully...");
            if (loginSuccessCallBack != null) {
                loginSuccessCallBack(obj);
            }
        }, function (obj) {
            console.log("RL_YTX.login 错误码： " + obj.code + "; 错误描述：" + obj.msg);
          navigator.notification.alert("登陆超时，请重新登录",function(){},"提示消息","确定");
            if (loginErrorCallBack != null) {
                loginErrorCallBack(obj);
            }
        });
    },
    // 登出
    logout: function (successCallBack, errorCallBack) {
        this.uninstallListeners();
        RL_YTX.logout(function () {
            console.log("RL_YTX.logout successfully...");
            if (successCallBack != null) {
                successCallBack();
            }
        }, function (obj) {
            console.log("RL_YTX.logout 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack();
            }
        });
    },
    // 获取用户状态
    getUserState: function (contact_you, isNew, successCallBack, errorCallBack) {
        var getUserStateBuilder = new RL_YTX.GetUserStateBuilder();
        getUserStateBuilder.setNewUserstate(isNew);
        getUserStateBuilder.setUseracc(contact_you);
        RL_YTX.getUserState(getUserStateBuilder, function (obj) {
            console.log("RL_YTX.getUserState successfully");
            if (successCallBack != null) {
                successCallBack(obj);
            }
        }, function (obj) {
            console.log("RL_YTX.getUserState 错误码：" + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        });
    },
    // 更新个人信息
    uploadPersonInfo: function (nickName, sex, birth, sign, successCallBack, errorCallBack) {
        var obj = new RL_YTX.UploadPersonInfoBuilder(nickName, sex, birth, sign);
        RL_YTX.uploadPerfonInfo(obj, function (obj) {
            console.log("RL_YTX.uploadPersonInfo successfully...");
            if (successCallBack != null) {
                successCallBack(obj);
            }
        }, function (obj) {
            console.log("RL_YTX.uploadPersonInfo 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        });
    }
};
IM.chat = {
    // 发送信息
    sendMsg: function (obj, successCallBack, errorCallBack, progressCallBack) {
        return RL_YTX.sendMsg(obj, function (obj) {
            if (successCallBack != null) {
                successCallBack(obj);
            }
        }, function (obj) { // 失败
            console.log("RL_YTX.sendMsg 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        }, function (sended, total, msgId) { // 进度条
            if (progressCallBack != null) {
                progressCallBack(sended, total, msgId);
            }
        });
    },
    // 发送信息（文本）
    sendTextMsg: function (text, receiver, extopts, isFireMessage, type, successCallBack, errorCallBack, progressCallBack) {
        var obj = new RL_YTX.MsgBuilder();
        obj.setText(text);
        obj.setType(1);
        obj.setReceiver(receiver);
        if (extopts != null && extopts.length > 0) {
            obj.setAtAccounts(extopts);
            obj.setType(11);
        }

        // 阅后即焚
        if (isFireMessage) {
            obj.setDomain("fireMessage");
        }

        if (!!type) {
            obj.setType(type);
        }

        return this.sendMsg(obj, successCallBack, errorCallBack, progressCallBack);
    },
    // 发送信息（文件）
    sendFileMsg: function (file, type, receiver, isFireMessage, successCallBack, errorCallBack, progressCallBack) {
        var obj = new RL_YTX.MsgBuilder();
        obj.setFile(file);
        obj.setType(type);
        obj.setReceiver(receiver);

        // 阅后即焚
        if (isFireMessage) {
            obj.setDomain("fireMessage");
        }

        return this.sendMsg(obj, successCallBack, errorCallBack, progressCallBack);
    }
};
IM.group = {
    // 创建群组
    createGroup: function (groupName, permission, target, groupType, province, city, declare, successCallBack, errorCallBack) {
        var obj = new RL_YTX.CreateGroupBuilder();
        obj.setGroupName(groupName);
        obj.setPermission(permission);
        obj.setTarget(target);
        if (!!groupType) {
            obj.setGroupType(groupType);
        }
        if (!!province && (province != "--")) {
            obj.setProvince(province);
        }
        if (!!city) {
            obj.setCity(city);
        }
        if (!!declare) {
            obj.setDeclared(declare);
        }

        RL_YTX.createGroup(obj, function (obj) {
            console.log("RL_YTX.createGroup successfully");
            if (successCallBack != null) {
                successCallBack(obj);
            }
        }, function (obj) {
            console.log("RL_YTX.createGroup 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        });
    },
    // 获取群组成员列表
    getGroupMemberList: function (groupId, successCallBack, errorCallBack) {
        var obj = new RL_YTX.GetGroupMemberListBuilder();
        obj.setGroupId(groupId);
        obj.setPageSize(-1);

        RL_YTX.getGroupMemberList(obj, function (obj) {
            console.log('get Group Member List successfully...');
            if (successCallBack != null) {
                successCallBack(obj);
            }
        }, function (obj) {
            console.log("RL_YTX.getGroupDetail 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        });
    },
    // 邀请成员加入群组
    inviteJoinGroup: function (groupId, declared, members, confirm, successCallBack, errorCallBack) {
        var obj = new RL_YTX.InviteJoinGroupBuilder(groupId, declared, members, confirm);
        RL_YTX.inviteJoinGroup(obj, function () {
            console.log('invite Join Group successfully...');
            if (successCallBack != null) {
                successCallBack();
            }
        }, function (obj) {
            console.log("RL_YTX.inviteJoinGroup 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        });
    },
    // 加入群组
    joinGroup: function (groupId, successCallBack, errorCallBack) {
        var obj = new RL_YTX.JoinGroupBuilder(groupId, "");
        RL_YTX.joinGroup(obj, function (obj) {
            console.log('RL_YTX.joinGroup successfully...');
            if (successCallBack != null) {
                successCallBack();
            }
        }, function (obj) {
            // 由于会重复加组 所以用log
            console.log("错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack();
            }
        });
    },
    // 修改群组成员名片
    modifyMemberCard: function (memberId, belong, nick, successCallBack, errorCallBack) {
        var obj = new RL_YTX.ModifyMemberCardBuilder();
        obj.setMember(memberId);
        obj.setBelong(belong);
        obj.setDisplay(nick);

        RL_YTX.modifyMemberCard(obj, function (obj) {
            console.log('RL_YTX.modifyMemberCard successfully...');
            if (successCallBack != null) {
                successCallBack(obj);
            }
        }, function (obj) {
            console.log("RL_YTX.modifyMemberCard 错误码： " + obj.code + "; 错误描述：" + obj.msg);
            if (errorCallBack != null) {
                errorCallBack(obj);
            }
        });
    }
};
IM.video = {
    //发起视屏
    videoCall: function (receiver, view, localView, successCallBack, errorCallBack) {
        RL_YTX.setCallView(view, localView);
        var makeCallBuilder = new RL_YTX.MakeCallBuilder();
        makeCallBuilder.setCalled(receiver); //被呼叫人号码
        makeCallBuilder.setCallType(1); //呼叫的类型 0 音频 1视频 2 落地电话
        console.log("called = " + receiver + "; " + "callType = " + callType);
        var callId = RL_YTX.makeCall(makeCallBuilder,
            function () {

            },
            function callback(obj) {
                console.log("错误码：" + obj.code + "; 错误描述：" + obj.msg);
                errorCallBack(obj);
                //$("#videoViewCanvas").hide();
                //$("#videoView").hide();
                //$("#cancelVoipCall").hide();
                //$("#voiceCallDiv_audio").hide();
                //$("#cancelVoiceCall").hide();
                //$("#pop_videoView").hide();
            });
        successCallBack(callId, receiver);
    },
    //接受视频
    answerCall: function (view, localView, callId, caller, called, successCallBack, errorCallBack) {
        RL_YTX.setCallView(view, localView);
        var acceptCallBuilder = new RL_YTX.AcceptCallBuilder();
        acceptCallBuilder.setCallId(callId); //请求的callId，
        acceptCallBuilder.setCaller(caller); //请求的主叫号码
        console.log("callId=" + callId + "; caller=" + caller);
        RL_YTX.accetpCall(acceptCallBuilder,
            function () {

            },
            function callback(obj) {
                console.log("错误码：" + obj.code + "; 错误描述：" + obj.msg);
                errorCallBack(obj);
            });
    },
    //取消视频
    cancelCall: function (callId, caller, called, successCallBack, errorCallBack) {
        var releaseCallBuilder = new RL_YTX.ReleaseCallBuilder();
        releaseCallBuilder.setCallId(callId); //请求的callId
        releaseCallBuilder.setCaller(caller); //请求的主叫号码
        releaseCallBuilder.setCalled(called); // 请求的被叫号码

        RL_YTX.releaseCall(releaseCallBuilder, function () {
            },
            function (obj) {
                console.log("错误码：" + obj.code + "; 错误描述：" + obj.msg);
                errorCallBack(obj);
            });
    },
    //拒绝视频
    refuseCall: function (callId, caller, successCallBack, errorCallBack) {
        var rejectCallBuilder = new RL_YTX.RejectCallBuilder();
        rejectCallBuilder.setCallId(callId); //请求的callId
        rejectCallBuilder.setCaller(caller); //请求的主叫号码

        RL_YTX.rejectCall(rejectCallBuilder, function () {

        }, function (obj) {
            console.log("错误码：" + obj.code + "; 错误描述：" + obj.msg);
            errorCallBack(obj);
        });
    }
};
IM.photo = {
    // 适用图片
    apply: function (objTag, onCanPlay, onErr) {
        RL_YTX.photo.apply(objTag, onCanPlay, onErr);
    },
    cancle:function () {
        RL_YTX.photo.cancel();
    },
    make: function() {
        return RL_YTX.photo.make();
    }
};
