/!*侧边导航*!/
var navigation = angular.module('NavModule', ["UserModule", "resourceModule"]);
navigation.factory('navFactory', function (userService, commonFunctionFactory) {
    return {
        navList: [{
            title: '患者审批',
            url: 'Approve.html',
            icons: 'navBg'
        }, {
            title: '向上转院',
            url: 'DiagnosisAsk.html',
            icons: 'navBg'
        }, {
            title: '向下转院',
            url: 'DiagnosisReply.html',
            icons: 'navBg'
        }, {
//            title: '合作医院',
//            url: 'Customer.html',
//            icons: 'navBg'
        }, {
//            title: '消息推送',
//            url: 'xxx.html',
//            icons: 'navBg'
        }, {
//            title: '数据统计',
//            url: 'xxx.html',
//            icons: 'navBg'
        }, {
//            title: '短信平台',
//            url: 'NeteaseMessage.html',
//            icons: 'navBg'
        }, {
//            title: '系统设置',
//            url: 'System.html',
//            icons: 'navBg'
        }, {
//            title: '帮助中心',
//            url: 'xxx.html',
//            icons: 'navBg'
        }],
        navDocList: [
            {
                title: '会诊组',
                url: 'Discuss.html',
                icons: 'navBg'
            }
            //, {
            //     title: '我的问诊',
            //     url: 'xxx.html',
            //     icons: 'navBg'
            //  }, {
            //     title: '个人信息',
            //      url: 'xxx.html',
            //      icons: 'navBg'
            //  }, {
            //      title: '帮助中心',
            //      url: 'xxx.html',
            //      icons: 'navBg'}
        ],
        navPartnerList: [{
            title: '患者列表',
            url: 'Patient.html',
            icons: 'navBg'
        }, {
            title: '向上转院',
            url: 'RequestDiagnosisAsk.html',
            icons: 'navBg'
        },
//            {
//            title: '向下转院',
//            url: 'ResponseDiagnosisReply.html',
//            icons: 'navBg'
//        }
            //, {
            //title: '系统设置',
            //url: 'xxx.html',
            //icons: 'navBg'
            //}, {
            //  title: '帮助中心',
            // url: 'xxx.html',
            // icons: 'navBg'
            //    }
        ],
        logoutSystem: function () {
            userService.removeUser();
            commonFunctionFactory.goToLogin();
        }
    };
});

navigation.directive('nav', function () {
    return {
        restrict: 'E',
        template: "<div id = 'sidebar' class = 'navCollapse ' ng-controller = 'navController'> " +
        "<div class = 'user dropdown'>" +
        "<a href = '#' class = 'dropdown-toggle bg clear' data-toggle = 'dropdown'>{{firstWord}}</a>" +
            '<div class = "container-fluid userDetails dropdown-menu animated fadeInRight aside clearfix">' +
            '<div class = "row">' +
            '<div class = "col-lg-12 col-md-12 col-sm-12">' +
            '<div class = "info">' +
                '<div class = "hosName" ><p>欢迎<span ng-bind="hospitalName"></span>互联网平台用户</p></div>' +
                '<div class = "docNum" ng-show = "doctorName==null"><p>管理员</p></div>' +
                '<div class = "docNum" ng-show = "doctorName!=null"><p>医生编号：{{doctorID}}</p></div>' +
                '<div class = "docName" ng-show = "doctorName!=null"><p>当前用户：<span ng-bind = "doctorName"></span>(<span ng-bind = "UserName">' +
                '</span>/<span ng-bind = "doctorRole"></span>)</p></div>' +
                '</div>' +
                '<div class = "modify">' +
                '<a ng-if = "setUser == 1" href = "medicalDepartment.html">用户设置</a>' +
                '<a ng-if = "setUser == 0" href = "doctor.html">修改信息</a>' +
                '<a ng-if = "setUser == 2" href = "#">系统设置</a>' +
                '<a href = "javascript:void()" ng-click = "logoutSystem()" >退出登录</a></div>' +
            '</div>' +
            '</div>' +
            '</div>' +
            "</div>" +
            "<ul class = 'sidebarMenu'>" +
            "<li class = 'sub-menu' ng-repeat = 'nav in navList'> " +
            "<a href = '{{nav.url}}' class = ''> " +
            "<i class = '{{nav.icons}}'></i> " + "<span>{{nav.title}}</span> " +
            "</a>" +
            " </li> " +
            "</ul>" +
            "<ul class='sidebarMenu'>" +
            "<li class='sub-menu'>" +
            "<label ng-click='selectLi()'>我的会诊间</label>&nbsp;" +
            "<ul class='sidebarMenu' ng-show='show'> " +
            "<li class='discussUl sub-menu' ><label><a ng-click='showUtility()'>广医三院</a></label></li> " +
            "</ul> " +
            "</li> " +
            "</ul> " +
               "<div class='row'>"+
                    "<div class='modal fade modalScroll' id='loadUtility' role='dialog' aria-labelledby='gridSystemModalLabel'>"+
                        "<div class='modal-dialog dialogInfo' role='document'>"+
                             "<div class='modal-content modalContentWidth'>"+
                               "<div class='modal-header'>"+
                               "<button type='button' class='close' data-dismiss='modal' aria-label='Close'>"+
                                "<span aria-hidden='true'>&times;</span>"+
                                "</button>"+
                             "</div>"+
                             "<div class='modal-body modalBodyHeight'>"+
                                "<div class='container-fluid'>"+
                                "</div> " +
                             "</div> " +
                        "</div> " +
                    "</div>"+
                "</div>"+
        "</div>" +
        "</div>"
        ,
        replace: true
    };
});


navigation.controller('navController', function ($scope, navFactory, userService) {
    $scope.logoutSystem = function () {
        navFactory.logoutSystem();
    };

    $scope.showText = function (show) {
        if (show) {
            return "-";
        } else {
            return "+";
        }
    };
    // 选择li
    $scope.show = false;
    $scope.selectLi = function () {
        $scope.show = !$scope.show;
    };

    //显示框
    $scope.showUtility = function () {
        $("#loadUtility").modal("show");
    };

    var currentUser = userService.getUser();
    if (currentUser.Body.UserType == 1) {
        // 医生
        $scope.navList = navFactory.navDocList;
        $scope.firstWord = currentUser.Body.User.Name.substr(0, 1);
        $scope.doctorName = currentUser.Body.User.Name;
        $scope.UserName = currentUser.Body.User.UserName;
        $scope.hospitalName = currentUser.Body.Customer != null ?
            currentUser.Body.Customer.CustomerName : "";
        $scope.doctorRole = (function () {
            switch (currentUser.Body.User.JobTitle) {
                case '0':
                    return '主任医师';
                case '1':
                    return '医干';
                case '2':
                    return '医生';
                default:
                    return '医生';
            }
        })();
        $scope.doctorID = currentUser.Body.User.UserID;
        $scope.setUser = 0;
    } else if (currentUser.Body.IsTop == 1) {
        // 医务处
        $scope.navList = navFactory.navList;
        $scope.firstWord = '医';
        $scope.setUser = 1;
        $scope.hospitalName = currentUser.Body.Customer.CustomerName;

    } else {
        // 下级医院医务处
        $scope.navList = navFactory.navPartnerList;
        $scope.firstWord = '合';
        $scope.setUser = 2;
        $scope.hospitalName = currentUser.Body.Customer != null ?
            currentUser.Body.Customer.CustomerName : "";
    }
});
angular.bootstrap($('aside'), ['NavModule']);

/*头部*/
var headerBar = angular.module('HeaderModule', []);
headerBar.directive('bottom', function () {
    return {
        restrict: 'E',
        template: "<div ng-controller='headerController'> <img ng-src='{{src}}'> <br /> </div>",
        replace: true
    };
});

headerBar.controller('headerController', function ($scope) {
    $scope.src = '../images/gysy.png';
});

angular.bootstrap($('header'), ['HeaderModule']);

/*底部*/
var footerBar = angular.module('FooterModule', []);
footerBar.directive('bottom', function () {
    return {
        restrict: 'E',
        template: "<div ng-controller='footerController'><strong>Copyright &copy; {{time}} <a href='{{ref}}'>{{title}}</a>.</strong> All rights reserved.</div>",
        replace: true
    };
});

footerBar.controller('footerController', function ($scope) {
    $scope.title = '广医三院   医利捷';
    $scope.ref = '#';
    $scope.time = '2016';
});

angular.bootstrap($('footer'), ['FooterModule']);

/*分页*/
var pagination = angular.module('PaginationModule', []);
pagination.directive('pagination', function () {
    return {
        restrict: 'EA',
        template: "<div class='page-list'>" +
        "<ul class='pagination' ng-show='conf.totalItems > 0'>" +
        "<li ng-class='{disabled: pageList == null || pageList.length == 0 || pageList[0] == 1}' ng-click='prevPage()'><span>&laquo;</span></li>" +
        "<li ng-click='changeCurrentPage(pageItem)' ng-repeat='pageItem in pageList' ng-class='{active: pageItem == conf.currentPage, separate: pageItem == \"...\"}'>" +
        "<span ng-bind='pageItem'></span>" +
        "</li>" +
        "<li ng-class='{disabled: pageList == null || pageList.length == 0 || pageList[pageList.length-1] == conf.numberOfPages}' ng-click='nextPage()'><span>&raquo;</span></li>" +
        "</ul>" +
        "<div class='page-total' ng-show='conf.totalItems > 0'>" +
        "第<input type='number' ng-model='jumpPageNum'  ng-keyup='jumpToPage($event)'/>页 " +
        "/共<strong ng-bind='conf.numberOfPages'></strong>页" +
        "</div>" +
        "</div>",
        replace: true
    };
});

pagination.service('paginationService', function () {
    var service = {};
    service.initialize = function ($scope) {
        $scope.conf = {};
        // 显示页数
        $scope.conf.pagesLength = 8;
        // 每页显示条数
        $scope.conf.itemsPerPage = 10;
        // 设置总件数
        $scope.setTotalItems = function (num) {
            $scope.conf.totalItems = num;
        };

        // 变更当前页
        $scope.changeCurrentPage = function (item) {
            if (item == '...') {
                return;
            } else {
                $scope.conf.currentPage = item;
            }
        };

        // pageList数组
        $scope.getPagination = function () {
            // 当前页
            $scope.conf.currentPage = parseInt($scope.conf.currentPage) ? parseInt($scope.conf.currentPage) : 1;

            // 总数
            $scope.conf.totalItems = parseInt($scope.conf.totalItems) ? parseInt($scope.conf.totalItems) : 0;

            // 分页数
            $scope.conf.numberOfPages = Math.ceil($scope.conf.totalItems / $scope.conf.itemsPerPage);

            // judge currentPage > scope.numberOfPages
            if ($scope.conf.currentPage < 1) {
                $scope.conf.currentPage = 1;
            }

            // 如果分页总数>0，并且当前页大于分页总数
            if ($scope.conf.numberOfPages > 0 && $scope.conf.currentPage > $scope.conf.numberOfPages) {
                $scope.conf.currentPage = $scope.conf.numberOfPages;
            }

            $scope.pageList = [];
            if ($scope.conf.numberOfPages <= $scope.conf.pagesLength) {
                // 判断总页数如果小于等于分页的长度，若小于则直接显示
                for (var i = 1; i <= $scope.conf.numberOfPages; i++) {
                    $scope.pageList.push(i);
                }
            } else {
                $scope.pageList = [];
                for (var i = 1; i <= $scope.conf.pagesLength; i++) {
                    $scope.pageList.push(i);
                }

                $scope.pageList.push("...");
            }
        };

        // prevPage
        $scope.prevPage = function () {
            if ($scope.pageList.length == 0) {
                return;
            }

            var min = $scope.pageList[0];
            if (min == 1) {
                return;
            }

            var max = min - 1;
            min = max - $scope.conf.pagesLength + 1;
            min = min >= 1 ? min : 1;
            $scope.pageList = [];
            for (var i = min; i <= max; i++) {
                $scope.pageList.push(i);
            }

            if (max < $scope.conf.numberOfPages) {
                $scope.pageList.push("...");
            }

            $scope.conf.currentPage = max;
        };

        // nextPage
        $scope.nextPage = function () {
            if ($scope.pageList.length == 0) {
                return;
            }

            var min = $scope.pageList[$scope.pageList.length - 1];
            if (min != "...") {
                return;
            }

            min = $scope.pageList[$scope.pageList.length - 2] + 1;
            var max = min + $scope.conf.pagesLength - 1;
            max = max >= $scope.conf.numberOfPages ? $scope.conf.numberOfPages : max;
            $scope.pageList = [];
            for (var i = min; i <= max; i++) {
                $scope.pageList.push(i);
            }

            if (max < $scope.conf.numberOfPages) {
                $scope.pageList.push("...");
            }

            $scope.conf.currentPage = min;
        };

        // 跳转页
        $scope.jumpToPage = function () {
            if ($scope.jumpPageNum > 0 && $scope.jumpPageNum <= $scope.conf.numberOfPages) {
                var min = $scope.jumpPageNum;
                var max = min + $scope.conf.pagesLength - 1;
                max = max >= $scope.conf.numberOfPages ? $scope.conf.numberOfPages : max;
                $scope.pageList = [];
                for (var i = min; i <= max; i++) {
                    $scope.pageList.push(i);
                }

                if (max < $scope.conf.numberOfPages) {
                    $scope.pageList.push("...");
                }

                $scope.conf.currentPage = min;
            }
        };

        // 显示页数所在内容
        $scope.changePaginationContent = function (totalList, showList) {
            if (!parseInt($scope.conf.currentPage)) {
                return;
            }

            var min = ($scope.conf.currentPage - 1) * $scope.conf.itemsPerPage + 1;
            var max = min + $scope.conf.itemsPerPage - 1;
            max = max > $scope.conf.totalItems ? $scope.conf.totalItems : max;
            for (var i = min - 1; i < max; i++) {
                showList.push(totalList[i]);
            }
        };
    };

    return service;
});
