gysyApp.service("onlineAskTextDetailService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};

  //图文问诊回复
  service.onlineAnswer = function (params, $scope) {
    httpHandlerService.AskMessageRequest(params, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $("#ask_send_content").val('');
          //更新此问诊的消息记录
          $scope.textAskDetail.ConsultMessageList.push(response.Body.ConsultMessage);
        }
        else {
          navigator.notification.alert("回复患者问诊出错",function(){},"提示消息","确定");
          //alert("回复患者问诊出错");
        }
      },
      function (response) {
        console.error(response);
      });
  };
  //获取图文问诊消息记录
  service.getMessageList = function (params, $scope) {
    httpHandlerService.AskMessageRequest(params, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.MessageList = "";
        }
        else {
          //alert("回复患者问诊出错");
          navigator.notification.alert("回复患者问诊出错",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.error(response);
      });
  };
  //修改在线问诊
  service.updateOnlineConsult = function (params, $scope) {
    httpHandlerService.getConsultRequest(params, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          console.info("修改状态成功")
        }
        else {
          console.info("修改状态失败");
        }
      },
      function (response) {
        console.log(response);
      });
  };
  return service;
});
gysyApp.controller("onlineAskTextDetailController", function ($ionicHistory,$scope, $rootScope, $state,onlineAskTextDetailService,userService) {
  // 初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body.User;
    // 当前用户id
    $scope.currentUserID = $scope.currentUser.UserID;
    // 当前用户姓名(用来更新myInfo)
    $scope.currentUserName = $scope.currentUser.Name;

    $scope.textAskDetail=$rootScope.textAskDetail;
  };

  $scope.goBack = function(){
    $ionicHistory.goBack();
  }
  //回复问题
  $scope.onlineAnswer = function () {
    var str = $('#ask_send_content').val();
    var ConsultMessage = {
      ConsultID: $scope.textAskDetail.Consult.ConsultID,
      Message: str,
      ReceiverID: $scope.textAskDetail.Consult.CreatorID,
      ReceiverName: $scope.textAskDetail.Consult.CreatorName,
      CreatorID: $scope.textAskDetail.Consult.ReceiverID,
      CreatorName: $scope.textAskDetail.Consult.ReceiverName
    };
    var Consult = {
      ConsultID: $scope.textAskDetail.Consult.ConsultID,
      ID: $scope.textAskDetail.Consult.ID,
      Subject: $scope.textAskDetail.Consult.Subject,
      Description: $scope.textAskDetail.Consult.Description,
      ReceiverID: $scope.textAskDetail.Consult.ReceiverID,
      ReceiverName: $scope.textAskDetail.Consult.ReceiverName,
      DepartmentID: $scope.textAskDetail.Consult.DepartmentID,
      DepartmentName: $scope.textAskDetail.Consult.DepartmentName,
      ConsultType: 2,//图文问诊
      CreatorID: $scope.textAskDetail.Consult.CreatorID,
      CreatorName: $scope.textAskDetail.Consult.CreatorName,
      PatientGender: $scope.textAskDetail.Consult.PatientGender == '男' ? 1 : 0,
      PatientAge: $scope.textAskDetail.Consult.PatientAge,
      PatientPhone: $scope.textAskDetail.Consult.PatientPhone,
      PatientIDCard: $scope.textAskDetail.Consult.PatientIDCard,
      PatientMedicalHistory: '',
      Status: 4,
      CreateTime: $scope.textAskDetail.Consult.CreateTime,
      ReserveDate: $scope.textAskDetail.Consult.ReserveDate,
      ReserveTime: $scope.textAskDetail.Consult.ReserveTime,
      State: $scope.textAskDetail.Consult.State,
      ReceiverTyp: $scope.textAskDetail.Consult.ReceiverTyp,
      OnlineType: $scope.textAskDetail.Consult.OnlineType,
      CustomerID: $scope.textAskDetail.Consult.CustomerID
    };
    var params = {
      ConsultMessage: ConsultMessage,
      Consult: Consult,
      FileList: []
    };
    onlineAskTextDetailService.onlineAnswer(params, $scope);
  };

  //性别转换
  $scope.GenderText = function (par) {
    switch (par) {
      case 0:
        return '女';
      case 1:
        return '男';
      default:
        return '未知';
    }
  };

  //图文状态
  $scope.AskStateText = function (par) {
    switch (par) {
      case 1:
        return '待回复';
      case 4:
        return '已回复';
      case 5:
        return '已取消';
      default:
        return '未知';
    }
  };

  //结束问诊
  $scope.overConsult = function () {
    //var receiver = $scope.selectContact();
    //if (receiver == "") {
    //  return;
    //}
    if (confirm("确定结束此咨询？")) {
      var consultInfo = $rootScope.textAskDetail.Consult;
      var Consult = {
        ConsultID: consultInfo.ConsultID,
        ReceiverID: consultInfo.ReceiverID,
        ReceiverName: consultInfo.ReceiverName,
        ID: consultInfo.ID,
        Subject: consultInfo.Subject,
        Status: 6,
        State: consultInfo.State,
        ReserveTime: consultInfo.ReserveTime,
        ReserveDate: consultInfo.ReserveDate,
        ReceiverType: consultInfo.ReceiverType,
        PatientPhone: consultInfo.PatientPhone,
        PatientMedicalHistory: consultInfo.PatientMedicalHistory,
        PatientIDCard: consultInfo.PatientIDCard,
        PatientGender: consultInfo.PatientGender == '男' ? 1 : 0,
        PatientAge: consultInfo.PatientAge,
        OnlineType: consultInfo.OnlineType,
        Description: consultInfo.Description,
        DepartmentName: consultInfo.DepartmentName,
        DepartmentID: consultInfo.DepartmentID,
        CustomerID: consultInfo.CustomerID,
        CreatorName: consultInfo.CreatorName,
        CreatorID: consultInfo.CreatorID,
        CreateTime: consultInfo.CreateTime,
        ConsultType: consultInfo.ConsultType
      };
      console.info(Consult);
      var params = {
        Consult: Consult,
        FileList: []
      };
      onlineAskTextDetailService.updateOnlineConsult(params, $scope);
    }
  };

  $scope.initialize();
});

