gysyApp.service("onlineAskService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};
  //获取问诊列表
  service.getConsult = function (params, $scope) {
    httpHandlerService.getConsultRequest(params, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
         /* //按申请时间排序
          var sortData = response.Body.ConsultList.sort(function (a, b) {
            return Date.parse(b.Consult.CreateTime) - Date.parse(a.Consult.CreateTime);
          });
          $scope.consultList = sortData;*/
          $scope.consultList = response.Body.ConsultList;
        }
        else {
          //alert("没有在线问诊患者");
          navigator.notification.alert("没有在线问诊患者",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.error(response);
      });
  };

  //图文问诊回复
  service.onlineAnswer = function (params, $scope) {
    httpHandlerService.AskMessageRequest(params, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $("#ask_send_content").html('');
          //更新此问诊的消息记录
          var consultList = $scope.consultList;
          for (var i in consultList) {
            if (consultList[i].Consult.ConsultID == response.Body.Consult.ConsultID) {
              consultList[i].ConsultMessageList.push(response.Body.ConsultMessage)
            }
          }
          $scope.consultList = consultList;
        }
        else {
          navigator.notification.alert("回复患者问诊出错",function(){},"提示消息","确定");
          //alert("回复患者问诊出错");
        }
      },
      function (response) {
        console.error(response);
      });
  };
  //获取图文问诊消息记录
  service.getMessageList = function (params, $scope) {
    httpHandlerService.AskMessageRequest(params, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.MessageList = "";
        }
        else {
          //alert("回复患者问诊出错");
          navigator.notification.alert("回复患者问诊出错",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.error(response);
      });
  };
  return service;
});
gysyApp.controller("onlineAskController", function ($scope, $rootScope, $state, $ionicPopup,onlineAskService,userService,$ionicHistory) {
  // 初始化
  $scope.initialize = function () {
    $scope.currentUser = userService.getUser().Body.User;
    // 当前用户id
    $scope.currentUserID = $scope.currentUser.UserID;
    // 当前用户姓名(用来更新myInfo)
    $scope.currentUserName = $scope.currentUser.Name;

    // 推送 todo
    pushGoEasy.initialize();
    var channel = "consult_channel_" + $scope.currentUserID;
    pushGoEasy.subscribe(channel, function (result) {
      //获取推送的数据  人或者群组
      var content = JSON.parse(result.content);
      if (content.Body.content != null && content.Body.content != "") {
        var response = JSON.parse(content.Body.content);
        //判断是否推送给本人的联系人或群组
        if ($scope.currentUserID == content.Header.ReceiverID) {
          if (response.ConsultType == 1 && response.OnlineType == 2){
            var consult = {
              ID: response.ID,
              ConsultID: response.ConsultID,
              ConsultType: response.ConsultType,
              CreateTime: response.CreateTime,
              CreatorID: response.CreatorID,
              CreatorName: response.CreatorName,
              CustomerID: response.CustomerID,
              DepartmentID: response.DepartmentID,
              DepartmentName: response.DepartmentName,
              Description: response.Description,
              OnlineType: response.OnlineType,
              PatientAge: response.PatientAge,
              PatientGender: response.PatientGender,
              PatientIDCard: response.PatientIDCard,
              PatientMedicalHistory: response.PatientMedicalHistory,
              PatientPhone: response.PatientPhone,
              ReceiverID: response.ReceiverID,
              ReceiverName: response.ReceiverName,
              ReceiverType: response.ReceiverType,
              ReserveDate: response.ReserveDate,
              ReserveTime: response.ReserveTime,
              State: response.State,
              Status: response.Status,
              Subject: response.Subject
            };
            var consultMessageList = [];
            var fileList = [];
            var item = {
              Consult: consult,
              ConsultMessageList: consultMessageList,
              FileList: fileList
            };
            $scope.consultList.push(item);
          }
          else if(response.ConsultType == 2){
            var consult = {
              ID: response.ID,
              ConsultID: response.ConsultID,
              ConsultType: response.ConsultType,
              CreateTime: response.CreateTime,
              CreatorID: response.CreatorID,
              CreatorName: response.CreatorName,
              CustomerID: response.CustomerID,
              DepartmentID: response.DepartmentID,
              DepartmentName: response.DepartmentName,
              Description: response.Description,
              OnlineType: response.OnlineType,
              PatientAge: response.PatientAge,
              PatientGender: response.PatientGender,
              PatientIDCard: response.PatientIDCard,
              PatientMedicalHistory: response.PatientMedicalHistory,
              PatientPhone: response.PatientPhone,
              ReceiverID: response.ReceiverID,
              ReceiverName: response.ReceiverName,
              ReceiverType: response.ReceiverType,
              ReserveDate: response.ReserveDate,
              ReserveTime: response.ReserveTime,
              State: response.State,
              Status: response.Status,
              Subject: response.Subject
            };
            var consultMessageList = [];
            var fileList = [];
            var item = {
              Consult: consult,
              ConsultMessageList: consultMessageList,
              FileList: fileList
            };
            $scope.consultList.push(item);
          }
          $scope.$apply();
        }
      }
    });

    $scope.ConsultType = 1;
    $scope.searchOnlineAsk($scope.ConsultType);
  };

  $scope.goBack = function(){
    $ionicHistory.goBack();
  }
  //Tab切换
  $scope.changeTab = function (type,event) {
    var _this = event.target;
    $(_this).addClass('active-a');
    $(_this).siblings().removeClass("active-a");
    if (type == 1) {
      $scope.ConsultType = 1;
      $scope.searchOnlineAsk($scope.ConsultType);
    }
    else if (type == 2) {
      $scope.ConsultType = 2;
      $scope.searchOnlineAsk($scope.ConsultType);
    }
    else {
     //alert("暂无数据");
      navigator.notification.alert("暂无数据",function(){},"提示消息","确定");
      return;
    }
  };

  //查询事件
  $scope.searchOnlineAsk = function (type) {
    $scope.paramsSearch = {
      ConsultType: "",
      PatientName: "",
      From: "",
      To: ""
    };
    $scope.paramsSearch.ConsultType = type;
    onlineAskService.getConsult($scope.paramsSearch, $scope);
  };

  /*搜素问诊事件*/
  $scope.OnlineAskSearch = function () {
    $scope.paramsSearch.PatientName = $scope.PatientName;
    $scope.paramsSearch.From = "";
    $scope.paramsSearch.To = "";
    onlineAskService.getConsult($scope.paramsSearch, $scope);
  };

  $scope.changeOnlineAskSearchEmpty = function () {
    if ($scope.PatientName == "") {
      $scope.searchOnlineAsk($scope.ConsultType);
    }
  };

  //转换时间片
  $scope.sliceText = function (par) {
    switch (par) {
      case 'G':
        return '09:00 - 10:00';
      case 'H':
        return '10:00 - 11:00';
      case 'I':
        return '11:00 - 12:00';
      case 'J':
        return '12:00 - 13:00';
      case 'K':
        return '13:00 - 14:00';
      case 'L':
        return '14:00 - 15:00';
      case 'M':
        return '15:00 - 16:00';
      case 'N':
        return '16:00 - 17:00';
      case 'O':
        return '17:00 - 18:00';
      case 'P':
        return '18:00 - 19:00';
      case 'Q':
        return '19:00 - 20:00';
      case 'R':
        return '20:00 - 21:00';
      default:
        return '现在';
    }
  };

  //转换问诊状态
  $scope.StateText = function (state) {
    switch (state) {
      case 1:
        return '已预约';
      case 2:
        return '侯诊中';
      case 3:
        return '就诊中';
      case 4:
        return '已完成';
      case 5:
        return '已取消';
      default:
        return '未知';
    }
  };

  //性别转换
  $scope.GenderText=function (par) {
    switch (par){
      case 0:
        return '女';
      case 1:
        return '男';
      default:
        return '未知';
    }
  };

  //进入在线问诊详情页
  $scope.goToOnlineAskDetail = function (list) {
    $rootScope.onlineAskDetail = list;
    $state.go("onlineRoom");
  };

  //进入图文问诊详情页
  $scope.goToTextAskDetail = function (list) {
    $rootScope.textAskDetail = list;
    $state.go("onlineAskTextDetail");
  };

  /**图文问诊**/
  //切换问题显示
  $scope.chooseContactList = function (index, list) {
    $scope.selAskIndex = index; //获取选中项下标
    //初始化消息记录
    $scope.ConsultMessage = [];
    $("#ask_content_list .item-question").attr('content_you', list.PatientMobile);
    $("#ask_content_list .item-question").show();
    $scope.questionInfo = {
      CreateTime: list.Consult.CreateTime,
      ConsultID: list.Consult.ConsultID,
      Subject: list.Consult.Subject,
      Description: list.Consult.Description,
      ReceiverID: list.Consult.ReceiverID,
      ReceiverName: list.Consult.ReceiverName,
      DepartmentID: list.Consult.DepartmentID,
      DepartmentName: list.Consult.DepartmentName,
      ConsultType: 2,//预约问诊
      CreatorID: list.Consult.CreatorID,
      CreatorName: list.Consult.CreatorName,
      PatientGender: $scope.GenderText(list.Consult.PatientGender),
      PatientAge: list.Consult.PatientAge,
      PatientPhone: list.Consult.PatientPhone,
      PatientIDCard: list.Consult.PatientIDCard,
      PatientMedicalHistory: '',
      Status: 4,
      ID: list.Consult.ID,
      ReserveDate: list.Consult.ReserveDate,
      ReserveTime: list.Consult.ReserveTime,
      State: list.Consult.State,
      ReceiverTyp: list.Consult.ReceiverTyp,
      OnlineType: list.Consult.OnlineType,
      CustomerID: list.Consult.CustomerID
    };
    $scope.ConsultMessage = list.ConsultMessageList;
  };

  //回复问题
  $scope.onlineAnswer = function () {
    var str = $('#ask_send_content').text();
    var ConsultMessage = {
      ConsultID: $scope.questionInfo.ConsultID,
      Message: str,
      ReceiverID: $scope.questionInfo.CreatorID,
      ReceiverName: $scope.questionInfo.CreatorName,
      CreatorID: $scope.questionInfo.ReceiverID,
      CreatorName: $scope.questionInfo.ReceiverName
    };
    var Consult = {
      ConsultID: $scope.questionInfo.ConsultID,
      ID: $scope.questionInfo.ID,
      Subject: $scope.questionInfo.Subject,
      Description: $scope.questionInfo.Description,
      ReceiverID: $scope.questionInfo.ReceiverID,
      ReceiverName: $scope.questionInfo.ReceiverName,
      DepartmentID: $scope.questionInfo.DepartmentID,
      DepartmentName: $scope.questionInfo.DepartmentName,
      ConsultType: 2,//图文问诊
      CreatorID: $scope.questionInfo.CreatorID,
      CreatorName: $scope.questionInfo.CreatorName,
      PatientGender: $scope.questionInfo.PatientGender == '男' ? 1 : 0,
      PatientAge: $scope.questionInfo.PatientAge,
      PatientPhone: $scope.questionInfo.PatientPhone,
      PatientIDCard: $scope.questionInfo.PatientIDCard,
      PatientMedicalHistory: '',
      Status: 4,
      CreateTime: $scope.questionInfo.CreateTime,
      ReserveDate: $scope.questionInfo.ReserveDate,
      ReserveTime: $scope.questionInfo.ReserveTime,
      State: $scope.questionInfo.State,
      ReceiverTyp: $scope.questionInfo.ReceiverTyp,
      OnlineType: $scope.questionInfo.OnlineType,
      CustomerID: $scope.questionInfo.CustomerID,
    };
    var params = {
      ConsultMessage: ConsultMessage,
      Consult: Consult,
      FileList: []
    };
    onlineAskService.onlineAnswer(params, $scope);
  };

  //性别转换
  $scope.GenderText = function (par) {
    switch (par) {
      case 0:
        return '女';
      case 1:
        return '男';
      default:
        return '未知';
    }
  };

  //图文状态
  $scope.AskStateText = function (par) {
    switch (par) {
      case 1:
        return '待回复';
      case 4:
        return '已回复';
      case 5:
        return '已取消';
      case 6:
            return '已完成';
      default:
        return '未知';
    }
  };

  // 获取当前时间
  $scope.getCurrentTime = function () {
    var date = new Date();
    var year = date.getFullYear();
    var month = (date.getMonth() + 1).toString();
    if (month.length == 1) {
      month = "0" + month;
    }

    var day = date.getDate().toString();
    if (day.length == 1) {
      day = "0" + day;
    }

    var hour = date.getHours().toString();
    if (hour.length == 1) {
      hour = "0" + hour;
    }

    var minute = date.getMinutes().toString();
    if (minute.length == 1) {
      minute = "0" + minute;
    }

    var seconds = date.getSeconds().toString();
    if (seconds.length == 1) {
      seconds = "0" + seconds;
    }

    return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;
  };

  $scope.initialize();
});
