gysyApp.service("onlineRoomService",function ($http, httpHandlerService, resourceFactory, chatUtilityService) {
  var service = {};
  // 获取所有聊天记录
  service.getChatMessages = function (ReceiverID, SenderID, LastID, Rows, ConsultID, $scope) {
    httpHandlerService.AskChatMessageRequest({
        ConsultID: ConsultID,
        LastID: LastID,
        Rows: Rows,
        ReceiverID: ReceiverID,
        SenderID: SenderID
      }, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          var historyList = response.Body;
          if (historyList != null && historyList.length > 0) {
            //获取附件路径
            for (var i = 0; i < historyList.length; i++) {
              var history = historyList[i];
              if (history.ChatType == 1) {
                history.Message = resourceFactory.address.AskChatDomain + history.Message;
              }
            }
          }
          chatUtilityService.createHistory(historyList, $scope);
        }
        else {
          //alert("数据获取失败");
          navigator.notification.alert("数据获取失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  // 上传聊天记录
  service.addChatMessage = function (MessageTime, ReceiverID, IsGroup, SenderID, SenderName, Message, ConsultID, ChatType, SourceName, $scope) {
    // isGroup 0 否 1 是
    httpHandlerService.AskChatMessageRequest({
        ConsultID: ConsultID,
        MessageTime: MessageTime,
        ReceiverID: ReceiverID,
        IsGroup: IsGroup,
        SenderID: SenderID,
        SenderName: SenderName,
        Message: Message,
        ChatType: ChatType,
        SourceName: SourceName
      }, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
        }
        else {
          //alert("数据获取失败");
          navigator.notification.alert("数据获取失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  //修改在线问诊
  service.updateOnlineConsult = function (params, $scope) {
    httpHandlerService.getConsultRequest(params, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          console.info("修改状态成功")
        }
        else {
          console.info("修改状态失败");
        }
      },
      function (response) {
        console.log(response);
      });
  };
  return service;
});

gysyApp.controller('onlineRoomCtrl', function ($rootScope, $ionicHistory,$scope, $state, chatUtilityService, userService,onlineRoomService) {
  // 初始化
  $scope.initialize = function () {
    console.log($rootScope.onlineAskDetail)
    $rootScope.hideTabs=true;
    $scope.currentUser = userService.getUser().Body.User;
    // 当前用户id
    $scope.UserID = $scope.currentUser.UserID;
    $scope.currentUserID = $scope.currentUser.UserName;
    // 当前用户姓名(用来更新myInfo)
    $scope.currentUserName = $scope.currentUser.Name;
    $scope.contactlist = [];
    $scope.receiver =  $rootScope.onlineAskDetail;
    if(!$scope.receiver){
      //alert('联系患者失败');
      navigator.notification.alert("联系患者失败",function(){},"提示消息","确定");
      return;
    }

    $scope.setThirdSDK();
    $scope.getHistoryMessage($scope.receiver.Consult.CreatorID);
    // 推送 todo
    pushGoEasy.initialize();
    var channel = "AskChat_Channel_" + $scope.currentUserID;
    pushGoEasy.subscribe(channel, function (result) {
      //获取推送的数据  人或者群组
      var content = JSON.parse(result.content);
      if (content.Body.content != null && content.Body.content != "") {
        var response = JSON.parse(content.Body.content);
        //判断是否推送给本人的联系人或群组
        if ($scope.currentUserID == content.Header.PartnerID) {
          var consult = {
            CreateTime: response.Consult.CreateTime,
            ConsultID: response.Consult.ConsultID,
            Subject: response.Consult.Subject,
            Description: response.Consult.Description,
            ReceiverID: response.Consult.ReceiverID,
            ReceiverName: response.Consult.ReceiverName,
            DepartmentID: response.Consult.DepartmentID,
            DepartmentName: response.Consult.DepartmentName,
            ConsultType: 2,//预约问诊
            CreatorID: response.Consult.CreatorID,
            CreatorName: response.Consult.CreatorName,
            PatientGender: $scope.GenderText(response.Consult.PatientGender),
            PatientAge: response.Consult.PatientAge,
            PatientPhone: response.Consult.PatientPhone,
            PatientIDCard: response.Consult.PatientIDCard,
            PatientMedicalHistory: '',
            Status: response.Consult.Status,
            ID: response.Consult.ID
          };
          $scope.consultList.push(consult);
          if ($scope.consultList.length == 1) {
            $scope.questionInfo = $scope.consultList[0];
          }
          $scope.$apply();
        }
      }
    });
  };
  $scope.goBack = function(){
    $ionicHistory.goBack();
  }
  var screenWidth = window.screen.availWidth;
  var screenHeight = window.screen.availHeight - 50;
  var sendHeight = screenHeight / 10;
  var chatHeight = screenHeight - sendHeight;
  var c = $("#im_content_list").css({"width": screenWidth, "maxHeight": screenHeight, "overflow": "auto"});
  $("#contentEditDiv").css({"min-height": sendHeight, "position": "fixed", "bottom": 0, "background": "#fff"});
  // 上传文件到本地
  window.uploadFile = function (data, MessageTime, ReceiverID, IsGroup, SenderID, SenderName) {
   // onlineRoomService.uploadAskChatFiles(data, MessageTime, ReceiverID, IsGroup, SenderID, SenderName,$scope.receiver.ConsultID, $scope);
  };
  // 上传聊天记录到本地
  $scope.addChatMessage = function (MessageTime, ReceiverID, IsGroup, SenderID, SenderName, Message,ConsultID, ChatType) {
    onlineRoomService.addChatMessage(MessageTime, ReceiverID, IsGroup, SenderID, SenderName, Message,ConsultID, ChatType, null, $scope);
  };
  // 本地历史数据
  $scope.loadHistory = 1000;
  $scope.getChatMessages = function (contact, lastID) {
    onlineRoomService.getChatMessages(contact, $scope.UserID, lastID, $scope.loadHistory,$scope.receiver.Consult.ConsultID, $scope);
  };

  //判断选择发送人
  /*$scope.selectContact = function () {
    var receiver = '', b = false;
    $('#onlineConsult-table').find('tbody tr').each(function () {
      if ($(this).hasClass('select-bgcolor')) {
        receiver = $(this).attr('contact_you');
        b = true;
      }
    });
    if (!b) {
      alert("您尚未选择就诊患者");
      return "";
    }
    else {
      return receiver;
    }
  };*/
  //结束问诊
  $scope.overConsult = function () {
    //var receiver = $scope.selectContact();
    //if (receiver == "") {
    //  return;
    //}
    if (confirm("确定结束此问诊？")) {
      var consultInfo = $rootScope.onlineAskDetail.Consult;
      var Consult = {
        ConsultID: consultInfo.ConsultID,
        ReceiverID: consultInfo.ReceiverID,
        ReceiverName: consultInfo.ReceiverName,
        ID: consultInfo.ID,
        Subject: consultInfo.Subject,
        Status: 4,
        State: consultInfo.State,
        ReserveTime: consultInfo.ReserveTime,
        ReserveDate: consultInfo.ReserveDate,
        ReceiverType: consultInfo.ReceiverType,
        PatientPhone: consultInfo.PatientPhone,
        PatientMedicalHistory: consultInfo.PatientMedicalHistory,
        PatientIDCard: consultInfo.PatientIDCard,
        PatientGender: consultInfo.PatientGender == '男' ? 1 : 0,
        PatientAge: consultInfo.PatientAge,
        OnlineType: consultInfo.OnlineType,
        Description: consultInfo.Description,
        DepartmentName: consultInfo.DepartmentName,
        DepartmentID: consultInfo.DepartmentID,
        CustomerID: consultInfo.CustomerID,
        CreatorName: consultInfo.CreatorName,
        CreatorID: consultInfo.CreatorID,
        CreateTime: consultInfo.CreateTime,
        ConsultType: consultInfo.ConsultType
      };
      console.info(Consult);
      var params = {
        Consult: Consult,
        FileList: []
      };
      onlineRoomService.updateOnlineConsult(params, $scope);
    }
  };

  $scope.addmsgcount = function (item) {
    if (item.mgscount < 99) {
      item.mgscount++;
    }
  };


  /** 在线问诊消息发送相关 **/
  //SDK 配置
  $scope.setThirdSDK = function () {
    // 当前用户id
    if ($scope.currentUser != null) {
      if (!!$scope.currentUser.User) {
        $scope.currentUserID = $scope.currentUser.User.UserID;
        $scope.currentUserName = $scope.currentUser.User.Name;
      }
    }
    // 初始化SDK
    chatUtilityService.initialize();

    // SDK登陆
    chatUtilityService.loginSDK($scope.currentUserID, function () {
      //alert("连接出错");
      navigator.notification.alert("连接出错",function(){},"提示消息","确定");
    });
  };

  //发送文本消息
  $scope.sendMsg = function () {
    var receiver = $scope.receiver.Consult.PatientPhone;
    //发送内容
    var str = $('#im_send_content').val();
    if (str == undefined || str == null || str == '') {
      navigator.notification.alert("发送内容不能为空",function(){},"提示消息","确定");
      //alert("发送内容不能为空");
      return;
    }
    var im_send_content = chatUtilityService.preReplaceContentToDb(str);

    // 清空pre中的内容
    $('#im_send_content_copy').html('');
    $('#im_send_content').text('');

    var messageId = new Date().getTime();
    im_send_content = im_send_content.replace(/&lt;/g, '<').replace(
      /&gt;/g, '>').replace(/&quot;/g, '"')
      .replace(/&amp;/g, '&').replace(/&nbsp;/g, ' ');
    /**
     * 发送消息
     *
     * @param msg --
     *            是否为临时消息 msg、temp_msg
     *            右侧对话消息display为block；temp_msg用于发送本地文件
     * @param msgType --
     *            消息类型1:文本消息 2：语音消息 3：视频消息 4：图片消息  6：文件
     * @param msgid --
     *            问诊ID
     * @param ChatType --
     *            C个人； G群组
     * @param ReceiverID  ReceiverName--
     *            接收消息ID，用户名
     * @param SenderID  senderName--
     *            发送消息ID，用户名
     * @param Message --
     *            消息内容
     **/
    var params = {
      ConsultID:$scope.receiver.Consult.ConsultID,
      msg: 'msg',
      msgType: 1,
      messageId: messageId,
      chatType: 'C',
      senderID: $scope.currentUserID,
      senderName: $scope.currentUserName,
      receiverID: $scope.receiver.Consult.PatientPhone,
      receiverName: $scope.receiver.Consult.CreatorName,
      message: im_send_content
    };
    console.log('messageId[' + params.messageId + '] content_type[' + params.chatType + '] content_you[' + params.receiverID + '] im_send_content[' + params.message + ']');
    chatUtilityService.addSendMsgHTML(params.msg, params.msgType, params.messageId, params.chatType, params.receiverID, params.message);
    chatUtilityService.sendMsgToServer(params.message, params.receiverID, params.messageId, function (obj) {
      $('#im_send_content').val("");
      $(document.getElementById(receiver + '_' + obj.msgClientNo)).show();
      $('#im_content_list').scrollTop($('#im_content_list')[0].scrollHeight);
      // 上传文字到本地
      try{
        $scope.addChatMessage($scope.getCurrentTime(), $scope.receiver.Consult.CreatorID, 0, $scope.UserID, params.senderName, im_send_content,$scope.receiver.Consult.ConsultID);
      }
      catch (e){
        console.log(e);
      }
    }, function (obj) {
      setTimeout(function () { //断线的时候如果不延迟会出现找不到标签的情况，延迟0.3秒可解决。
        if (170001 == obj.code) {
          $(document.getElementById(receiver + '_' + obj.msgClientNo)).remove();
         // commonFunctionFactory.showAlert('发送消息内容超长，请分条发送');
        } else if (174002 == obj.code) {
          $(document.getElementById(receiver + '_' + obj.msgClientNo)).remove();
          console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
         // commonFunctionFactory.showAlert('网络不稳定，请退出重新进入');
        } else {
          $(document.getElementById(receiver + '_' + obj.msgClientNo)).remove();
          console.error("错误码： " + obj.code + "; 错误描述：" + obj.msg);
         // commonFunctionFactory.showAlert('当前医生较忙，请等待医生与您联系');
        }
      }, 300)
    });
  };

  //获取历史消息
  $scope.getHistoryMessage = function (contact) {
    $scope.historyMsgId = null;
    $scope.getChatMessages(contact, $scope.historyMsgId);
  };

  // 获取当前时间
  $scope.getCurrentTime = function () {
    var date = new Date();
    var year = date.getFullYear();
    var month = (date.getMonth() + 1).toString();
    if (month.length == 1) {
      month = "0" + month;
    }

    var day = date.getDate().toString();
    if (day.length == 1) {
      day = "0" + day;
    }

    var hour = date.getHours().toString();
    if (hour.length == 1) {
      hour = "0" + hour;
    }

    var minute = date.getMinutes().toString();
    if (minute.length == 1) {
      minute = "0" + minute;
    }

    var seconds = date.getSeconds().toString();
    if (seconds.length == 1) {
      seconds = "0" + seconds;
    }

    return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + seconds;
  };

  $scope.initialize();

});
