/**
 * Created by ylj on 2016/10/14.
 */
var selectMemberModule=angular.module("selectMemberModule",["IMModule", "UserModule"]);
selectMemberModule.service("selectMemberService", function ($http, httpHandlerService,sessionFactory,resourceFactory, IMContentService,$state) {
  var service = {};
  //获取层级数据
  service.getDoctorGroupByDepartment = function ($scope) {
    var result = sessionFactory.getDataFromSession('doctorDepartment');
    if (result != null && result != 'undefined') {
      $scope.showCustomerList = JSON.parse(result);
    } else {
      httpHandlerService.getDoctorGroupByDepartmentRequest({}, resourceFactory.operateCode.get,
        function (response) {
          if (response.Header.StatusCode == 0) {
            $scope.showCustomerList = response.Body;
            sessionFactory.saveDataToSession('doctorDepartment', JSON.stringify($scope.showCustomerList));
          }
          else {
            console.error("没有任何用户");
          }
        },
        function (response) {
          console.error(response);
        }
      );
    }
  };
  // group list 相关
  //获取会诊间列表
  service.getChatList = function (data, $scope) {
    httpHandlerService.chatRequest(data, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          $scope.chatList = response.Body.ChatList;
        }
        else {
          if (response.Header.StatusCode != 0) {
            navigator.notification.alert(response.Header.Message,function(){},"提示消息","确定");
          }

          $scope.chatList = [];
        }

        $scope.resetGroupList();

      },
      function (response) {
        console.log(response);
      }
    );
  };
  // 新增会诊间
  service.addChat = function ($scope) {
    if (!$.formValidator.pageIsValid("1")) {
      return;
    }

    if ($scope.loginSuccessfully) {
      IM.group.createGroup(
        $scope.addChat.Subject,
        1,
        2,  // 群组
        "",
        "",
        "",
        "",
        function (obj) {
          var groupId = obj.data;
          console.log(groupId);
          var dataBag = [];
          $scope.addChat.GroupID = groupId;
          dataBag.push($scope.addChat);
          httpHandlerService.chatRequest({ChatList: dataBag}, resourceFactory.operateCode.insert,
            function (response) {
              if (response.Header.StatusCode == 0) {
                navigator.notification.alert("新增成功",function(){},"提示消息","确定");
                service.getChatList({FunctionType: 1}, $scope);
              }
              else {
                navigator.notification.alert("新增失败",function(){},"提示消息","确定");
              }
            },
            function (response) {
              navigator.notification.alert("新增失败",function(){},"提示消息","确定");
            }
          );
        }, function (obj) {
          navigator.notification.alert("创建会诊间失败",function(){},"提示消息","确定");
        }
      );
    } else {
      navigator.notification.alert("还没有登陆成功",function(){},"提示消息","确定");
    }
  };
  // 修改会诊间内容
  service.updateChatDetail = function ($scope) {
    if (!$.formValidator.pageIsValid("2")) {
      return;
    }

    // 每条chat数据都需要更新
    httpHandlerService.getListByGroupIDRequest({GroupID: $scope.updateChat.GroupID}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          var list = [];
          for (var i = 0; i < response.Body.ChatList.length; i++) {
            var chat = JSON.parse(JSON.stringify(response.Body.ChatList[i])).Chat;
            chat.Subject = $scope.updateChat.Subject;
            chat.Photo = $scope.updateChat.Photo;
            list.push(chat);
          }

          httpHandlerService.chatRequest({ChatList: list}, resourceFactory.operateCode.update,
            function (response) {
              if (response.Header.StatusCode == 0) {
                service.getChatList({FunctionType: 1}, $scope);
                navigator.notification.alert("会诊间信息修改成功",function(){},"提示消息","确定");
              }
              else {
                navigator.notification.alert("会诊间信息修改失败",function(){},"提示消息","确定");
              }
            },
            function (response) {
              navigator.notification.alert("会诊间信息修改失败",function(){},"提示消息","确定");
            }
          );
        }
        else {
          navigator.notification.alert("会诊间信息修改失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        navigator.notification.alert("会诊间信息修改失败",function(){},"提示消息","确定");
      }
    );
  };
  // 删除会诊间
  service.submitDeleteUpdateChat = function (chat, $scope) {
    chat.State = 2;
    httpHandlerService.chatRequest({ChatList: [chat]}, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          service.getChatList({FunctionType: 1}, $scope);
          navigator.notification.alert("退出成功",function(){},"提示消息","确定");
        }
        else {
          navigator.notification.alert("退出失败",function(){},"提示消息","确定");
        }
      },
      function (response) {
        navigator.notification.alert("退出失败",function(){},"提示消息","确定");
      }
    );
  };
  // 上传群图片
  service.uploadGroupPhoto = function (data, successCallback, errorCallback) {
    return httpHandlerService.uploadGroupPhotoRequest(data, successCallback, errorCallback)
  };

  // group member 相关
  // 更新聊天
  service.submitGroupMembers = function (ids, $scope) {
    IM.group.createGroup(
      $scope.discussGroupName,
      1,
      2,  // 群组
      "",
      "",
      "",
      "",
      function (obj) {
        var groupId = obj.data;
        console.log(groupId);
        var list = [];
        for (var i = 0; i < ids.length; i++) {
          var temp = {
            Subject: $scope.discussGroupName,
            PartnerID: ids[i],
            CreatorID: $scope.groupCreatorID,
            Status: 0,
            FunctionType: 1,
            GroupID: groupId
          };
          list.push(temp);
        }

        httpHandlerService.chatRequest({ChatList: list}, resourceFactory.operateCode.update,
          function (response) {
            if (response.Header.StatusCode == 0) {
              service.getListByGroupID($scope.groupID, $scope);
              navigator.notification.alert("会诊间创建成功",function(){},"提示消息","确定");
              $state.go("discussGroupList");
            }
            else {
              navigator.notification.alert("会诊间创建失败",function(){},"提示消息","确定");
            }
          },
          function (response) {
            navigator.notification.alert("会诊间创建失败",function(){},"提示消息","确定");
          }
        );
      }, function (obj) {
        navigator.notification.alert("创建会诊间失败",function(){},"提示消息","确定");
      }
    );
  };
  // 获取所有chat数据通过groupid
  service.getListByGroupID = function (groupId, $scope) {
    httpHandlerService.getListByGroupIDRequest({GroupID: groupId}, resourceFactory.operateCode.get,
      function (response) {
        $scope.groupMemberList = [];
        $scope.groupList = [];
        if (response.Header.StatusCode == 0 && response.Body.ChatList != null && response.Body.ChatList.length > 0) {
          for (var i = 0; i < response.Body.ChatList.length; i++) {
            var temp = JSON.parse(JSON.stringify(response.Body.ChatList[i]));
            $scope.groupMemberList.push(temp.Chat);
            // 当前用户默认在线
            if (temp.Partner.UserID == $scope.currentUserID) {
              temp.Partner.onlineState = 1;
            }

            $scope.groupList.push(temp.Partner);
          }
        }
        else {
          console.error("获取失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };

  // content 相关
  // 获取所有聊天记录
  service.getChatMessages = function (ReceiverID, SenderID, LastID, Rows, $scope) {
    httpHandlerService.chatMessageRequest({
        LastID: LastID,
        Rows: Rows,
        ReceiverID: ReceiverID,
        SenderID: SenderID
      }, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          var historyList = response.Body;
          if (historyList != null && historyList.length > 0) {
            // 更新第一条历史消息读取状态
            var temp = historyList[0];
            service.addChatRead(temp.MessageTime, $scope.currentUserID, $scope.groupID, null, $scope);
            for (var i = 0; i < historyList.length; i++) {
              var history = historyList[i];
              if (history.ChatType == 1) {
                history.Message = service.getFileBase(history.CustomerID) + history.Message;
              }
            }
          }

          IMContentService.createHistory(historyList, $scope);
        }
        else {
          console.error("获取信息失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  // 上传聊天记录
  service.addChatMessage = function (MessageTime, ReceiverID, IsGroup, SenderID, SenderName, Message, ChatType, SourceName, $scope) {
    // isGroup 0 否 1 是
    httpHandlerService.chatMessageRequest({
        MessageTime: MessageTime,
        ReceiverID: ReceiverID,
        IsGroup: IsGroup,
        SenderID: SenderID,
        SenderName: SenderName,
        Message: Message,
        ChatType: ChatType,
        SourceName: SourceName
      }, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
        }
        else {
          console.error("添加信息失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  // 上传聊天状态
  service.addChatRead = function (MessageTime, UserID, GroupID, SenderID, $scope) {
    // isGroup 0 否 1 是
    httpHandlerService.chatReadRequest({
        ChatReadList: [{
          MessageTime: MessageTime,
          UserID: UserID,
          GroupID: GroupID,
          SenderID: SenderID
        }]
      }, resourceFactory.operateCode.insert,
      function (response) {
        if (response.Header.StatusCode == 0) {
        }
        else {
          console.error("添加信息失败");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  // 上传文件
  service.uploadFiles = function (data, MessageTime, ReceiverID, IsGroup, SenderID, SenderName, $scope) {
    return httpHandlerService.uploadFilesRequest(data, function (data) {
        if (data == null || data.Body == null || data.Body.length < 1) {
          console.error("文件上传失败");
          return;
        }

        var fileName = data.Body[0].FileName;
        var sourceName = data.Body[0].SourceName;
        service.addChatMessage(MessageTime, ReceiverID, IsGroup, SenderID, SenderName, fileName, 1, sourceName, $scope);
      },
      function (data) {
        console.error("文件上传失败");
      });
  };
  // 文件上传路径base
  service.getFileBase = function (customerID) {
    return httpHandlerService.getFileBase(customerID);
  };

  //获取会诊间医院数据
  service.getCustomListGroup = function ($scope) {
    httpHandlerService.getCustomListGroupRequest({}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          $scope.customerList = response.Body;
          console.log($scope.customerList);
        }
        else {
          console.error("没有任何用户");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  //获取会诊间科室数据数据
  service.getDepartmentListGroupByCustom = function ($scope,data, li) {
    console.log(data);
    httpHandlerService.getDepartmentListGroupByCustomRequest({"CustomerID":data}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          li.DepartmentList = response.Body;
        }
        else {
          console.error("没有任何用户");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  //获取会诊间医生数据数据
  service.getDoctorListGroupByDepartment = function ($scope,data, li) {
    httpHandlerService.getDoctorListGroupByDepartmentRequest({"DepartmentID":data}, resourceFactory.operateCode.get,
      function (response) {
        if (response.Header.StatusCode == 0) {
          li.UserList = response.Body;
        }
        else {
          console.error("没有任何用户");
        }
      },
      function (response) {
        console.error(response);
      }
    );
  };
  return service;
});
selectMemberModule.controller("selectMemberController",function($scope,$ionicHistory,selectMemberService, IMGroupMemberService, userService){
  $scope.initialize = function () {
    //selectMemberService.getDoctorGroupByDepartment($scope);
    selectMemberService.getCustomListGroup($scope);
  };

  $scope.currentUser = userService.getUser().Body.User;
  $scope.groupCreatorID = $scope.currentUser.UserID;
  $scope.discussGroupName="";

  //根据医院选择科室
  $scope.getDepartmentList = function(data, li){
    console.log(data);
    selectMemberService.getDepartmentListGroupByCustom($scope,data, li);
  };
  //根据科室选择医生
  $scope.getDoctorList = function(data, li){
    console.log(data);
    selectMemberService.getDoctorListGroupByDepartment($scope,data, li);
  }


  $scope.selectGroupMemberList = [];
  $scope.selectGroupMemberList.push($scope.currentUser);
  IMGroupMemberService.initialize($scope);
  /*提交新增会诊间*/
  $scope.submitAddChat = function () {
    selectMemberService.addChat($scope);
  };
  $scope.goCancel=function(){
    $ionicHistory.goBack();
  };

  $scope.updateGroupMembers = function () {
    if ($scope.selectGroupMemberList.length == 0) {
      return;
    }

    var ids = [];
    for (var i = 0; i < $scope.selectGroupMemberList.length; i++) {
      ids.push($scope.selectGroupMemberList[i].UserID);
    }
    selectMemberService.submitGroupMembers(ids, $scope);
  };
  $scope.initialize();
});
