/**
 * Created by ylj on 2016/10/12.
 */
var setModule = angular.module('setModule', ["UserModule", "resourceModule", "httpHandlerModule", "sessionModule"]);

setModule.factory('setFactory', function (userService, commonFunctionFactory) {
  return {
    logoutSystem: function () {

      userService.removeUser();

      commonFunctionFactory.goToLogin();
    }
  };
});


setModule.service("setService", function ($http, httpHandlerService, resourceFactory) {
  var service = {};

  //修改用户
  service.getupdateUser = function ($scope) {
    httpHandlerService.userRequest($scope.updatedUser, resourceFactory.operateCode.update,
      function (response) {
        if (response.Header.StatusCode == 0) {
          navigator.notification.alert("用户更新成功", function () {
          }, "提示消息", "确定");
          service.getUserList($scope);
        }
        else {
          navigator.notification.alert("用户更新失败", function () {
          }, "提示消息", "确定");

        }
      },
      function (response) {
        console.log(response);
      }
    );
  };


  //保存个人信息
  service.saveUserInfo = function ($scope) {
    try {
      httpHandlerService.userRequest($scope.currentUser.User, resourceFactory.operateCode.update,
        function (response) {
          if (response.Header.StatusCode == 0) {
            resources.CommonFun.getDataFromSession("CurrentUser").User = response;
            navigator.notification.alert("保存成功！", function () {
            }, "提示消息", "确定");
          }
          else {
            navigator.notification.alert("保存失败，请稍候重试！", function () {
            }, "提示消息", "确定");
          }
        },
        function (response) {
          navigator.notification.alert(response, function () {
          }, "提示消息", "确定");
        });
    }
    catch (e) {
      console.log(e);
    }
  };

  return service;
});

setModule.controller('setController', function ($scope, $state, setFactory, userService, setService, $ionicHistory, $ionicPopup) {

  var disabledDates = [
    new Date(1437719836326),
    new Date(),
    new Date(2015, 7, 10), //months are 0-based, this is August, 10th!
    new Date('Wednesday, August 12, 2015'), //Works with any valid Date formats like long format
    new Date("08-14-2015"), //Short format
    new Date(1439676000000) //UNIX format
  ];
  //方便的年月日设置方式，正和我意，可以随便改了。
  var weekDaysList = ["S", "M", "T", "W", "T", "F", "S"];//中文：["日", "一", "二", "三", "四", "五", "六"];
  var monthList = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
  //中文：["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
  // 日期选择后的回调函数
  var datePickerCallbacke = function (val) {
    if (typeof (val) === 'undefined') {
    } else {
      console.log('Selected date is : ', val);
      $scope.scheduleInfo.scheduleDate = val;//更新日期。
    }
  };
  //主体对象
  $scope.datepickerObjectEnd = {
    titleLabel: '选择日期',  //可选
    todayLabel: '今天',  //可选
    closeLabel: '关闭',  //可选
    setLabel: '设置',  //可选
    setButtonType: 'button-assertive',  //可选
    todayButtonType: 'button-assertive',  //可选
    closeButtonType: 'button-assertive',  //可选
    inputDate: new Date(),  //可选，输入值
    mondayFirst: true,  //可选,星期一开头
    disabledDates: disabledDates, //可选
    weekDaysList: weekDaysList, //可选
    monthList: monthList, //可选
    templateType: 'popup', //可选i.e.的模式 modal or popup(兼容模式？)
    showTodayButton: 'true', //可选
    modalHeaderColor: 'bar-positive', //可选
    modalFooterColor: 'bar-positive', //可选
    from: new Date(2008, 8, 2), //可选
    to: new Date(2030, 8, 25),  //可选
    callback: function (val) {  //Mandatory
      datePickerCallbacke(val);
    },
    dateFormat: 'yyyy-MM-dd', //可选
    closeOnSelect: true, //可选,设置选择日期后是否要关掉界面。呵呵，原本是false。
  };


  $scope.currentUser = userService.getUser().Body;
  //医院检查报告检验报告显示
  var currentUser = userService.getUser();
  currentUser.Body.IsTop == 1?$scope.isShow =true:$scope.isShow =false;

  $scope.logoutSystem = function () {
    setFactory.logoutSystem();
    //  ionic.Platform.exitApp();退出APP
  };
  $scope.goBack = function () {
    $ionicHistory.goBack();
  };
  $scope.goReadImg = function () {
    var currentUser = userService.getUser();
    currentUser.Body.IsTop == 1 ? $state.go("HosReadImg") : $state.go("communityReadImg");
  };
  $scope.test = function () {
    $ionicPopup.show({
        template: "<h1>程序猿正在加班加点的努力中。。。</h1>",
        title: "模块待定",
        scope: $scope,
        buttons: [

          {
            text: "确定",
            type: "button-royal",
          }
        ]
      })
      .then(function (res) {
      });
  };
  $scope.goUserInfo = function () {
    $state.go('userInfo');
  }

  //编辑用户信息
  $scope.editUserInfo = function () {
    $("#person_info .show_item").css("display", "none");
    $("#person_info .hide_item").css("display", "inline-block");
  };

  //初始化性别列表
  // $scope.GenderList = resources.factoryList;

  //加载
  $scope.getGender = function (age) {
    return resources.displayText.GenderText(age);
  };

  //个人信息点击
  $scope.showUserInfo = function () {
    $("#person_info .show_item").show();
    $("#person_info .hide_item").hide();
    $("#person_info").modal("show");
  };

  //保存用户个人信息
  $scope.saveUserInfo = function () {
    setService.saveUserInfo($scope);
  };


  $scope.showText = function (show) {
    if (show) {
      return "-";
    } else {
      return "+";
    }
  };
  // 选择li
  $scope.show = false;
  $scope.selectLi = function () {
    $scope.show = !$scope.show;
  };
  $scope.sub = function (str) {
    if (str == null || str.length <= 3) {
      return str;
    }

    return str.substr(0, 3) + ".";
  };

  var currentUser = userService.getUser();

  if (currentUser.Body.UserType == 1) {
    // 医生
    //$scope.navList = navFactory.navDocList;
    $scope.firstWord = currentUser.Body.User.Name.substr(0, 1);
    $scope.doctorName = currentUser.Body.User.Name;
    $scope.UserName = currentUser.Body.User.UserName;
    $scope.hospitalName = currentUser.Body.Customer != null ?
      currentUser.Body.Customer.CustomerName : "";
    $scope.doctorRole = (function () {
      switch (currentUser.Body.User.JobTitle) {
        case '0':
          return '主任医师';
        case '1':
          return '医干';
        case '2':
          return '医生';
        default:
          return '医生';
      }
    })();
    $scope.doctorID = currentUser.Body.User.UserID;
    $scope.setUser = 0;
  } else if (currentUser.Body.IsTop == 1) {
    // 医务处
    //$scope.navList = navFactory.navList;
    $scope.firstWord = '医';
    $scope.setUser = 1;
    $scope.hospitalName = currentUser.Body.Customer.CustomerName;

  } else {
    // 下级医院医务处
    //$scope.navList = navFactory.navPartnerList;
    $scope.firstWord = '合';
    $scope.setUser = 2;
    $scope.doctorName = currentUser.Body.User.Name;
    $scope.UserName = currentUser.Body.User.UserName;
    $scope.hospitalName = currentUser.Body.Customer != null ?
      currentUser.Body.Customer.CustomerName : "";
    $scope.doctorRole = (function () {
      switch (currentUser.Body.User.JobTitle) {
        case '0':
          return '主任医师';
        case '1':
          return '医干';
        case '2':
          return '医生';
        default:
          return '医生';
      }
    })();
    $scope.doctorID = currentUser.Body.User.UserID;
    //赋值
    $scope.currentUser = currentUser.Body;
    $scope.currentUser.User.Birthday = resources.displayText.DateToDayText(currentUser.Body.User.Birthday);
  }
  //患者管理
  $scope.goPatientManage = function(){
    var flg = false;
    // 判断权限
    var list = currentUser.Body.RoleModuleList;
    if(currentUser.Body.UserType == 2){
      flg = true;
    }else{
      for (var i = 0; i < list.length; i++) {
        //var nav = list[i];
        for (var j = 0; j < currentUser.Body.RoleModuleList.length; j++) {
          var roleModule = currentUser.Body.RoleModuleList[j];
          if (roleModule.ModuleNo == "M007" && roleModule.Purview != null && roleModule.Purview.indexOf("1") > -1) {
            flg = true;
            break;
          }
        }
      }
    }
    if(!flg){
      //alert("您没有该权限");
      navigator.notification.alert("您没有该权限", function () {
      }, "提示消息", "确定");
    }else{
      $state.go("patientManageList");
    }

  }

  $scope.goPatientReport = function(){
    $state.go("patientReport");
  }

  $scope.goInspectReport = function(){
    $state.go("inspectReport");
  };

  $scope.goGreenRouteList = function(){
    var flg = false;
    // 判断权限
    var list = currentUser.Body.RoleModuleList;
    if(currentUser.Body.UserType == 2){
      flg = true;
    }else{
      for (var i = 0; i < list.length; i++) {
        //var nav = list[i];
        for (var j = 0; j < currentUser.Body.RoleModuleList.length; j++) {
          var roleModule = currentUser.Body.RoleModuleList[j];
          if (roleModule.ModuleNo == "M002" && roleModule.Purview != null && roleModule.Purview.indexOf("1") > -1) {
            flg = true;
            break;
          }
        }
      }
    }
    if(!flg){
      //alert("您没有该权限");
      navigator.notification.alert("您没有该权限", function () {
      }, "提示消息", "确定");
    }else{
      $state.go("greenRouteList");
    }

  }

  $scope.goCommunityReproductionList = function(){
    var flg = false;
    // 判断权限
    var list = currentUser.Body.RoleModuleList;
    if(currentUser.Body.UserType == 2){
      flg = true;
    }else{
      for (var i = 0; i < list.length; i++) {
        //var nav = list[i];
        for (var j = 0; j < currentUser.Body.RoleModuleList.length; j++) {
          var roleModule = currentUser.Body.RoleModuleList[j];
          if (roleModule.ModuleNo == "M013" && roleModule.Purview != null && roleModule.Purview.indexOf("1") > -1) {
            flg = true;
            break;
          }
        }
      }
    }
    if(!flg){
      //alert("您没有该权限");
      navigator.notification.alert("您没有该权限", function () {
      }, "提示消息", "确定");
    }else{
      $state.go("communityReproductionList");
    }
  };

  $scope.goFeedback = function(){
    alert(110);
    $state.go("feedback");
    alert(120);
  };

  $scope.goAnnounce = function(){
    $state.go("announce");
  };

  $scope.goVersions = function(){
    $state.go("versions");
  };

});


angular.bootstrap($('setting'), ['setModule']);
